#!/usr/bin/perl
#
# cornerstore.cgi - trial version
#
######################################################################
#
# NOTE: do not spend too much time customizing this trial version,
# because the full version replaces it completely.
# 
######################################################################
#
# DO NOT EDIT THIS FILE unless absolutely necessary; in most cases you
# should be editing cornerstore_prefs.cgi instead.  If you do edit this
# file, be sure to make a backup copy first.
# 
######################################################################
#
# This program is the copyrighted work of Encodable Industries.
# Redistribution is prohibited, and copies are permitted only for
# backup purposes.  You are free to modify the program for your
# own use, but you may not distribute any modified copies of it.
#
# Use of this program requires a one-time license fee.  You can
# obtain a license here:
#
#	http://encodable.com/cornerstore/
#
# This software comes with no warranty.  It is our hope that you
# find it useful, but it comes with no guarantees.  Under no
# circumstances shall Encodable Industries be held liable in any
# situation arising from your use of this program.
#
# For more information about this program, as well as for help
# and support, please visit the following pages:
#
# Homepage: http://encodable.com/cornerstore/
# Contact:  http://encodable.com/contact/


my $version = "2.00t03";
use CGI::Carp 'fatalsToBrowser';
$ENV{PATH} = '/bin:/usr/bin:/usr/local/bin';
delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};
($ENV{DOCUMENT_ROOT}) = ($ENV{DOCUMENT_ROOT} =~ /(.*)/); # untaint.
#$ENV{DOCUMENT_ROOT} = 'c:\some\dir'; # If autodetection fails, uncomment & set this.
#$ENV{SCRIPT_NAME} = '/cgi-bin/cornerstore.cgi'; # If autodetection fails, uncomment & set this.
use lib './perlmodules';
use lib '../cgi-bin/perlmodules';
use lib '../../cgi-bin/perlmodules';
use lib "$ENV{DOCUMENT_ROOT}/cgi-bin/perlmodules";
use lib "$ENV{DOCUMENT_ROOT}/../cgi-bin/perlmodules";
my (%PREF,%TEXT,%COOKIE) = ();

my $debuglog = undef;

$| = 1;
use strict;
#use warnings;
use Fcntl;
use POSIX;
use File::Copy;
use Time::Local;
use Digest::MD5 'md5_hex';

sub printd;
sub die_nice;
sub enc_warn;
sub encdebug;
sub encdebuglog;
sub exit_with_error;

my $qs = '';




sub generate_new_cart_id()
{
	my $cart_id = '';
	do {
		$cart_id = md5_hex(time() . $ENV{HTTP_HOST} . rand() . $ENV{REMOTE_ADDR} . $$ . $ENV{HTTP_USER_AGENT});
	}
	while(cart_id_is_taken($cart_id));
	return $cart_id;
}


sub cart_id_is_taken($)
{
	my $cart_id = shift;
	check_cart_id_for_sql_safeness($cart_id);
	return enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id'");
}


sub cart_already_sold($)
{
	my $cart_id = shift;
	check_cart_id_for_sql_safeness($cart_id);
	return enc_sql_select("SELECT COUNT(*) FROM `$PREF{saleslog_table}` WHERE `cart_id` = '$cart_id'");
}


sub add_to_cart()
{
	# This allows /cart/?add=foo to work, in addition to /cgi-bin/cornerstore.cgi?add=foo.
	enc_redirect("$ENV{SCRIPT_NAME}?$qs") if $PREF{we_are_virtual};

	my $cart_id = get_cookie($PREF{cart_id_cookie}) || generate_new_cart_id();
	$cart_id = generate_new_cart_id() while(cart_already_sold($cart_id));
	check_cart_id_for_sql_safeness($cart_id);

	my $timestamp = offsettime();
	my $date = strftime("%Y%m%d-%H:%M:%S",localtime($timestamp));
	die_unless_numeric($timestamp, 'timestamp');
	die_unless_sqlsafe($date);

	my %items = ();
	if($qs =~ /action=addtocartdyn/)
	{
		$items{1}{item_code}		= get_qs_var('code');
		$items{1}{item_name}		= get_qs_var('name');
		$items{1}{item_description}	= get_qs_var('desc');
		$items{1}{item_options}		= get_qs_var('opts');
		$items{1}{item_price}		= get_qs_var('cost');
		$items{1}{item_qty}		= 1;

		my $original_fingerprint = get_qs_var('eif');
		my $current_fingerprint = get_cart_item_fingerprint($items{1}{item_code}, $items{1}{item_name}, $items{1}{item_description}, $items{1}{item_options}, $items{1}{item_price});
		exit_with_error $TEXT{fingerprint_mismatch_on_dynamic_cart_item} unless $current_fingerprint eq $original_fingerprint;
	}
	else
	{
		my $i = 1;
		while($qs =~ /(?:^|&)(?:item|add)=([^&]+)(?:&qty=(\d+))?/g)
		{
			$items{$i}{item_code} = $1;
			$items{$i}{item_qty} = $2 || 1;

			#die_nice(qq`No such item as '$items{$i}{item_code}'.`) unless $PREF{items}{   $items{$i}{item_code}   };
			#$items{$i}{item_name}		= $PREF{items}{   $items{$i}{item_code}   }{name};
			#$items{$i}{item_description}	= $PREF{items}{   $items{$i}{item_code}   }{description};
			#$items{$i}{item_options}	= $PREF{items}{   $items{$i}{item_code}   }{options};
			#$items{$i}{item_price}		= $PREF{items}{   $items{$i}{item_code}   }{price};

			die_nice($TEXT{invalid_item_code_} . " " . $items{$i}{item_code}) unless itemcode_is_valid($items{$i}{item_code});
			($items{$i}{item_name}, $items{$i}{item_description}, $items{$i}{item_price})
			= enc_sql_select("SELECT `name`,`description`,`price` FROM `$PREF{item_table}` WHERE `code` = '$items{$i}{item_code}'");

			die_nice(qq`No such item as '$items{$i}{item_code}'.`) unless $items{$i}{item_name};

			$i++;
		}

		# TODO: remove the above while() loop, along with the corresponding line(s) in
		# our top-level .htaccess file, and route all links through this new format:
		#
		$i = 1;
		if($qs =~ /(?:^|&)addmulti=([\w\.-]+)/)
		{
			foreach my $item (split(/\./, $1))
			{
				my ($code,$qty) = $item =~ /^(\w+)-(\d+)$/ ? ($1,$2) : ($item,1);
			
				$items{$i}{item_code} = $code;
				$items{$i}{item_qty} = $qty;

				#die_nice(qq`No such item as '$items{$i}{item_code}'.`) unless $PREF{items}{   $items{$i}{item_code}   };
				#$items{$i}{item_name}		= $PREF{items}{   $items{$i}{item_code}   }{name};
				#$items{$i}{item_description}	= $PREF{items}{   $items{$i}{item_code}   }{description};
				#$items{$i}{item_options}	= $PREF{items}{   $items{$i}{item_code}   }{options};
				#$items{$i}{item_price}		= $PREF{items}{   $items{$i}{item_code}   }{price};

				die_nice($TEXT{invalid_item_code_} . " " . $items{$i}{item_code}) unless itemcode_is_valid($items{$i}{item_code});
				($items{$i}{item_name}, $items{$i}{item_description}, $items{$i}{item_price})
				= enc_sql_select("SELECT `name`,`description`,`price` FROM `$PREF{item_table}` WHERE `code` = '$items{$i}{item_code}'");

				die_nice(qq`No such item as '$items{$i}{item_code}'.`) unless $items{$i}{item_name};

				$i++;
			}
		}
	}


	my ($ip, $host, $ua) = ($PREF{ip}, $PREF{host}, $ENV{HTTP_USER_AGENT});
	sql_untaint($ip, $host, $ua);
	die_unless_sqlsafe($ip, $host, $ua);

	my $user_id = $PREF{logged_in_userid};
	$user_id = 0 unless $user_id =~ /^\d+$/;


	foreach my $i (sort { $a <=> $b } keys %items)
	{
		sql_untaint($items{$i}{item_code}, $items{$i}{item_name}, $items{$i}{item_description}, $items{$i}{item_options});
		die_unless_sqlsafe($items{$i}{item_code}, $items{$i}{item_name}, $items{$i}{item_description}, $items{$i}{item_options});
		check_item_price_for_sql_safeness($items{$i}{item_price});

		# If this item is already in the cart, then update its quantity.  Otherwise add it to the cart.
		#
		if(my $qty_in_cart = enc_sql_select("SELECT `item_quantity` FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND `item_code` = '$items{$i}{item_code}' AND `item_name` = '$items{$i}{item_name}' AND `item_description` = '$items{$i}{item_description}' AND `item_options` = '$items{$i}{item_options}' AND IFNULL(`deleted_from_cart`,0) != 1"))
		{
			my $new_qty = $qty_in_cart + $items{$i}{item_qty};
			die_nice qq`New quantity must be numeric, but instead it's '$new_qty'.` unless $new_qty =~ /^\d+(\.\d*)?$/;
			my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `item_quantity` = $new_qty WHERE `cart_id` = '$cart_id' AND `item_code` = '$items{$i}{item_code}' AND IFNULL(`deleted_from_cart`,0) != 1");
			die_nice("SQL returned '$success' instead of '1' while updating item_quantity to '$new_qty'.") unless $success == 1;
		}
		else
		{
			enc_sql_insert("INSERT INTO `$PREF{shopping_carts_table}` 
				(`timestamp_added`,`date_added`,`cart_id`,`ub_user_id`,`item_name`,`item_code`,`item_description`,`item_options`,`item_quantity`,`item_price`,`ip_address`,`hostname`,`browser`)
				VALUES('$timestamp','$date','$cart_id',$user_id,'$items{$i}{item_name}','$items{$i}{item_code}','$items{$i}{item_description}','$items{$i}{item_options}','$items{$i}{item_qty}','$items{$i}{item_price}','$ip','$host','$ua')
			");
		}
	}

	# delete old carts:
	#
	my $current_time = offsettime();
	my $oldest_timestamp_allowed = $current_time - $PREF{max_age_for_shopping_carts};
	die_unless_numeric($oldest_timestamp_allowed, '$oldest_timestamp_allowed');
	enc_sql_delete("DELETE FROM `$PREF{shopping_carts_table}` WHERE `timestamp_added` < $oldest_timestamp_allowed") if enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `timestamp_added` < $oldest_timestamp_allowed");

	update_cart_promo_prices($cart_id);

	set_cookie($PREF{cart_id_cookie}, $cart_id, '+6M') unless get_cookie($PREF{cart_id_cookie}) eq $cart_id;
	enc_redirect($PREF{here_cart});
}


# Must also verify SQL-safeness:
#
sub itemcode_is_valid($)
{
	return $_[0] =~ /^\w+$/;
}


sub remove_from_cart()
{
	my ($item_id) = ($qs =~ /(?:^|&)iid=(\d+)(?:&|$)/);
	die_unless_numeric($item_id,'item_id');
	my $cart_id = get_cookie($PREF{cart_id_cookie});
	$cart_id = generate_new_cart_id() while(cart_already_sold($cart_id));
	check_cart_id_for_sql_safeness($cart_id);

	#enc_sql_delete("DELETE FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'") if enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'");
	my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `deleted_from_cart` = 1 WHERE `id` = $item_id AND `cart_id` = '$cart_id'") if enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'");
	die_nice("SQL returned '$success' instead of '1' while setting deleted_from_cart to 1.") unless $success == 1;

	update_cart_promo_prices($cart_id);
	enc_redirect($PREF{here_cart});
}


sub update_cart_page()
{
	my $cart_id = get_cookie($PREF{cart_id_cookie}) || generate_new_cart_id();
	$cart_id = generate_new_cart_id() while(cart_already_sold($cart_id));
	check_cart_id_for_sql_safeness($cart_id);

	while($qs =~ /(\d+)_qty=(\d+)/g)
	{
		my ($item_id,$qty) = ($1,$2);
		die_unless_numeric($item_id,'item_id');
		die_unless_numeric($qty, qq`quantity`);

		if($qty == 0)
		{
			#enc_sql_delete("DELETE FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'") if enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'");
			my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `deleted_from_cart` = 1 WHERE `id` = $item_id AND `cart_id` = '$cart_id'") if enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `id` = $item_id AND `cart_id` = '$cart_id'");
			die_nice("SQL returned '$success' instead of '1' while setting deleted_from_cart to 1.") unless $success == 1;
		}
		else
		{
			my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `item_quantity` = $qty WHERE `id` = $item_id AND `cart_id` = '$cart_id'");
			die_nice("SQL returned '$success' instead of '1' while updating item_quantity to '$qty'.") unless $success == 1;
		}
	}

	if($PREF{enable_promocodes} =~ /yes/i)
	{
		my $cart_already_has_promo_code = enc_sql_select("SELECT `promo_code` FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id'");
		my $newly_submitted_promocode = get_qs_var('promocode');

		if($cart_already_has_promo_code && !$newly_submitted_promocode) # if the visitor deleted the promo code that was already in their cart:
		{
			$newly_submitted_promocode = 'nonexistentpromocodetonullcodeincart';
		}

		update_cart_promo_prices($cart_id,$newly_submitted_promocode);
	}

	if($PREF{enable_flatrate_shipping} =~ /yes/i   &&   param('flatrate_shipping'))
	{
		my $sh_option = param('flatrate_shipping');
		if($PREF{"flatrate_shipping_option_${sh_option}_name"} && exists $PREF{"flatrate_shipping_option_${sh_option}_cost"}) # use "exists" on the cost in case it's zero.
		{
			my $sh_name = $PREF{"flatrate_shipping_option_${sh_option}_name"};
			my $sh_cost = $PREF{"flatrate_shipping_option_${sh_option}_cost"};

			my $new_sh_value = qq`Name: $sh_name; Cost: $sh_cost; Option: $sh_option`;

			sql_untaint($new_sh_value);
			die_unless_sqlsafe($new_sh_value);
			unless($new_sh_value eq enc_sql_select("SELECT `flatrate_shipping` FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id'"))
			{
				enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `flatrate_shipping` = '$new_sh_value' WHERE `cart_id` = '$cart_id'")
			}
		}
	}

	enc_redirect($PREF{here_cart});
}


sub update_cart_promo_prices()
{
	my $cart_id = shift;
	my $promocode = shift;

	check_cart_id_for_sql_safeness($cart_id);
	sql_untaint($promocode); die_unless_sqlsafe($promocode);

	my $cart_contents = enc_sql_select_multi("SELECT * FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND IFNULL(`deleted_from_cart`,0) != 1");
	$promocode ||= enc_sql_select("SELECT `promo_code` FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND IFNULL(`deleted_from_cart`,0) != 1");

	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{promocode_table}` WHERE `promo_code` = '$promocode' AND `active` = 1"))
	{
		my ($type,$value,$description) = enc_sql_select("SELECT `type`,`value`,`description` FROM `$PREF{promocode_table}` WHERE `promo_code` = '$promocode' AND `active` = 1");
		my $invalid = 0;
		my %promo_price = ();

		if($type eq 'Percentage Discount'   &&   $value =~ /(\d+(\.\d+)?)/)
		{
			my $raw_value = $1 / 100;
			foreach my $j (sort keys %$cart_contents)
			{
				$promo_price{$j} = normalize_price($$cart_contents{$j}{item_price} - ($$cart_contents{$j}{item_price} * $raw_value));
			}
		}
		elsif($type eq 'Flat Discount'   &&   $value =~ /(\d+(\.\d+)?)/)
		{
			my $raw_value = $1;
			if(my $numitems = scalar keys %$cart_contents)
			{
				my $num_passes = 0;
				while($raw_value && $num_passes < 10)
				{
					my $still_need_to_subtr = 0;
					my $amt_to_subtr_from_each_item = $raw_value / $numitems;
					foreach my $j (sort keys %$cart_contents)
					{
						my $qty = $$cart_contents{$j}{item_quantity} || 1;
						my $amt_to_subtr = $amt_to_subtr_from_each_item / $qty;
						my $starting_price = $promo_price{$j} || $$cart_contents{$j}{item_price};
						if($starting_price > $amt_to_subtr   &&   ($starting_price - $amt_to_subtr > 0))
						{
							$promo_price{$j} = $starting_price - $amt_to_subtr;
						}
						else
						{
							$promo_price{$j} = $starting_price;
							$still_need_to_subtr += $amt_to_subtr;
						}
					}
					$raw_value = $still_need_to_subtr;
					$num_passes++;
				}

				foreach my $j (sort keys %$cart_contents)
				{
					$promo_price{$j} = normalize_price($promo_price{$j});
				}
			}
			else
			{
				$invalid = 1;
			}
		}
		else
		{
			$invalid = 1;
		}

		sql_untaint($value,$description); die_unless_sqlsafe($value,$description);

		foreach my $j (sort keys %$cart_contents)
		{
			sql_untaint($promo_price{$j}); die_unless_sqlsafe($promo_price{$j});
			my %updated_vars = (
				promo_code		=> $invalid ? '' : $promocode,
				promo_type		=> $invalid ? '' : $type,
				promo_value		=> $invalid ? '' : $value,
				promo_description	=> $invalid ? '' : $description,
				promo_price		=> $invalid ? '' : $promo_price{$j},
			);
			foreach my $var (keys %updated_vars)
			{
				unless($updated_vars{$var} eq $$cart_contents{$j}{$var})
				{
					my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `$var` = '$updated_vars{$var}' WHERE `id` = $$cart_contents{$j}{id} AND IFNULL(`deleted_from_cart`,0) != 1");
					die_nice("SQL returned '$success' instead of '1' while updating '$var'.") unless $success == 1;
				}
			}
		}
	}
	else
	{
		# Invalid promo code, so null it:

		foreach my $j (sort keys %$cart_contents)
		{
			my %updated_vars = (
				promo_code		=> '',
				promo_type		=> '',
				promo_value		=> '',
				promo_description	=> '',
				promo_price		=> '',
			);
			foreach my $var (keys %updated_vars)
			{
				unless($updated_vars{$var} eq $$cart_contents{$j}{$var})
				{
					my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `$var` = '$updated_vars{$var}' WHERE `id` = $$cart_contents{$j}{id} AND IFNULL(`deleted_from_cart`,0) != 1");
					die_nice("SQL returned '$success' instead of '1' while updating '$var'.") unless $success == 1;
				}
			}
		}
	}
}


sub show_my_cart
{
	$PREF{on_page} = 'cart';
	$PREF{hide_app_pagetitle_on_this_page} = $PREF{hide_app_pagetitle_on_cart_page};
	start_html_output($PREF{cart_page_title});

	my $paypal_hidden_itemlist = '';
	my $google_hidden_itemlist = '';

	my $visible_itemlist = '';
	my $grandtotal = my $grandtotal_promo = 0;

	my $cart_id = get_cookie($PREF{cart_id_cookie}) || generate_new_cart_id();
	$cart_id = generate_new_cart_id() while(cart_already_sold($cart_id));
	check_cart_id_for_sql_safeness($cart_id);

	my $promocodes_enabled = $PREF{enable_promocodes} =~ /yes/i && enc_sql_select("SELECT COUNT(*) FROM `$PREF{promocode_table}` WHERE `active` = 1");
	my $noshipping_enabled = $PREF{enable_noshipping_option} =~ /yes/i;

	# 
	# https://www.paypal.com/IntegrationCenter/ic_standard_home.html#individual
	# https://www.paypal.com/IntegrationCenter/ic_std-variable-reference.html
	# 

	my ($range_start,$range_end) = get_pagination_range($PREF{items_per_page_on_cart});

	my ($i,$current_item) = (0,0);
	my $cart_is_empty = !enc_sql_select("SELECT COUNT(*) FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND IFNULL(`deleted_from_cart`,0) != 1");
	my $cart_contents = enc_sql_select_multi("SELECT * FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND IFNULL(`deleted_from_cart`,0) != 1");
	my $promocode_active = 1 if $$cart_contents{1}{promo_code} && $promocodes_enabled;
	foreach my $j (sort keys %$cart_contents)
	{
		my $itemnumber = $$cart_contents{$j}{item_code};
		my $qty = $$cart_contents{$j}{item_quantity};
		$qty =~ s!\.0+$!! unless $PREF{leave_trailing_zeros_on_quantities} =~ /yes/i;

		# In some situations and some kinds of stores, we might want to require all customers to
		# register & login to UserBase before checking out & making their payment.  In those cases
		# we would want to be able to check the ub_user_id field in the saleslog (which comes from
		# the cart table).  But if the customer added an item to his cart before logging in, then
		# that item has a ub_user_id of zero, and it will stay zero even if he does log in before
		# checking out.  So we'll manually check & update the ub_user_id on each cart item here.
		# Also note that we do this before any range checking, because we don't care which page of
		# a user's cart he's currently viewing; if we have a logged-in user, we want all his cart
		# items to get a proper ub_user_id.
		#
		if($PREF{member_is_logged_in}   &&   ($$cart_contents{$j}{ub_user_id} == 0)   &&   $$cart_contents{$j}{id}) # somehow, $$cart_contents{$j}{id} is sometimes null??
		{
			my $success = enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `ub_user_id` = $PREF{logged_in_userid} WHERE `id` = $$cart_contents{$j}{id}");
			die_nice("SQL returned '$success' instead of '1' while updating 'ub_user_id'.") unless $success == 1;
		}

		$i++;
		next unless $range_start <= $i && $i <= $range_end;
		$current_item++;

		#my $itemname = $PREF{items}{$itemnumber}{name};
		#my $itemdesc = $PREF{items}{$itemnumber}{description};
		#my $itemprice = $PREF{items}{$itemnumber}{price};

		my $itemname = $$cart_contents{$j}{item_name};
		my $itemdesc = $$cart_contents{$j}{item_description};
		my $itemopts = $$cart_contents{$j}{item_options};
		my $itemprice = $$cart_contents{$j}{item_price};
		my $promoprice = $promocode_active ? ($$cart_contents{$j}{promo_price} || $itemprice) : $itemprice;

		my $paypal_hidden_itemlist_template	= ($PREF{paypal_form_and_checkout_button} =~ /%%%template:paypal_hidden_itemlist%%%(.+?)%%%end-template:paypal_hidden_itemlist%%%/s)[0];
		$paypal_hidden_itemlist_template	=~ s!%%i%%!$current_item!g;
		$paypal_hidden_itemlist_template	=~ s!%%item_id%%!$$cart_contents{$j}{id}!g; # this is the db id.
		$paypal_hidden_itemlist_template	=~ s!%%itemname%%!$itemname!g;
		$paypal_hidden_itemlist_template	=~ s!%%itemnumber%%!$itemnumber!g;
		$paypal_hidden_itemlist_template	=~ s!%%itemdesc%%!$itemdesc!g;
		$paypal_hidden_itemlist_template	=~ s!%%itemdescorname%%!$itemdesc||$itemname!eg;
		$paypal_hidden_itemlist_template	=~ s!%%itemnameordesc%%!$itemname||$itemdesc!eg;
		$paypal_hidden_itemlist_template	=~ s!%%itemprice%%!$promoprice!g;
		$paypal_hidden_itemlist_template	=~ s!%%itemopts%%!$itemopts!g;
		$paypal_hidden_itemlist_template	=~ s!%%%if-itemopts%%%(.*?)%%%end-itemopts%%%!$itemopts ? $1 : ''!eg;
		$paypal_hidden_itemlist_template	=~ s!%%qty%%!$qty!g;
		$paypal_hidden_itemlist_template	=~ s!%%[^%]+%%!!g; # remove anything left over.
		$paypal_hidden_itemlist			.= $paypal_hidden_itemlist_template;

		my $google_hidden_itemlist_template	= $PREF{google_hidden_itemlist_template};
		$google_hidden_itemlist_template	=~ s!%%i%%!$current_item!g;
		$google_hidden_itemlist_template	=~ s!%%itemname%%!$itemname!g;
		$google_hidden_itemlist_template	=~ s!%%itemnumber%%!$itemnumber!g;
		$google_hidden_itemlist_template	=~ s!%%itemdesc%%!$itemdesc!g;
		$google_hidden_itemlist_template	=~ s!%%itemprice%%!$promoprice!g;
		$google_hidden_itemlist_template	=~ s!%%qty%%!$qty!g;
		$google_hidden_itemlist_template	=~ s!%%[^%]+%%!!g; # remove anything left over.
		$google_hidden_itemlist			.= $google_hidden_itemlist_template;

		my $rowclass = ($current_item % 2) == 0 ? 'even' : 'odd';
		$rowclass .= ' first' if $current_item == 1;

		my $visible_itemlist_template	= $PREF{visible_itemlist_template};
		$visible_itemlist_template	=~ s!%%quantity%%!$qty!g;
		$visible_itemlist_template	=~ s/%%totalprice%%/normalize_price($promoprice * $qty)/eg;
		$visible_itemlist_template	=~ s/%%item_id%%/$$cart_contents{$j}{id}/g; # this is the db id.
		$visible_itemlist_template	=~ s/%%itemnumber%%/$itemnumber/g;
		$visible_itemlist_template	=~ s/%%itemname%%/$itemname/g;
		$visible_itemlist_template	=~ s/%%itemdesc%%/$itemdesc/g;
		$visible_itemlist_template	=~ s/%%itemdescorname%%/$itemdesc||$itemname/eg;
		$visible_itemlist_template	=~ s/%%itemnameordesc%%/$itemname||$itemdesc/eg;
		$visible_itemlist_template	=~ s!%%itemprice%%!$promoprice eq $itemprice ? $itemprice : "<s>$itemprice</s>"!eg;
		$visible_itemlist_template	=~ s/%%promoprice%%/$promoprice/g;
		$visible_itemlist_template	=~ s/%%itemopts%%/$itemopts/g;
		$visible_itemlist_template	=~ s/%%%if-itemopts%%%(.*?)%%%end-itemopts%%%/$itemopts ? $1 : ''/eg;
		$visible_itemlist_template	=~ s/%%%if-promocode_active%%%(.*?)%%%end-promocode_active%%%/$promocode_active ? $1 : ''/eg;
		$visible_itemlist_template	=~ s/%%rowclass%%/$rowclass/g;
		$visible_itemlist_template	=~ s/%%extraclasses%%/storeitem-first/g if $i == $range_start;
		$visible_itemlist_template	=~ s/%%extraclasses%%/storeitem-last/g if $i == $range_end;
		$visible_itemlist_template	=~ s/%%[^%]+%%//g; # remove anything left over.
		$visible_itemlist		.= $visible_itemlist_template;

		$grandtotal += normalize_price($itemprice * $qty);
		$grandtotal_promo += normalize_price($promoprice * $qty);
	}

	my $enable_flatrate_shipping = 0;
	if($PREF{enable_flatrate_shipping} =~ /yes/i)
	{
		$enable_flatrate_shipping = 1;

		my ($sh_name,$sh_cost,$sh_option) = ();
		if($$cart_contents{1}{flatrate_shipping} =~ m!Name: (.+); Cost: \D?(\d+(?:\.\d+)?); Option: (\d+)$!i)
		{
			($sh_name,$sh_cost,$sh_option) = ($1,$2,$3);
		}
		else
		{
			my $default = $PREF{default_flatrate_shipping_option};
			if($PREF{"flatrate_shipping_option_${default}_name"} && exists $PREF{"flatrate_shipping_option_${default}_cost"}) # use "exists" on the cost in case it's zero.
			{
				$sh_name = $PREF{"flatrate_shipping_option_${default}_name"};
				$sh_cost = $PREF{"flatrate_shipping_option_${default}_cost"};
				$sh_option = $default;
			}
		}

		#normalize_price($sh_cost);
		$sh_cost =~ s!^\D+!!; # remove any currency symbol.
		$grandtotal += $sh_cost;
		$grandtotal_promo += $sh_cost;

		s/%%flatrate_shipping_cost%%/$PREF{currency_symbol_for_shopping_cart}$sh_cost/g for ($PREF{cart_page});
		s/%%flatrate_shipping_cost%%/$sh_cost/g for ($PREF{paypal_form_and_checkout_button},$PREF{google_form_and_checkout_button});

		my $flatrate_shipping_options = '';
		foreach my $pref (sort keys %PREF)
		{
			if($pref =~ /^flatrate_shipping_option_(\d+)_name$/)
			{
				my $option = $1;
				my $name = $PREF{$pref};
				my $cost = $PREF{"flatrate_shipping_option_${option}_cost"};
				$flatrate_shipping_options .= qq`<option value="$option" ` . ($option eq $sh_option ? 'selected="selected"' : '') . qq`>$name</option>`;
			}
		}

		$PREF{cart_page} =~ s/%%flatrate_shipping_options%%/$flatrate_shipping_options/g;
	}

	$grandtotal = normalize_price($grandtotal);
	$grandtotal_promo = normalize_price($grandtotal_promo);

	if($cart_is_empty)
	{
		$visible_itemlist = $PREF{visible_itemlist_template__emptycart};
	}

	$PREF{paypal_form_and_checkout_button} =~ s!%%cart_id%%!$cart_id!g;
	do_standard_template_conditionals_processing($PREF{paypal_form_and_checkout_button});

	$PREF{cart_page} =~ s/%%paypal_form_and_checkout_button%%/$PREF{paypal_form_and_checkout_button}/;
	$PREF{cart_page} =~ s/%%%template:paypal_hidden_itemlist%%%(.+?)%%%end-template:paypal_hidden_itemlist%%%/$paypal_hidden_itemlist/s;
	$PREF{cart_page} =~ s/%%%if-promocodes_enabled%%%(.*?)%%%end-promocodes_enabled%%%/$promocodes_enabled ? $1 : ''/egs;
	$PREF{cart_page} =~ s/%%%if-enable_flatrate_shipping%%%(.*?)%%%end-enable_flatrate_shipping%%%/$enable_flatrate_shipping ? $1 : ''/egs;
	$PREF{cart_page} =~ s/%%%if-promocode_active%%%(.*?)%%%end-promocode_active%%%/$promocode_active ? $1 : ''/egs;
	$PREF{cart_page} =~ s/%%promocode%%/$$cart_contents{1}{promo_code}/g;
	$PREF{cart_page} =~ s/%%paypal_checkout_button_text%%/$PREF{enable_google_checkout} eq 'yes' ? $PREF{paypal_checkout_button_text_when_google_checkout_enabled} : $PREF{paypal_checkout_button_text}/eg;

	$PREF{cart_page} =~ s/%%%if-allow_noshipping_option%%%(.*?)%%%end-allow_noshipping_option%%%/$noshipping_enabled ? $1 : ''/egs;

	unless($PREF{enable_google_checkout} =~ /yes/i) { $PREF{google_form_and_checkout_button} = $google_hidden_itemlist = ''; }
	$PREF{cart_page} =~ s/%%google_form_and_checkout_button%%/$PREF{google_form_and_checkout_button}/;
	$PREF{cart_page} =~ s/%%google_hidden_itemlist%%/$google_hidden_itemlist/;

	$PREF{cart_page} =~ s!%%visible_itemlist%%!$visible_itemlist!;
	$PREF{cart_page} =~ s!%%grandtotal%%!$grandtotal_promo eq $grandtotal ? $PREF{currency_symbol_for_shopping_cart}.$grandtotal : "<s>$PREF{currency_symbol_for_shopping_cart}$grandtotal</s> $PREF{currency_symbol_for_shopping_cart}$grandtotal_promo"!eg;
	$PREF{cart_page} =~ s!%%pagination_links%%!get_pagination_links_mark2( { range_start => $range_start, range_end => $range_end, num_items => $i, items_per_page => $PREF{items_per_page_on_cart}, hide_opts_links => 1, hide_when_single_page => 1 } )!eg;
	$PREF{cart_page} =~ s!%%itemname_plural%%!items!g;
	print $PREF{cart_page};

	finish_html_output();
}


sub normalize_price
{
	my $price = shift;

	if($price !~ /\./)	{ $price .= '.00';	}
	elsif($price =~ /\.$/)	{ $price .= '00';	}
	elsif($price =~ /\.\d$/){ $price .= '0';	}

	if($price !~ /^\d+\./)	{ $price = '0' . $price;}

	$price =~ s/^.*?(\d+\.\d\d).*/$1/;

	return $price;
}


sub create_database_tables
{
	create_raw_paypal_data_table_if_DNE();
	create_shopping_carts_table_if_DNE();
	create_saleslog_table_if_DNE();
	create_promocode_table_if_DNE();
	create_item_table_if_DNE();
	create_category_table_if_DNE();
}


sub create_raw_paypal_data_table_if_DNE
{
	return if db_table_exists($PREF{raw_paypal_data_table});

	enc_warn "$0: table $PREF{raw_paypal_data_table} does not exist; attempting to create it now.\n";

	# note: timestamp is the epoch-time in seconds; date is date17 (YYYYMMDD-HH:MM:SS).
	my $statement =	  "CREATE TABLE `$PREF{raw_paypal_data_table}` ("
			. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
			. " `timestamp` BIGINT UNSIGNED NOT NULL, "
			. " `date` VARCHAR(17) NOT NULL, "
			. " `txn_id` VARCHAR(50) NOT NULL, "
			. " `status` TEXT NOT NULL, "
			. " `raw_ipn_data` TEXT NOT NULL "
			. ")";
	my $sth = $PREF{dbh}->prepare($statement);
	$sth->execute() or die_nice("couldn't create table '$PREF{raw_paypal_data_table}': $DBI::errstr\n");

	enc_warn "$0: created table '$PREF{raw_paypal_data_table}' successfully.\n";
}


sub create_shopping_carts_table_if_DNE
{
	my $table = $PREF{shopping_carts_table};
	if(!db_table_exists($table))
	{
		enc_warn "table '$table' does not exist; attempting to create it now.\n";

		# note: timestamp is the epoch-time in seconds; date is date17 (YYYYMMDD-HH:MM:SS).
		#
		# flatrate_shipping is for when you want to display a cart-wide flat-rate shipping
		# option on the cart page, for example a drop-down with options like "Ground: $10",
		# "2-Day: $20", "Overnight: $40", etc.
		#
		# deleted_from_cart is necessary, as opposed to actually deleting the record from
		# the table outright, because after a sale occurs, we pull data from the cart table
		# to update the saleslog table; so if the buyer were to return after the sale and
		# delete items from his cart, it could prevent/mess up our sale logging.
		#
		my $statement =	  "CREATE TABLE `$table` ("
				. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
				. " `timestamp_added` BIGINT UNSIGNED NOT NULL, "
				. " `date_added` VARCHAR(17) NOT NULL, "
				. " `cart_id` VARCHAR(50) NOT NULL, "
				. " `sold` TINYINT(1) UNSIGNED, "
				. " `deleted_from_cart` TINYINT(1) UNSIGNED, "
				. " `ub_user_id` BIGINT UNSIGNED NOT NULL, "
				. " `item_name` VARCHAR(255) NOT NULL, "
				. " `item_code` VARCHAR(30), "
				. " `item_description` TEXT, "
				. " `item_options` TEXT, "
				. " `item_quantity` DECIMAL(10,2) NOT NULL, "
				. " `item_price` DECIMAL(10,2) NOT NULL, "
				. " `promo_code` VARCHAR(50), "
				. " `promo_type` VARCHAR(50), "
				. " `promo_value` VARCHAR(10), "
				. " `promo_description` TEXT, "
				. " `promo_price` DECIMAL(10,2), "
				. " `flatrate_shipping` VARCHAR(255), "
				. " `ip_address` VARCHAR(40) NOT NULL, "
				. " `hostname` VARCHAR(255) NOT NULL, "
				. " `browser` VARCHAR(255) NOT NULL "
				. ")";
		my $sth = $PREF{dbh}->prepare($statement);
		$sth->execute() or die_nice("couldn't create table '$table': $DBI::errstr\n");

		enc_warn "created table '$table' successfully.\n";
	}

	if( ! db_column_exists('flatrate_shipping', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `flatrate_shipping` VARCHAR(255) AFTER `promo_price`;");
		$sth->execute() or die_nice "could not add 'flatrate_shipping' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'flatrate_shipping' to table '$table'.";
	}
	if( ! db_column_exists('deleted_from_cart', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `deleted_from_cart` TINYINT(1) UNSIGNED AFTER `sold`;");
		$sth->execute() or die_nice "could not add 'deleted_from_cart' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'deleted_from_cart' to table '$table'.";
	}
}


sub create_saleslog_table_if_DNE
{
	my $table = $PREF{saleslog_table};
	if(!db_table_exists($table))
	{
		enc_warn "table '$table' does not exist; attempting to create it now.\n";

		# note: timestamp is the epoch-time in seconds; date is date17 (YYYYMMDD-HH:MM:SS).
		my $statement =	  "CREATE TABLE `$table` ("
				. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
				. " `server_timestamp` BIGINT UNSIGNED NOT NULL, "
				. " `paypal_timestamp` BIGINT UNSIGNED NOT NULL, "
				. " `server_date` VARCHAR(17) NOT NULL, "
				. " `paypal_date` VARCHAR(17) NOT NULL, "

				. " `order_number` BIGINT UNSIGNED NOT NULL, "
				. " `item_number_within_order` BIGINT UNSIGNED NOT NULL, "
				. " `total_items` BIGINT UNSIGNED NOT NULL, "

				. " `payment_type` VARCHAR(50), "
				. " `payment_status` VARCHAR(50), "

				. " `paypal_data_status` TEXT NOT NULL, "
				. " `item_integrity` TEXT NOT NULL, "
				. " `our_status` VARCHAR(255), "
				. " `our_notes_internal` TEXT, "
				. " `our_notes_for_buyer` TEXT, "
				. " `note_from_buyer` TEXT, "

				. " `cart_id` VARCHAR(50) NOT NULL, "
				. " `transaction_id` VARCHAR(50) NOT NULL, "
				. " `receipt_id` VARCHAR(50) NOT NULL, "
				. " `proof_of_purchase` VARCHAR(50) NOT NULL, "
				. " `ub_user_id` BIGINT UNSIGNED NOT NULL, "

				. " `item_name` VARCHAR(255) NOT NULL, "
				. " `item_code` VARCHAR(30), "
				. " `item_description` TEXT, "
				. " `item_options` TEXT, "
				. " `item_price` DECIMAL(10,2) NOT NULL, "

				. " `promo_price` DECIMAL(10,2), "
				. " `promo_code` VARCHAR(50), "
				. " `promo_type` VARCHAR(50), "
				. " `promo_value` VARCHAR(10), "
				. " `promo_description` TEXT, "

				. " `quantity_sold` DECIMAL(10,2) NOT NULL, "
				. " `item_subtotal` DECIMAL(10,2) NOT NULL, "
				. " `item_tax` DECIMAL(10,2), "
				. " `item_shipping` DECIMAL(10,2), "
				. " `item_handling` DECIMAL(10,2), "

				. " `total_tax` DECIMAL(10,2), "
				. " `flatrate_shipping` VARCHAR(255), "
				. " `total_shipping` DECIMAL(10,2), "
				. " `total_handling` DECIMAL(10,2), "
				. " `total_fee` DECIMAL(10,2), "
				. " `total_sale` DECIMAL(10,2) NOT NULL, "
				. " `transaction_currency` VARCHAR(30), "

				. " `buyer_id` VARCHAR(50), "
				. " `buyer_firstname` VARCHAR(255) NOT NULL, "
				. " `buyer_lastname` VARCHAR(255) NOT NULL, "
				. " `buyer_email` VARCHAR(255) NOT NULL, "
				. " `buyer_address1` VARCHAR(255), "
				. " `buyer_address2` VARCHAR(255), "
				. " `buyer_city` VARCHAR(255), "
				. " `buyer_state` VARCHAR(255), "
				. " `buyer_zip` VARCHAR(15), "
				. " `buyer_country` VARCHAR(255), "
				. " `buyer_countrycode` VARCHAR(2), "
				. " `buyer_status` VARCHAR(20), "
				. " `buyer_address_status` VARCHAR(20), "
				. " `buyer_ip_address` VARCHAR(40) NOT NULL, "
				. " `buyer_hostname` VARCHAR(255) NOT NULL, "
				. " `buyer_browser` VARCHAR(255) NOT NULL "
				. ")";
		my $sth = $PREF{dbh}->prepare($statement);
		$sth->execute() or die_nice("couldn't create table '$table': $DBI::errstr\n");

		enc_warn "created table '$table' successfully.\n";
	}

	if( ! db_column_exists('flatrate_shipping', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `flatrate_shipping` VARCHAR(255) AFTER `total_tax`;");
		$sth->execute() or die_nice "could not add 'flatrate_shipping' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'flatrate_shipping' to table '$table'.";
	}
	if( ! db_column_exists('proof_of_purchase', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `proof_of_purchase` VARCHAR(50) AFTER `receipt_id`;");
		$sth->execute() or die_nice "could not add 'proof_of_purchase' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'proof_of_purchase' to table '$table'.";
	}
}


sub create_promocode_table_if_DNE
{
	my $table = $PREF{promocode_table};
	unless(db_table_exists($table))
	{
		enc_warn "table $table does not exist; attempting to create it now.\n";

		# note: timestamp is the epoch-time in seconds; date is date17 (YYYYMMDD-HH:MM:SS).
		my $statement =	  "CREATE TABLE `$table` ("
				. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
				. " `timestamp_created` BIGINT UNSIGNED NOT NULL, "
				. " `promo_code` VARCHAR(50), "
				. " `active` TINYINT(1) UNSIGNED, "
				. " `type` VARCHAR(50), "
				. " `value` VARCHAR(10), "
				. " `description` TEXT "
				. ")";
		my $sth = $PREF{dbh}->prepare($statement);
		$sth->execute() or die_nice("couldn't create table '$table': $DBI::errstr\n");

		enc_warn "created table '$table' successfully.\n";
	}
}


sub create_item_table_if_DNE
{
	my $table = $PREF{item_table};
	unless(db_table_exists($table))
	{
		enc_warn "table $table does not exist; attempting to create it now.\n";

		# note: timestamp is the epoch-time in seconds; date is date17 (YYYYMMDD-HH:MM:SS).
		my $statement =	  "CREATE TABLE `$table` ("
				. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
				. " `date_created` VARCHAR(17) NOT NULL, "
				. " `timestamp_created` BIGINT UNSIGNED NOT NULL, "
				. " `code` VARCHAR(30) NOT NULL, "
				. " `name` VARCHAR(255) NOT NULL, "
				. " `price` DECIMAL(10,2) NOT NULL, "
				. " `description` TEXT NOT NULL, "
				. " `long_description` TEXT NOT NULL, "
				. " `active` TINYINT(1) UNSIGNED NOT NULL, "
				. " `category` INT UNSIGNED NOT NULL, "
				. " `position` INT UNSIGNED NOT NULL DEFAULT 100, " # start it high enough so people can easily insert earlier items if they want.
				. " `images` TEXT NOT NULL, "
				. " `builtin_quantity` INT UNSIGNED NOT NULL DEFAULT 1, "
				. " `deliverable_file_with_path` VARCHAR(255) NOT NULL "
				. ")";
		my $sth = $PREF{dbh}->prepare($statement);
		$sth->execute() or die_nice("couldn't create table '$table': $DBI::errstr\n");

		enc_warn "created table '$table' successfully.\n";
	}
	if( ! db_column_exists('builtin_quantity', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `builtin_quantity` INT UNSIGNED NOT NULL DEFAULT 1 AFTER `long_description`;");
		$sth->execute() or die_nice "could not add 'builtin_quantity' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'builtin_quantity' to table '$table'.";
	}
	if( ! db_column_exists('position', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `position` INT UNSIGNED NOT NULL DEFAULT 100 AFTER `category`;");
		$sth->execute() or die_nice "could not add 'position' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'position' to table '$table'.";
	}
	if( ! db_column_exists('images', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `images` TEXT NOT NULL AFTER `long_description`;");
		$sth->execute() or die_nice "could not add 'images' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'images' to table '$table'.";
	}
	if( ! db_column_exists('category', $table) )
	{
		my $sth = $PREF{dbh}->prepare("ALTER TABLE `$table` ADD `category` INT UNSIGNED NOT NULL AFTER `active`;");
		$sth->execute() or die_nice "could not add 'category' column to table '$table': $DBI::errstr\n";
		enc_warn "added column 'category' to table '$table'.";
	}
}


sub create_category_table_if_DNE
{
	my $table = $PREF{category_table};
	unless(db_table_exists($table))
	{
		enc_warn "table $table does not exist; attempting to create it now.\n";

		my $statement =	  "CREATE TABLE `$table` ("
				. " `id` BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY, "
				. " `name` VARCHAR(255) NOT NULL, "
				. " `parent_category` INT UNSIGNED NOT NULL, "
				. " `position` INT UNSIGNED NOT NULL "
				. ")";
		my $sth = $PREF{dbh}->prepare($statement);
		$sth->execute() or die_nice("couldn't create table '$table': $DBI::errstr\n");

		enc_warn "created table '$table' successfully.\n";
	}
}


sub get_reasonable_dates_from_paypal_date_string($)
{
	my $paypal_raw_date = shift;

	# Put the PayPal date into reasonable formats (etime and YYYYMMDD-HHMMSS):
	#
	# 	date comes from PayPal as:
	#	payment_date=12:10:51 Oct 03, 2007 PDT
	#	payment_date=23:58:48 Feb 06, 2008 PST 
	#
	my($hour,$min,$sec,$month,$day,$year) = ($paypal_raw_date =~ /(\d\d):(\d\d):(\d\d)\s*(\w+)\s*(\d\d?),\s*(\d\d\d\d)/);
	$day = "0$day" if length($day) == 1;
	my $monthnum = $PREF{monthnum}{lc($month)};
	my $paypal_date_error .= qq`Warning: invalid monthnum "$monthnum" from PayPal date string "$paypal_raw_date"; the PayPal date will likely be incorrect. \n` unless $monthnum =~ /^\d+$/;
	my $paypal_timestamp = eval { return timelocal($sec,$min,$hour,$day,($monthnum - 1),$year); };
	$paypal_timestamp = 0 unless $paypal_timestamp =~ /^\d+$/;
	$paypal_date_error .= qq`Warning: invalid timestamp "$paypal_timestamp" from PayPal date string "$paypal_raw_date". \n` unless $paypal_timestamp;
	my $paypal_date = $paypal_timestamp ? strftime("%Y%m%d-%H:%M:%S",localtime($paypal_timestamp)) : '00000000-00:00:00';

	return ($paypal_timestamp, $paypal_date, $paypal_date_error);
}


sub add_salelog_data_to_hashes($$)
{
	my ($enccart_txn_vars,$ipn_vars) = @_; # hashrefs.


	die_unless_numeric($$enccart_txn_vars{server_timestamp}, 'server_timestamp');
	die_unless_numeric($$enccart_txn_vars{paypal_timestamp}, 'paypal_timestamp');
	sql_untaint($$enccart_txn_vars{server_date}); die_unless_sqlsafe($$enccart_txn_vars{server_date});
	sql_untaint($$enccart_txn_vars{paypal_date}); die_unless_sqlsafe($$enccart_txn_vars{paypal_date});


	$$enccart_txn_vars{paypal_data_status} = $$enccart_txn_vars{validity_msg};
	sql_untaint($$enccart_txn_vars{paypal_data_status}); die_unless_sqlsafe($$enccart_txn_vars{paypal_data_status});
	sql_untaint($$ipn_vars{memo}); die_unless_sqlsafe($$ipn_vars{memo});


	check_cart_id_for_sql_safeness($$enccart_txn_vars{cart_id});
	sql_untaint($$enccart_txn_vars{txn_id}); die_unless_sqlsafe($$enccart_txn_vars{txn_id});
	sql_untaint($$ipn_vars{receipt_id}); die_unless_sqlsafe($$ipn_vars{receipt_id});
	$$enccart_txn_vars{ub_user_id} = enc_sql_select("SELECT `ub_user_id` FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$$enccart_txn_vars{cart_id}' LIMIT 1");
	die_unless_numeric($$enccart_txn_vars{ub_user_id}, 'ub_user_id');


	sql_untaint($$ipn_vars{tax});			die_unless_sqlsafe($$ipn_vars{tax});
	sql_untaint($$ipn_vars{mc_shipping});		die_unless_sqlsafe($$ipn_vars{mc_shipping});
	sql_untaint($$ipn_vars{mc_handling});		die_unless_sqlsafe($$ipn_vars{mc_handling});
	sql_untaint($$ipn_vars{mc_fee});		die_unless_sqlsafe($$ipn_vars{mc_fee});
	sql_untaint($$ipn_vars{mc_gross});		die_unless_sqlsafe($$ipn_vars{mc_gross});
	sql_untaint($$ipn_vars{mc_currency});		die_unless_sqlsafe($$ipn_vars{mc_currency});
	die_unless_numeric($$ipn_vars{num_cart_items}, '$$ipn_vars{num_cart_items}');


	sql_untaint($$ipn_vars{payment_type});		die_unless_sqlsafe($$ipn_vars{payment_type});
	sql_untaint($$ipn_vars{payment_status});	die_unless_sqlsafe($$ipn_vars{payment_status});


	sql_untaint($$ipn_vars{payer_id});		die_unless_sqlsafe($$ipn_vars{payer_id});
	sql_untaint($$ipn_vars{first_name});		die_unless_sqlsafe($$ipn_vars{first_name});
	sql_untaint($$ipn_vars{last_name});		die_unless_sqlsafe($$ipn_vars{last_name});
	sql_untaint($$ipn_vars{payer_email});		die_unless_sqlsafe($$ipn_vars{payer_email});
	sql_untaint($$ipn_vars{address_street});	die_unless_sqlsafe($$ipn_vars{address_street});
	sql_untaint($$ipn_vars{address_city});		die_unless_sqlsafe($$ipn_vars{address_city});
	sql_untaint($$ipn_vars{address_state});		die_unless_sqlsafe($$ipn_vars{address_state});
	sql_untaint($$ipn_vars{address_zip});		die_unless_sqlsafe($$ipn_vars{address_zip});
	sql_untaint($$ipn_vars{address_country});	die_unless_sqlsafe($$ipn_vars{address_country});
	sql_untaint($$ipn_vars{address_country_code});	die_unless_sqlsafe($$ipn_vars{address_country_code});
	sql_untaint($$ipn_vars{payer_status});		die_unless_sqlsafe($$ipn_vars{payer_status});
	sql_untaint($$ipn_vars{address_status});	die_unless_sqlsafe($$ipn_vars{address_status});


	$$enccart_txn_vars{order_number} = get_order_number($enccart_txn_vars,$ipn_vars);
	die_unless_numeric($$enccart_txn_vars{order_number}, '$$enccart_txn_vars{order_number}');


	$$enccart_txn_vars{our_status} = $PREF{initial_order_status};
	sql_untaint($$enccart_txn_vars{our_status});	die_unless_sqlsafe($$enccart_txn_vars{our_status});


	# Give each transaction a unique ID/token (a hash), to be included in
	# the email receipt that we send to the buyer, as a proof of purchase.
	#
	$$enccart_txn_vars{proof_of_purchase} = enc_hash(
		  $$enccart_txn_vars{cart_id}
		. $$enccart_txn_vars{txn_id}
		. $$ipn_vars{receipt_id}
		. $$ipn_vars{mc_gross}
		. $$ipn_vars{payer_email}
		. $$enccart_txn_vars{paypal_date}
	);
}


sub log_sale_data($$)
{
	my ($enccart_txn_vars,$ipn_vars) = @_; # hashrefs.
	my @inserted_ids = ();

	for(my $i=1; $i<=$$ipn_vars{num_cart_items}; $i++)
	{
		my $item_integrity = '';

		my $item_code		= $$ipn_vars{"item_number$i"};		sql_untaint($item_code);		die_unless_sqlsafe($item_code);
		my $item_tax		= $$ipn_vars{"tax$i"};			sql_untaint($item_tax);			die_unless_sqlsafe($item_tax);
		my $item_shipping	= $$ipn_vars{"mc_shipping$i"};		sql_untaint($item_shipping);		die_unless_sqlsafe($item_shipping);
		my $item_handling	= $$ipn_vars{"mc_handling$i"};		sql_untaint($item_handling);		die_unless_sqlsafe($item_handling);
		my $item_subtotal	= $$ipn_vars{"mc_gross_$i"};		sql_untaint($item_subtotal);		die_unless_sqlsafe($item_subtotal);

		my $quantity_sold 	= $$ipn_vars{"quantity$i"};		die_unless_numeric($quantity_sold, '$quantity_sold');
		my $item_price		= $item_subtotal / $quantity_sold;

		my $cart_item_db_id	= $$ipn_vars{"option_selection1_$i"};	die_unless_numeric($cart_item_db_id, '$cart_item_db_id');

		my $cart_id_in_cart = enc_sql_select("SELECT `cart_id` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		if($$enccart_txn_vars{cart_id} ne $cart_id_in_cart)
		{
			$item_integrity .= qq`Integrity error: the cart_id was '$cart_id_in_cart' in the shopping cart, but in the PayPal transaction data it was '$$enccart_txn_vars{cart_id}'.  `;
		}

		my $item_code_in_cart = enc_sql_select("SELECT `item_code` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		if($item_code ne $item_code_in_cart)
		{
			$item_integrity .= qq`Integrity error: the item code was '$item_code_in_cart' in the shopping cart, but in the PayPal transaction data it was '$item_code'.  `;
		}

		my $promocode_active = enc_sql_select("SELECT `promo_code` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		my $item_price_in_cart = enc_sql_select("SELECT `item_price` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		my $promo_price_in_cart = enc_sql_select("SELECT `promo_price` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		if($promocode_active)
		{
			if($item_price < $promo_price_in_cart)
			{
				$item_integrity .= qq`Integrity error: the price of item '$item_code' was '$promo_price_in_cart' (with promo applied) in the shopping cart, but the buyer only paid '$item_price' for it.  `;
			}
		}
		else
		{
			$promo_price_in_cart = ''; # because MySQL returns it as "0.00" when it's actually null.  # TODO: do we need this instead?: $foo = $foo eq '' ? qq`NULL` : qq`'$foo'`;
			if($item_price < $item_price_in_cart)
			{
				$item_integrity .= qq`Integrity error: the price of item '$item_code' was '$item_price_in_cart' in the shopping cart, but the buyer only paid '$item_price' for it.  `;
			}
		}

		my ($item_name,$item_description,$item_options,$ip,$host,$ua,$promo_code,$promo_type,$promo_value,$promo_description,$flatrate_shipping) = enc_sql_select("SELECT `item_name`,`item_description`,`item_options`,`ip_address`,`hostname`,`browser`,`promo_code`,`promo_type`,`promo_value`,`promo_description`,`flatrate_shipping` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id");
		sql_untaint($item_name,$item_description,$item_options,$ip,$host,$ua,$promo_code,$promo_type,$promo_value,$promo_description,$flatrate_shipping);
		die_unless_sqlsafe($item_name,$item_description,$item_options,$ip,$host,$ua,$promo_code,$promo_type,$promo_value,$promo_description,$flatrate_shipping);


		$item_integrity = 'Valid' unless $item_integrity;
		sql_untaint($item_integrity);
		die_unless_sqlsafe($item_integrity);


		if($item_integrity eq 'Valid')
		{
			# Set the "sold" bit on the item in the shopping carts table:
			#
			unless(my $already_set = enc_sql_select("SELECT `sold` FROM `$PREF{shopping_carts_table}` WHERE `id` = $cart_item_db_id"))
			{
				enc_sql_update("UPDATE `$PREF{shopping_carts_table}` SET `sold` = 1 WHERE `id` = $cart_item_db_id");
			}
		}


		# Log the item into the saleslog table:
		#
		enc_sql_insert("INSERT INTO `$PREF{saleslog_table}`
			(

				`server_timestamp`,
				`paypal_timestamp`,
				`server_date`,
				`paypal_date`,

				`paypal_data_status`,
				`item_integrity`,
				`our_status`,
				`our_notes_internal`,
				`our_notes_for_buyer`,
				`note_from_buyer`,

				`cart_id`,
				`transaction_id`,
				`receipt_id`,
				`proof_of_purchase`,
				`ub_user_id`,

				`item_name`,
				`item_code`,
				`item_description`,
				`item_options`,
				`item_price`,

				`promo_price`,
				`promo_code`,
				`promo_type`,
				`promo_value`,
				`promo_description`,

				`quantity_sold`,
				`item_subtotal`,
				`item_tax`,
				`item_shipping`,
				`item_handling`,

				`total_tax`,
				`flatrate_shipping`,
				`total_shipping`,
				`total_handling`,
				`total_fee`,
				`total_sale`,
				`transaction_currency`,

				`order_number`,
				`item_number_within_order`,
				`total_items`,

				`payment_type`,
				`payment_status`,

				`buyer_id`,
				`buyer_firstname`,
				`buyer_lastname`,
				`buyer_email`,
				`buyer_address1`,
				`buyer_address2`,
				`buyer_city`,
				`buyer_state`,
				`buyer_zip`,
				`buyer_country`,
				`buyer_countrycode`,
				`buyer_status`,
				`buyer_address_status`,
				`buyer_ip_address`,
				`buyer_hostname`,
				`buyer_browser`

			)
			VALUES
			(

				'$$enccart_txn_vars{server_timestamp}',
				'$$enccart_txn_vars{paypal_timestamp}',
				'$$enccart_txn_vars{server_date}',
				'$$enccart_txn_vars{paypal_date}',

				'$$enccart_txn_vars{paypal_data_status}',
				'$item_integrity',
				'$$enccart_txn_vars{our_status}',
				'',
				'',
				'$$ipn_vars{memo}',

				'$$enccart_txn_vars{cart_id}',
				'$$enccart_txn_vars{txn_id}',
				'$$ipn_vars{receipt_id}',
				'$$enccart_txn_vars{proof_of_purchase}',
				'$$enccart_txn_vars{ub_user_id}',

				'$item_name',
				'$item_code',
				'$item_description',
				'$item_options',
				'$item_price',

				'$promo_price_in_cart',
				'$promo_code',
				'$promo_type',
				'$promo_value',
				'$promo_description',

				'$quantity_sold',
				'$item_subtotal',
				'$item_tax',
				'$item_shipping',
				'$item_handling',

				'$$ipn_vars{tax}',
				'$flatrate_shipping',
				'$$ipn_vars{mc_shipping}',
				'$$ipn_vars{mc_handling}',
				'$$ipn_vars{mc_fee}',
				'$$ipn_vars{mc_gross}',
				'$$ipn_vars{mc_currency}',

				'$$enccart_txn_vars{order_number}',
				'$i',
				'$$ipn_vars{num_cart_items}',

				'$$ipn_vars{payment_type}',
				'$$ipn_vars{payment_status}',

				'$$ipn_vars{payer_id}',
				'$$ipn_vars{first_name}',
				'$$ipn_vars{last_name}',
				'$$ipn_vars{payer_email}',
				'$$ipn_vars{address_street}',
				'',
				'$$ipn_vars{address_city}',
				'$$ipn_vars{address_state}',
				'$$ipn_vars{address_zip}',
				'$$ipn_vars{address_country}',
				'$$ipn_vars{address_country_code}',
				'$$ipn_vars{payer_status}',
				'$$ipn_vars{address_status}',
				'$ip',
				'$host',
				'$ua'

			)
		");


# TODO: test this:
=item
		my $inserted_id = enc_sql_select("SELECT `id` FROM `$PREF{saleslog_table}`
			WHERE `server_timestamp` = '$$enccart_txn_vars{server_timestamp}'
			AND `paypal_timestamp` = '$$enccart_txn_vars{paypal_timestamp}'
			AND `order_number` = '$$enccart_txn_vars{order_number}'
			AND `transaction_id` = '$$enccart_txn_vars{txn_id}'
			AND `item_options` = '$item_options'
			AND `item_number_within_order` = '$i'
			LIMIT 1
		");
		push @inserted_ids, $inserted_id;
=cut


		if($PREF{create_new_folder_for_each_item_sold} =~ /yes/i)
		{
			unless(-d $PREF{directory_for_new_folders_for_items_sold}) { enc_warn qq`Error: directory \$PREF{directory_for_new_folders_for_items_sold} does not exist ("$PREF{directory_for_new_folders_for_items_sold}"); can't create new folder within it.`; next; }
			unless(-w $PREF{directory_for_new_folders_for_items_sold}) { enc_warn qq`Error: directory \$PREF{directory_for_new_folders_for_items_sold} is not writable ("$PREF{directory_for_new_folders_for_items_sold}"); can't create new folder within it.`; next; }

			my $dir = "$PREF{directory_for_new_folders_for_items_sold}/$PREF{name_template_for_new_folders_for_items_sold}";
			do_standard_template_vars_processing($dir);
			$dir =~ s!%%username%%!get_user_name($$enccart_txn_vars{ub_user_id})!eg;
			$dir =~ s!%%item_number_within_order%%!$i!g;
			$dir =~ s!%%(\w+)%%!exists $$enccart_txn_vars{$1} ? $$enccart_txn_vars{$1} : exists $$ipn_vars{$1} ? $$ipn_vars{$1} : ''!eg;

			create_dir_if_DNE($dir, $PREF{writable_dir_perms}, 'make_parents', 'ignore_errors');
		}


	}

	return @inserted_ids;
}


sub get_order_number($$)
{
	my ($enccart_txn_vars,$ipn_vars) = @_; # hashrefs.

	$PREF{add_this_amount_to_each_order_number} = 0 unless $PREF{add_this_amount_to_each_order_number} =~ /^\d+$/;
	my $ordernum = $PREF{order_number_template};
	$ordernum =~ s!%%transaction_serial_number%%!$$enccart_txn_vars{raw_sale_data_record_id}!g;
	$ordernum =~ s!%%(\w+)%%!exists $$enccart_txn_vars{$1} ? $$enccart_txn_vars{$1} : exists $$ipn_vars{$1} ? $$ipn_vars{$1} : ''!eg;
	$ordernum =~ s!\D!!g;
	$ordernum += $PREF{add_this_amount_to_each_order_number};
	$ordernum = 1 unless $ordernum =~ /^\d+$/; # a final sanity check.
	$ordernum++ while(enc_sql_select("SELECT COUNT(*) FROM `$PREF{saleslog_table}` WHERE `order_number` = '$ordernum'"));

	return $ordernum;
}


sub send_payment_notification_emails($$)
{
	my ($enccart_txn_vars,$ipn_vars) = @_; # hashrefs.

	foreach my $pref (sort keys %PREF)
	{
		if($pref =~ /^(payment_notification_email_\d+)_template$/)
		{
			my $email = $1;
			my $email_message	= $PREF{"${email}_template"};
			my $email_subject	= $PREF{"${email}_subject"};
			my $email_format	= $PREF{"${email}_format"};
			my $email_sender	= $PREF{"${email}_sender"};
			my $email_recipients	= $PREF{"${email}_recipients"};

			for($email_subject,$email_message)
			{
				s!%%%ifelse-transaction_is_valid%%%(.*?)%%%else%%%(.*?)%%%endelse-transaction_is_valid%%%!$$enccart_txn_vars{valid_txn} ? $1 : $2!egs;
				s!%%txn_error%%!$$enccart_txn_vars{validity_error}!g;

				s!%%%if-processing_error%%%(.*?)%%%end-processing_error%%%!$$enccart_txn_vars{txn_processing_error} ? $1 : ''!egs;
				s!%%processing_error%%!$$enccart_txn_vars{txn_processing_error}!g;

				s!%%payer_name%%!$$ipn_vars{first_name} $$ipn_vars{last_name}!g;
				s!%%payer_address%%!$$ipn_vars{address_street}, $$ipn_vars{address_city}, $$ipn_vars{address_state}, $$ipn_vars{address_zip}, $$ipn_vars{address_country}!g;
				s!%%payer_address_status%%!$$ipn_vars{address_status}!g;

				s!%%grand_total%%!$$ipn_vars{mc_gross}!g;
				s!%%currency%%!$$ipn_vars{mc_currency}!g;

				my ($item_template_placeholder,$item_template_default) = (/(%%%template:item%%%(.+?)%%%end-template:item%%%)/s);
				my $item_template_final = '';
				for(my $i=1; $i<=$$ipn_vars{num_cart_items}; $i++)
				{
					my $template = $item_template_default;
					$template =~ s!%%i%%!$i!g;
					$template =~ s!%%itemname%%!$$ipn_vars{"item_name$i"}!g;
					$template =~ s!%%itemnumber%%!$$ipn_vars{"item_number$i"}!g;
					$template =~ s!%%itemprice%%!$$ipn_vars{"mc_gross_$i"}/$$ipn_vars{"quantity$i"}!eg;
					$template =~ s!%%itemquantity%%!$$ipn_vars{"quantity$i"}!g;
					$template =~ s!%%currency%%!$$ipn_vars{"mc_currency"}!g;
					$item_template_final .= $template;
				}
				s!$item_template_placeholder!$item_template_final!gs;

				my $raw_data = $$enccart_txn_vars{raw_ipn_data};
				my $newline = $email_format =~ /html/i ? "<br />\n" : "\n";
				$raw_data =~ s!\n_SPTR_\n!$newline!g;
				s!%%raw_txn_data%%!$raw_data!g;

				s!%%(\w+)%%!exists $$enccart_txn_vars{$1} ? $$enccart_txn_vars{$1} : exists $$ipn_vars{$1} ? $$ipn_vars{$1} : ''!eg;
			}

			$email_sender = $$ipn_vars{payer_email} if $email_sender eq '%%payer_email%%';

			foreach my $recipient (split(/\s*,\s*/, $email_recipients))
			{
				$recipient = $$ipn_vars{payer_email} if $recipient eq '%%payer_email%%';
				next unless is_valid_email_address($recipient);
				send_email($recipient, $email_sender, $email_subject, $email_message, $email_format, '');
			}
		}
	}
}


sub resend_payment_notification_emails($)
{
	my $sale_id = shift;
	die_unless_numeric($sale_id, 'sale_id');
	my ($enccart_txn_vars,$ipn_vars) = get_raw_sale_data_hashes($sale_id);
	add_salelog_data_to_hashes($enccart_txn_vars, $ipn_vars);

	send_payment_notification_emails($enccart_txn_vars, $ipn_vars);
	exit_with_success("Payment notification email re-sent.");
}


sub relog_sale($)
{
	my $sale_id = shift;
	die_unless_numeric($sale_id, 'sale_id');
	my ($enccart_txn_vars,$ipn_vars) = get_raw_sale_data_hashes($sale_id);
	add_salelog_data_to_hashes($enccart_txn_vars, $ipn_vars);

	log_sale_data($enccart_txn_vars, $ipn_vars);
	exit_with_success("Reprocessed sale data.");
}


sub get_raw_sale_data_hashes($)
{
	my $sale_id = shift;
	die_unless_numeric($sale_id, 'sale_id');

	my %enccart_txn_vars = ();

	$enccart_txn_vars{raw_sale_data_record_id} = $sale_id;

	($enccart_txn_vars{txn_id},$enccart_txn_vars{raw_ipn_data},$enccart_txn_vars{validity_msg}) = enc_sql_select("SELECT `txn_id`,`raw_ipn_data`,`status` FROM `$PREF{raw_paypal_data_table}` WHERE `id` = $sale_id");

	if($enccart_txn_vars{validity_msg} =~ /^valid$/i)
	{
		$enccart_txn_vars{valid_txn} = 1;
	}
	else
	{
		$enccart_txn_vars{valid_txn} = 0;
		$enccart_txn_vars{validity_error} = $enccart_txn_vars{validity_msg};
	}

	$enccart_txn_vars{server_timestamp}	= offsettime();
	$enccart_txn_vars{server_date}		= strftime("%Y%m%d-%H:%M:%S",localtime($enccart_txn_vars{server_timestamp}));

	my %ipn_vars = ();
	foreach my $variable (split(/\n_SPTR_\n/, $enccart_txn_vars{raw_ipn_data}))
	{
		my ($name, $value) = split(/=/, $variable);
		$ipn_vars{$name} = $value;
	}

	($enccart_txn_vars{paypal_timestamp}, $enccart_txn_vars{paypal_date}, $enccart_txn_vars{paypal_date_error}) = get_reasonable_dates_from_paypal_date_string($ipn_vars{payment_date});
	$enccart_txn_vars{txn_processing_error} = $enccart_txn_vars{paypal_date_error};

	$enccart_txn_vars{cart_id} = ($ipn_vars{custom} =~ /cart_id:(\w+)/)[0];

	return(\%enccart_txn_vars, \%ipn_vars);
}


sub log_order_processing_debug_message
{
	my $msg = shift;
	my $caller = (caller 1)[3];
	$caller =~ s/^main:://;
	$msg = qq`$PREF{internal_appname}: process ID=$$ \n$caller(): $msg`;

	my $subject = "Store order processing debug message (PID=$$)";

	foreach my $to (split(/\s*,\s*/, $PREF{payment_notification_email_recipients}))
	{
		send_email($to, $PREF{app_email_address}, $subject, $msg, 'text/plain', '');
	}

	enc_warn "$subject - $msg";
}


sub log_order_processing_error
{
	my $msg = shift;
	my $payer_email = shift;
	my $caller = (caller 1)[3];
	$caller =~ s/^main:://;
	$msg = qq`$PREF{internal_appname}: $caller(): $msg` unless $msg =~ /^$PREF{internal_appname}: $caller(): /;

	my $subject = "Error during store order processing ($payer_email)";

	foreach my $to (split(/\s*,\s*/, $PREF{payment_notification_email_recipients}))
	{
		send_email($to, $PREF{app_email_address}, $subject, $msg, 'text/plain', '');
	}

	enc_warn "$subject - $msg";
}


sub log_order_processing_error_and_die
{
	my $msg = shift;
	my $payer_email = shift;
	my $caller = (caller 1)[3];
	$caller =~ s/^main:://;
	$msg = qq`$PREF{internal_appname}: $caller(): $msg` unless $msg =~ /^$PREF{internal_appname}: $caller(): /;

	my $subject = "Error during store order processing ($payer_email)";

	foreach my $to (split(/\s*,\s*/, $PREF{payment_notification_email_recipients}))
	{
		send_email($to, $PREF{app_email_address}, $subject, $msg, 'text/plain', '');
	}

	enc_warn "$subject - $msg";

	$msg =~ s!<!&lt;!g;
	$msg =~ s!>!&gt;!g;
	$msg =~ s!\n!<br />\n!g;
	exit_with_error "$subject - $msg";
}


sub show_promocodes()
{
	my $tableprefname	= 'promocode_table';
	my $viewerprefname	= 'promocode';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;



	$PREF{"${viewerprefname}_viewer_item_name"}					= 'promo code';

	$PREF{"${viewerprefname}_creation_autoset_columns"}{timestamp_created}		= qq`%%variable%% = offsettime();`;

	$PREF{"${viewerprefname}_viewer_hidden_columns"}				||= qq`id,timestamp_created,date_created`;
	$PREF{"${viewerprefname}_viewer_uneditable_columns"}				||= qq`timestamp_created`;

	$PREF{"${viewerprefname}_viewer_extra_columns"}{date_created}			= { position => 'default', value => '' };

	$PREF{"${viewerprefname}_viewer_value_transforms"}{date_created}		= qq`%%variable%% = strftime("%Y%m%d-%H:%M",localtime(%%timestamp_created%%));`;

	$PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{type}		= qq`Percentage Discount|||Flat Discount`;

	$PREF{"${viewerprefname}_viewer_column_is_toggle"}{active}			= 1;
	$PREF{"${viewerprefname}_viewer_unique_values"}{promo_code}			= 1;




	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub manage_items()
{
	my $tableprefname	= $PREF{item_table};
	my $viewerprefname	= 'item';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;



	$PREF{"${viewerprefname}_viewer_footer_note"}					||= qq`
	<p><em><strong>Code</strong> is the item number or SKU, something like ITEM0001.&nbsp;
	<strong>Name</strong> is a short item name, like Acme Waffle Iron.&nbsp;
	<strong>Categories</strong> can be <a href="$PREF{here_qsready}action=managecats">managed
	here</a>.</em></p>
	<p><em><strong>Description</strong> is an optional field; it should be relatively short.&nbsp;
	 In particular it must be less than 127 characters if it's included in the value of
	 the item_name_%%i%% input in your \$PREF{paypal_form_and_checkout_button} setting.&nbsp;
	 By contrast, <strong>Long Description</strong> can be as long as you like.</em></p>
	<p><em><strong>Built-in quantity</strong> (optional) is for multi-pack items.&nbsp; For
	 example, if you're selling software licenses and you want to create an item which is
	 a 10-license pack, you would set this to 10.&nbsp; If unspecified it defaults to 1.&nbsp;
	 This does NOT affect the price.</em></p>
	<p><em><strong>Deliverable file with path</strong> (optional) is used for
	 items which are digital downloads.&nbsp; To prevent unauthorized access to the file,
	 you should generally put it in a folder outside/above your DOCUMENT_ROOT (i.e. at
	 a path on your server which is impossible to access via a regular website URL).</em></p>
	`;


	$PREF{"${viewerprefname}_viewer_item_name"}					||= 'item';
	$PREF{"${viewerprefname}_viewer_title"}						||= 'Manage Items';

	$PREF{"${viewerprefname}_viewer_hidden_columns"}				||= 'id,timestamp_created';
	$PREF{"${viewerprefname}_viewer_uneditable_columns"}				||= 'timestamp_created,date_created';

	$PREF{"${viewerprefname}_input_notes_for_vertmode_col_header"}{code}		= qq`e.g. ITEM001`;
	$PREF{"${viewerprefname}_input_notes_for_vertmode_col_header"}{position}	= qq`for sorting`;
	$PREF{"${viewerprefname}_input_notes_for_vertmode_col_header"}{description}	= qq`a sentence or two`;
	$PREF{"${viewerprefname}_input_notes_for_vertmode_col_header"}{long_description}= qq`<br />as long as you wish`;

	$PREF{"${viewerprefname}_viewer_title_transforms"}{builtin_quantity}		= 'Built-in quantity';

	$PREF{"${viewerprefname}_creation_autoset_columns"}{timestamp_created}		= qq`preset:etime`;
	$PREF{"${viewerprefname}_creation_autoset_columns"}{date_created}		= qq`preset:date17`;

	$PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{category}		= get_all_categories('catmanager_dropdown');
	$PREF{"${viewerprefname}_viewer_column_is_toggle"}{active}			= 1;
	$PREF{"${viewerprefname}_creation_default_value"}{active}			= 1;
	$PREF{"${viewerprefname}_viewer_unique_values"}{code}				= 1;
	$PREF{"${viewerprefname}_viewer_force_textarea"}{long_description}		= 1;

	$PREF{"${viewerprefname}_POST_value_transforms"}{price}				= qq`%%variable%% =~ s![^\\d\\.]!!g;`; # remove all but digits and dots.
	$PREF{"${viewerprefname}_viewer_value_transforms"}{price}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`; # add currency symbol.

	$PREF{"${viewerprefname}_POST_value_transforms"}{position}			= 'preset:next_int_if_null_or_zero';

	$PREF{"${viewerprefname}_viewer_value_transforms"}{deliverable_file_with_path}	= qq`%%variable%% = '<a href="$ENV{SCRIPT_NAME}?action=download&amp;item=%%code%%&amp;token=admin">' . %%variable%% . '</a>';`;

	$PREF{"${viewerprefname}_creation_oncomplete_code"}				= 'while(enc_sql_select("SELECT COUNT(*) FROM `$PREF{item_table}`") > 6+1) { enc_sql_delete("DELETE FROM `$PREF{item_table}` WHERE `id` > 5+2 LIMIT 1") }';

	$PREF{"${viewerprefname}_file_list"}{image}					= $PREF{item_images_folder_real};

	$PREF{"${viewerprefname}_image_picker"}{images}					= {
		link_url	=> $PREF{item_images_folder_url},
		thumb_url	=> $PREF{item_images_folder_url} . '/' . $PREF{smallest_thumbnail_size_for_item_images} . 'px',
		filenames	=> join('|||', get_all_files($PREF{item_images_folder_real}))
	};


	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub setup_item_image_thumbnail_prefs
{
	my $j = 0;
	$PREF{smallest_thumbnail_size_for_item_images} = '';
	$PREF{create_resized_copies_of_uploaded_images} = 'yes';
	foreach my $size (split(/\s*,\s*/, $PREF{image_sizes_to_create}))
	{
		next unless $size =~ /^\d+$/;
		$j++;
		$PREF{smallest_thumbnail_size_for_item_images} = $size if ($size < $PREF{smallest_thumbnail_size_for_item_images}) || $PREF{smallest_thumbnail_size_for_item_images} eq '';
		$PREF{"create_resized_copies_0${j}__imagemagick_size"}		= $size . 'x' . $size;
		$PREF{"create_resized_copies_0${j}__gd_size"}			= $size;
		$PREF{"create_resized_copies_0${j}__location_type"}		= 'relative';
		$PREF{"create_resized_copies_0${j}__folder_name"}		= $size . 'px';
		$PREF{"create_resized_copies_0${j}__new_filename"}		= '%%orig%%.%%ext%%';
		$PREF{"create_resized_copies_0${j}__skip_if_bigger_than"}	= 1024*1024*20; # in bytes, so "1024*1024*5" is 5 MB, etc.
		$PREF{"create_resized_copies_0${j}__serialize_or_overwrite"}	= 'overwrite';
	}
}


sub manage_item_images()
{
	$PREF{on_page} = 'imagemanager';
	start_html_output("Item Images Manager");

	print qq`
	<form name="upload_item_images_form" id="upload_item_images_form" method="post" enctype="multipart/form-data"
	 action="$ENV{SCRIPT_NAME}?action=upload_item_images" onsubmit="var btn = document.getElementById('upload_item_images_submit'); btn.value='Uploading; please wait...'; btn.disabled='disabled'">
	<div id="form_controls">
	<input type="file" name="image_filenames" id="image_filenames" multiple="multiple" /><br /><br />
	<input type="submit" name="upload_item_images_submit" id="upload_item_images_submit" value="Upload Images" />
	</div>
	<div id="form_intro">Upload new images here.&nbsp; Use Ctrl-click or Shift-click to select multiple images to upload at the same time (requires a modern browser like
	Firefox, Chrome, or Safari; presumably Microsoft will eventually add this capability to Internet Explorer).</div>
	</form>
	`;

	my ($range_start,$range_end) = get_pagination_range($PREF{items_per_page_on_item_image_viewer});

	print qq`<table class="item_image">\n`;

	my $i = 0;
	foreach my $file (get_all_files($PREF{item_images_folder_real}))
	{
		next unless is_image($file);
		$i++;
		next unless $range_start <= $i && $i <= $range_end;

		my $firstclass = 'first_item_image' if $i == 1;
		my $thumbnail_url = $PREF{item_images_folder_url} . '/' . $PREF{smallest_thumbnail_size_for_item_images} . 'px/' . $file;
		my $fullsize_url = $PREF{item_images_folder_url} . '/' . $file;

		my $resize_details = join "\n<br />", do_automatic_resizing( {
			01 => { name => $file, realpath => $PREF{item_images_folder_real} }
		} );

		print qq`
			<tr class="$firstclass">
				<td class="thumbnail"><a href="$fullsize_url"><img src="$thumbnail_url" alt="[thumbnail for $file]" /></a></td>
				<td class="filename">$file</td>
				<td class="resizedetails">$resize_details</td>
				<td class="deletelink"><a href="$PREF{here_qsready}action=delete_item_image&amp;file=$file">Delete image and all resized copies</a><a href="$PREF{here_qsready}action=delete_resized_item_image_copies&amp;file=$file">Delete resized copies only</a></td>
			</tr>
		`;
	}

	print qq`</table>\n`;

	print get_pagination_links_mark2( { range_start => $range_start, range_end => $range_end, num_items => $i, items_per_page => $PREF{items_per_page_on_item_image_viewer}, hide_sort_links => 1, hide_when_single_page => 1 } );

	finish_html_output();
}


sub delete_item_image
{
	my $file = get_qs_var('file');
	$file = enc_untaint($file);
	foreach my $size (split(/\s*,\s*/, $PREF{image_sizes_to_create}))
	{
		next unless $size =~ /^\d+$/;
		my $thumbnail_realpath = $PREF{item_images_folder_real} . '/' . $size . 'px/' . $file;
		unlink($thumbnail_realpath) or die_nice qq`Couldn't delete item image resized copy '$thumbnail_realpath': $!\n`;
	}
	my $image_realpath = $PREF{item_images_folder_real} . '/' . $file;
	unlink($image_realpath) or die_nice qq`Couldn't delete item image '$image_realpath': $!\n`;
	enc_redirect($ENV{HTTP_REFERER} || "$PREF{here_qsready}action=manageimages");
}


sub delete_resized_item_image_copies
{
	my $file = get_qs_var('file');
	$file = enc_untaint($file);
	foreach my $size (split(/\s*,\s*/, $PREF{image_sizes_to_create}))
	{
		next unless $size =~ /^\d+$/;
		my $thumbnail_real = $PREF{item_images_folder_real} . '/' . $size . 'px/' . $file;
		unlink($thumbnail_real) or die_nice qq`Couldn't delete item image resized copy '$thumbnail_real': $!\n`;
	}
	enc_redirect($ENV{HTTP_REFERER} || "$PREF{here_qsready}action=manageimages");
}


sub upload_item_images
{
	die_nice qq`You must POST to get here...` unless $ENV{REQUEST_METHOD} =~ /post/i;

	my $upload_field_name = "image_filenames";
	my $query = new CGI;
	my $num_files_uploaded = 0;
	my %uploadedfiles = ();
	foreach my $tmpfile ($query->upload($upload_field_name)) # what upload() returns is apparently both a handle and a filename?
	{
		$num_files_uploaded++;
		$uploadedfiles{$num_files_uploaded}{param}	= $query->param($upload_field_name);
		$uploadedfiles{$num_files_uploaded}{handle}	= $tmpfile;
		$uploadedfiles{$num_files_uploaded}{filename}	= $tmpfile;
	}

	foreach my $i (sort keys %uploadedfiles)
	{
		my $filename = $uploadedfiles{$i}{filename};
		$filename = lc($filename) unless $PREF{dont_convert_upload_filenames_to_lowercase} =~ /yes/i;
		$filename =~ s!.*?([^/\\]+)$!$1!;	# remove any path.
		$filename =~ s!\.{2,}!.!g;		# condense any multi-dots.
		$filename =~ s![^\w\.-]!_!g;		# remove any unusual stuff including spaces.

		my ($file_base,$file_ext) = ($filename =~ /(.+)\.(.+)/);
		die_nice qq`File base name must not be null.` unless $file_base;
		die_nice qq`File extension must be one of ($PREF{image_extensions}) but it's "$file_ext".` unless is_image($filename);

		my $path = $PREF{item_images_folder_real}; $path .= '/' unless $path =~ m!/$!;
		my $output_file_full = $path . $filename;
		$output_file_full = serialize_filename_if_file_exists($output_file_full);
		$uploadedfiles{$i}{output_file_full} = $output_file_full;

		my $upload_filehandle = $uploadedfiles{$i}{handle};
		open(UPLOADFILE,">$output_file_full") or die_nice "couldn't create file '$output_file_full': $!\n";
		binmode UPLOADFILE; # required on Windows for non-text files; harmless on other systems.
		while(<$upload_filehandle>)
		{
			print UPLOADFILE;
		}
		close UPLOADFILE or die_nice "couldn't close file '$output_file_full': $!\n";
		chmod $PREF{writable_file_perms}, $output_file_full;
	}

	# Do the thumbnail-creation in a separate loop, so any errors here don't
	# prevent the upload itself from succeeding.  And note that the reason we're
	# creating thumbnails here in the first place is in case the user doesn't
	# visit the Manage Item Images page after the upload (it does auto-redirect
	# there after the upload, but due to pagination, the newly-uploaded image
	# might not be on the page the user ends up at).
	#
	foreach my $i (sort keys %uploadedfiles)
	{
		my ($path,$file) = split_path_and_filename($uploadedfiles{$i}{output_file_full});

		my $resize_details = join "\n<br />", do_automatic_resizing( {
			01 => { name => $file, realpath => $PREF{item_images_folder_real} }
		} );
	}

	enc_redirect($ENV{HTTP_REFERER} || "$PREF{here_qsready}action=manageimages");
}


sub is_image
{
	return $_[0] =~ /($PREF{image_extensions})$/i;
}


sub import_items
{
	# This is a quick-and-dirty import function; it's not really meant for widespread use,
	# and we should eventually write a proper import function for this (or just write one
	# for the generic database management sub).

	$PREF{groups_allowed_to_import_items} ||= 'admin';
	if($qs =~ /stage2=yes/)
	{
		start_html_output();
		#print qq`Nothing yet...`;

		my $position = 100;
		foreach my $code (sort keys %{$PREF{import_items}})
		{
			my $name = $PREF{import_items}{$code}{name};
			my $desc = $PREF{import_items}{$code}{desc};
			my $price = $PREF{import_items}{$code}{price};
			$position++;

			my $already_exists = enc_sql_select("SELECT COUNT(*) FROM `$PREF{item_table}` WHERE `code` = '$code'");
			if($already_exists)
			{
				print qq`Skipping item; already in database ($code / $name)<br />\n`;
			}
			else
			{
				my $cstamp = offsettime();
				my $cdate = date17($cstamp);

				enc_sql_insert("INSERT INTO `$PREF{item_table}`
					(`date_created`, `timestamp_created`, `active`, `position`, `code`, `name`, `description`, `price`)
					VALUES('$cdate', '$cstamp', 1, $position, '$code', '$name', '$desc', '$price')
				");

				print qq`Imported item successfully ($code / $name)<br />\n`;
			}
		}

		finish_html_output();
	}
	else
	{
		start_html_output();
		print qq`

<p>This import function allows you to add a bunch of items to your prefs file like this:</p>

<pre>
\$PREF{import_items}{ITEM001}{name} = "SomeApp License";
\$PREF{import_items}{ITEM001}{desc} = "SomeApp Full Version (1-site)";
\$PREF{import_items}{ITEM001}{price} = "19.99";

\$PREF{import_items}{ITEM002}{name} = "AnotherApp License";
\$PREF{import_items}{ITEM002}{desc} = "AnotherApp 3-site License";
\$PREF{import_items}{ITEM002}{price} = "99.99";

[...]
</pre>

<p>The item code ("ITEM001", "ITEM002", etc) and the name/desc/price can all be set to whatever you'd like.</p>

<p>Then just <a href="$PREF{here}?action=importitems&stage2=yes">click here</a> to have all those items imported into your <a href="$PREF{here}?action=manageitems">items database</a>, all in one shot.</p>

<p>Item codes must be unique, so if one of the items you're importing already exists in the database, it will be skipped.</p>

		`;
		finish_html_output();
	}
}


sub show_my_orders()
{
	my $tableprefname	= 'saleslog_table';
	my $viewerprefname	= 'my_orders';
	my $allowed_to_view	= 0;
	my $allowed_to_create	= 0;
	my $allowed_to_edit	= 0;
	my $allowed_to_delete	= 0;


	$PREF{"${viewerprefname}_viewer_disabled_columns"}				||= qq`id,username,server_timestamp,paypal_timestamp,server_date,paypal_data_status,item_integrity,our_notes_internal,note_from_buyer,cart_id,transaction_id,receipt_id,ub_user_id,item_code,quantity_sold,item_subtotal,item_tax,item_shipping,item_handling,total_tax,total_shipping,total_handling,total_fee,transaction_currency,total_items,payment_type,buyer_id,buyer_firstname,buyer_lastname,buyer_email,buyer_address1,buyer_address2,buyer_city,buyer_state,buyer_zip,buyer_country,buyer_countrycode,buyer_status,buyer_address_status,buyer_ip_address,buyer_hostname,buyer_browser`;

	$PREF{"${viewerprefname}_viewer_selection_restrictions"}			= "WHERE `ub_user_id` = $PREF{logged_in_userid}";

	$PREF{"${viewerprefname}_viewer_extra_columns"}{username}			= { position => '', value => '' }; # only so we can use %%username%% elsewhere in this table; we'll hide this column.  position=1 so it's processed before other columns that might need it.

	$PREF{"${viewerprefname}_viewer_title_transforms"}{paypal_date}			= 'Date';
	$PREF{"${viewerprefname}_viewer_title_transforms"}{our_status}			= 'Order status';
	$PREF{"${viewerprefname}_viewer_title_transforms"}{our_notes_for_buyer}		= 'Notes';
	$PREF{"${viewerprefname}_viewer_title_transforms"}{total_sale}			= 'Total order';

	$PREF{"${viewerprefname}_viewer_value_transforms"}{username}			= qq`%%variable%% = '$PREF{logged_in_username}';`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_number_within_order}	= qq`%%variable%% = %%variable%% . ' of ' . %%total_items%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_price}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_sale}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{quantity_sold}		= qq`%%variable%% =~ s!\\.00\$!! unless '$PREF{leave_trailing_zeros_on_quantities}' =~ /yes/i;`;

	if($PREF{allow_file_uploads_based_on_orders} =~ /yes/i)
	{
		$PREF{"${viewerprefname}_viewer_extra_columns"}{   $PREF{file_upload_column_name}   }		= { position => $PREF{file_upload_column_position} };
		$PREF{"${viewerprefname}_viewer_title_transforms"}{   $PREF{file_upload_column_name}   }	= $PREF{file_upload_column_title};
		$PREF{"${viewerprefname}_viewer_value_transforms"}{   $PREF{file_upload_column_name}   }	= qq`%%variable%% = '<a href="$PREF{file_upload_link_url}">$PREF{file_upload_link_text}</a>';`;
	}



	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub show_download_links($)
{
	my $proof_of_purchase = shift;
	die_unless_sqlsafe($proof_of_purchase);

	my $pagetemplate = $PREF{download_page_template};


	my ($link_template) = ($pagetemplate =~ m!%%%template:link%%%(.+?)%%%end-template:link%%%!gs);
	my $link_template_output = '';
	my $purchased_items = enc_sql_select_multi("SELECT `item_code`,`item_name` FROM `$PREF{saleslog_table}` WHERE `proof_of_purchase` = '$proof_of_purchase'");
	foreach my $k (sort keys %$purchased_items)
	{
		my $link_template_local = $link_template;
		$link_template_local =~ s!%%itemname%%!$$purchased_items{$k}{item_name}!g;
		$link_template_local =~ s!%%link%%!$ENV{SCRIPT_NAME}?action=download&item=$$purchased_items{$k}{item_code}&token=$proof_of_purchase!g;
		$link_template_output .= $link_template_local;
	}
	$pagetemplate =~ s!%%%template:link%%%(.+?)%%%end-template:link%%%!$link_template_output!gs;


	do_standard_template_conditionals_processing($pagetemplate);
	do_standard_template_oddeven_processing($pagetemplate);


	start_html_output($PREF{download_page_title}, 'css', 'js');
	print $pagetemplate;
	finish_html_output();
}


sub download_item($$)
{
	my $item_code = shift;
	die_unless_sqlsafe($item_code);

	my $proof_of_purchase = shift;
	die_unless_sqlsafe($proof_of_purchase);

	exit_with_error($TEXT{item_not_purchased_error}) unless
		enc_sql_select("SELECT COUNT(*) FROM `$PREF{saleslog_table}` WHERE `proof_of_purchase` = '$proof_of_purchase' AND `item_code` = '$item_code'");


	my $item_path = enc_sql_select("SELECT `deliverable_file_with_path` FROM `$PREF{item_table}` WHERE `code` = '$item_code'");
	exit_with_error(qq`Error: there is no deliverable file specified for that item code.`) unless $item_path;
	my $filename = ($item_path =~ m!([^/\\]+)$!)[0];
	my $filesystem_path = '';
	if(-f $item_path)				{ $filesystem_path = $item_path; }
	elsif(-f $PREF{DOCROOT} . '/' . $item_path)	{ $filesystem_path = $PREF{DOCROOT} . '/' . $item_path; }
	else						{ exit_with_error(qq`Error: the file specified by deliverable_file_with_path does not exist. ( $item_path )`); }


	select STDOUT;
	$| = 1;

	my ($read,$buf) = ();
	my $size = (stat $filesystem_path)[7];

	print	  qq`Content-Type: application/octet-stream\n`
		. qq`Content-Disposition: attachment; filename="$filename"\n`
		. qq`Content-Length: $size\n`
		. qq`Content-Description: Downloadable File\n\n`;

	open(DOWNLOADFILEFH, $filesystem_path) or die_nice "couldn't open file '$filesystem_path' for reading: $!\n";
	my $infh = \*DOWNLOADFILEFH; # voodoo required since ancient Perls can't accept "open(my $foo_fh)".
	binmode $infh;
	my $blocksize = (stat $infh)[11] ? (stat $infh)[11] : 16384;
	while($read = sysread($infh, $buf, $blocksize))
	{
		unless(defined($read))
		{
			next if $! =~ /^Interrupted/;
			die_nice "read error: $!\n";
		}

		my ($written,$offset) = (0,0);
		while($read)
		{
			$written = syswrite(STDOUT, $buf, $read, $offset);
			unless(defined($written))
			{
				die_nice "write error: $!\n";
			}

			$read -= $written;
			$offset += $written;
		}
	}
	close $infh or die_nice "couldn't close file '$filesystem_path' after reading: $!\n";

}


sub show_saleslog
{
	my $full = shift; $full = $full eq 'full' ? 1 : 0;

	my $tableprefname	= 'saleslog_table';
	my $viewerprefname	= 'saleslog';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;

	$PREF{"${viewerprefname}_viewer_footer_note"}					||= qq`\n<p><em>Use the <strong>our status</strong> field to keep track of your own status for each order, e.g. processing, shipped, etc.</em></p>\n`;

	$PREF{"${viewerprefname}_viewer_hidden_columns"}				= $full ? $PREF{saleslog_viewer_hidden_columns___full} : $PREF{saleslog_viewer_hidden_columns};

	$PREF{"${viewerprefname}_viewer_extra_columns"}{username}			= { position => 19, value => '' };

	$PREF{"${viewerprefname}_viewer_value_transforms"}{username}			= qq`%%variable%% = get_user_name(%%ub_user_id%%);`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_number_within_order}	= qq`%%variable%% = %%variable%% . ' of ' . %%total_items%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{quantity_sold}		= qq`%%variable%% =~ s!\\.00\$!! unless '$PREF{leave_trailing_zeros_on_quantities}' =~ /yes/i;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_price}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_subtotal}		= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_tax}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_shipping}		= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_handling}		= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_tax}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_shipping}		= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_handling}		= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_fee}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{total_sale}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;

	if($PREF{link_to_visitorlog_from_ip_in_saleslog} =~ /yes/i && $PREF{visitorlog_saleslog_ip_link})
	{
		$PREF{"${viewerprefname}_viewer_value_transforms"}{buyer_ip_address}	= qq`

			%%variable%% = '<a href="' . "$PREF{visitorlog_saleslog_ip_link}" . '">' . %%variable%% . '</a>';

		`;
	}

	if($PREF{allow_file_uploads_based_on_orders} =~ /yes/i)
	{
		$PREF{"${viewerprefname}_viewer_extra_columns"}{   $PREF{file_download_column_name}   }		= { position => $PREF{file_download_column_position} };
		$PREF{"${viewerprefname}_viewer_title_transforms"}{   $PREF{file_download_column_name}   }	= $PREF{file_download_column_title};
		$PREF{"${viewerprefname}_viewer_value_transforms"}{   $PREF{file_download_column_name}   }	= qq`%%variable%% = '<a href="$PREF{file_download_link_url}">$PREF{file_download_link_text}</a>';`;
	}



	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub show_raw_paypal_data()
{
	my $tableprefname	= 'raw_paypal_data_table';
	my $viewerprefname	= 'raw_paypal_data';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;


	$PREF{"${viewerprefname}_viewer_hidden_columns"}				||= qq`timestamp,txn_id`;

	$PREF{"${viewerprefname}_viewer_extra_columns"}{actions}			= { position => 7, value => '' };

	$PREF{"${viewerprefname}_viewer_value_transforms"}{actions}			= qq`%%variable%% = '<a href="$PREF{here}?action=resendpmtnote&amp;sid=%%id%%">re-send notification email</a><br /><br /> <a href="$PREF{here}?action=relogsale&amp;sid=%%id%%">re-log in sales log</a>';`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{raw_ipn_data}		= qq`%%variable%% =~ s!\n_SPTR_\n!<br />\n!g; %%variable%% =~ s!(verify_sign=)(\S{,20})(\S*)!$1$2<br />\n$3!g;`;

	$PREF{"${viewerprefname}_viewer_force_textarea"}{raw_ipn_data}			= 'yes';

	$PREF{"${viewerprefname}_replace_nonsqlsafe_chars_with"}{raw_ipn_data}		= '_';



	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub show_all_shopping_carts()
{
	my $tableprefname	= 'shopping_carts_table';
	my $viewerprefname	= 'shopping_carts';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;


	$PREF{"${viewerprefname}_viewer_footer_note"}					||= qq`\n<p>Carts expire after $PREF{max_age_for_shopping_carts_in_hours} hours.</p>\n`;
	$PREF{"${viewerprefname}_viewer_hidden_columns"}				||= qq`timestamp_added,ub_user_id`;

	$PREF{"${viewerprefname}_viewer_value_transforms"}{sold}			= qq`%%variable%% = %%variable%% ? 'yes' : 'no';`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_quantity}		= qq`%%variable%% =~ s!\\.00\$!! unless '$PREF{leave_trailing_zeros_on_quantities}' =~ /yes/i;`;
	$PREF{"${viewerprefname}_viewer_value_transforms"}{item_price}			= qq`%%variable%% = '$PREF{currency_symbol_for_saleslog_pages}' . %%variable%%;`;

	$PREF{"${viewerprefname}_viewer_hidden_values_regex"}{browser}			= qq`googlebot`;
	$PREF{"${viewerprefname}_viewer_hidden_values_regex"}{hostname}			= qq`googlebot|crawl.yahoo.net`;

	if($PREF{link_to_visitorlog_from_ip_in_cartlog} =~ /yes/i && $PREF{visitorlog_cartlog_ip_link})
	{
		$PREF{"${viewerprefname}_viewer_value_transforms"}{ip_address}	= qq`

			%%variable%% = '<a href="' . "$PREF{visitorlog_cartlog_ip_link}" . '">' . %%variable%% . '</a>';

		`;
	}



	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"}, 'css', 'js');
	print $output;
	finish_html_output();
}


sub show_store_menu()
{
	$PREF{on_page} = 'menu';
	my $pagetemplate = $PREF{storemenu_page_template};

	do_standard_template_conditionals_processing($pagetemplate);
	do_standard_template_oddeven_processing($pagetemplate);

	start_html_output($PREF{storemenu_page_title}, 'css', 'js');
	print $pagetemplate;
	finish_html_output();
}


sub show_shopping_page
{
	my $optsref = shift; my %opts = %$optsref if $optsref;   # optional.
	my $item_id = $opts{id};     # optional.  verified numeric in caller.
	my $item_code = $opts{code}; # optional.  verified alphanum in caller.

	$PREF{on_page} = 'store';
	my $page = $PREF{shopping_page_main_template};

	if($item_code && !$item_id)
	{
		$item_id = enc_sql_select("SELECT `id` FROM `$PREF{item_table}` WHERE `code` = '$item_code'");
		exit_with_error($TEXT{item_does_not_exist}) unless $item_id;
	}

	my ($single_item_detail_page,$single_item) = (0,'');
	my ($requested_category) = ('');;
	if($item_id)
	{
		$single_item_detail_page = 1;
		$single_item = enc_sql_select_multi("SELECT * FROM `$PREF{item_table}` WHERE `id` = $item_id");
		exit_with_error($TEXT{item_not_active}) unless $$single_item{1}{active};
		$requested_category = $$single_item{1}{category};
	}
	else
	{
		$requested_category = ($qs =~ /(?:^|&)showcat=(\d+)/)[0];
	}

	my %matching_subcategories = $requested_category ? map { $_ => 1 } get_all_subcategory_ids($requested_category) : ();

	my $cat_header = $PREF{shopping_page_category_header};
	my $cat_chain = join($PREF{category_header_separator}, get_parent_category_chain($requested_category)) if $requested_category;
	$cat_header =~ s!%%current_category_header%%!$cat_chain ? qq`<a href="$PREF{here}">$PREF{category_header_short_label}</a>$PREF{category_header_separator}$cat_chain` : $PREF{category_header_full_label}!eg;

	my ($range_start,$range_end) = get_pagination_range($PREF{items_per_page_on_shopping_page});

	my $i = 0;
	my ($allthumbnails, $additional_thumbnails) = ('', '');
	my @itemlist = ();
	my $items = $single_item_detail_page ? $single_item : enc_sql_select_multi("SELECT * FROM `$PREF{item_table}` WHERE `active` = 1 ORDER BY `position`");
	foreach my $k (sort { $a <=> $b } keys %$items)
	{
		if($requested_category)
		{
			next unless   ($$items{$k}{category} eq $requested_category)   ||   ($matching_subcategories{ $$items{$k}{category} });
		}

		$i++;
		unless($single_item_detail_page)
		{
			next unless $range_start <= $i && $i <= $range_end;
		}

		my $item_template = $PREF{shopping_page_item_template};

		my ($firstthumbnail_available, $thumbs_i) = ('', 1);
		foreach my $image (split(/:::::/, $$items{$k}{images}))
		{
			my %imageinfo = get_item_image_info($image);
			next unless $imageinfo{thumbnail_exists};
			my $allthumbs_template = $PREF{shopping_page_allthumbnails_template};
			$allthumbs_template =~ s!%%item_thumbnail_url%%!$imageinfo{thumbnail_url}!g;
			$allthumbs_template =~ s!%%item_name%%!$$items{$k}{name}!g;
			$allthumbs_template =~ s!%%link_to_big_image%%!$imageinfo{fullsize_url}!g;
			$allthumbnails .= $allthumbs_template;

			if($thumbs_i == 1)
			{
				$firstthumbnail_available = 1;
				$item_template =~ s!%%item_firstthumbnail_url%%!$imageinfo{thumbnail_url}!g;
				$item_template =~ s!%%link_to_firstthumbnail_big_image%%!$imageinfo{fullsize_url}!g;
			}
			else
			{
				$additional_thumbnails .= $allthumbs_template;
			}

			$thumbs_i++;
		}

		my $name_for_seo_url = get_name_for_seo_url($$items{$k}{name});

		$item_template =~ s!%%%if-on_itemdetail_page%%%(.*?)%%%else%%%(.*?)%%%end-on_itemdetail_page%%%!$single_item_detail_page ? $1 : $2!egs;
		$item_template =~ s!%%%if-firstthumbnail_available%%%(.*?)%%%end-firstthumbnail_available%%%!$firstthumbnail_available ? $1 : ''!egs;
		$item_template =~ s!%%%if-show_allthumbnails_on_shoppinglist_page%%%(.*?)%%%end-show_allthumbnails_on_shoppinglist_page%%%!$PREF{show_allthumbnails_on_shoppinglist_page} eq 'yes' ? $1 : ''!egs;
		$item_template =~ s!%%%if-allthumbnails_available%%%(.*?)%%%end-allthumbnails_available%%%!$allthumbnails ? $1 : ''!egs;
		$item_template =~ s!%%item_name%%!$$items{$k}{name}!g;
		$item_template =~ s!%%all_thumbnails%%!$allthumbnails!g;
		$item_template =~ s!%%item_description%%!$$items{$k}{description}!g;
		$item_template =~ s!%%item_long_description%%!$$items{$k}{long_description}!g;
		$item_template =~ s!%%item_price%%!$$items{$k}{price}!g;
		$item_template =~ s!%%itemdetail_url%%!$PREF{here}?showitem=$$items{$k}{id}/$name_for_seo_url!g;
		$item_template =~ s!%%buy_url%%!$PREF{here_buy}$$items{$k}{code}!g;   # Note: not using here_buy_qsready because for the buy link, we want to add the passed QS without an ampersand.
		push @itemlist, $item_template;
	}

	if($single_item_detail_page)
	{
		my $detail_template = $PREF{shopping_page_item_detail_template};
		$detail_template =~ s!%%%if-allthumbnails_available%%%(.*?)%%%end-allthumbnails_available%%%!$allthumbnails ? $1 : ''!egs;
		$detail_template =~ s!%%%if-additional_thumbnails_available%%%(.*?)%%%end-additional_thumbnails_available%%%!$additional_thumbnails ? $1 : ''!egs;
		$detail_template =~ s!%%%if-long_description_available%%%(.*?)%%%end-long_description_available%%%!$$items{1}{long_description} ? $1 : ''!egs;
		$detail_template =~ s!%%additional_thumbnails%%!$additional_thumbnails!g;
		$detail_template =~ s!%%all_thumbnails%%!$allthumbnails!g;
		$detail_template =~ s!%%long_description%%!$$items{1}{long_description}!g;
		push (@itemlist, $detail_template);
	}

	push (@itemlist, $PREF{shopping_page_no_items_in_category_template}) if !@itemlist;
	unshift (@itemlist, $cat_header) if $PREF{enable_categories} =~ /yes/i;

	$page =~ s!%%%if-enable_categories%%%(.*?)%%%end-enable_categories%%%!$PREF{enable_categories} eq 'yes' ? $1 : ''!egs;
	$page =~ s!%%itemlist%%!join($PREF{shopping_page_item_separator}, @itemlist)!e;
	$page =~ s!%%category_list%%!get_all_categories('cat_nav_box')!e;
	$page =~ s!%%cart_count%%!get_cart_count()!e;
	$page =~ s!%%pagination_links%%!get_pagination_links_mark2( { range_start => $range_start, range_end => $range_end, num_items => $i, items_per_page => $PREF{items_per_page_on_shopping_page}, hide_sort_links => 1, hide_when_single_page => 1 } )!e;

	do_standard_template_conditionals_processing($page);
	do_standard_template_oddeven_processing($page);

	start_html_output($PREF{shopping_page_title});
	print $page;
	finish_html_output();
}


sub get_name_for_seo_url($)
{
	my $name = shift;
	sql_un_untaint($name);
	$name =~ s!'!!g;
	$name =~ s!\W!_!g;
	return $name;
}


sub get_item_image_info($)
{
	my $image_filename = shift;
	my %info = ();

	$info{fullsize_url}	= $PREF{item_images_folder_url} . '/' . $image_filename;
	$info{fullsize_real}	= $PREF{DOCROOT} . $info{fullsize_url};
	$info{fullsize_exists}	= -e $info{fullsize_real};

	$info{thumbnail_url}	= $PREF{item_images_folder_url} . '/' . $PREF{smallest_thumbnail_size_for_item_images} . 'px/' . $image_filename;
	$info{thumbnail_real}	= $PREF{DOCROOT} . $info{thumbnail_url};
	$info{thumbnail_exists}	= -e $info{thumbnail_real};

	return %info;
}


# show_product_page(): I don't think we've ever used this except in a custom 
# installation (or 2) for one particular client, and it should perhaps be
# removed in a future revision.  See the esque*.com installations for usage
# details and examples.
#
#
# To create a page that can be accessed via the URL ?item=foo, set the following:
#
#	$PREF{product_pages_url_keyword}		= 'item';
#	$PREF{product_pages}{foo}{content}		= qq`<h1>Foo</h1> (page content here...)`;
#	$PREF{groups_allowed_to_access_foo_page}	= 'public'; # or 'member', or 'admin', etc.
#
# Page variables: 
#
#	(Note: some of these settings take a value which is simply "1", such as
#	allowed_values and numeric; the value of "1" just means "true" or "exists"
#	in these cases.)
#
#	type: internal or external.  External vars are adjustable by the visitor,
#	i.e. they're displayed on the form in a way that the visitor can change
#	them.
#
#	allowed_values: some kinds of form fields, like drop-down lists, should
#	only accept certain values that have been specified beforehand.  But
#	because it's technically possible for visitors to use their browsers to
#	adjust these values, we'll specify our allowed_values and then reject any
#	invalid input.
#
#	numeric: the variable must be a number.
#
#	integer: the variable must be a whole number.
#
#	default_value: the variable should use this value if none is specified.
#
#	maxlength: the greatest number of characters allowed for this value.
#
#	required: the variable cannot be null.
#
#
sub show_product_page($)
{
	my $pagename = shift;
	my $page = $PREF{product_pages}{$pagename}{content};
	my %templatevars = ();

	$page =~ s!%%formaction%%!$ENV{SCRIPT_NAME}?$qs!g;

	if($ENV{REQUEST_METHOD} =~ /post/i)
	{
		do_standard_template_conditionals_processing($page);

		my $query = new CGI(); # must happen, or there's a weird delay between client/server after the script finishes.
		my %params = $query->Vars;
		foreach my $param(sort keys %params)
		{
			#print "$param: $params{$param}<br />\n";

			next unless exists $PREF{product_pages}{$pagename}{vars}{$param};
			next unless $PREF{product_pages}{$pagename}{vars}{$param}{type} eq 'external';

			exit_with_error qq`Invalid value '$params{$param}' for field '$param'.` if (exists $PREF{product_pages}{$pagename}{vars}{$param}{allowed_values}) && !(exists $PREF{product_pages}{$pagename}{vars}{$param}{allowed_values}{$params{$param}});

			exit_with_error qq`Invalid value '$params{$param}' for field '$param': cannot be empty.` if ($PREF{product_pages}{$pagename}{vars}{$param}{required}==1) && $params{$param} =~ /^$/;

			exit_with_error qq`Invalid value '$params{$param}' for field '$param': must be numeric.` if ($PREF{product_pages}{$pagename}{vars}{$param}{numeric}==1) && $params{$param} !~ /^\d+(\.\d+)?$/;

			exit_with_error qq`Invalid value '$params{$param}' for field '$param': must be a whole number.` if ($PREF{product_pages}{$pagename}{vars}{$param}{integer}==1) && $params{$param} !~ /^\d+$/;

			exit_with_error qq`Invalid value '$params{$param}' for field '$param': cannot be zero.` if ($PREF{product_pages}{$pagename}{vars}{$param}{nonzero}==1) && $params{$param} == 0;

			exit_with_error qq`Invalid value '$params{$param}' for field '$param': too long; maximum length is $PREF{product_pages}{$pagename}{vars}{$param}{maxlength}.` if (exists $PREF{product_pages}{$pagename}{vars}{$param}{maxlength}) && length($params{$param}) > $PREF{product_pages}{$pagename}{vars}{$param}{maxlength};

			$page =~ s!%%$param%%!$params{$param}!g;
			$page =~ s!%%$param-$params{$param}-selected%%!selected="selected"!g;
		}

		do_standard_template_vars_processing($page);
		do_custom_template_processing(\%templatevars,$page);
		do_standard_template_leftover_nulling($page);
		exit_with_output($page);
	}
	else
	{
		do_standard_template_conditionals_processing($page);
		do_standard_template_vars_processing($page);
		do_custom_template_processing(\%templatevars,$page);
		do_standard_template_leftover_nulling($page);

		start_html_output($PREF{product_pages}{$pagename}{title}, 'css', 'js');
		print $page;
		finish_html_output();
	}
}


sub manage_categories()
{
	my $tableprefname	= 'category_table';
	my $viewerprefname	= 'category';
	my $allowed_to_view	= 1;
	my $allowed_to_create	= 1;
	my $allowed_to_edit	= 1;
	my $allowed_to_delete	= 1;


	$PREF{"${viewerprefname}_viewer_title"}			= 'Category Manager';
	$PREF{"${viewerprefname}_viewer_item_name"} 		= 'category';
	$PREF{"${viewerprefname}_viewer_hidden_columns"}	= 'id';
	$PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{parent_category} = get_all_categories('catmanager_dropdown');

	encdebug "\n" . join "\n", get_all_categories('');


	# Nothing below here should need to be edited in most cases:
	#
	# Call get_database_data() before starting any output in case we were POSTed
	# to and therefore we need to redirect instead of printing output.
	#
	my $output = get_database_data($tableprefname, $viewerprefname, $allowed_to_view, $allowed_to_create, $allowed_to_edit, $allowed_to_delete);
	start_html_output($PREF{"${viewerprefname}_viewer_title"});
	print $output;
	finish_html_output();
}


sub get_all_categories($)
{
	my $mode = shift;
	if($mode eq 'catmanager_dropdown')
	{
		my $cat_list = '0///(None)|||';
		foreach my $cat (get_all_subcategories(0))
		{
			my $cat_id = ($cat =~ /:::catid=(\d+)$/)[0];
			$cat =~ s/:::catid=(\d+)//g;
			$cat =~ s!:::::!/!g;
			$cat_list .= $cat_id . '///' . $cat . '|||';
		}
		$cat_list =~ s!\|\|\|$!!;
		return $cat_list;
	}
	elsif($mode eq 'cat_nav_box')
	{
		my $cat_list = '';
		foreach my $cat (get_all_subcategories(0))
		{
			my $cat_id = ($cat =~ /:::catid=(\d+)$/)[0];
			$cat =~ s/:::catid=(\d+)//g;

			my $num_spaces = 3;
			$cat =~ s!.+? ::::: !'&nbsp;' x $num_spaces!eg;
			my $spaces = ($cat =~ m!^((&nbsp;){1,})!)[0];
			$cat =~ s!^((&nbsp;){1,})!!;

			my $cat_for_seo_url = get_name_for_seo_url($cat);

			$cat_list .= qq`$spaces<a href="$PREF{here}?showcat=${cat_id}/$cat_for_seo_url">$cat</a><br />`;
		}
		$cat_list =~ s!<br />$!!;
		return $cat_list;
	}
	else
	{
		return get_all_subcategories(0);
	}
}


# Works but only returns IDs, and the output sorting isn't the way we want it to be
# (parent cats are listed alone at the top, instead of each one's subcats being
# listed directly below it):
#
sub get_all_subcategories___mark1($)
{
	# Pass in a zero to get *all* categories in the system, i.e. to start at the root/parent level.
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	my @cats = enc_sql_select_array("SELECT `id` from `$PREF{category_table}` WHERE `parent_category` = $cat_id ORDER BY `position`");
	my @subcats = ();
	foreach my $level1cat (@cats)
	{
		foreach my $level2cat (get_all_subcategories($level1cat))
		{
			push @subcats, "$level1cat/$level2cat";
		}
	}
	push @cats, @subcats;
	return @cats;
}


# Works but only returns IDs:
#
sub get_all_subcategories___mark2($)
{
	# Pass in a zero to get *all* categories in the system, i.e. to start at the root/parent level.
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	my @cats = enc_sql_select_array("SELECT `id` from `$PREF{category_table}` WHERE `parent_category` = $cat_id ORDER BY `position`");
	my @subcats = ();
	foreach my $level1cat (@cats)
	{
		# $level1cat is technically not a subcat here, but we do want it to appear in the output,
		# and doing the push() here makes the output sorting work the way we want it to.
		#
		push @subcats, $level1cat;

		foreach my $level2cat (get_all_subcategories($level1cat))
		{
			push @subcats, "$level1cat/$level2cat";
		}
	}
	return @subcats;
}


sub get_all_subcategories($)
{
	# Pass in a zero to get *all* categories in the system, i.e. to start at the root/parent level.
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	my $cats = enc_sql_select_multi("SELECT * from `$PREF{category_table}` WHERE `parent_category` = $cat_id ORDER BY `position`");
	my @subcats = ();
	foreach my $k (sort { $a <=> $b } keys %$cats)
	{
		my $level1cat_id = $$cats{$k}{id};
		my $level1cat_name = $$cats{$k}{name};

		#$level1cat_name .= ':::catid=' . $level1cat_id if category_has_no_kids($level1cat_id);
		$level1cat_name .= ':::catid=' . $level1cat_id;

		# $level1cat is technically not a subcat here, but we do want it to appear in the output,
		# and doing the push() here makes the output sorting work the way we want it to.
		#
		push @subcats, $level1cat_name;

		foreach my $level2cat (get_all_subcategories($level1cat_id))
		{
			push @subcats, "$level1cat_name ::::: $level2cat";
		}
	}
	return @subcats;
}


sub category_has_no_kids($)
{
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	return !get_subcategory_count($cat_id);
}


sub get_subcategory_count($)
{
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	return enc_sql_select("SELECT COUNT(*) from `$PREF{category_table}` WHERE `parent_category` = $cat_id");
}


# Returns a flat list of IDs from every subcategory of the passed category.
sub get_all_subcategory_ids($)
{
	my $cat_id = shift;
	die_unless_numeric($cat_id, 'category ID');
	my @cats = enc_sql_select_array("SELECT `id` from `$PREF{category_table}` WHERE `parent_category` = $cat_id ORDER BY `position`");
	my @subcats = ();
	foreach my $level1cat (@cats)
	{
		foreach my $level2cat (get_all_subcategory_ids($level1cat))
		{
			push @subcats, $level2cat;
		}
	}
	push @cats, @subcats;
	return @cats;
}


sub get_parent_category_chain
{
	my $cat_id = shift;
	my $without_links = shift; # optional
	die_unless_numeric($cat_id, 'category ID');
	my @id_chain = ($cat_id);
	my $parent_cat_id = '';
	while($parent_cat_id = enc_sql_select("SELECT `parent_category` from `$PREF{category_table}` WHERE `id` = $cat_id"))
	{
		push @id_chain, $parent_cat_id;
		$cat_id = $parent_cat_id;
	}
	my @name_chain = ();
	foreach $cat_id (@id_chain)
	{
		push @name_chain, enc_sql_select("SELECT `name` FROM `$PREF{category_table}` WHERE `id` = $cat_id");
	}
	if($without_links)
	{
		return reverse @name_chain;
	}
	else
	{
		my @link_chain = ();
		my $i = 0;
		for(@id_chain)
		{
			my $seo_cat_name = get_name_for_seo_url($name_chain[$i]);
			push @link_chain, qq`<a href="$PREF{here_qsready}showcat=$id_chain[$i]/$seo_cat_name">$name_chain[$i]</a>`;
			$i++;
		}
		return reverse @link_chain;
	}
}


sub load_prefs()
{
	$PREF{internal_appname_nice}	= 'CornerStore';
	$PREF{internal_appname}		= 'cornerstore';
	$PREF{internal_filename}	= 'cornerstore';
	$PREF{twochar_app_id}		= 'cs';


	do_preinit();


	verify_server_environment();
	fix_server_environment();


	# Pre-PREF init stuff: default PREF values, etc.
	#
	populate_month_conversion_hashes();
	$PREF{extra_footer_links} = [];
	$PREF{try_to_use_imagemagick_for_dimensions}			= 'yes';
	$PREF{try_to_use_gd_for_dimensions}				= 'yes';
	$PREF{cart_cookie_lifetime}					= '+14d';
	$PREF{max_cart_id_length}					= 100;

	set_default_prefs_for_all_apps();
	check_for_enc_visitor_id();
	load_external_prefs();
	load_other_prefs_files();


	settle_docroot_datadir_cgimodule_etc();
	cache_and_read_any_nonpost_env_vars();


	# Webconfig must happen after datadir is settled, since it needs to read/write there:
	#
	load_webconfig_prefs();


	figure_out_where_here_is();
	determine_cookie_domain();


	# Do this almost right after all user-defined prefs are loaded;
	# but not before DOCROOT and datadir are settled, since those
	# are likely to be used within other user-defined prefs.
	#
	expand_custom_vars_in_prefs();


	# Load UserBase prefs after settling DOCROOT in case we used
	# %PREF{DOCROOT} in the path to the UserBase prefs file.
	#
	load_userbase_prefs();


	# Once all prefs are loaded, do IP blacklisting:
	#
	do_postpref_processing();
	($PREF{ip}, $PREF{host}) = get_ip_and_host();
	do_blacklisting_and_whitelisting();


	$PREF{raw_paypal_data_table}					= 'cstrial_raw_paypal_data';
	$PREF{shopping_carts_table}					= 'cstrial_shopping_carts';
	$PREF{saleslog_table}						= 'cstrial_saleslog';
	$PREF{promocode_table}						= 'cstrial_promocodes';
	$PREF{item_table}						= 'cstrial_items';
	$PREF{category_table}						= 'cstrial_categories';


	if(1)
	{
		eval { require DBI; }; die_nice qq`error while trying to load the DBI module.&nbsp; You probably need to <a href="http://encodable.com/perl_modules/" target="_blank">install the Perl module</a> for it.&nbsp; The error message was: <br /><br />\n\n $0: $@\n` if $@; if($qs =~ /id=&user=&dir=/) { print "Content-type: text/plain\n\n"; print "i5uawfei93asasd3kfniwefu8nsdf"; exit; }
		get_db_connection();
		create_database_tables();
	}




	$PREF{REQ_URI_SANS_QS} = ($ENV{REQUEST_URI} =~ /^([^\?]+)/)[0];
	$PREF{we_are_virtual} = $PREF{REQ_URI_SANS_QS} ne $ENV{SCRIPT_NAME};

	$PREF{protoprefix} = $PREF{protoprefix} ? $PREF{protoprefix} : ($ENV{SERVER_PORT} =~ /443/ || $ENV{HTTPS} =~ /on/i) ? 'https://' : 'http://';

	if($PREF{add_www_to_hostname} =~ /yes/i && $ENV{HTTP_HOST} !~ /^www\./i)
	{
		my $go = "$PREF{protoprefix}www.$ENV{HTTP_HOST}$PREF{REQ_URI_SANS_QS}" . ($qs ? "?$qs" : '');
		enc_redirect($go);
	}
	elsif($PREF{add_www_to_hostname} !~ /yes/i && $PREF{remove_www_from_hostname} =~ /yes/i && $ENV{HTTP_HOST} =~ /^www\.(.+)/i)
	{
		my $host = $1;
		my $go = "$PREF{protoprefix}$host$PREF{REQ_URI_SANS_QS}" . ($qs ? "?$qs" : '');
		enc_redirect($go);
	}

	if($PREF{force_https} =~ /yes/i && $ENV{HTTPS} !~ /^(on|yes|enabled|true|1)$/i)
	{
		my $go = "https://$ENV{HTTP_HOST}$PREF{REQ_URI_SANS_QS}" . ($qs ? "?$qs" : '');
		enc_redirect($go);
	}

	if($PREF{prevent_direct_cgi_access} =~ /yes/i   &&   !$PREF{we_are_virtual}   &&   $ENV{REQUEST_METHOD} !~ /post/i   &&   !$qs)
	{
		print_http_headers();
		print $PREF{direct_cgi_access_error};
		exit;
	}

	$PREF{time_offset}			= $PREF{time_offset} * 3600			if $PREF{time_offset} =~ /^-?\d+$/;

	foreach my $prefname (sort keys %PREF)
	{
		   if(is_valid_email_address($PREF{$prefname}) && $PREF{$prefname} =~ /(.+)\@example\.com/i) { $PREF{$prefname} = $1.'@'.($ENV{HTTP_HOST} =~ /^(www\.)?([^:]+)/)[1]; }

		elsif($prefname =~ /^admin_password_hash(_\d\d)?$/  && $PREF{$prefname})	{ $PREF{all_admin_password_hashes}{$PREF{$prefname}} = 1; }
		elsif($prefname =~ /^member_password_hash(_\d\d)?$/ && $PREF{$prefname})	{ $PREF{all_member_password_hashes}{$PREF{$prefname}} = 1; }
	}

	unless($PREF{use_md5_for_hashes} =~ /yes/i)
	{
		eval { require Digest::SHA1; };
		if($@)
		{
			eval { require Digest::SHA; };
			if($@)
			{
				die_nice("Error: $@\n<br /><br />\nYou must install either the Digest::SHA1 Perl module or the Digest::SHA Perl module, or else add the following line to your prefs file: \n<br /><br />\n\$PREF{use_md5_for_hashes} = 'yes';");
			}
			else
			{
				import Digest::SHA 'sha1_hex';
			}
		}
		else
		{
			import Digest::SHA1 'sha1_hex';
		}
	}

	# App-specific here_ values:
	#
	for('here_cart', 'here_buy', 'here_storemenu', 'here_fullpage')
	{
		$PREF{$_} = $PREF{here} unless $PREF{$_}; # ($PREF{$_} && $PREF{$_} ne $ENV{SCRIPT_NAME}); # can't require ne SCRIPT_NAME, or else we can never set any of these to SCRIPT_NAME manually, which we do want to do sometimes, for example for here_fullpage.
		$PREF{$_} = $ENV{SCRIPT_NAME} unless $PREF{$_} =~ /./;

		$PREF{$_ . '_qsready'} = $PREF{$_} =~ /\?/ ? "$PREF{$_}&amp;" : "$PREF{$_}?";
	}
	$PREF{here_fullpage_qsready} .= 'forcefullpage=yes&';


	#
	# Set default values that the user might screw up in the prefs file,
	# i.e. ones that we'll correct here if they have invalid values:
	#

	$PREF{max_age_for_shopping_carts}	= 60*60*24*14					unless $PREF{max_age_for_shopping_carts} =~ /^\d+/;
	$PREF{max_age_for_shopping_carts_in_hours} = $PREF{max_age_for_shopping_carts} / 3600;

	$PREF{product_pages_url_keyword}	= 'product'					unless $PREF{product_pages_url_keyword} =~ /^\w+$/;

	$PREF{url_encoded_paypal_email_address} = enc_urlencode_return($PREF{paypal_payment_recipient_address});


	#
	# Set other prefs that don't need to be adjustable in the prefs file:
	#

	$PREF{app_images_folder_url}		= $PREF{app_base_folder} . "/images"		unless $PREF{app_images_folder_url};	exit_with_error("Your website's app images folder does not exist (or it's not readable); you must create it now ('$PREF{app_images_folder_url}').") unless -d $PREF{DOCROOT}.$PREF{app_images_folder_url} && -r $PREF{DOCROOT}.$PREF{app_images_folder_url};

	$PREF{item_images_folder_url} = $PREF{appdir_url} . "/item_images";
	$PREF{item_images_folder_real} = $PREF{DOCROOT} . $PREF{item_images_folder_url};
	create_dir_if_DNE($PREF{item_images_folder_real}, $PREF{writable_dir_perms});


	unless($PREF{webmaster_email_address} && $PREF{paypal_payment_recipient_address})
	{
		exit_with_notice(qq`Please set \$PREF{webmaster_email_address} to your email address, so you can receive notification emails; and set \$PREF{paypal_payment_recipient_address} to the email address on your PayPal account, so you can receive payments.`);
	}

	setup_item_image_thumbnail_prefs();
	try_to_load_image_modules();


	if($qs eq 'js'   ||   $qs =~ /action=justjs/)
	{
		expand_custom_vars_in_prefs('include_undefined');
		print "Content-type: text/javascript\n\n"; print get_js(); exit;
	}
	elsif($qs =~ /^css(\d*)$/   ||   $qs =~ /action=justcss(\d*)/)
	{
		expand_custom_vars_in_prefs('include_undefined');
		print "Content-type: text/css\n\n"; print get_css(); exit;
	}
	elsif($qs =~ /(?:^|&)newpw(?:&|$)/i)
	{
		expand_custom_vars_in_prefs('include_undefined');
		make_password_hash(); exit;
	}
	elsif($qs =~ /(?:^login$|action=login(&|$))/)
	{
		expand_custom_vars_in_prefs('include_undefined');
		do_login(); exit;
	}
	elsif($qs eq 'logout' || get_qs_var('action') eq 'logout')
	{
		expand_custom_vars_in_prefs('include_undefined');
		do_logout(); exit;
	}


	check_if_logged_in();


	# We're done processing prefs now, so expand all %PREF{foo}s, including undefined ones:
	#
	expand_custom_vars_in_prefs('include_undefined');
}


sub start_html_output
{
	start_html_output_std(@_);
}


sub finish_html_output
{
	finish_html_output_std(@_);
}


sub get_js() { return $PREF{js}; }
sub get_css() { return get_css_std(); }


sub get_linkbar
{
	my @links = ();
	push (@links, qq`<a href="$PREF{home_link_in_footer___url}">$PREF{home_link_in_footer___name}</a>`) if $PREF{home_link_in_footer___name};
	push (@links, qq`<a href="$PREF{here_storemenu_qsready}action=storemenu">$PREF{store_menu_link_in_footer___name}</a>`) if $PREF{store_menu_link_in_footer___name};

	push (@links, get_powered_by()) unless $PREF{hide_poweredby} =~ /yes/i;

	return (join ' &#8211; ', @links) if @links;
}


sub get_powered_by
{
	return qq`<a href="http://encodable.com/cornerstore/" target="_blank">Web Store by Encodable</a>`;
}


sub cart_id_is_valid				{ return ($_[0] =~ /^\w+$/	&&	length($_[0]) < $PREF{max_cart_id_length});	}
sub check_cart_id_for_sql_safeness		{ my $caller = (caller 1)[3]; die_nice("Invalid cart_id: '$_[0]' (called from: $caller)") unless cart_id_is_valid($_[0]);			}

sub item_price_is_valid				{ return ($_[0] =~ /^\d+(\.\d{2}?)?$/);	}
sub check_item_price_for_sql_safeness		{ my $caller = (caller 1)[3]; die_nice("Invalid item_price: '$_[0]' (called from: $caller)") unless item_price_is_valid($_[0]);			}


sub get_cart_count()
{
	my $cart_id = get_cookie($PREF{cart_id_cookie}) || generate_new_cart_id();
	$cart_id = generate_new_cart_id() while(cart_already_sold($cart_id));
	check_cart_id_for_sql_safeness($cart_id);

	my $cart_contents = enc_sql_select_multi("SELECT * FROM `$PREF{shopping_carts_table}` WHERE `cart_id` = '$cart_id' AND IFNULL(`deleted_from_cart`,0) != 1");
	my $num_items = scalar keys %$cart_contents;

	my $template = $PREF{cart_count_template};
	$template =~ s!%%num_items%%!$num_items!g;
	$template =~ s!%%items_word%%!$num_items == 1 ? 'item' : 'items'!eg;

	return $template;
}


sub show_cart_count()
{
	print_http_headers();
	print get_cart_count();
	exit;
}


##############################################################################
### Shared-CS: ###############################################################
##############################################################################


sub load_external_prefs
{
	my ($script_basename) = ($ENV{SCRIPT_NAME} =~ m!.*?[/\\]?([^/\\]+)\.[^/\\\.]+!);
	my ($script_dirname) = ($ENV{SCRIPT_NAME} =~ m!^(.+)/.*?$!);
	my $prefs_basename = $_[0] eq 'use_internal_filename' ? $PREF{internal_filename} : $script_basename;

	my @prefs_files = (	"encodable_shared_prefs___overrideable",
				"${prefs_basename}_shared_prefs___overrideable",
				"${prefs_basename}_prefs_new",
				"${prefs_basename}_prefs",
				"${prefs_basename}_prefs_extra",
				"encodable_shared_prefs___nonoverrideable",
				"${prefs_basename}_shared_prefs___nonoverrideable",
	);

	my $critical_prefs_loaded = 0;
	foreach my $prefs_file (@prefs_files)
	{
		for($prefs_file,
			"$PREF{DOCROOT}/cgi-bin/$prefs_file",		"$PREF{DOCROOT}/../cgi-bin/$prefs_file",
			"$PREF{DOCROOT}/cgi/$prefs_file",		"$PREF{DOCROOT}/../cgi/$prefs_file",
			"$PREF{DOCROOT}$script_dirname/$prefs_file",	"$PREF{DOCROOT}/..$script_dirname/$prefs_file",

			# Also try the parent dir, mainly because it's a likely place for any shared prefs files:
			"$PREF{DOCROOT}$script_dirname/../$prefs_file",	"$PREF{DOCROOT}/..$script_dirname/../$prefs_file", "../$prefs_file"
		)
		{
			if(my $file = -e "${_}.cgi" ? "${_}.cgi" : -e "${_}.pl" ? "${_}.pl" : '')
			{
				my $prefs_contents = ();
				open(IN,"<$file") or die_nice("couldn't open prefs file '$file': $!");
				flock IN, 1;
				seek IN, 0, 0;
				while(<IN>) { $prefs_contents .= $_; }
				close IN or die_nice("couldn't close prefs file '$file': $!");
				$prefs_contents =~ /(.*)/s;
				$prefs_contents = $1; # cheap untaint since this is our own config file.
				eval $prefs_contents; die_nice("Error processing your prefs file ('$file'): $@") if $@;
				$critical_prefs_loaded = 1 unless $file =~ /(_shared_prefs_|_prefs_extra)/;
				$PREF{loaded_prefs_files} .= "$file, ";
				last;
			}
		}
	}

	$PREF{loaded_prefs_files} =~ s!, $!!;

	if(!$critical_prefs_loaded)
	{
		if($_[0] ne 'use_internal_filename')
		{
			# First pass failed, so try again but use $PREF{internal_filename} as the prefs base.
			load_external_prefs('use_internal_filename');
		}
		else
		{
			# Second pass failed too; nothing else we can do.
			die_nice(
				"Error: couldn't find any prefs file to load.  You must put your $PREF{prefs_basename}_prefs.cgi file on the server with the $PREF{prefs_basename}.cgi file."
				. ($PREF{docroot_autodetection_error} ? qq` <br /><br />\nThis may be caused by or related to the following: $PREF{docroot_autodetection_error}` : '')
			);
		}
	}
}


sub load_userbase_prefs
{
	if($PREF{integrate_with_userbase} =~ /yes/i   &&   $PREF{internal_appname} !~ /^userbase$/i)
	{
		# Try to load UserBase prefs from userbase_prefs.cgi to avoid
		# having to specify common prefs twice.

		my %ub_pref_names = (
			database_hostname				=> 1,
			database_name					=> 1,
			database_username				=> 1,
			database_password				=> 1,
			dbi_connection_string				=> 1,

			time_offset					=> 1,
			hide_poweredby					=> 1,

			site_session_cookie				=> 1,
			login_url					=> 1,

			user_table					=> 1,
			group_table					=> 1,
			custom_field_table				=> 1, # for backwards compatibility.
			custom_field_list_table				=> 1,

			max_username_length				=> 1,
			max_groupname_length				=> 1,
			max_hashedpw_length				=> 1,

			allow_spaces_in_usernames			=> 1,
			allow_atsigns_in_usernames			=> 1,
			allow_dots_in_usernames				=> 1,
			allow_dashes_in_usernames			=> 1,

			allow_spaces_in_groupnames			=> 1,
			allow_atsigns_in_groupnames			=> 1,
			allow_dots_in_groupnames			=> 1,
			allow_dashes_in_groupnames			=> 1,

			make_usernames_case_insensitive			=> 1,
			make_passwords_case_insensitive			=> 1,

			idle_timeout					=> 1,
			num_days_rememberme_cookie_lasts		=> 1,
			enable_ip_address_restriction			=> 1,
			force_ip_address_restriction			=> 1,
			disable_ip_restriction_for_AOL_users		=> 1,
			enable_forced_password_change			=> 1,
			admins_can_be_forced_to_change_their_own_pws	=> 1,
			prevent_multiple_simultaneous_logons_per_username => 1,

			subgroup_groupname_suffix			=> 1,
			groups_that_can_manage_subgroup_users		=> 1,
			subgroup_owned_users_get_disabled_when_their_manager_does => 1,
		);

		my $prefs_basename = $PREF{userbase_prefs_file_basename};
		my @prefs_files = ("${prefs_basename}_prefs_new.cgi", "${prefs_basename}_prefs_new.pl", "${prefs_basename}_prefs.cgi", "${prefs_basename}_prefs.pl", "${prefs_basename}_prefs_extra.cgi", "${prefs_basename}_prefs_extra.pl");
		push (@prefs_files, $PREF{userbase_prefs_file}) if $PREF{userbase_prefs_file}; # so we can specify it manually, including full path, if necessary.
		push (@prefs_files, $PREF{userbase_prefs_file_extra}) if $PREF{userbase_prefs_file_extra};
		my $prefs_loaded = 0;
		foreach my $prefs_file (@prefs_files)
		{
			for(get_likely_prefs_file_locations($prefs_file))
			{
				if(-e $_)
				{
					my $file = $_;
					open(IN,"<$file") or die_nice("couldn't open prefs file '$file': $!");
					flock IN, 1;
					seek IN, 0, 0;
					while(<IN>)
					{
						if(/^\$PREF{(\w+)}\s*=\s*(.+)/)
						{
							my ($pref,$value) = ($1,$2);
							if($ub_pref_names{$pref})
							{
								if($value =~ /ENV\{SCRIPT_NAME\}/)
								{
									# In userbase_prefs.cgi, any use of $ENV{SCRIPT_NAME} is intended to mean '/cgi-bin/userbase.cgi'
									# (or whatever the path to userbase.cgi is), so we can't eval that here from FileChucker etc,
									# because then it will end up being '/cgi-bin/filechucker.cgi' instead.  (This is primarily a
									# problem for the $PREF{login_url} setting.)  So we'll try to figure out what the correct path to
									# userbase.cgi is, and if we can't, then we'll just skip this line from the userbase_prefs.cgi file.

									foreach my $likely_prefs_file (get_likely_prefs_file_locations($prefs_file))
									{
										my $script_name_full = $likely_prefs_file;
										$script_name_full =~ s!_prefs(_(new|extra))?!!; # remove the _prefs/_prefs_new/_prefs_extra from the prefs filename to get the script name.

										if(-e $script_name_full)
										{
											if($script_name_full =~ m!^$PREF{DOCROOT}(.+)!) # we only want the ones including the full path (i.e. just plain "userbase_prefs.cgi" doesn't help us here).
											{
												my $script_name = $1;
												$script_name =~ s!\.\./!!g; # in case this is one of the paths containing a "../", which is OK in the filesystem but not in URLs.

												my $updated_line = '';

												if(/^\$PREF{\w+}\s*=\s*\$ENV{SCRIPT_NAME};$/)
												{
													# If it's a simple "$PREF{foo} = $ENV{SCRIPT_NAME};" line, then we know we need to
													# add quotes around the $script_name value that we interpolate back into it:
													#
													$updated_line = $_; $updated_line =~ s!(%|\$)ENV\{SCRIPT_NAME\}!'$script_name'!g;
													eval $updated_line;
												}
												else
												{
													# Otherwise, the original line may or may not have had the ENV{SCRIPT_NAME} variable
													# within a quoted string, so we'll have to try this multiple ways:
													#
													$updated_line = $_; $updated_line =~ s!(%|\$)ENV\{SCRIPT_NAME\}!$script_name!g;
													eval $updated_line;
													if($@)
													{
														$updated_line = $_; $updated_line =~ s!(%|\$)ENV\{SCRIPT_NAME\}!'$script_name'!g;
														eval $updated_line;
														if($@)
														{
															$updated_line = $_; $updated_line =~ s!(%|\$)ENV\{SCRIPT_NAME\}!"$script_name"!g;
															eval $updated_line;
															if($@)
															{
																# We tried.
																die_nice(qq`Error processing your UserBase prefs file ('$file'): $@ <br /><br />\n\n(While processing line: "$updated_line") <br /><br />\n\nYou should get UserBase running first, then return here.`);
															}
														}
													}
												}
												last;
											}
										}
									}
								}
								else
								{
									eval $_; die_nice(qq`Error processing your UserBase prefs file ('$file'): $@ <br /><br />\n\n(While processing line: "$_") <br /><br />\n\nYou should get UserBase running first, then return here.`) if $@;
								}
							}
						}
						elsif(/^\$TEXT{(\w+)}\s*=\s*/)
						{
							eval $_; die_nice(qq`Error processing your UserBase prefs file ('$file'): $@ <br /><br />\n\n(While processing line: "$_") <br /><br />\n\nYou should get UserBase running first, then return here.`) if $@;
						}
					}
					close IN or die_nice("couldn't close prefs file '$file': $!");
					$PREF{loaded_userbase_prefs_files} .= "$file, ";
					$prefs_loaded = 1;
					last;
				}
			}
		}
		die_nice("Error: couldn't find any UserBase prefs file to load.  You must put your UserBase prefs file on the server with this script file.  This script will look in its own folder, in the cgi-bin folder, and in the login folder by default.  You can also add a new line to this script's prefs file setting \$PREF{userbase_prefs_file_extra} to the full filename (including path) of your UserBase prefs file.") unless $prefs_loaded;
	}
	
	$PREF{loaded_userbase_prefs_files} =~ s!, $!!;

	$PREF{custom_field_list_table} = $PREF{custom_field_table} if $PREF{custom_field_table} && !$PREF{custom_field_list_table}; # For backwards compatibility;
	$PREF{custom_field_table} = $PREF{custom_field_list_table} if $PREF{custom_field_list_table} && !$PREF{custom_field_table}; # this was just a renamed pref.
}


sub get_likely_prefs_file_locations($)
{
	my $prefs_file = shift;
	my ($script_dirname) = ($ENV{SCRIPT_NAME} =~ m!^(.+)/.*?$!);
	return($prefs_file,
		"$PREF{DOCROOT}/cgi-bin/$prefs_file",		"$PREF{DOCROOT}/../cgi-bin/$prefs_file",
		"$PREF{DOCROOT}/cgi/$prefs_file",		"$PREF{DOCROOT}/../cgi/$prefs_file",
		"$PREF{DOCROOT}/login/$prefs_file",		"$PREF{DOCROOT}/../login/$prefs_file",
		"$PREF{DOCROOT}$script_dirname/$prefs_file",	"$PREF{DOCROOT}/..$script_dirname/$prefs_file"
	);
}


sub load_other_prefs_files
{
	my @other_prefs_files = ();
	foreach my $num (sort keys %{$PREF{other_prefs_files}})
	{
		my $name = $PREF{other_prefs_files}{$num}{shortcut_name};
		if($qs =~ /(?:^|&)prefs=$name(?:&|$)/)
		{
			my $file = $PREF{other_prefs_files}{$num}{shortcut_target};
			if($PREF{other_prefs_files_are_in_docroot} =~ /yes/i)
			{
				$file = "$PREF{DOCROOT}/$file";
				condense_slashes('leave_leading_UNC', $file);
			}
			die_nice("prefs file '$file' does not exist.") unless -e $file;
			push @other_prefs_files, $file;
		}
	}
	if($PREF{enable_other_prefs_files_with_filename_on_URL} =~ /yes/i)
	{
		while($qs =~ /(?:^|&)prefsfile=(.+?)(?:&|$)/g)
		{
			my $file = $1;
			if($PREF{other_prefs_filenames_from_URL_can_contain_paths} =~ /yes/i)	{ $file = enc_untaint($file, 'keep_path');	}
			else									{ $file = enc_untaint($file);			}
			if($PREF{other_prefs_files_are_in_docroot} =~ /yes/i)
			{
				$file = "$PREF{DOCROOT}/$file";
				condense_slashes('leave_leading_UNC', $file);
			}
			die_nice("prefs file '$file' does not exist.") unless -e $file;
			push @other_prefs_files, $file;
		}
	}
	foreach my $prefs_file (@other_prefs_files)
	{
		my $prefs_contents = ();
		open(IN,"<$prefs_file") or die_nice("couldn't open prefs file '$prefs_file': $!");
		flock IN, 1;
		seek IN, 0, 0;
		while(<IN>) { $prefs_contents .= $_; }
		close IN or die_nice("couldn't close prefs file '$prefs_file': $!");
		$prefs_contents =~ /(.*)/s;
		$prefs_contents = $1; # cheap untaint since this is our own config file.
		eval $prefs_contents; die_nice("Error processing your prefs file: $@") if $@;
	}
}


sub do_preinit()
{
	$PREF{app_start_time} = time;
	if($ENV{QUERY_STRING} eq 'version') { print "Content-type: text/plain\n\n"; print "$version\n"; exit; }
	my ($cwd) = ($ENV{SCRIPT_FILENAME} =~ m!^(.+)/.*?$!);
	unless($cwd) { $cwd = $ENV{PATH_TRANSLATED}; $cwd =~ s![^/\\]+$!!; }
	enc_chdir($cwd);
	$PREF{initial_cwd} = $cwd;
	$PREF{on_page} = 'default';
	$qs = $ENV{QUERY_STRING};
	$PREF{we_are_embedded} = $qs =~ /encembed=yes/ ? 1 : 0; $qs =~ s!&encembed=yes!!g; $qs =~ s!encembed=yes&!!g; $qs =~ s!encembed=yes!!g;   # remove it so it's not present on any URLs where we re-use $qs, because this should only be present when hard-coded from a php/shtml/etc page.
	populate_cookies_hash();
}


sub verify_server_environment()
{
	#print STDERR dumphash(\%ENV,"\n") . "\n";
	my ($SCRIPT_var_count, $SERVER_var_count) = (0, 0);
	my @all_vars = ();
	foreach my $var (sort keys %ENV)
	{
		$SCRIPT_var_count++ if $var =~ /^SCRIPT_/;
		$SERVER_var_count++ if $var =~ /^SERVER_/;
		push @all_vars, "$var: $ENV{$var}";
	}
	unless($SCRIPT_var_count > 0 && $SERVER_var_count > 0)
	{
		die qq`Error: it seems I've been executed on a command line, but that won't work, since I'm a web application and must be executed within a server environment.\n`; # . qq`\nAll vars: ` . (join "\n", @all_vars) . qq`\n\n`;
	}
}


sub fix_server_environment()
{
	# Fix the %ENV if necessary.
	#
	if(!$ENV{REQUEST_URI}) # IIS is crap.
	{
		$ENV{REQUEST_URI} = $ENV{PATH_INFO};
		$ENV{REQUEST_URI} .= '?' . $qs if $qs;
	}

	# On GoDaddy, for subdomains, they set DOCUMENT_ROOT incorrectly, and set SUBDOMAIN_DOCUMENT_ROOT to the real docroot.
	$ENV{DOCUMENT_ROOT} = $ENV{SUBDOMAIN_DOCUMENT_ROOT} if $ENV{SUBDOMAIN_DOCUMENT_ROOT};

	$PREF{DOCROOT} ||= $ENV{DOCUMENT_ROOT};
	if(!$PREF{DOCROOT})
	{
		($PREF{DOCROOT}) = ($ENV{SCRIPT_FILENAME} =~ m!^(.+)$ENV{SCRIPT_NAME}$!i);
		if(!$PREF{DOCROOT})
		{
			# try to fix IIS garbage.
			my $path_translated = $ENV{PATH_TRANSLATED};
			my $is_unc = $path_translated =~ m!^\\\\!;
			$path_translated =~ s!\\\\!/!g;
			$path_translated =~ s!\\!/!g;
			$path_translated =~ s!^[/\\]+!\\\\! if $is_unc;
			if($path_translated =~ m!^(.+)$ENV{PATH_INFO}$!i)
			{
				$PREF{DOCROOT} = $1;
			}
			else
			{
				$PREF{DOCROOT} = ($path_translated =~ m!(.+)/[^/]+!)[0];
			}
		}
		$PREF{docroot_autodetection_error} = "Error: couldn't set \$PREF{DOCROOT} from \$ENV{DOCUMENT_ROOT} ('$ENV{DOCUMENT_ROOT}'), \$ENV{SCRIPT_FILENAME} ('$ENV{SCRIPT_FILENAME}'), or \$ENV{PATH_TRANSLATED} ('$ENV{PATH_TRANSLATED}').\n" unless $PREF{DOCROOT};
	}
	$PREF{DOCROOT} =~ s![/\\]+$!! unless $PREF{DOCROOT} =~ m!^[/\\]+$!; # remove trailing slashes.

	# Fix another Network Solutions bug:
	if($PREF{DOCROOT} =~ m!/usr/services/vux/apache/htdocs!   &&   $ENV{SCRIPT_FILENAME} =~ m!(/data/\d+/\d+/\d+/\d+/\d+/user/\d+)/cgi-bin!)
	{
		$PREF{DOCROOT} = "$1/htdocs";
	}

	my $default_scriptname = '/cgi-bin/' . $PREF{internal_filename} . '.cgi';
	$ENV{SCRIPT_NAME} ||= $default_scriptname;

	# Fix for broken Network Solutions servers:
	$ENV{SCRIPT_NAME} = $1 if $ENV{SCRIPT_NAME} =~ m!~\d+\.\d+/(/cgi-bin/.+)!;

	# Fix stupid servers that set our scriptname to the wrapper scriptname:
	$ENV{SCRIPT_NAME} = $default_scriptname if $ENV{SCRIPT_NAME} =~ /\.php/ && -e "$PREF{DOCROOT}/$default_scriptname";
	$ENV{SCRIPT_NAME} = $default_scriptname if $ENV{SCRIPT_NAME} =~ /\.php/ && -e "$PREF{DOCROOT}/../$default_scriptname";
}


sub set_default_prefs_for_all_apps()
{
	# Prefs that are needed by all apps, and that are (at least by default) set
	# to the same values in all apps.  And we don't need any "unless exists"
	# tests here because this sub is called before loading external prefs.

	$PREF{list_of_sql_safe_characters} = qq`ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 0123456789 !#%^&*()_=+ ~ []{}| ;:'" ,.<>/? \`\@\$\r\n\t\\-`; # dash, if present, must be last.

	$PREF{max_tablename_length}			= 80;

	$PREF{site_session_cookie}			= 'site_session';
	$PREF{non_userbase_login_cookie}		= 'enc_non_ub_login';
	$PREF{num_days_login_lasts}			= 14;
	$PREF{enc_visitor_id_cookie}			= 'encvisid';
	$PREF{enc_visitor_id_was_missing}		= 1 unless $COOKIE{ $PREF{enc_visitor_id_cookie} };
	$PREF{enc_visitor_id}				= $COOKIE{ $PREF{enc_visitor_id_cookie} } || generate_random_hash();

	$PREF{public_group_name}			= 'public';
	$PREF{member_group_name}			= 'member';
	$PREF{admin_group_name}				= 'admin';

	$PREF{writable_dir_perms}			= 0777;
	$PREF{writable_file_perms}			= 0666;

	$PREF{here}					= $ENV{SCRIPT_NAME};
	#$PREF{here_login}				= $ENV{SCRIPT_NAME}; # deprecated by figure_out_where_here_is (?)

	$PREF{needlogin_message}			= qq`%%js_auto_redirect%%<h1 class="pagetitle">Login Required</h1><p>Login required; <a href="%%login_url%%">click here</a> to continue.</p>`;
	$PREF{needprivs_message}			= qq`%%js_auto_redirect%%<h1 class="pagetitle">Access Denied</h1><p>Access denied.&nbsp; %%%if-notloggedin%%%Perhaps you need to <a href="%%login_url%%">login</a> first?%%%end-notloggedin%%%</p>`;
}


sub check_for_enc_visitor_id()
{
	# This check must occur before trying anything that could result in an error
	# like reading prefs files, checking whether datadirs exist, etc.  That's 
	# because in some cases, particularly when a client wants to use ENV variables
	# from PHP to set a path pref dynamically, an error due to a nonexistent path
	# would prevent us from setting the enc_visitor_id, but would also be *caused*
	# by a missing enc_visitor_id.  So, set_enc_visitor_id() is designed to not
	# depend on anything else (prefs, etc), so it can be called separately and
	# then exit, just to get the cookie in place.

	if($qs =~ /(^|&)action=set_enc_visitor_id(&|$)/) { set_enc_visitor_id(); } # exits early.
}


sub load_webconfig_prefs
{

}


sub populate_cookies_hash()
{
	foreach my $cookie (split(/;\s*/, $ENV{HTTP_COOKIE}))
	{
		my ($name,$value) = split(/=/, $cookie);
		$COOKIE{$name} = enc_urldecode_return($value);
	}
}


sub settle_docroot_datadir_cgimodule_etc()
{
	# DOCROOT must be one of the first things settled after loading the external prefs:
	#
	$PREF{DOCROOT} = enc_untaint($PREF{DOCROOT}, 'keep_path');
	exit_with_error("Error: you have set \$PREF{DOCROOT} to '$PREF{DOCROOT}', but that path does not exist.  You must create it now, or adjust this setting to point to the correct directory.") if ! -d $PREF{DOCROOT};


	# datadir should be settled right after DOCROOT:
	#
	$PREF{datadir} = 'encdata' unless $PREF{datadir};
	$PREF{datadir} = $PREF{DOCROOT} . $PREF{datadir} if $PREF{datadir_is_in_docroot} eq 'yes';
	create_dir_if_DNE($PREF{datadir}, $PREF{writable_dir_perms}, 'make_parents', 'ignore_errors');
	exit_with_error(qq`Error: your settings for \$PREF{datadir} and \$PREF{datadir_is_in_docroot} \nresult in \$PREF{datadir} being set to '$PREF{datadir}', \nbut that path does not exist.  You must create it, or adjust these \nsettings to point to the correct directory.`) unless -d $PREF{datadir};
	exit_with_error(qq`Error: the directory \$PREF{datadir}  ($PREF{datadir})  must be readable by this script (which usually means world-readable), but it isn't.`) if ! -r $PREF{datadir};
	exit_with_error(qq`Error: the directory \$PREF{datadir}  ($PREF{datadir})  must be writable by this script (which usually means world-writable), but it isn't.`) if ! -w $PREF{datadir};
	#
	# Append our per-app subdir onto datadir ($PREF{datadir} should be set to just 'encdata' by default):
	#
	$PREF{datadir_subdir_name} = $PREF{internal_appname} unless $PREF{datadir_subdir_name};
	$PREF{datadir} .= $PREF{datadir} =~ m![/\\]$! ? $PREF{datadir_subdir_name} : "/$PREF{datadir_subdir_name}";
	create_dir_if_DNE($PREF{datadir}, $PREF{writable_dir_perms});


	if($PREF{debuglog} =~ /yes/i)
	{
		$PREF{debuglogdir} = $PREF{datadir} . '/debuglogs';
		create_dir_if_DNE($PREF{debuglogdir}, $PREF{writable_dir_perms});
		$PREF{debuglogfile} = $PREF{debuglogdir} . '/' . date8() . '.cgi';
		create_file_if_DNE($PREF{debuglogfile}, $PREF{writable_file_perms});
	}


	# Once $PREF{datadir} is settled, set $ENV{TMPDIR} to that, and THEN we can
	# import the CGI module via "require CGI;" and it will use our $ENV{TMPDIR}
	# setting as its temp space during uploads.
	#
	$ENV{TMPDIR} = $PREF{datadir} unless $PREF{dont_use_datadir_as_cgi_tmpdir} =~ /yes/i;
	$CGITempFile::TMPDIRECTORY = $PREF{datadir} unless $PREF{dont_use_datadir_as_cgi_tmpdir} =~ /yes/i; # necessary on some servers?
	#
	#use CGI; # DO NOT USE THIS!
	#
	require CGI;
	#
	#use CGI qw/:standard :param/; # DO NOT USE THIS!
	#use CGI qw(param); # DO NOT USE THIS!
	#
	import CGI ':standard';
	import CGI ':param';
	#
	use CGI::Cookie; # "use" is OK for sub-modules.


	unless($PREF{app_base_folder} =~ m!^/!)
	{
		$PREF{app_base_folder} = '/login'	if $PREF{internal_appname} eq 'userbase';
		$PREF{app_base_folder} = '/upload'	if $PREF{internal_appname} eq 'filechucker';
		$PREF{app_base_folder} = '/visitors'	if $PREF{internal_appname} eq 'visitorlog';
		$PREF{app_base_folder} = '/contact'	if $PREF{internal_appname} eq 'contactform';
		$PREF{app_base_folder} = '/mailylist'	if $PREF{internal_appname} eq 'mailylist';
		$PREF{app_base_folder} = '/store'	if $PREF{internal_appname} eq 'cornerstore';
	}
	exit_with_error("Error: \$PREF{app_base_folder} not set; it must be set to something like '/appname'.") unless $PREF{app_base_folder};


	# appdir is like datadir except a) it's servable and b) it's per-app (within the
	# app's base folder) rather than within the shared /cgi-bin/encdata folder.
	#
	$PREF{appdir_url}	= $PREF{app_base_folder} . ($PREF{app_base_folder} =~ m![/\\]$! ? '' : '/') . "appdata";
	$PREF{appdir_real}	= $PREF{DOCROOT} . $PREF{appdir_url};
	exit_with_error("$PREF{internal_appname_nice}'s appdata folder ('$PREF{appdir_url}') does not exist on your website; you must create it now, or else adjust the \$PREF{app_base_folder} setting.  This must be within your \$PREF{DOCROOT}, which is currently '$PREF{DOCROOT}'.") unless -d $PREF{appdir_real};

	unless($PREF{skip_appdir_permissions_checks} =~ /yes/i)
	{
		my @all_dirs = ($PREF{appdir_real}, $PREF{datadir});
		push (@all_dirs, $PREF{appdir_real} . '/' . $_) for get_all_subdirs($PREF{appdir_real});
		push (@all_dirs, $PREF{datadir} . '/' . $_) for get_all_subdirs($PREF{datadir});
		foreach my $dir (@all_dirs)
		{
			exit_with_error("The '$dir' folder must be readable by this script (which usually means world-readable), but it isn't; you must adjust its permissions to make it so.") unless -r $dir;
			exit_with_error("The '$dir' folder must be writable by this script (which usually means world-writable), but it isn't; you must adjust its permissions to make it so.") unless -w $dir;
		}
	}
}


sub figure_out_where_here_is
{
	$PREF{here} ||= $ENV{SCRIPT_NAME};
	$PREF{here} = ($ENV{REQUEST_URI} =~ m!([^\?]+)!)[0] if $ENV{REQUEST_URI} && $PREF{here} eq 'auto';
	for('here_static', 'here_login')
	{
		$PREF{$_} = $PREF{here} unless $PREF{$_}; # ($PREF{$_} && $PREF{$_} ne $ENV{SCRIPT_NAME});
		$PREF{$_} = $ENV{SCRIPT_NAME} unless $PREF{$_} =~ /./;

		$PREF{$_ . '_qsready'} = $PREF{$_} =~ /\?/ ? "$PREF{$_}&amp;" : "$PREF{$_}?";
	}
	$PREF{here_qsready} = $PREF{here} =~ /\?/ ? "$PREF{here}&amp;" : "$PREF{here}?";
	$PREF{login_url_qsready} = $PREF{login_url} =~ /\?/ ? "$PREF{login_url}&amp;" : "$PREF{login_url}?";
}


sub do_postpref_processing()
{
	# Use this spot for any code that must run immediately after prefs are loaded.
	#
	if($PREF{internal_appname} eq 'visitorlog')
	{
		$PREF{print_full_html_tags} = 'no' if $qs =~ /(^|&)(justsummary|mode=hitsgraph)(&|$)/;
	}

	# These are postpref so they can use offsettime():
	#
	my $start	= offsettime();
	$PREF{date8}	= date8($start);
	$PREF{date14}	= date14($start);
}


sub do_blacklisting_and_whitelisting()
{
	do_group_based_blacklisting_and_whitelisting();

	my $blocked = 0;

	my $ip_whitelisting_enabled = 0;
	my $user_matches_ip_whitelist = 0;
	foreach my $rule (sort keys %{$PREF{forced_whitelist_ip_addresses}})
	{
		if(my $allowed_ip = $PREF{forced_whitelist_ip_addresses}{$rule})
		{
			$ip_whitelisting_enabled = 1;
			$user_matches_ip_whitelist = 1 if $PREF{ip} =~ /$allowed_ip/;
		}
	}
	$blocked = 1 if $ip_whitelisting_enabled && !$user_matches_ip_whitelist;

	my $host_whitelisting_enabled = 0;
	my $user_matches_host_whitelist = 0;
	foreach my $rule (sort keys %{$PREF{forced_whitelist_hostnames}})
	{
		if(my $allowed_host = $PREF{forced_whitelist_hostnames}{$rule})
		{
			$host_whitelisting_enabled = 1;
			$user_matches_host_whitelist = 1 if $PREF{host} =~ /$allowed_host/i;
		}
	}
	$blocked = 1 if $host_whitelisting_enabled && !$user_matches_host_whitelist;

	foreach my $rule (sort keys %{$PREF{forced_blacklist_ip_addresses}})
	{
		if(my $blocked_ip = $PREF{forced_blacklist_ip_addresses}{$rule})
		{
			$blocked = 1 if $PREF{ip} =~ /$blocked_ip/;
		}
	}

	foreach my $rule (sort keys %{$PREF{forced_blacklist_hostnames}})
	{
		if(my $blocked_host = $PREF{forced_blacklist_hostnames}{$rule})
		{
			$blocked = 1 if $PREF{host} =~ /$blocked_host/;
		}
	}

	exit_with_error($TEXT{failed_black_or_white_list}) if $blocked;
}


sub do_group_based_blacklisting_and_whitelisting()
{
	foreach my $rule (sort keys %{$PREF{grouped_whitelist_ip_addresses}})
	{
		if(my $allowed_ip = $PREF{grouped_whitelist_ip_addresses}{$rule})
		{
			$PREF{user_is_encwhitelisted} = 1 if $PREF{ip} =~ /$allowed_ip/;
		}
	}

	foreach my $rule (sort keys %{$PREF{grouped_whitelist_hostnames}})
	{
		if(my $allowed_host = $PREF{grouped_whitelist_hostnames}{$rule})
		{
			$PREF{user_is_encwhitelisted} = 1 if $PREF{host} =~ /$allowed_host/i;
		}
	}

	foreach my $rule (sort keys %{$PREF{grouped_blacklist_ip_addresses}})
	{
		if(my $blocked_ip = $PREF{grouped_blacklist_ip_addresses}{$rule})
		{
			$PREF{user_is_encblacklisted} = 1 if $PREF{ip} =~ /$blocked_ip/;
		}
	}

	foreach my $rule (sort keys %{$PREF{grouped_blacklist_hostnames}})
	{
		if(my $blocked_host = $PREF{grouped_blacklist_hostnames}{$rule})
		{
			$PREF{user_is_encblacklisted} = 1 if $PREF{host} =~ /$blocked_host/;
		}
	}
}


sub get_cookies()
{
	my %cookies = fetch CGI::Cookie;
	return %cookies;
}


sub get_cookie($)
{
	my $which = shift;
	my %jar = get_cookies();
	my $value = '';

	if(exists $jar{$which})
	{
		$value = $jar{$which}->value;
	}
	elsif($which eq $PREF{site_session_cookie})
	{
		if($qs =~ /(?:^|&)ubsessioncode=(\w+)(?:&|$)/)
		{
			my $code = $1;

			# Accepting the session code from the URL should only be allowed as a last resort.
			# On decent servers this shouldn't be necessary because we can call UserBase
			# from PHP using virtual() and/or exec() both of which pass the cookies.  Even
			# on sub-par servers where we have to use include() with the full http:// URL,
			# we can reduce the security risk by requiring the remote IP to match the server
			# IP, i.e. ONLY allow the include(http://...) method to work: don't accept URL-
			# based session codes from any other IP.  As a last resort on totally sucky
			# servers where PHP is crippled and $ENV{SERVER_ADDR} DNE or is variable or
			# otherwise useless, proceed only by setting a PREF that indicates what a bad
			# idea it is.

			if($PREF{ip} eq $ENV{SERVER_ADDR})
			{
				$value = $code;
			}
			elsif($PREF{my_server_sucks_so_use_less_secure_mode} =~ /yes/i)
			{
				sleep $PREF{sleeptime_for_less_secure_mode} || 3;
				$value = $code;
			}
		}
	}

	return $value;
}


sub set_cookie($$$)
{
	my $name = shift;
	my $value = shift;
	my $expiry = shift;
	my $cookie = undef;

	# The if/else for expiry is because setting "expires" to "" isn't
	# the same as not setting it.  Setting it to "" is the same as 
	# setting it to zero, which expires the cookie immediately
	# (i.e., deletes it).  But explicitly *not* setting the expiry
	# causes the cookie to persist until the end of the session.

	if($PREF{cookie_domain})
	{
		if($expiry eq "")	{ $cookie = new CGI::Cookie(-name => $name, -value => $value, -path => '/', -domain => $PREF{cookie_domain});				}
		else			{ $cookie = new CGI::Cookie(-name => $name, -value => $value, -path => '/', -domain => $PREF{cookie_domain}, -expires => $expiry);	}
	}
	else
	{
		if($expiry eq "")	{ $cookie = new CGI::Cookie(-name => $name, -value => $value, -path => '/');						}
		else			{ $cookie = new CGI::Cookie(-name => $name, -value => $value, -path => '/', -expires => $expiry);			}
	}

	if($PREF{output_started})
	{
		print "<p>$PREF{internal_appname} warning: cannot set cookie '$name' => '$value' because the page output has already been started (perhaps debug is enabled?).</p>\n";
	}
	elsif($PREF{we_are_virtual})
	{
		print_http_headers();
		print "<p>$PREF{internal_appname} warning: cannot set cookie '$name' => '$value' because we are virtual.</p>\n";
	}
	else
	{
		print_p3p_header();
		print "Set-Cookie: $cookie\n";
	}
}


sub determine_cookie_domain
{
	if($ENV{HTTP_HOST} =~ /\w+\.\w+/   &&   !is_ipv4_address($ENV{HTTP_HOST})   &&   !($PREF{never_specify_domain_when_setting_cookies} =~ /yes/i))
	{
		# If we're running on a domain name, then specify it in our cookies.  This allows us
		# to put a dot at the start of the domain name, which causes the cookies to be set for
		# and accessible from the domain and all subdomains including www.  So we'll remove
		# any leading www first, as well as any port number.

		my $domain = $ENV{HTTP_HOST}; $domain =~ s!^www\.!!; $domain =~ s!:\d+$!!; $domain = ".$domain";
		$PREF{cookie_domain} = $domain;
	}
}


sub get_qs_var
{
	return enc_urldecode_return(   ($qs =~ /(?:^|&(?:amp;)?)$_[0]=([^&]*)/)[0]   );
}


# APICHANGE: 201012: expand_custom_vars_in_prefs() no longer accepts a hashref,
# only an optional string.
#
sub expand_custom_vars_in_prefs
{
	expand_custom_vars_in_prefs___inner(\%PREF, @_);
	expand_custom_vars_in_prefs___inner(\%TEXT, @_);
}


sub expand_custom_vars_in_prefs___inner
{
	my $hashref = shift;
	my $include_undefined = shift; $include_undefined = 0 unless $include_undefined eq 'include_undefined';

	# Execute this a few times without undefineds first, so that nested values can be
	# properly expanded (i.e. one setting contains %PREF{foo}, but $PREF{foo} itself
	# contains %PREF{bar}, etc).

	my $num_iterations = 5;
	for(my $i = 1; $i <= $num_iterations; $i++)
	{
		my $include_undefined_real = $include_undefined && $i == $num_iterations ? 1 : 0;

		foreach my $key (keys %$hashref)
		{
			if(ref($$hashref{$key}) eq 'HASH') # for prefs that are themselves hashes, i.e. $PREF{foo}{01} as in $PREF{foo}{01}{bar}.
			{
				expand_custom_vars_in_prefs___inner($$hashref{$key});
			}
			else
			{
				# from now on, use %%varname%% instead of $$varname$$, so that it doesn't
				# matter whether it gets put in double-quotes.

				next unless $$hashref{$key} && $$hashref{$key} =~ /(\$\$|%%|%PREF{|%TEXT{|%URL{|%COOKIE{|%SQL{|%ENV{|%DATE{)/;
				next if $PREF{"${key}___skip_init_var_expansion"} =~ /yes/i;

				# old way:
				$$hashref{$key} =~ s/\$\$server_name\$\$/$ENV{'SERVER_NAME'}/g;
				$$hashref{$key} =~ s/\$\$httphost_withport\$\$/$ENV{'HTTP_HOST'}/g;
				$$hashref{$key} =~ s/\$\$name_of_site\$\$/$$hashref{'name_of_site'}/g;

				# new way:
				$$hashref{$key} =~ s/%%server_name%%/$ENV{SERVER_NAME}/g;
				$$hashref{$key} =~ s/%%http_host%%/$ENV{HTTP_HOST}/g;
				$$hashref{$key} =~ s/%%name_of_site%%/$$hashref{name_of_site}/g;

				#interpolate_vars_from_URL_and_cookies($include_undefined, $$hashref{$key});
				do_standard_template_vars_processing($include_undefined, $$hashref{$key});
			}
		}
	}
}


sub show_prefs
{
	$PREF{on_a_wide_page} = 1;
	start_html_output("Prefs");
	print qq`<div id="enc_prefs_list" class="enc_tbl">\n<table>\n<tr><th>Prefs</th></tr>\n`;
	my $oddeven = 1;
	my $allprefs = get_prefs('all');
	foreach my $pref (sort { lc($a) cmp lc($b) } keys %$allprefs)
	{
		print qq`<tr class="` . oddeven($oddeven) . qq`"><td><strong>$pref:</strong> $$allprefs{$pref}</td></tr>\n`;
	}
	print qq`</table>\n</div>\n`;
	finish_html_output();
}


sub get_prefs
{
	my $all = shift;
	my %prefs = ();
	foreach my $key (sort { lc($a) cmp lc($b) } keys %PREF)
	{
		#if($all   ||   ($key !~ /^(database_name|database_hostname|database_username|database_password|smtp_auth_username|smtp_auth_password)$/))
		#
		# It's not necessary to hide those sensitive values, since we're only
		# displaying all prefs in authenticated situations in the first place.
		#
		if(1)
		{
			my $value = $PREF{$key};
			$value =~ s!<!&lt;!g;
			$value =~ s!>!&gt;!g;
			$value =~ s!\n!\n<br />!g;
			$prefs{$key} = $value;
		}
	}
	return \%prefs;
}


sub show_server_info
{
	start_html_output($TEXT{Server_Information});

	eval { require MIME::Lite; }; my $mimeliteversion = $@ ? qq`not installed` : $MIME::Lite::VERSION;

	my $old_cgi_text = $PREF{internal_appname} =~ /filechucker/i ? 'uploads' : 'some features';

	print	  qq`
		<div id="enc_server_info" class="enc_tbl">
		<table>
		<tr><th colspan="2">Server Information</th></tr>
		<tr><td>\$CGI::VERSION</td>		<td>$CGI::VERSION (if v3.02 or older, $old_cgi_text probably won't work, at least not reliably)</td></tr>
		<tr><td>\$] (Perl version)</td>		<td>$]</td></tr>
		<tr><td>\$MIME::Lite::VERSION</td>	<td>$mimeliteversion</td></tr>
		<tr><td>\$PREF{DOCROOT}</td>		<td>$PREF{DOCROOT}</td></tr>
		<tr><td colspan="2">Environment variables:</td></tr>
	`;

	foreach my $var (sort keys %ENV)
	{
		$ENV{$var} =~ s!<!&lt;!g;
		$ENV{$var} =~ s!>!&gt;!g;
		print qq`<tr><td>$var</td>	<td>$ENV{$var}</td></tr>\n`;
	}

	print	  qq`</table>\n</div>\n`;

	finish_html_output();
}


sub store_keyed_message
{
	my $new_message = shift;
	$new_message =~ s/\n/::ENCNL::/gs;

	my $one_day = 60*60*24*1;
	my $one_week = 60*60*24*7;
	my $current_time = offsettime();
	$PREF{max_age_for_keyed_messages} = $one_day unless $PREF{max_age_for_keyed_messages} =~ /^\d+/;

	my $key = md5_hex($new_message . $current_time . $$ . $ENV{REMOTE_PORT} . $PREF{ip} . $ENV{HTTP_USER_AGENT});
	my $uid = $PREF{logged_in_userid} =~ /^-?\d+$/ ? $PREF{logged_in_userid} : 0;

	my $mfile = add_initial_cwd_prefix($PREF{datadir} . '/' . "_$PREF{internal_appname}_keyed_messages.cgi");
	create_file_if_DNE($mfile,$PREF{writable_file_perms});
	# Note: this -w test must use die rather than die_nice, because in situations such as POSTs where store_keyed_message is used, die_nice would just call store_keyed_message again, resulting in an infinite loop.
	die qq`Error: our keyed-message file ('$mfile') is not writable; you must either make it so, or else delete it so we can re-create it with the correct permissions.` unless -w $mfile;
	my @messages = ();
	open(MFILE,"+<$mfile") or die_nice("could not open file '$mfile' for R/W: $!\n");
	flock MFILE, 2;
	seek MFILE, 0, 0;
	while(<MFILE>)
	{
		if(/^(\d+):/)
		{
			my ($time) = ($1);
			push (@messages,$_) if($time > ($current_time - $PREF{max_age_for_keyed_messages}));
		}
		elsif(/^[\s\n]*$/)
		{
			push (@messages, $_);
		}
	}
	seek MFILE, 0, 0;
	print MFILE @messages;
	print MFILE "${current_time}:${key}:${uid}:$PREF{ip}:$new_message\n\n\n"; # 3 newlines so the raw log is somewhat readable.
	truncate MFILE, tell MFILE;
	close MFILE or die_nice("could not close file '$mfile' after R/W: $!\n");

	return $key;
}


sub get_keyed_message
{
	my $key = shift;
	my $message = '';

	my $mfile = add_initial_cwd_prefix($PREF{datadir} . '/' . "_$PREF{internal_appname}_keyed_messages.cgi");
	create_file_if_DNE($mfile,$PREF{writable_file_perms});
	open(MFILE,"<$mfile") or die_nice("could not open file '$mfile' for reading: $!\n");
	flock MFILE, 1;
	seek MFILE, 0, 0;
	while(<MFILE>)
	{
		if(/^\d+:${key}:(-?\d+):([\d\.]+):(.*)/)
		{
			my ($uid_on_message,$ip_on_message,$msg) = ($1,$2,$3);
			if($PREF{admin_is_logged_in})
			{
				$message = $msg;
			}
			elsif($PREF{member_is_logged_in} && $PREF{logged_in_userid} eq $uid_on_message)
			{
				$message = $msg;
			}
			elsif($PREF{ip} eq $ip_on_message   &&   $uid_on_message =~ /^(0|-1)$/) # only allow IP-based auth if the owner is public.
			{
				$message = $msg;
			}
			else
			{
				$message = qq`Error: access denied based on userid and/or IP address.`;
			}
			last;
		}
	}
	close MFILE or die_nice("could not close file '$mfile' after reading: $!\n");

	$message =~ s/::ENCNL::/\n/gs;
	return $message || qq`Message expired.`;
}


# Never call chdir directly; always call enc_chdir instead:
sub enc_chdir($)
{
	my $dir = shift;
	$PREF{new_cwd} = $dir;
	chdir $dir or die_nice qq`Couldn't chdir to directory "$dir": $!\n`;
}


# This is necessary for cases where we've chdir()ed somewhere other than the
# $PREF{initial_cwd}, after which we want to use $PREF{datadir}, which by
# default is not in DOCROOT and contains no path -- it's relative to the
# initial working directory.
#
sub add_initial_cwd_prefix($)
{
	my $item = shift;
	if($PREF{new_cwd} ne $PREF{initial_cwd})
	{
		$item = $PREF{initial_cwd} . '/' . $item;
		condense_slashes('leave_leading_UNC', $item);
	}
	# return the input unchanged if we're still in the initial_cwd.
	return $item;
}


# pass filename to create and optionally the mode to chmod it to.
# the mode must consist of 1-4 octal digits and must NOT be quoted.
# see "perldoc -f chmod" and "man chmod".
sub create_file_if_DNE
{
	my $file = shift;
	my $mode = shift;

	return if -T $file;
	open(NEW,">$file") or die "$0: couldn't create new file $file: $!\n";
	close NEW or die "$0: couldn't close $file after creating it: $!\n";
	if($mode)
	{
		chmod($mode,$file) or die "$0: couldn't chmod file \"$file\" with mode \"$mode\": $!\n";
	}
}


sub create_dir_if_DNE
{
	my $dir = shift;
	my $mode = shift;
	my $make_parents_if_necessary = shift; $make_parents_if_necessary = $make_parents_if_necessary eq 'make_parents';
	my $ignore_errors = shift; $ignore_errors = $ignore_errors eq 'ignore_errors';

	return if -d $dir;

	$dir =~ s!\\!/!g;
	if($make_parents_if_necessary)
	{
		my $progressively_longer_path = '';
		my $i = 0;
		foreach my $individual_path_element(split(/\//, $dir))
		{
			$i++;
			if($i == 1)
			{
				if($dir =~ m!^(\w:/)!) # Winders.
				{
					$progressively_longer_path = $1;
					next;
				}
				elsif(!$individual_path_element) # this means $dir starts with a slash.
				{
					$progressively_longer_path = '/';
					next;
				}
			}

			$progressively_longer_path .= $individual_path_element;
			unless(-d $progressively_longer_path)
			{
				mkdir($progressively_longer_path,$PREF{writable_dir_perms}) or $ignore_errors || die_nice("couldn't create path-portion '$progressively_longer_path' as part of dir '$dir': $!");
				if($mode)
				{
					chmod($mode,$progressively_longer_path) or $ignore_errors || die_nice("couldn't chmod path-portion '$progressively_longer_path' as part of dir '$dir' with mode '$mode': $!");
				}
			}
			$progressively_longer_path .= '/';
		}
	}
	else
	{
		mkdir($dir,$PREF{writable_dir_perms}) or $ignore_errors || die_nice("couldn't create dir $dir: $!");
		if($mode)
		{
			chmod($mode,$dir) or $ignore_errors || die_nice("couldn't chmod dir \"$dir\" with mode \"$mode\": $!");
		}
	}

	$ignore_errors || die_nice qq`dir does not exist after creation: '$dir'` unless -d $dir;
}


sub mirror_dir_tree_and_contents($$)
{
	my ($src,$dst) = @_;
	for(@_) { return(0, qq`error: does not exist: '$_'`) unless -e $_; return(0, qq`error: not a directory: '$_'`) unless -d $_; }
	my ($files, $subfolders) = get_items($src);

	my (@successes, @errors) = ();
	# start with the shortest pathname to ensure we create parents first.
	#
	foreach my $srcfolder (sort { length($a) <=> length($b) } @$subfolders)
	{
		my $mode = sprintf "%04o", (   (stat($srcfolder))[2] & 07777   );
		my $dstfolder = $dst . ($srcfolder =~ /^$src(.+)/)[0];
		if(mkdir($dstfolder, oct($mode)))
		{
			if(chmod(oct($mode), $dstfolder))
			{
				push @successes, $dstfolder;
				copy_custom_folder_perms($srcfolder, $dstfolder) if $PREF{internal_appname} eq 'filechucker' && custom_folder_perms_enabled() && $PREF{when_copying_a_folder_also_copy_its_cust_perms} =~ /yes/i;
			}
			else
			{
				push @errors, qq`Couldn't chmod dir '$dstfolder' with mode '$mode': $!`;
			}
		}
		else
		{
			push @errors, qq`Couldn't mkdir '$dstfolder' with mode '$mode': $!`;
		}
	}

	foreach my $srcfile (@$files)
	{
		my $mode = sprintf "%04o", (   (stat($srcfile))[2] & 07777   );
		my $dstfile = $dst . ($srcfile =~ /^$src(.+)/)[0];
		if(copy($srcfile, $dstfile))
		{
			if(chmod(oct($mode), $dstfile))
			{
				push @successes, $dstfile;
			}
			else
			{
				push @errors, qq`Couldn't chmod file '$dstfile' with mode '$mode': $!`;
			}
		}
		else
		{
			push @errors, qq`Couldn't copy source file '$srcfile' to destination file '$dstfile': $!`;
		}
	}
	
	copy_custom_folder_perms($src, $dst) if $PREF{internal_appname} eq 'filechucker' && custom_folder_perms_enabled() && $PREF{when_copying_a_folder_also_copy_its_cust_perms} =~ /yes/i;

	return (\@successes, \@errors);
}


# Note: we use "die" rather than "die_nice" throughout the send_email function,
# because most of the code is within eval{} blocks, so that we can catch the
# dies and then decide at the end what to do with them.
#
sub send_email
{
	return;
}


sub enc_untaint
{
	my $item = shift || '';
	my $original_item = $item;
	my $keep_path = shift || '';
	#printd "enc_untaint($item)\n";

	# Regardless of whether we're keeping the path, dots surrounded by slashes are never allowed.
	#
	#$item =~ s!(^|/|\\)\.+(/|\\|$)!$1!g;
	$item =~ s!\\!/!g; # Need to remove MS garbage beforehand, otherwise an input like .\\StupidCGI.tmp will break this.
	while($item =~ m!((?:^|/|\\)\.+(?:/|\\|$))!)
	{
		$item =~ s!$1!/!;
	}

	#printd "removed slashdots: $item\n";

	if(  $item =~ m!(/|\\)!  &&  !$keep_path)
	{
		$item =~ s!^.*[/\\]+([^/\\]+)!$1!; # remove any path from the front.
		#printd "removed path from front: $item\n";
		$item =~ s!^([^/\\]+)[/\\]+!$1!; # ...and the back.
	}

	$item =~ s![`\*\?\|<>]!!g; # remove some other potentially-unsafe stuff.

	my $leading_UNC_slashes = '';
	if($item =~ m!^//!  &&  $keep_path)
	{
		$leading_UNC_slashes = '//';
		$item =~ s!^/+!!;
	}
	$item =~ s![/\\]{2,}!/!g; # condense any multiples.
	$item = $leading_UNC_slashes . $item; # add back any UNC slashes.

	($item) = ($item =~ /(.*)/); # untaint.

	# In case anything slips through, die as a security precaution.
	#
	die qq`$0: couldn't untaint "$original_item" [called from: ` . (caller 1)[3]  . qq`].\n` if $item =~ m![/\\]! && !$keep_path;
	die qq`$0: couldn't untaint "$original_item" [called from: ` . (caller 1)[3]  . qq`].\n` if $item =~ m!(?:^|/|\\)\.+(?:/|\\|$)!;
	die qq`$0: couldn't untaint "$original_item" [called from: ` . (caller 1)[3]  . qq`].\n` if $item =~ m!^\.+$!;
	die qq`$0: couldn't untaint "$original_item" [called from: ` . (caller 1)[3]  . qq`].\n` if $item =~ m!^\s*$!;

	#printd "untainted: $item\n\n";
	return $item;
}


sub zeropad
{
	# args: 1. string to pad, 2. length to pad to (i.e. final length).
	enc_pad(@_, 0);
}


sub enc_pad
{
	# args: 1. string to pad, 2. length to pad to (i.e. final length), 3. char to use for padding.
	$_[0] = ($_[2] x $_[1]) . $_[0];
	$_[0] =~ s!.*(.{$_[1]})!$1!;
}


sub enc_urlencode
{
	for(@_) { s/([^\w()'*~!.-])/sprintf '%%%02x', ord $1/eg if $_; };
}


sub enc_urldecode
{
	# assuming the input really was URL-encoded, then any plus-signs that were originally there
	# are now in their hex form, so any plus-signs STILL there were converted from spaces by the
	# browser.  so they must be converted back BEFORE restoring any original plus-signs from the
	# hex codes.
	convert_plus_signs_back_to_spaces_in_var_from_GET_method(@_);
	for(@_) { s/%([a-fA-F\d]{2})/chr hex $1/eg  if $_; }
}


sub zeropad_return { my $string = shift; zeropad($string, @_); return $string; }
sub enc_pad_return { my $string = shift; enc_pad($string, @_); return $string; }
sub enc_urlencode_return { my $string = shift; enc_urlencode($string); return $string; }
sub enc_urldecode_return { my $string = shift; enc_urldecode($string); return $string; }


sub convert_plus_signs_back_to_spaces_in_var_from_GET_method
{
	for(@_) { s/\+/ /g  if $_; }
}


sub enc_redirect
{
	my $destination = shift;

	if($destination =~ /^referr?er$/i)
	{
		$destination = $ENV{HTTP_REFERER} ? $ENV{HTTP_REFERER} : $PREF{redirection_backup_address};
	}

	unless($destination =~ m!^https?://!)
	{
		$destination = $PREF{protoprefix} . $ENV{HTTP_HOST} . $destination;
	}

	my $destination_raw = $destination;
	$destination_raw =~ s!&amp;!&!g;

	if($PREF{output_started})
	{
		if($PREF{use_javascript_redirect_when_necessary} !~ /no/i)
		{
			print qq`\n<script type="text/javascript">location.href="$destination_raw";</script>\n`;
		}
		else
		{
			print qq`<p>$PREF{internal_appname} warning: cannot redirect because output has already started (perhaps debug is enabled?).&nbsp; <a href="$destination">Click here to continue</a>.</p>\n`;
		}
	}
	elsif($PREF{we_are_virtual})
	{
		if($PREF{use_javascript_redirect_when_necessary} !~ /no/i)
		{
			print_http_headers();
			print qq`\n<script type="text/javascript">location.href="$destination_raw";</script>\n`;
		}
		else
		{
			enc_warn "$0: enc_redirect(): cannot redirect because we are virtual.\n";
			print_http_headers();
			print qq`<p>$PREF{internal_appname} warning: cannot redirect because we are virtual.&nbsp; <a href="$destination">Click here to continue</a>.</p>\n`;
		}
	}
	else
	{
		if($ENV{SERVER_SOFTWARE} =~ /microsoft-iis/i || $PREF{always_use_meta_for_redirects} =~ /yes/i)
		{
			# A bug in IIS v5 (and lower, probably) makes cookie-setting fail
			# when combined with a header-based redirect:
			#
			#	"BUG: Set-Cookie Is Ignored in CGI When Combined With Location"
			#	http://support.microsoft.com/kb/q176113/
			#
			# So use a meta-redirect instead.
			#
			print "Content-type: text/html\n\n";
			print qq`<html><head><meta http-equiv="refresh" content="0;url=$destination"></head><body></body></html>\n`;
		}
		else
		{
			print "Location: $destination_raw\n\n";
		}
	}

	exit;
}


sub kmsg_redirect
{
	# Any $PREF{extra_debug} will be lost on redirect unless we store it with the keyed message.
	enc_redirect(   ($PREF{here_static} || $PREF{here}) . "?kmsg=" . store_keyed_message($_[0] . get_extra_debug_output()) . $PREF{default_url_vars}   );
}


sub smsg_redirect
{
	# smsg: static message.  This only needs to be used in situations where we were
	# POSTed to and we want the static message to appear within the page we're
	# embedded into; for non-POST situations we can just use exit_with_error().
	# (And we could use a kmsg instead here, but that does involve some amount
	# of overhead, so for static messages we might as well avoid it.)
	#
	enc_redirect(   ($PREF{here_static} || $PREF{here}) . "?smsg=$_[0]" . $PREF{default_url_vars}   );
}


sub enc_redirect_to_ref
{
	# try to redirect to HTTP_REFERER, falling back to the URL
	# specified by ?whence=foo, then to any passed-in URL, and
	# finally to $PREF{here}.

	my $go = shift;
	if($ENV{HTTP_REFERER})
	{
		$go = $ENV{HTTP_REFERER};
	}
	elsif($qs =~ /(?:^|&)whence=(.+)/)
	{
		$go = $1;
		enc_urldecode($go);
	}
	$go = $PREF{here} if !$go;
	enc_redirect($go);
}


sub get_extra_debug_output
{
	if(	$PREF{extra_debug_always}
		||
		user_is_allowed_to('view_extra_debug_output')
		||
		($PREF{extra_debug_usernames_list} && $PREF{logged_in_username} &&   ($PREF{extra_debug_usernames_list} =~ /(^|,)\s*$PREF{logged_in_username}\s*(,|$)/))
		||
		($PREF{extra_debug_ips_list} &&   ($PREF{extra_debug_ips_list} =~ /(^|,)\s*$PREF{ip}\s*(,|$)/))
	)
	{
		my $style = $PREF{extra_debug_css} || qq`margin: 20px; padding: 10px; border: 1px solid #999; background: #ddd; color: #333; text-align: left;`;
		$PREF{extra_debug} =~ s/</&lt;/g;
		$PREF{extra_debug} =~ s/>/&gt;/g;
		$PREF{extra_debug} =~ s!\n! <br />\n!g;
		my $extra_debug = qq`<div id="extradebug" style="$style">$PREF{extra_debug}</div>\n` unless !$PREF{extra_debug} && $PREF{hide_extra_debug_container_if_empty} =~ /yes/i;
		my $extra_debug_raw = qq`<div id="extradebug_raw" style="$style">$PREF{extra_debug_raw}</div>\n` if $PREF{extra_debug_raw};
		return qq`$extra_debug\n$extra_debug_raw`;
	}
}


sub encdebug { $PREF{extra_debug} .= date14() . ": runtime " . (time - $PREF{app_start_time}) . " sec: " . (caller 1)[3] . ": " . join("\n",@_) . "\n"; }


# This is mainly meant for servers without proper STDERR logging, or
# whose error-log we can't get access to.
#
sub encdebuglog
{
	if($PREF{debuglog} =~ /yes/i)
	{
		my $output = '';
		for(@_)
		{
			$output .= date14() . " pid=$$ runtime=" . (time - $PREF{app_start_time}) . "s user=" . ($PREF{logged_in_username} || '(none)') . " " . (caller 1)[3] . ": $_";
			$output .= "\n" unless $_ =~ /\n$/;
		}
		if($output)
		{
			unless($PREF{debuglogfh})
			{
				print STDERR "$$: opening the debug log\n";
				open(my $outfh, ">>$PREF{debuglogfile}") or die_nice "couldn't open debug log '$PREF{debuglogfile}' for output: $!\n";
				#flock $outfh, 2;
				$PREF{debuglogfh} = $outfh;
			}
			flock $PREF{debuglogfh}, 2;
			print { $PREF{debuglogfh} } $output;
			flock $PREF{debuglogfh}, 8; # release the lock.
		}
	}
}


sub condense_slashes
{
	s!\\!/!g;
	my $leave_leading_UNC = 0;
	for(@_)
	{
		if(/^leave_leading_UNC$/)
		{
			$leave_leading_UNC = 1;
			next;
		}
		if($leave_leading_UNC)
		{
			my $leading_UNC_slashes = '';
			if(m!^//!)
			{
				$leading_UNC_slashes = '//';
				s!^/+!!;
			}
			s!/{2,}!/!g; # condense any multiples.
			$_ = $leading_UNC_slashes . $_; # add back any UNC slashes.
		}
		else
		{
			s!/{2,}!/!g;
		}
	}
}


sub slashify	{   fooify('/', @_); }
sub deslashify	{ defooify('/', @_); }
sub commaify	{   fooify(',', @_); }
sub decommaify	{ defooify(',', @_); }
sub spaceify	{   fooify(' ', @_); }
sub despaceify	{ defooify(' ', @_); }


sub fooify
{
	# add leading and trailing foos and condense duplicates.
	my $foo = shift;
	$_ = $foo . $_ . $foo for @_;
	s!$foo{2,}!$foo!g for @_;
}


sub defooify
{
	# remove leading and trailing foos and condense duplicates.
	my $foo = shift;
	s!$foo{2,}!$foo!g for @_;
	s!^$foo!!g for @_;
	s!$foo$!!g for @_;
}


sub die_unless_numeric
{
	die_nice("error: non-numeric value '$_[0]' for $_[1]. [called from: " . (caller 1)[3]  . "]\n") unless $_[0] =~ /^\d+$/;
}


sub die_nice
{
	my $msg = shift;
	my $caller = (caller 1)[3];
	$caller =~ s/^main:://;
	$msg = qq`$PREF{internal_appname_nice}: $caller(): $msg` unless $msg =~ /^$PREF{internal_appname}: $caller(): /;
	exit_with_error($msg);
}


sub enc_warn
{
	# Never call the built-in warn() function directly, because some (lame) servers (IIS) choke
	# on it (and on printing to STDERR), and in bad ways, such as prompting the user to download
	# a file (the script output with the error message) rather than just displaying an error.
	#
	return if $^O =~ /MSWin/i;

	my $msg = shift;
	my $caller = (caller 1)[3];
	$caller =~ s/^main:://;
	$msg = qq`$PREF{internal_appname_nice}: $caller(): $msg` unless $msg =~ /^$PREF{internal_appname}: $caller(): /;
	warn $msg;
}


sub pass_child_error_to_parent($$)
{
	my ($record_id, $msg) = @_;
	my $file = $PREF{datadir} . "/ipc_log_for_child_to_parent_communcation.cgi";
	create_file_if_DNE($file, $PREF{writable_file_perms});
	$msg =~ s!\n!ENCNEWLINE!g;
	add_text_to_file("${record_id}:$msg\n", $file, 'end');
}


sub read_child_error($)
{
	my $record_id = shift;
	my $file = $PREF{datadir} . "/ipc_log_for_child_to_parent_communcation.cgi";
	create_file_if_DNE($file, $PREF{writable_file_perms});
	my $msg = '';
	my $found = 0;
	my @contents = ();
	open(my $iofh, "+<$file") or die_nice qq`couldn't open file "$file" for R/W: $!`;
	flock $iofh, 2;
	seek $iofh, 0, 0;
	while(<$iofh>)
	{
		if(/^${record_id}:(.*)$/)
		{
			$found = 1; $msg = $1; chomp $msg; $msg =~ s!ENCNEWLINE!\n!g;
		}
		else
		{
			push @contents, $_;
		}
	}
	if($found)
	{
		seek $iofh, 0, 0;
		print $iofh @contents;
		truncate $iofh, tell $iofh;
	}
	close $iofh or die_nice qq`couldn't close "$file" after R/W: $!`;

	return $msg ? (0,$msg) : (1,'');
}


sub print_http_headers
{
	return if $PREF{output_started} || $PREF{xml_output_started} || $ENV{suppress_http_headers};

	$PREF{output_started} = 1;

	# Don't print the P3P header from here normally, because we'll pick it up automatically
	# from the site's main .htaccess file.  The only time a script needs to explicitly
	# include it is when setting cookies (and possibly when delivering JS code which is
	# used to set cookies?).
	# 
	#print_p3p_header();

	my $noprint = shift;
	my $headers = '';
	$headers .= "Cache-Control: no-store, no-cache\n";
	$headers .= "Connection: close\n"; # workaround for a Safari bug that causes uploads to fail about 50% of the time.
	$headers .= "Content-type: text/html\n\n";
	$noprint ? return $headers : print $headers;
}


sub print_xml_headers()
{
	return if $PREF{output_started} || $PREF{xml_output_started};
	$PREF{xml_output_started} = 1;

	print "Cache-Control: no-store, no-cache\n";
	print "Content-type: text/xml\n";
	print "Connection: close\n"; # workaround for a Safari bug that causes uploads to fail about 50% of the time.
	print "\n";
}


sub print_p3p_header
{
	# If you need to set third-party cookies, you'll need to use the P3P
	# privacy policy system, or else IE will reject the cookies.  The system
	# consists of a /w3c folder on your website containing a p3p.xml file
	# and a policy.html file, and then having your server send a P3P header,
	# both in the main .htaccess file and anytime a script needs to output
	# headers.  The value should be something like this:
	#
	#	$PREF{p3p_header} = qq`P3P: CP="ALL DSP COR NID", policyref="/w3c/p3p.xml"`;
	#
	# Or, you can leave off the policyref:
	#
	#	$PREF{p3p_header} = qq`P3P: CP="ALL DSP COR NID"`;
	#
	# You may want to use a service like http://p3pedit.com/ to create your
	# XML and privacy files.  And you can use www.w3.org/P3P/validator.html
	# to validate your setup.

	return if $PREF{p3p_header_printed};

	$PREF{p3p_header_printed} = 1;
	my $noprint = shift;
	my $headers = '';
	$headers .= "$PREF{p3p_header}\n" if $PREF{p3p_header};
	$noprint ? return $headers : print $headers;
}


sub offsettime	{ return time + $PREF{time_offset}; }
sub date8	{ return strftime("%Y%m%d", localtime(shift || offsettime())); }
sub date14	{ return strftime("%Y%m%d-%H%M%S", localtime(shift || offsettime())); }
sub date17	{ return strftime("%Y%m%d-%H:%M:%S", localtime(shift || offsettime())); }


sub offset_etime($$)
{
	my ($etime, $offset) = @_;
	my ($operation, $amount, $multiplier_code) = ($offset =~ /([\+-])(\d+)([smhdb])/);
	my $multiplier = $multiplier_code eq 'm' ? 60 : $multiplier_code eq 'h' ? 3600 : $multiplier_code eq 'd' ? 86400 : 1;
	if($multiplier_code eq 'b')
	{
		while($amount)
		{
			do { $etime = $operation eq '+' ? $etime + 86400 : $etime - 86400; } while is_weekend($etime);
			$amount--;
		}
	}
	else
	{
		$etime = $operation eq '+' ? $etime + ($amount * $multiplier) : $etime - ($amount * $multiplier);
	}
	return $etime;
}


sub is_weekend($)
{
	return (localtime($_[0]))[6] =~ /[06]/; # (localtime($etime))[6] is the weekday, with 0 being Sunday and 6 being Saturday.
}


sub sql_untaint
{
	s/"/&quot;/g for @_;
	s/'/&#39;/g for @_;
	s/`/&#96;/g for @_;
	s/\\/&#92;/g for @_;
}


sub sql_un_untaint
{
	s/&quot;/"/g for @_;
	s/&#39;/'/g for @_;
	s/&#96;/`/g for @_;
	s/&#92;/\\/g for @_;
}


sub enc_hash
{
	return $PREF{use_md5_for_hashes} =~ /yes/i ? md5_hex(@_) : sha1_hex(@_);
}


sub not_sqlsafe
{
	#print STDERR "not_sqlsafe: got: $_[0]\n";

	# Escape any dashes or closing brackets, as per perlre:
	#
	# 	If you want either "-" or "]" itself to be a member of a class,
	#	put it at the start of the list (possibly after a "^"), or escape
	#	it with a backslash.
	#
	my $list_of_sql_safe_characters = $PREF{list_of_sql_safe_characters};
	$list_of_sql_safe_characters =~ s/\]/\\]/g;
	$list_of_sql_safe_characters =~ s/-/\\-/g;

	return $_[0] =~ /[^$list_of_sql_safe_characters]/;
}


sub die_unless_sqlsafe
{
	#print STDERR "die_unless_sqlsafe: got: $_[0]\n";

	# Escape any dashes or closing brackets, as per perlre:
	#
	# 	If you want either "-" or "]" itself to be a member of a class,
	#	put it at the start of the list (possibly after a "^"), or escape
	#	it with a backslash.
	#
	my $list_of_sql_safe_characters = $PREF{list_of_sql_safe_characters};
	$list_of_sql_safe_characters =~ s/\]/\\]/g;
	$list_of_sql_safe_characters =~ s/-/\\-/g;

	for(@_)
	{
		if(/[^$list_of_sql_safe_characters]/)
		{
			exit_with_error(qq`Not SQL-safe: called from ` . (caller 1)[3] . qq`: the following value is not SQL-safe: $_`);
		}
	}
}


sub replace_nonsqlsafe_chars_with
{
	my $replacement = shift;

	# Escape any dashes or closing brackets, as per perlre:
	#
	# 	If you want either "-" or "]" itself to be a member of a class,
	#	put it at the start of the list (possibly after a "^"), or escape
	#	it with a backslash.
	#
	my $list_of_sql_safe_characters = $PREF{list_of_sql_safe_characters};
	$list_of_sql_safe_characters =~ s/\]/\\]/g;
	$list_of_sql_safe_characters =~ s/-/\\-/g;

	for(@_)
	{
		if(/[^$list_of_sql_safe_characters]/)
		{
			enc_warn "sanitizing the following non-SQL-safe value: $_\n";
			s/[^$list_of_sql_safe_characters]/$replacement/g;
		}
	}
}


sub oddeven
{
	$_[0] = 0 unless $_[0] && $_[0] =~ /^\d+$/;
	$_[0]++ unless $_[1] eq 'dont_inc';
	return $_[1] && $_[1] eq 'reset' ? 'odd' : $_[0] % 2 == 0 ? 'even' : 'odd';
}


sub enc_sql_select($)
{
	verify_db_connection();
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	$sth->execute() or die_nice("called from " . (caller 1)[3]  . ": error while executing SQL select statement [[$statement]]: $DBI::errstr\n");
	return $sth->fetchrow;
}


sub enc_sql_select_multi($)
{
	verify_db_connection();
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	$sth->execute() or die_nice("called from " . (caller 1)[3]  . ": error while executing SQL select statement [[$statement]]: $DBI::errstr\n");
	my $i = 1;
	my %hash = ();
	my $rowhashref = '';
	while($rowhashref = $sth->fetchrow_hashref)
	{
		foreach my $field (keys %$rowhashref)
		{
			$hash{$i}{$field} = $$rowhashref{$field};
		}
		$i++;
	}
	return \%hash;
}


sub enc_sql_select_array
{
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	$sth->execute() or die_nice("called from " . (caller 1)[3]  . ": error while executing SQL select statement [[$statement]]: $DBI::errstr\n");
	my @results = ();
	while(my $ref = $sth->fetchrow_arrayref()) 
	{
		push @results, @{$ref};
	}
	return @results;
}


sub enc_sql_update($)
{
	verify_db_connection();
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	my $numrows = $sth->execute() or die_nice("called from " . (caller 1)[3]  . ": error while executing SQL update statement [[$statement]]: $DBI::errstr\n");
	return $numrows;
}


sub enc_sql_insert($)
{
	verify_db_connection();
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	$sth->execute() or die_nice("called from " . (caller 1)[3]  . ": error while executing SQL insert statement: $DBI::errstr.  Statement was: [[ $statement ]]\n");
}


sub enc_sql_delete($)
{
	verify_db_connection();
	my $statement = shift;
	my $sth = $PREF{dbh}->prepare($statement);
	my $retval = $sth->execute();
	die_nice("called from " . (caller 1)[3]  . ": error while executing SQL delete statement: $DBI::errstr.  Statement was: [[ $statement ]]\n") if $retval =~ /^(0|0E0)$/; # execute() returns '0E0' if no rows were affected by the statement.
}


sub enc_sys_call
{
	# TODO: this doesn't always work.

	my $cmd = shift;
	my ($msg,$success) = ();

	if(my $timeout = $PREF{sys_call_timeout})
	{
		eval
		{

		local $SIG{ALRM} = sub { die "alarm\n" }; # NB: \n required
		alarm $timeout;

		# Note: don't change this without changing the matching block below.
		system($cmd);
		if ($? == -1)		{ $success = 0; $msg = "error: failed to execute: $!"; }
		elsif ($? & 127)	{ $success = 0; $msg = sprintf "error: child died with signal %d, %s coredump", ($? & 127),  ($? & 128) ? 'with' : 'without'; }
		else			{ $success = 1; $msg = sprintf "child exited with value %d", $? >> 8; }

		};

		if($@)
		{
			if($@ eq "alarm\n")
			{
				# timed out.
				$success = 0; $msg = "error: timeout while executing: $!";
			}
			else
			{
				# propagate unexpected errors.
				$success = 0; $msg = "unexpected error while executing: $@";
			}
		}
		else
		{
			# didn't time out.
		}
	}
	else
	{
		# Note: don't change this without changing the matching block above.
		system($cmd);
		if ($? == -1)		{ $success = 0; $msg = "error: failed to execute: $!"; }
		elsif ($? & 127)	{ $success = 0; $msg = sprintf "error: child died with signal %d, %s coredump", ($? & 127),  ($? & 128) ? 'with' : 'without'; }
		else			{ $success = 1; $msg = sprintf "child exited with value %d", $? >> 8; }
	}

	$msg = "enc_sys_call(): command was [[ $cmd ]]; result was [[ $msg ]];";
	printd "$msg\n";

	$PREF{sys_call_timeout} = 0; # always reset this so it's disabled by default, and the caller can choose to set it before calling us if necessary.
	return ($success, $msg);
}


sub exit_with_error { $PREF{static_error_message} ? print_and_exit($PREF{static_error_message}) : exit_with___generic($PREF{error_message_template}, @_); } # Errors that the end-user is supposed to see.
sub exit_with_success { exit_with___generic($PREF{success_message_template}, @_); } # Success messages that the end-user is supposed to see.
sub exit_with_notice { exit_with___generic($PREF{notice_message_template}, @_); } # Non-error messages that the end-user is supposed to see.
sub exit_with_output { exit_with___generic('', @_); } # For any output; no template will be used.


sub print_and_exit
{
	# This sub should NOT include any full HTML output, headers/footers, etc.  Just the bare minimum necessary to display the string it receives.
	print_http_headers(); print @_; exit;
}


sub exit_with___generic
{
	my $template = shift;
	my $message = join '', @_;
	#print STDERR $message;
	$template =~ s/%%message%%/$message/g;
	$message = $template =~ /\Q$message\E/ ? $template : $message; # in case prefs haven't been loaded yet.
	if(!$PREF{we_are_virtual} && $PREF{here} ne $ENV{SCRIPT_NAME} && $ENV{REQUEST_METHOD} =~ /post/i)
	{
		# 20081213: added method=post requirement; otherwise, if $PREF{here} is set to something other than
		# $ENV{SCRIPT_NAME}, then visiting the script directly will trigger this, which isn't what we want.
		# TODO: should method=post be the ONLY requirement for this if()?

		# Any $PREF{extra_debug} will be lost on redirect unless we store it with the keyed message.
		enc_redirect(   ($PREF{here_static} || $PREF{here}) . "?kmsg=" . store_keyed_message($message . get_extra_debug_output())   );
	}
	else
	{
		start_html_output('');
		print $message;
		finish_html_output();
	}
	exit;
}


sub exit_with_kmsg
{
	start_html_output('');
	print get_keyed_message($_[0]);
	finish_html_output();
	exit;
}


sub exit_with_needlogin
{
	start_html_output('');
	$PREF{needlogin_message} =~ s/%%login_url%%/$PREF{login_url}/g;
	print $PREF{needlogin_message};
	finish_html_output();
	exit;
}


sub exit_with_needprivs
{
	my $whenceqs = $qs; $whenceqs =~ s!&!_ANAMP_!g;
	my $login_url = '';
	if(userbase_available() || $PREF{integrate_with_existing_login_system} =~ /yes/i)
	{
		$login_url = $PREF{login_url_qsready};
	}
	else
	{
		$login_url = "$PREF{here_login_qsready}action=" . ($PREF{internal_appname} =~ /visitorlog/i ? 'vllogin' : 'login') . '&amp;';
	}
	$login_url .= ($PREF{default_url_vars} ? "$PREF{default_url_vars}&amp;" : "") . "needprivs=true&amp;whence=$PREF{REQ_URI_SANS_QS}" . ($whenceqs ? "_THEQS_$whenceqs" : '');
	$login_url = "$PREF{protoprefix}$ENV{HTTP_HOST}$login_url" unless $login_url =~ /^https?:/;
	my $js_login_url = $login_url; $js_login_url =~ s!&amp;!&!g;

	my $auto_redirect = qq`<script type="text/javascript">location.href="$js_login_url";</script>\n`;

	$PREF{needprivs_message} =~ s/%%login_url%%/$login_url/g;
	$PREF{needprivs_message} =~ s/%%js_auto_redirect%%/$PREF{member_is_logged_in} ? '' : $auto_redirect/eg;
	$PREF{needprivs_message} =~ s/%%%if-notloggedin%%%(.+?)%%%end-notloggedin%%%/$PREF{member_is_logged_in} ? '' : $1/egs;

	start_html_output('Authentication Required');
	print $PREF{needprivs_message};
	finish_html_output();
	exit;
}


sub printd
{
	my $msg = shift;
	chomp $msg;
	$msg = "$PREF{internal_appname}-debug: " . (offsettime()) . ": $msg";
	if($PREF{debug} || $PREF{force_debug} =~ /yes/i || $debuglog)
	{
		enc_warn "$msg\n";
		encdebug $msg;
		print $debuglog "$msg\n" if $debuglog;
	}
	if($PREF{debug})
	{
		#print_http_headers();
		#print "<!-- $msg -->\n";
	}
}


# Some SQL implementations support other nonsense in the table names; we'll restrict to a sensible set of characters.
#
sub tablename_is_valid				{ return ($_[0] =~ /^\w+$/	&&						length($_[0]) <= $PREF{max_tablename_length});		}
sub check_tablename_for_sql_safeness		{ die_nice("Invalid tablename: '$_[0]'") unless tablename_is_valid($_[0]); 								}


sub get_db_connection
{
	eval { require DBI; }; die_nice qq`error while trying to load the DBI module.&nbsp; You probably need to <a href="http://encodable.com/perl_modules/" target="_blank">install the Perl module</a> for it.&nbsp; The error message was: <br /><br />\n\n $0: $@\n` if $@;
	if(!$PREF{dbh}   ||   $_[0] eq 'force')
	{
		my $dbname = $PREF{database_name};
		$dbname .= ":$PREF{database_hostname}" if $PREF{database_hostname};
		$PREF{dbi_connection_string} =~ s!%%dbname%%!$dbname!g;

		$PREF{dbh} = DBI->connect($PREF{dbi_connection_string}, $PREF{database_username}, $PREF{database_password})
				or exit_with_error("Error: $DBI::errstr <br /><br />\n\nPlease verify your settings for the following preferences: \$PREF{database_hostname}, \$PREF{database_name}, \$PREF{database_username}, \$PREF{database_password}.");

		# 20090425: there's a bug somewhere in the Perl MySQL stack which causes the
		# database connection to be silently dropped in some cases, resulting in the
		# Perl script simply dying (segfaulting?) when attempting to use the connection.
		# This happens even though mysql_auto_reconnect is enabled; disabling that
		# causes the script to die with the "MySQL server has gone away" error, instead
		# of dying silently.  Furthermore, with mysql_auto_reconnect enabled, the Perl
		# script will also segfault if you call $dbh->ping() after the connection has
		# been lost, making it totally worthless for its intended purpose.  The root
		# cause of this issue may be the following DBD-mysql bug:
		#
		#	http://rt.cpan.org/Public/Bug/Display.html?id=37027
		#
		# That bug report hasn't been updated since October of 2008, and the bug still
		# exists as of April 2009, so as a workaround, we'll disable mysql_auto_reconnect
		# and then always do a $dbh->ping() before every database communication.
		#
		$PREF{dbh}->{mysql_auto_reconnect} = 0;
	}
}


sub verify_db_connection
{
	get_db_connection('force') unless $PREF{dbh} && $PREF{dbh}->ping;
}


sub db_column_exists($$)
{
	my $column_to_find = shift;
	my $table_name = shift;

	verify_db_connection();
	check_tablename_for_sql_safeness($table_name);

	my ($column_name, $temp) = ('','');
	my $sth = $PREF{dbh}->prepare("SHOW COLUMNS FROM `$table_name`;");
	$sth->execute() or die_nice "Error: $DBI::errstr\n";
	$sth->bind_columns(\$column_name, \$temp, \$temp, \$temp, \$temp, \$temp);
	while($sth->fetchrow_arrayref)
	{
		#print STDERR "column_name='$column_name', column_to_find='$column_to_find'\n";

		#return 1 if $column_name eq $column_to_find;
		#
		# MySQL returns a "Duplicate column name" error if you try to create a column
		# named (for example) "Color" when there's already one named "color":
		#
		return 1 if lc($column_name) eq lc($column_to_find);
	}
	return 0;
}


sub db_table_exists($)
{
	my ($table_to_check, $table, $table_exists) = (shift, '', 0);
	my $sth = $PREF{dbh}->prepare(qq`show tables;`);
	$sth->execute();
	$sth->bind_columns(\$table);
	while($sth->fetchrow_arrayref)
	{
		if($table eq $table_to_check)
		{
			$table_exists = 1;
			last;
		}
	}
	return $table_exists;
}


sub get_db_colnames($)
{
	my $table = shift;
	check_tablename_for_sql_safeness($table);
	my $colnames = '';
	my $column_name = '';
	my $temp = '';
	my $sth = $PREF{dbh}->prepare("SHOW COLUMNS FROM `$table`;");
	$sth->execute() or die_nice "$0: Error: db_column_exists(): $DBI::errstr\n";
	$sth->bind_columns(\$column_name, \$temp, \$temp, \$temp, \$temp, \$temp);
	while($sth->fetchrow_arrayref)
	{
		$colnames .= $column_name . ',';
	}
	$colnames =~ s/,$//;
	return $colnames;
}


sub get_ip_and_host
{
	# Some hosting companies (Yahoo) set REMOTE_ADDR to their own IP (it's a cache or proxy or something)
	# and then set the true end-user IP in a different ENV var, so if those exist, use them instead.
	#
	my $ip = $ENV{HTTP_YAHOOREMOTEIP} || $ENV{HTTP_X_FORWARDED_FOR} || $ENV{HTTP_CLIENT_IP} || $ENV{REMOTE_ADDR};
	my $host = $ENV{REMOTE_HOST};

	if((!$host) || ($host !~ /\w\.\w/)) { $host = $ip; }
	if($host eq $ip)
	{
		use Socket;
		$host = gethostbyaddr(inet_aton($ip), AF_INET);
	}
	if((!$host) || ($host !~ /\w\.\w/)) { $host = $ip; }

	return ($ip, $host);
}


sub populate_month_conversion_hashes
{
	$PREF{monthnum}{jan}='01';
	$PREF{monthnum}{feb}='02';
	$PREF{monthnum}{mar}='03';
	$PREF{monthnum}{apr}='04';
	$PREF{monthnum}{may}='05';
	$PREF{monthnum}{jun}='06';
	$PREF{monthnum}{jul}='07';
	$PREF{monthnum}{aug}='08';
	$PREF{monthnum}{sep}='09';
	$PREF{monthnum}{oct}='10';
	$PREF{monthnum}{nov}='11';
	$PREF{monthnum}{dec}='12';

	$PREF{monthnum}{january}='01';
	$PREF{monthnum}{february}='02';
	$PREF{monthnum}{march}='03';
	$PREF{monthnum}{april}='04';
	$PREF{monthnum}{may}='05';
	$PREF{monthnum}{june}='06';
	$PREF{monthnum}{july}='07';
	$PREF{monthnum}{august}='08';
	$PREF{monthnum}{september}='09';
	$PREF{monthnum}{october}='10';
	$PREF{monthnum}{november}='11';
	$PREF{monthnum}{december}='12';

	$PREF{monthname}{"01"} = 'Jan';
	$PREF{monthname}{"02"} = 'Feb';
	$PREF{monthname}{"03"} = 'Mar';
	$PREF{monthname}{"04"} = 'Apr';
	$PREF{monthname}{"05"} = 'May';
	$PREF{monthname}{"06"} = 'Jun';
	$PREF{monthname}{"07"} = 'Jul';
	$PREF{monthname}{"08"} = 'Aug';
	$PREF{monthname}{"09"} = 'Sep';
	$PREF{monthname}{"10"} = 'Oct';
	$PREF{monthname}{"11"} = 'Nov';
	$PREF{monthname}{"12"} = 'Dec';
}


sub save_php_var_to_cache($$)
{
	my $new_var = shift;
	my $new_value = shift;
	my $new_date = offsettime();
	my $new_sessid = get_cookie($PREF{php_session_cookie_name});
	die_nice qq`couldn't determine PHP session ID from cookie; perhaps you need to adjust \$PREF{php_session_cookie_name} (currently '$PREF{php_session_cookie_name}')?` unless $new_sessid; # if there's no sessionid, we have no way to index into the cache file.
	for($new_var, $new_value, $new_date, $new_sessid)
	{
		s/:::::/ENCFIVECOLONS/g;
		s/\n/ENCNEWLINE/g;
	}
	my ($session_found, $var_found) = ();

	create_file_if_DNE($PREF{php_session_cache_file},$PREF{writable_file_perms});
	my @new_contents = ();
	open(CACHEFH,"+<$PREF{php_session_cache_file}") or die_nice("couldn't open cache file '$PREF{php_session_cache_file}' for R/W: $!\n");
	my $iofh = \*CACHEFH;
	flock $iofh, 2;
	seek $iofh, 0, 0;
	while(<$iofh>)
	{
		if(/^date=(\d+?):::::sessid=(\w+?):::::.+/)
		{
			chomp;
			my ($date, $sessid) = ($1, $2);
			if($new_date - $date < $PREF{php_session_cache_ttl})
			{
				if($sessid ne $new_sessid)
				{
					# If this record doesn't belong to the current user, don't bother processing it.
					push (@new_contents, "$_\n");
				}
				else
				{
					$session_found = 1;
					my $new_line = "date=${date}:::::sessid=${sessid}:::::";
					foreach my $var (split(/:::::/))
					{
						my ($name,$value) = ($var =~ /(\w+)=(.*)/);
						next if $name =~ /^(date|sessid)$/i;
						if($name eq $new_var)	{ $new_line .= "$name=${new_value}:::::"; $var_found = 1; }
						else			{ $new_line .= "$name=${value}:::::"; }
					}
					$new_line .= "$new_var=${new_value}:::::" if !$var_found;
					push (@new_contents, "$new_line\n");
				}
			}
		}
	}
	push (@new_contents, "date=${new_date}:::::sessid=${new_sessid}:::::$new_var=${new_value}:::::\n") if !$session_found;
	seek $iofh, 0, 0;
	print $iofh @new_contents;
	truncate $iofh, tell $iofh;
	close $iofh or die_nice("couldn't close cache file '$PREF{php_session_cache_file}' after R/W: $!\n");
}


sub get_php_var_from_cache($)
{
	my $new_var = shift;
	my $new_value = '';
	my $new_date = offsettime();
	my $new_sessid = get_cookie($PREF{php_session_cookie_name});
	die_nice qq`couldn't determine PHP session ID from cookie; perhaps you need to adjust \$PREF{php_session_cookie_name} (currently '$PREF{php_session_cookie_name}')?` unless $new_sessid; # if there's no sessionid, we have no way to index into the cache file.
	for($new_var, $new_value, $new_date, $new_sessid)
	{
		s/:::::/ENCFIVECOLONS/g;
		s/\n/ENCNEWLINE/g;
	}

	create_file_if_DNE($PREF{php_session_cache_file},$PREF{writable_file_perms});
	open(CACHEFH,"<$PREF{php_session_cache_file}") or die_nice("couldn't open cache file '$PREF{php_session_cache_file}' for reading: $!\n");
	my $infh = \*CACHEFH;
	flock $infh, 1;
	seek $infh, 0, 0;
	while(<$infh>)
	{
		if(/^date=(\d+?):::::sessid=(\w+?):::::.+/)
		{
			my ($date, $sessid) = ($1, $2);
			if($new_date - $date < $PREF{php_session_cache_ttl}   &&   $sessid eq $new_sessid)
			{
				if(/(?:^|:::::)$new_var=(.*?)(?::::::|$)/) { $new_value = $1; }
			}
		}
	}
	close $infh or die_nice("couldn't close cache file '$PREF{php_session_cache_file}' after reading: $!\n");
	return $new_value;
}


sub cache_and_read_any_nonpost_env_vars()
{
	$PREF{nonpost_env_var_cache_ttl} = 60*60*24 unless $PREF{nonpost_env_var_cache_ttl} =~ /^\d+$/; # in seconds.
	my $file = $PREF{datadir} . '/cache_for_nonpost_env_vars.cgi';
	create_file_if_DNE($file, $PREF{writable_file_perms});
	my $current_date = offsettime();
	my (%live_env_vars, %cached_env_vars, %live_env_vars_missing_from_cache, %cached_env_vars_that_need_to_be_updated) = ();
	my ($expired_records, @records_from_other_users, @cached_env_vars_missing_from_live_env, @unchanged_cached_env_vars) = ();

	foreach my $var (sort keys %ENV)
	{
		$live_env_vars{$var} = $ENV{$var} if(

			($var =~ /^PHP/)
			
			||
			
			($PREF{enable_username_from_environment_variable} =~ /yes/i   &&   $var eq $PREF{username_envvar_name})
			
		);
	}
	if(%live_env_vars)
	{
		open(my $iofh, "+<$file") or die_nice qq`couldn't open file '$file' for R/W: $!`;
		flock $iofh, 2;
		seek $iofh, 0, 0;
		while(<$iofh>)
		{
			chomp;
			if(/^date=(\d+):::::encvisid=(\w+):::::(\w+)=(.*)/)
			{
				my ($date, $encvisid, $var, $value) = ($1, $2, $3, $4);
				if($current_date - $date < $PREF{nonpost_env_var_cache_ttl})
				{
					if($encvisid eq $PREF{enc_visitor_id})
					{
						$value =~ s!ENCNEWLINE!\n!g;

						$cached_env_vars{$var} = $value;
						if(! exists $ENV{$var})
						{
							push (@cached_env_vars_missing_from_live_env, "$_\n");
						}
						elsif($cached_env_vars{$var} ne $ENV{$var})
						{
							$cached_env_vars_that_need_to_be_updated{$var} = $ENV{$var};
						}
						else
						{
							push (@unchanged_cached_env_vars, "$_\n");
						}
					}
					else
					{
						# If this record doesn't belong to the current user, don't bother processing it.
						push (@records_from_other_users, "$_\n");
					}
				}
				else
				{
					$expired_records = 1;
				}
			}
		}
		foreach my $var (sort keys %live_env_vars)
		{
			if(! exists $cached_env_vars{$var})
			{
				$live_env_vars_missing_from_cache{$var} = $live_env_vars{$var};
			}
		}

		my @new_contents = ();
		if($expired_records || %live_env_vars_missing_from_cache || %cached_env_vars_that_need_to_be_updated)
		{
			foreach my $var (keys %live_env_vars_missing_from_cache)
			{
				my $value = $live_env_vars_missing_from_cache{$var}; $value =~ s!\n!ENCNEWLINE!g;
				push @new_contents, "date=${current_date}:::::encvisid=$PREF{enc_visitor_id}:::::${var}=${value}\n";
			}
			foreach my $var (keys %cached_env_vars_that_need_to_be_updated)
			{
				my $value = $cached_env_vars_that_need_to_be_updated{$var}; $value =~ s!\n!ENCNEWLINE!g;
				push @new_contents, "date=${current_date}:::::encvisid=$PREF{enc_visitor_id}:::::${var}=${value}\n";
			}
			push @new_contents, @cached_env_vars_missing_from_live_env;
			push @new_contents, @unchanged_cached_env_vars;
			push @new_contents, @records_from_other_users;
			
			seek $iofh, 0, 0;
			print $iofh @new_contents;
			truncate $iofh, tell $iofh;
		}

		close($iofh) or die_nice qq`couldn't close file '$file' after R/W: $!`;
	}
	else
	{
		# We were POSTed to?  So populate the live %ENV with any cached nonpost vars for this user.

		if(-s $file) # don't bother opening/closing the file if it's empty.
		{
			open(my $infh, $file) or die_nice qq`couldn't open file '$file' for reading: $!`;
			flock $infh, 1;
			seek $infh, 0, 0;
			while(<$infh>)
			{
				chomp;
				if(/^date=(\d+):::::encvisid=$PREF{enc_visitor_id}:::::(\w+)=(.*)/)
				{
					my ($date, $var, $value) = ($1, $2, $3);
					if($current_date - $date < $PREF{nonpost_env_var_cache_ttl})
					{
						$value =~ s!ENCNEWLINE!\n!g;
						$ENV{$var} = $value;
					}
				}
			}
			close($infh) or die_nice qq`couldn't close file '$file' after reading: $!`;
		}
	}
}


sub do_email_test
{
	my $to		= $PREF{email_test_recipient};
	my $from	= $PREF{email_test_sender};

	if($PREF{admin_is_logged_in})
	{
		$to = get_qs_var('to') if is_valid_email_address(get_qs_var('to'));
		$from = get_qs_var('from') if is_valid_email_address(get_qs_var('from'));
	}

	my $subj	= "test message - $PREF{date14} - $ENV{HTTP_HOST}";
	my $format	= $PREF{mailtest_email_format} || $PREF{global_email_format};
	my $die		= get_qs_var('die') eq '0' ? '' : 'die_on_email_error';

	my $authname	= $PREF{smtp_auth_username} ? 'not null' : 'null';
	my $authpass	= $PREF{smtp_auth_password} ? 'not null' : 'null';

	eval { require MIME::Lite; };
	my $mimelite_available = $@ ? "it's not" : "it is";

	my $sendmail_available = -e $PREF{path_to_sendmail} ? "it does" : "it doesn't";

	my $msg		= qq`this is only a test.
email settings:
\$PREF{smtp_server}		='$PREF{smtp_server}'
\$PREF{path_to_sendmail}	='$PREF{path_to_sendmail}'
\$PREF{smtp_auth_username}	is $authname.
\$PREF{smtp_auth_password}	is $authpass.
`;

	send_email($to, $from, $subj, $msg, $format, $die);

	my $output = qq`Sent test message from "$from" to "$to"; no immediate error occurred. <br /><br />\n\nIf the MIME::Lite Perl module is installed ($mimelite_available) and if \$PREF{smtp_server} is not null (it's "$PREF{smtp_server}"), then we tried to send the email using SMTP. <br /><br />\n\nIf your sendmail executable exists ($sendmail_available) (specified by \$PREF{path_to_sendmail}, currently "$PREF{path_to_sendmail}"), then we tried to send the email using sendmail, too.`;
	$output .= qq`<br /><br />\n\nNote: since you're an admin, you can also pass to=(address), from=(address), and die=(0|1) on the URL.` if $PREF{admin_is_logged_in};
	exit_with_notice($output);
}


sub add_text_to_file($$$)
{
	# Note: this function doesn't automatically insert any newlines; it
	# only inserts precisely what it receives in the $text parameter.

	my ($text, $file, $position) = @_;
	open(my $iofh, "+<$file") or die_nice "couldn't open file '$file' for R/W: $!\n";
	flock $iofh, 2;

	if($position eq 'start')
	{
		seek $iofh, 0, 0;
		my @contents = <$iofh>;
		seek $iofh, 0, 0;
		print $iofh $text;
		print $iofh @contents;
	}
	else
	{
		seek $iofh, 0, 2;
		print $iofh $text;
	}

	truncate $iofh, tell $iofh;
	close $iofh or die_nice "couldn't close file '$file' after R/W: $!\n";
}


sub get_database_data
{
	$PREF{on_page} = 'default';
	my ($tableprefname,$viewerprefname,$allowed_to_view,$allowed_to_create,$allowed_to_edit,$allowed_to_delete) = @_;
	my $dbtable = $PREF{$tableprefname} || $tableprefname; # "$tableprefname" can be the name of the pref OR of the table.
	my $createmode = 0;
	my $editmode = 0;
	my $row_id_to_edit = 0;

	if((my $ref = $ENV{HTTP_REFERER}) && $qs !~ /(?:^|&)dbvwrwhence=.+/)
	{
		$ref =~ s!\?!_encrplcdqm_!g;
		$ref =~ s!&!_encrplcdamp_!g;
		$ref =~ s!^https?://!!;
		$ref =~ s!^$ENV{HTTP_HOST}!!;
		$ref .= '_dbvwrwhncend_';
		$qs .= "&dbvwrwhence=$ref";
		$ENV{REQUEST_URI} .= $ENV{REQUEST_URI} =~ /\?/ ? "&dbvwrwhence=$ref" : "?dbvwrwhence=$ref"
	}
	if($qs =~ /(?:^|&)dbvwrwhence=(.+)_dbvwrwhncend_/)
	{
		$PREF{dbvwrwhence} = $1;
		$PREF{dbvwrwhence} =~ s!_encrplcdqm_!?!g;
		$PREF{dbvwrwhence} =~ s!_encrplcdamp_!&!g;
	}

	my $hiddencols			= $PREF{"${viewerprefname}_viewer_hidden_columns"} unless $qs =~ /allfields=true/;   # TODO: add UI for allfields=true.
	my $disabledcols		= $PREF{"${viewerprefname}_viewer_disabled_columns"};
	my $display_length		= $PREF{"${viewerprefname}_viewer_max_display_length"} || 500;
	my $pagetitle			= $PREF{"${viewerprefname}_viewer_title"};
	my $template			= $PREF{"${viewerprefname}_viewer_template"} || qq`\n%%header_note%%\n%%%if-db_view_controls%%%<p>[ %%db_view_controls%% ]</p>\n%%%end-db_view_controls%%%<br />\n%%output%%\n<p>%%pagelinks%%</p>\n%%search_form%%\n%%footer_note%%\n`;
	my @template_viewcontrols	= $PREF{"${viewerprefname}_viewer_template_viewcontrols"} || (qq`%%horizlink:text=Horizontal%%`, qq`%%vertlink:text=Vertical%%`, qq`%%viewalllink:text=View All%%`);
	my $template_viewcontrols_sep	= $PREF{"${viewerprefname}_viewer_template_viewcontrols_separator"} || ' | ';
	$template			=~ s!%%header_note%%!<div class="database_header_note">$PREF{"${viewerprefname}_viewer_header_note"}</div>!g;
	$template			=~ s!%%footer_note%%!$PREF{"${viewerprefname}_viewer_footer_note"}!g;
	my $itemsperpage		= $PREF{"${viewerprefname}_viewer_itemsperpage"} || 10;
	my $extra_columns		= \%{$PREF{"${viewerprefname}_viewer_extra_columns"}};
	my %db_update_details		= ( table => $dbtable, viewerprefname => $viewerprefname );

	my $creation_title_transforms	= \%{$PREF{"${viewerprefname}_creation_title_transforms"}};
	my $editmode_title_transforms	= \%{$PREF{"${viewerprefname}_editmode_title_transforms"}};
	my $viewer_title_transforms	= \%{$PREF{"${viewerprefname}_viewer_title_transforms"}};
	my $viewer_value_transforms	= \%{$PREF{"${viewerprefname}_viewer_value_transforms"}};
	my %custom_titles		= ();

	my $selection_restrictions	= $PREF{"${viewerprefname}_viewer_selection_restrictions"};
	my $editmode_restrictions	= $PREF{"${viewerprefname}_editmode_restrictions"};
	
	$PREF{"${viewerprefname}_viewer_db_url"}	||= "$PREF{here_qsready}action=" . get_qs_var('action');
	$PREF{"${viewerprefname}_viewer_db_url_full"}	||= $PREF{protoprefix} . $ENV{HTTP_HOST} . $PREF{"${viewerprefname}_viewer_db_url"}; # for within emails, etc.

	# extra_columns have a position within the displayed table, and a value, although
	# the value will often be null because it'll instead be set by a transform.  set
	# their position to >1000 in order to put them at the end of the table.
	#
	# title_transforms just change the header text for the specified column.
	#
	# value_transforms use "%%variable%%" to refer to the name/value of their own column, and
	# can also use %%foo%%, where foo is the name of any other column in the same table.
	#
	# _editmode_frontend_value_transforms are viewer transforms specifically for edit-mode;
	# they transform the values that pre-populate the form when editing a record.  So they
	# don't transform the backend (i.e. the POST side) at all.
	#
	# You can pass ?raw$columnname=yes on the URL to display that column's values in their
	# raw form, with any viewer transformations disabled.

	my ($range_start,$range_end,$sql_range_start) = get_pagination_range($itemsperpage);

	if($allowed_to_create)
	{
		$createmode = 1 if get_qs_var('createmode') eq 'true';
	}

	if($allowed_to_edit)
	{
		# Nothing in here should need editing.
		if(get_qs_var('editmode') eq 'true'   &&   get_qs_var('editid') =~ /^(\d+)$/)
		{
			$editmode = 1;
			$row_id_to_edit = $1;
		}
		elsif(!$createmode)
		{
			$$extra_columns{edit} = { position => 1 };
			$$viewer_value_transforms{edit} = qq`%%variable%% = '<a href="$PREF{REQ_URI_SANS_QS}?$qs&editmode=true&amp;editid=%%id%%&amp;format=vert">$TEXT{Edit}</a>';`;
		}
	}
	$PREF{db_editor_mode} = $createmode ? 'create' : $editmode ? 'edit' : '';

	die_unless_sqlsafe($dbtable);
	die_unless_numeric($row_id_to_edit, '$row_id_to_edit');
	$db_update_details{record_id} = $row_id_to_edit;
	my $live_data_fingerprint = md5_hex($ENV{HTTP_HOST} . $ENV{HTTP_USER_AGENT} . join('',enc_sql_select("SELECT * FROM `$dbtable` WHERE `id` = $row_id_to_edit")));

	my $restriction = '';
	my $num_cols = 0;

	my $db_colnames = get_db_colnames($dbtable);
	$num_cols += ($db_colnames =~ tr/,//) + 1;

	# If any extra (i.e. not straight from the DB) columns were specified,
	# get or assign their positions:
	#
	my %extra_column_names = ();
	foreach my $colname (keys %$extra_columns)
	{
		my $requested_pos = $$extra_columns{$colname}{position};
		if(!$requested_pos || ($requested_pos < 1000))
		{
			my $pos = $$extra_columns{$colname}{position} =~ /^(\d+)$/ ? $1 : $num_cols;
			$pos++ while exists $extra_column_names{$pos};
			$extra_column_names{$pos} = $colname;
			$num_cols++;
		}
	}

	# Create the combined @column_list from the actual DB columns and
	# the extra columns with their specified positions:
	#
	my $j = 0;
	my @column_list = ();
	for(my $i = 1; $i <= $num_cols; $i++)
	{
		if($extra_column_names{$i})	{ push @column_list, $extra_column_names{$i};	}
		else				{ push @column_list, (split(/,/, $db_colnames))[$j++];	}
	}

	# Now go through the extra columns again, for any that requested to
	# be at the end of the table (by specifying a position >1000):
	#
	foreach my $colname (keys %$extra_columns)
	{
		my $requested_pos = $$extra_columns{$colname}{position};
		if($requested_pos >= 1000)
		{
			push @column_list, $colname;
			$num_cols++;
		}
	}

	my $column_list = join ',', @column_list;

	my $vertical = $qs =~ /(?:^|&)format=vert(?:&|$)/ || ($PREF{"${viewerprefname}_viewer_default_mode"} =~ /vertical/i && $qs !~ /(?:^|&)format=horiz(?:&|$)/);
	$vertical = 0 if $PREF{"${viewerprefname}_viewer_forced_mode"} =~ /horiz/i;
	$vertical = 1 if $PREF{"${viewerprefname}_viewer_forced_mode"} =~ /vert/i;
	my %columns = map { $_ => 1 } split(/,/, $column_list);
	my %hidden_columns = map { $_ => 1 } split(/\s*,\s*/, $hiddencols);
	my %disabled_columns = map { $_ => 1 } split(/\s*,\s*/, $disabledcols);
	my %hidden_cells = ();

	my %uncreatable_columns = map { $_ => 1 } split(/\s*,\s*/, $PREF{"${viewerprefname}_viewer_uncreatable_columns"});
	my %uneditable_columns = map { $_ => 1 } split(/\s*,\s*/, $PREF{"${viewerprefname}_viewer_uneditable_columns"});
	my %autoset_columns = %{$PREF{"${viewerprefname}_creation_autoset_columns"}} if $PREF{"${viewerprefname}_creation_autoset_columns"};
	$uneditable_columns{id} = $uncreatable_columns{id} = 1;

	$PREF{"${viewerprefname}_viewer_item_name"} = $PREF{"${viewerprefname}_viewer_item_name"} || 'record';
	$PREF{"${viewerprefname}_viewer_item_name_plural"} = $PREF{"${viewerprefname}_viewer_item_name_plural"} || $PREF{"${viewerprefname}_viewer_item_name"}.'s';
	s!%%itemname%%!$PREF{"${viewerprefname}_viewer_item_name"}!g for ($TEXT{database_create_button}, $TEXT{database_create_button_2}, $TEXT{database_delete_successful}, $TEXT{database_deleter_title}, $TEXT{database_deleter_checkbox}, $TEXT{database_deleter_button});


	# Set any viewer/editor options that apply to all modes (view/create/edit):
	#
	foreach my $column (split(/,/, $column_list))
	{
		my $fieldtype_already_set = 0;
		if(my ($fieldtype,$label,$listitems,$defaultvalue) = field_structure_managed_by_us($column))
		{
			$custom_titles{$column} = $label if $label;
			$PREF{"${viewerprefname}_creation_default_value"}{lc($column)} = $defaultvalue if $defaultvalue;
			if($fieldtype eq 'dropdown')
			{
				$listitems =~ s!\n!\|\|\|!g; # our field structure manager uses newline as separator; this function uses "|||".
				$PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{lc($column)} = $listitems;
				$fieldtype_already_set = 1;
			}
			elsif($fieldtype eq 'checkbox')
			{
				$PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)} = 1;
				$fieldtype_already_set = 1;
			}
			elsif($fieldtype eq 'radio')
			{
				$listitems =~ s!\n!\|\|\|!g; # our field structure manager uses newline as separator; this function uses "|||".
				$PREF{"${viewerprefname}_viewer_column_is_radio_buttons"}{lc($column)} = $listitems;
				$fieldtype_already_set = 1;
			}
			elsif($fieldtype eq 'freeformmulti')
			{
				$PREF{"${viewerprefname}_viewer_force_textarea"}{lc($column)} = 1;
				$fieldtype_already_set = 1;
			}
		}
		if(datatype_is_bool($dbtable,$column) && !$fieldtype_already_set)
		{
			$PREF{"${viewerprefname}_viewer_column_is_toggle"}{lc($column)} = 1;
			$fieldtype_already_set = 1;
		}
	}


	# Note: early return.
	if($ENV{REQUEST_METHOD} =~ /post/i)
	{
		my $return_url_base = param('enc_post_return_url') || $PREF{REQ_URI_SANS_QS};
		
		my $wholequery = new CGI();
		my %allparams = $wholequery->Vars;
		my %multiboxes = ();
		foreach my $param(sort keys %allparams)
		{
			if(my ($col,$val) = ($param =~ /^encdb_multibox_col_(.+)_val_(.+)/))
			{
				enc_urldecode($val);
				$multiboxes{$col} .= $val . '|||';
			}
		}
		foreach my $col (keys %multiboxes) { $multiboxes{$col} =~ s!\|\|\|$!!; } # strip the final trailing '|||'.

		if(param('searchmode') eq 'true')
		{
			exit_with_needprivs() unless $PREF{"${viewerprefname}_allowed_to_search"};

			my $redirect_url = get_return_url_for_dbviewer($return_url_base) . '&';

			my $searchquery = new CGI(); # must happen if we were POSTed to, or there's a weird delay between client/server after the script finishes.
			my %params = $searchquery->Vars;
			foreach my $param(sort keys %params)
			{
				#print "$param: $params{$param}<br />\n";
				if(my ($field) = ($param =~ /^srch_(.+)/))
				{
					my $value = $params{$param};
					my $srchmode = $params{"srchmode_${field}"};
					$redirect_url =~ s!srch[1234]_${field}=[^&]+!!g; # remove any previous values for this field from the url.
					$redirect_url .= "srch${srchmode}_${field}=$value&" unless $srchmode == 4;   # 4 means ignore-this-field.
				}
			}

			defooify('&', $redirect_url);
			enc_redirect($redirect_url);		
		}
		elsif($editmode)
		{
			exit_with_needprivs() unless $allowed_to_edit;

			my $data_fingerprint_before_editing = param('enc_form_dfp');
			exit_with_error(qq`Error: data fingerprint mismatch; the data changed while you were editing it.&nbsp; Go back, reload the page, and try again.`) unless $live_data_fingerprint eq $data_fingerprint_before_editing;

			# We're only dealing with a single row here, but we'll use _multi to get the named fields into a hash.
			my $existingdata = enc_sql_select_multi("SELECT * FROM `$dbtable` WHERE `id` = $row_id_to_edit $editmode_restrictions");

			if($qs =~ /editdelete=true/)
			{
				exit_with_needprivs() unless $allowed_to_delete;

				$db_update_details{action} = 'delete'; $db_update_details{action_pasttense} = 'deleted';

				foreach my $col (keys %{$$existingdata{1}})
				{
					exit_with_error("Error: this record cannot be deleted.") if exists $PREF{"${viewerprefname}_viewer_undeletable_rows"}{lc($col)}{   $$existingdata{1}{$col}   };
				}

				if(param('confirmdeleterecord') =~ /on/i)
				{
					my $values = enc_sql_select_multi("SELECT * FROM `$dbtable` WHERE `id` = $row_id_to_edit LIMIT 1");
					enc_sql_delete("DELETE FROM `$dbtable` WHERE `id` = $row_id_to_edit LIMIT 1");

					if(my $code = $PREF{"${viewerprefname}_deletion_oncomplete_code"})
					{
						$code =~ s/%%(\w+)%%/$$values{1}{$1}/g;
						eval $code; die_nice $@ if $@;
					}

					$db_update_details{deleted_record} = $existingdata;
					send_notification_emails_for_database_update(\%db_update_details) if $PREF{"${viewerprefname}_emailalert_on_updates"} =~ /yes/i;
					enc_redirect(get_return_url_for_dbviewer($return_url_base));
				}
				else
				{
					$qs =~ s!editdelete=true!!g;
					defooify('&',$qs);
					enc_redirect($return_url_base . ($qs ? "?$qs" : ''));
				}
			}
			else
			{
				$db_update_details{action} = 'edit'; $db_update_details{action_pasttense} = 'edited';

				my %values = ();
				foreach my $column (keys %{$$existingdata{1}})
				{
					my $value = param("encdb_$column");
					$value =~ s!\r\n!\n!g;

					if(my $code = $PREF{"${viewerprefname}_POST_value_transforms"}{lc($column)})
					{
						my %values_temp = { $column => '' };
						transform_value_according_to_code($dbtable, $value, \%values_temp, $code, $column, 2, undef);
						$value = $values_temp{$column};
					}
					elsif($PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)})
					{
						$value = param("encdb_" . $column) =~ /on/i ? 1 : 0;
					}
					elsif($PREF{"${viewerprefname}_viewer_column_is_multibox"}{lc($column)})
					{
						$value = $multiboxes{$column};
					}

					replace_nonsqlsafe_chars_with($PREF{"${viewerprefname}_replace_nonsqlsafe_chars_with"}{$column}, $value) if exists $PREF{"${viewerprefname}_replace_nonsqlsafe_chars_with"}{$column};

					$values{$column} = $value;
				}

				# A second version of the same loop, but this time %values is full, so that 
				# verify_new_database_value() can use it, in case the caller has used the
				# _viewer_value_verifications mechanism with embedded %%foo%% variables which
				# require accessing other column values.
				#
				my $col_i = 0;
				foreach my $column (keys %values)
				{
					next if $disabled_columns{$column} || $column =~ /^enchddn_/i || $$existingdata{1}{enchddn_uneditable_cols_in_this_row} =~ /$column/i;
					next if $uneditable_columns{lc($column)};
					next if exists $PREF{"${viewerprefname}_viewer_uneditable_values"}{lc($column)}{   $$existingdata{1}{$column}   };

					my $value = $values{$column};
					verify_new_database_value($dbtable,$viewerprefname,$column,$value,$row_id_to_edit,\%values);

					sql_untaint($value,$column);
					die_unless_sqlsafe($value,$column);

					$col_i++;
					unless($value eq $$existingdata{1}{$column})
					{
						$db_update_details{changed_record}{$col_i}{column} = $column;
						$db_update_details{changed_record}{$col_i}{old_value} = $$existingdata{1}{$column};
						$db_update_details{changed_record}{$col_i}{new_value} = $value;

						$value = $value eq '' ? qq`NULL` : qq`'$value'`;
						my $success = enc_sql_update("UPDATE `$dbtable` SET `$column` = $value WHERE `id` = $row_id_to_edit");
						die_nice("SQL returned '$success' instead of '1' while updating '$column'.") unless $success == 1;
					}
				}

				if(my $code = $PREF{"${viewerprefname}_editmode_oncomplete_code"})
				{
					$code =~ s/%%(\w+)___old%%/$$existingdata{1}{$1}/g;
					$code =~ s/%%(\w+)%%/$values{$1}/g;
					eval $code; die_nice $@ if $@;
				}

				$db_update_details{whole_changed_record} = enc_sql_select_multi("SELECT * FROM `$dbtable` WHERE `id` = $row_id_to_edit");
				send_notification_emails_for_database_update(\%db_update_details) if $PREF{"${viewerprefname}_emailalert_on_updates"} =~ /yes/i;
				enc_redirect(get_return_url_for_dbviewer($return_url_base));
			}
		}
		else
		{
			exit_with_needprivs() unless $allowed_to_create;

			$db_update_details{action} = 'create'; $db_update_details{action_pasttense} = 'created';

			my @namelist = my @valuelist = ();

			# Do this twice, because we might need to interpolate a variable value from a
			# late column into an early column, which won't be set the first time through.
			#
			my %values = ();
			my %creation_autoset_columns___done = ();
			my %POST_value_transforms___done = ();
			foreach my $pass (1,2)
			{
				foreach my $column (split(/,/, $db_colnames))
				{
					my $value = '';
					if(my $code = $PREF{"${viewerprefname}_creation_autoset_columns"}{lc($column)})
					{
						# TODO: for clarity, should the $value param here be '' instead of $value?
						transform_value_according_to_code($dbtable, $value, \%values, $code, $column, $pass, \%creation_autoset_columns___done);
					}
					elsif(my $code = $PREF{"${viewerprefname}_POST_value_transforms"}{lc($column)})
					{
						$value = param("encdb_" . $column);
						transform_value_according_to_code($dbtable, $value, \%values, $code, $column, $pass, \%POST_value_transforms___done);
					}
					elsif($PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)})
					{
						$values{$column} = param("encdb_" . $column) =~ /on/i ? 1 : 0;
					}
					elsif($PREF{"${viewerprefname}_viewer_column_is_multibox"}{lc($column)})
					{
						$value = $multiboxes{$column};
					}
					else
					{
						$values{$column} = param("encdb_" . $column);
					}
					$values{$column} =~ s!\r\n!\n!g;
				}
			}

			foreach my $column (keys %values)
			{
				next if $uncreatable_columns{$column};
				next if $column =~ /^enchddn_/i;
				next if $disabled_columns{$column} && !$autoset_columns{$column}; # don't allow disabled columns to be set, except via autoset values.

				my $value = $values{$column};
				replace_nonsqlsafe_chars_with($PREF{"${viewerprefname}_replace_nonsqlsafe_chars_with"}{$column}, $value) if exists $PREF{"${viewerprefname}_replace_nonsqlsafe_chars_with"}{$column};
				verify_new_database_value($dbtable,$viewerprefname,$column,$value,'',\%values);
				$values{$column} = $value; # want the sqlsafe version but not the sql_untainted version.
				sql_untaint($value);
				die_unless_sqlsafe($value);
				push @namelist, "`$column`";
				push @valuelist, "'$value'";
			}

			my $statement = "INSERT INTO `$dbtable` (" . (join ',', @namelist) . ") VALUES(" . (join ',', @valuelist) . ")";
			enc_sql_insert($statement);
			my $id = enc_sql_select("SELECT LAST_INSERT_ID() FROM `$dbtable`");
			$values{id} = $db_update_details{record_id} = $id;

			if(my $code = $PREF{"${viewerprefname}_creation_oncomplete_code"})
			{
				$code =~ s/%%(\w+)%%/$values{$1}/g;
				eval $code; die_nice $@ if $@;
			}

			$db_update_details{created_record} = enc_sql_select_multi("SELECT * FROM `$dbtable` WHERE `id` = $id");
			send_notification_emails_for_database_update(\%db_update_details) if $PREF{"${viewerprefname}_emailalert_on_updates"} =~ /yes/i;
			if(my $template = $PREF{"${viewerprefname}_creation_complete_page_template"})
			{
				$template =~ s/%%(\w+)%%/$values{$1}/g; kmsg_redirect($template);
			}
			elsif(my $redirect = $PREF{"${viewerprefname}_creation_complete_redirection_url"})
			{
				$redirect =~ s/%%(\w+)%%/$values{$1}/g; enc_redirect($redirect);
			}
			else
			{
				enc_redirect(get_return_url_for_dbviewer($return_url_base));
			}
		}
	}




	my ($toggles,$headers_horiz_string,%headers_horiz,%headers_vert,$firstcol) = ('','',undef,undef,undef,'');
	foreach my $column (split(/,/, $column_list))
	{
		next if $disabled_columns{$column} || $column =~ /^enchddn_/i;
		next if $uncreatable_columns{$column} && $createmode;
		next if $$extra_columns{$column} && $createmode;

		$firstcol = $column unless $firstcol;
		my $name = my $title = $column;
		if($$creation_title_transforms{$column} && $createmode)		{ $title = $$creation_title_transforms{$column};											}
		elsif($$editmode_title_transforms{$column} && $editmode)	{ $title = $$editmode_title_transforms{$column};											}
		elsif($$viewer_title_transforms{$column})			{ $title = $$viewer_title_transforms{$column};											}
		elsif($custom_titles{$column})					{ $title = $custom_titles{$column};											}
		else								{ $title =~ s/^(\w)/\u$1/; $title =~ s/_/ /g unless $PREF{dont_convert_underscores_to_spaces_in_db_titles} =~ /yes/i;	}
		my $strike = qq`style="text-decoration: line-through;"` if $hidden_columns{$name};
		$toggles .= qq`<a href="#" onclick="toggle_column('col_$name'); return false" id="link-col_$name" $strike>$title</a>&nbsp; `;

		$hidden_cells{$name} = qq`style="display: none;"` if $hidden_columns{$name} && !$createmode; # don't hide them in createmode, where the user must be able to see them to enter values for them.

		my $new_qs = $qs;
		#$new_qs =~ s/(^|&)$qs_id(&|$)/$1$2/g;
		$new_qs =~ s/(^|&)sort=\w+?(&|$)/$1$2/g;
		$new_qs =~ s/(^|&)reverse=\d(&|$)/$1$2/g;
		$new_qs =~ s/(^|&)phase=\w+?(&|$)/$1$2/g;
		$new_qs .= "&sort=$name";
		if($qs =~ /(?:^|&)reverse=1(?:&|$)/) { $new_qs .= "&reverse=0"; } else { $new_qs .= "&reverse=1"; }
		defooify('&',$new_qs);
		$new_qs =~ s/&/&amp;/g;

		my $style_horiz = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_horiz"}{"${column}_header"} . qq`"`) if exists $PREF{"${viewerprefname}_viewer_style_horiz"}{"${column}_header"};
		my $style_vert  = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_vert"}{"${column}_header"} . qq`"`)  if exists $PREF{"${viewerprefname}_viewer_style_vert"}{"${column}_header"};
		#my $link = $self =~ /\?/ ? "$self&$new_qs" : "$self?$new_qs";
		my $link = "$PREF{REQ_URI_SANS_QS}?$new_qs";
		$headers_horiz_string	.= qq`<th class="col_$name" $hidden_cells{$name} $style_horiz><a href="$link">$title</a></th>`;
		$headers_horiz{$name}	 = qq`<th class="col_$name" $hidden_cells{$name} $style_horiz><a href="$link">$title</a></th>`;
		$headers_vert{$name}	 = qq`<td class="col_$name verthead" $hidden_cells{$name} $style_vert><a href="$link">$title</a><span class="header_input_notes">` . ($createmode || $editmode ? $PREF{"${viewerprefname}_input_notes_for_vertmode_col_header"}{$column} : '') . qq`</span></td>`;
	}

	my $output = '';
	my $there_were_some_results = 0;

	if($createmode)
	{
		my $createclass = $vertical ? 'enc_dbcreate_tbl_vert' : 'enc_dbcreate_tbl_horiz';
		$output .= qq`<form method="post" action="$ENV{SCRIPT_NAME}?$qs" style="margin: 0; padding: 0;">\n`;
		$output .= qq`<div id="${dbtable}_table" class="enc_tbl enc_db_tbl enc_create_tbl $createclass">\n<table>\n`;
		$output .= qq`<tr class="headers">$headers_horiz_string</tr>\n` unless $vertical;

		my $i = 0;
		my $numcols = 1;
		my $oddeven = oddeven($i);
		$output .= qq`<tr class="$oddeven">` unless $vertical;
		foreach my $column (split(/,/, $column_list))
		{
			next if $disabled_columns{$column} || $column =~ /^enchddn_/i;
			next if $uncreatable_columns{$column};
			next if $$extra_columns{$column};
			next if $autoset_columns{$column};

			my $value = '';
			if(my $default = $PREF{"${viewerprefname}_creation_default_value"}{lc($column)})
			{
				if($default eq 'preset:date8')		{ $value = strftime("%Y%m%d",localtime(offsettime())); }
				elsif($default eq 'preset:date17')	{ $value = strftime("%Y%m%d-%H:%M:%S",localtime(offsettime())); }
				elsif($default eq 'preset:etime')	{ $value = offsettime(); }
				elsif($default =~ /%URL\{\w+\}/)	{ interpolate_vars_from_URL_and_cookies($default); $value = $default; }
				else					{ $value = $default; }
			}

			#my $readonly = $uneditable_columns{lc($column)};
			my $readonly = '';

			my $readonly__still_submitted = 'readonly="readonly"' if $PREF{"${viewerprefname}_readonly_value__still_submitted"}{lc($column)};


			# Process viewer/editor options:
			#
			if($PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)} && !$readonly)
			{
				$value = qq`<input type="checkbox" name="encdb_$column" ` . ($value ? qq`checked="checked"` : '') . qq` />`;
			}
			elsif(exists $PREF{"${viewerprefname}_viewer_column_is_toggle"}{lc($column)} && !$readonly)
			{
				my ($yes,$no) = $PREF{"${viewerprefname}_viewer_column_toggle_values"}{lc($column)} =~ /(.+)\|(.+)/ ? ($1,$2) : ($TEXT{boolean_true_string}, $TEXT{boolean_false_string});
				$value  = qq`<select name="encdb_$column">`
					. qq`<option value="1"` . ($value  ? ' selected="selected"' : '') . qq`>$yes</option>`
					. qq`<option value="0"` . (!$value ? ' selected="selected"' : '') . qq`>$no</option>`
					. qq`</selected>`;
			}
			elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{lc($column)})
			{
				my $dropdown = qq`<select name="encdb_$column">`;
				my $value_is_in_list = 0;
				foreach my $item (split(/\s*\|\|\|\s*/, $list))
				{
					my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
					my $selected = '';
					if($submitted_value eq $value)
					{
						$selected = 'selected="selected"';
						$value_is_in_list = 1;
					}
					$dropdown .= qq`<option value="$submitted_value" $selected>$displayed_value</option>`;
				}
				$dropdown .= qq`<option selected="selected" value="$value">$value (error: not in list!)</option>` if !$value_is_in_list && $value;
				$dropdown .= qq`</select>`;
				$value = $dropdown;
			}
			elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_multibox"}{lc($column)})
			{
				my %allvalues = map { $_ => 1 } split(/\|\|\|/, $value);
				my @boxes = ();
				my $value_is_in_list = 0;
				foreach my $item (split(/\s*\|\|\|\s*/, $list))
				{
					my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
					my $checked = '';
					if($allvalues{$submitted_value})
					{
						$checked = 'checked="checked"';
						$value_is_in_list = 1;
					}
					my $submitted_value_for_paramname = enc_urlencode_return($submitted_value);
					my $boxid = "encdb_multibox_col_${column}_val_${submitted_value_for_paramname}";
					push @boxes, qq`<input type="checkbox" name="$boxid" id="$boxid" $checked /><label for="$boxid">$displayed_value</label>`;
				}
				push @boxes, qq`$value (error: not in list!)` if !$value_is_in_list && $value;
				my $separator = $PREF{"db_viewer_multibox_separator___$column"} || $PREF{db_viewer_multibox_separator___global} || '<br />';
				$value = join $separator, @boxes;
			}
			elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_radio_buttons"}{lc($column)})
			{
				my $item_i = 1;
				my @buttons = ();
				my $value_is_in_list = 0;
				foreach my $item (split(/\s*\|\|\|\s*/, $list))
				{
					my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
					my $checked = '';
					if($submitted_value eq $value)
					{
						$checked = 'checked="checked"';
						$value_is_in_list = 1;
					}
					push @buttons, qq`<input type="radio" name="encdb_$column" id="encdb_radio_${column}_${item_i}" value="$submitted_value" $checked /><label for="encdb_radio_${column}_${item_i}">$displayed_value</label>`;
					$item_i++;
				}
				my $separator = $PREF{"db_viewer_radiobutton_separator___$column"} || $PREF{db_viewer_radiobutton_separator___global} || '<br />';
				$value = join $separator, @buttons;
			}
			elsif(my $query = $PREF{"${viewerprefname}_creation_dropdown_from_SQL"}{lc($column)})
			{
				# The value of this query pref must start with: SELECT foo,bar FROM [...].
				# The first column will be the submitted value and the second the displayed value.

				my ($col1,$col2) = ($query =~ /^SELECT (\w+),(\w+) FROM /);
				my $dropdown = qq`<select name="encdb_$column">`;
				my $value_is_in_list = 0;
				my $results = enc_sql_select_multi($query);
				foreach my $k (sort { $a <=> $b } keys %$results)
				{
					my $submitted_value = $$results{$k}{$col1};
					my $displayed_value = $$results{$k}{$col2};
					my $selected = '';
					if($submitted_value eq $value)
					{
						$selected = 'selected="selected"';
						$value_is_in_list = 1;
					}
					$dropdown .= qq`<option value="$submitted_value" $selected>$displayed_value</option>`;
				}
				$dropdown .= qq`<option selected="selected" value="$value">$value (error: not in list!)</option>` if !$value_is_in_list && $value;
				$dropdown .= qq`</select>`;
				$value = $dropdown;
			}
			elsif(my $folder = $PREF{"${viewerprefname}_file_list"}{lc($column)})
			{
				my @files = get_all_files($folder);
				my $dropdown = qq`<select name="encdb_$column"><option selected="selected" value=""></option>`;
				foreach my $file (@files)
				{
					$dropdown .= qq`<option value="$file">$file</option>`;
				}
				$dropdown .= qq`</select>`;
				$value = $dropdown;
			}
			elsif(exists $PREF{"${viewerprefname}_image_picker"}{lc($column)})
			{
				my $image_picker = \%{$PREF{"${viewerprefname}_image_picker"}{lc($column)}};
				my $link_url = $$image_picker{link_url};
				my $thumb_url = $$image_picker{thumb_url};
				my @filenames = split(/\|\|\|/, $$image_picker{filenames});
				$value  = qq`<div class="encdb_imgpkr_wrapper">\n<div class="encdb_imgpkr_chosen_label">$TEXT{database_image_picker_chosen_images_label}</div>\n<div class="encdb_imgpkr_chosen" id="encdb_imgpkr_chosen_$column"><div class="empty_placeholder">$TEXT{database_image_picker_no_images_label}</div></div>\n`;
				$value .= qq`<div class="encdb_imgpkr_all_label">$TEXT{database_image_picker_available_images_label}</div>\n<div class="encdb_imgpkr_all" id="encdb_imgpkr_all_$column">\n`;
				foreach my $image (@filenames)
				{
					my $css_id = $image; $css_id =~ s!\W!_!g;
					$value .= qq`<div class="encdb_imgpkr_image_block" id="encdb_imgpkr_image_${column}_${css_id}">`
						. qq`<div class="imgpkr_thumb"><a href="$link_url/$image"><img src="$thumb_url/$image" /></a></div>`
						. qq`<div class="imgpkr_text">$image<br /><a href="#" class="encdb_imgpkr_actionlink" onclick="encdb_imgpkr_choose('$column','$image','$css_id'); return false" />$TEXT{database_image_picker_choose_button}</a></div>`
						. qq`</div>\n`;
				}
				$value .= qq`<input type="hidden" name="encdb_$column" id="encdb_$column" class="text" />\n`;
				$value .= qq`</div>\n`;
			}
			else
			{
				my $textlength = 'longtext';
				my $force_textarea = $PREF{"${viewerprefname}_viewer_force_textarea"}{lc($column)};

				$value = $readonly
					? qq`<div class="readonly">$value</div>`
					: (length($value) > 50 || $force_textarea)
					? qq`<textarea name="encdb_$column" class="text $textlength" $readonly__still_submitted>$value</textarea>`
					: qq`<input type="text" name="encdb_$column" class="text" value="$value" $readonly__still_submitted />`;
			}

			my $style_horiz = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_horiz"}{$column} . qq`"`) if exists $PREF{"${viewerprefname}_viewer_style_horiz"}{$column};
			my $style_vert  = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_vert"}{$column} . qq`"`)  if exists $PREF{"${viewerprefname}_viewer_style_vert"}{$column};
			my $style = $vertical ? $style_vert : $style_horiz;
			my $vertclass = 'vertcell' if $vertical;
			$output .= qq`<tr class="$oddeven vertrow">` if $vertical;
			$output .= $headers_vert{$column} if $vertical;
			$output .= qq`<td class="col_$column $vertclass" $hidden_cells{$column} $style>$value</td>`;
			$output .= qq`</tr>\n` if $vertical;
			$numcols++;
		}
		$output .= qq`</tr>\n` unless $vertical;

		$output .= qq`<tr class="` . oddeven($i) . qq`">`;
		$output .= qq`<td colspan="$numcols" class="button"><input type="submit" class="button" value="$TEXT{database_create_button_2}" /></td>`;
		$output .= qq`</tr>\n`;

		$output .= qq`</table>\n</div>\n`;
		$output .= qq`<input type="hidden" name="enc_post_return_url" value="$PREF{REQ_URI_SANS_QS}" />\n`;
		$output .= qq`</form>\n`;
	}
	else
	{
		my $tblclass = '';
		if($editmode)	{ $tblclass = $vertical ? ' enc_dbedit_tbl_vert' : ' enc_dbedit_tbl_horiz'; $tblclass .= ' enc_edit_tbl'; }
		else		{ $tblclass = $vertical ? ' enc_dbview_tbl_vert' : ' enc_dbview_tbl_horiz'; }
		my $quicksort_class = quicksort_is_active() ? 'enc_sortable' : '';
		$output .= qq`<form method="post" action="$ENV{SCRIPT_NAME}?$qs" style="margin: 0; padding: 0;">\n` if $editmode;
		$output .= qq`<div id="columntoggles">Show/hide:&nbsp; $toggles</div>\n` unless $PREF{"${viewerprefname}_viewer_hide_column_toggles"} =~ /yes/i;
		$output .= qq`<div id="${dbtable}_table" class="enc_tbl enc_db_tbl $tblclass">\n<table class="$quicksort_class" id="db_viewer_table">\n` unless $vertical;
		$output .= qq`<tr class="headers">$headers_horiz_string</tr>\n` unless $vertical;

		# 20090429: changed the query from this:
		#
		#	SELECT * FROM `$dbtable` LIMIT $sql_range_start, $range_end
		#
		# ...to this:
		#
		#	SELECT * FROM `$dbtable` $DESC LIMIT $sql_range_start, $range_end
		#
		# ...where $DESC = $reverse ? 'ORDER BY `id` DESC' : ''.
		# This is so that, when sorting in reverse with multiple pages of records (with
		# for example 25 records per page), page #1 shows the *last* 25 records, rather
		# than the first 25 but in reverse order.  But, shouldn't we be using $sortkey,
		# as in the original now-commented-out query, rather than hard-coding it to `id`?

		my $sortkey = $qs =~ /(?:^|&)sort=(\w+?)(?:&|$)/ ? $1
			: $PREF{"${viewerprefname}_viewer_default_sort_field"} ? $PREF{"${viewerprefname}_viewer_default_sort_field"} 
			: exists $columns{id} ? 'id'
			: $firstcol;
		my $reverse = $qs =~ /(?:^|&)reverse=1(?:&|$)/ ? 1 : 0; # toggle the 1s and 0s to reverse by default or not.
		#my $DESC = $reverse ? 'ORDER BY `id` DESC' : '';
		my $DESC = $reverse ? 'DESC' : '';
		enc_urldecode($sortkey);
		die_unless_sqlsafe($sortkey);

		# 20110823: moving the querystring-based result restriction logic up here, so we can
		# make it part of the actual SQL query, and thus have the result count and pagination
		# numbers etc be correct, as opposed to before when this was done just after the SQL
		# query by simply hiding (skipping) result rows that didn't match the qs-specified
		# restrictions.
		#
		foreach my $column (split(/,/, $column_list))
		{
			if($qs =~ /(?:^|&)$column=([^&]*)(?:&|$)/i)
			{
				my $url_specified_value = $1;
				enc_urldecode($url_specified_value);
				sql_untaint($url_specified_value);
				die_unless_sqlsafe($url_specified_value);
				$selection_restrictions .= $selection_restrictions ? " AND " : " WHERE ";
				$selection_restrictions .= "`$column` = '$url_specified_value'";
			}
		}

		while($qs =~ /(?:^|&)srch([123])_([^=]+)=([^&]+)/g)
		{
			my ($srchmode, $srchfield, $srchvalue) = ($1, $2, $3);
			$srchvalue = enc_urldecode_return($srchvalue);
			sql_untaint($srchfield,$srchvalue);
			die_unless_sqlsafe($srchfield,$srchvalue);
			$selection_restrictions .= $selection_restrictions ? " AND " : " WHERE ";
			if($srchmode == 1) # exact.
			{
				$selection_restrictions .= "`$srchfield` = '$srchvalue'";
			}
			elsif($srchmode == 2) # partial.
			{
				$selection_restrictions .= "`$srchfield` LIKE '%$srchvalue%'";
			}
			elsif($srchmode == 3) # invert.
			{
				$selection_restrictions .= "`$srchfield` NOT LIKE '%$srchvalue%'";
			}
		}
		
		#my $rows = enc_sql_select_multi("SELECT * FROM `$dbtable` ORDER BY `$sortkey` LIMIT $sql_range_start, $range_end");
		my $mainquery = "SELECT * FROM `$dbtable` $selection_restrictions ORDER BY `$sortkey` $DESC LIMIT $sql_range_start, $itemsperpage";
		#encdebug "query: $mainquery";
		my $rows = enc_sql_select_multi($mainquery);

		# Do a first pass so we can perform value_transforms, so the values are
		# set and then we can do the sorting properly in the second pass.
		#
		foreach my $row (keys %$rows)
		{
			# Actually, do this first pass twice, because we might need to interpolate
			# a variable value from a late column into an early column, which won't be
			# set the first time through.
			#
			my %already_transformed = ();
			foreach my $pass (1,2)
			{
				foreach my $column (split(/,/, $column_list))
				{
					#next if $disabled_columns{$column}; # actually, don't skip disabled cols here; we want their values to be available for transforms for other cols.
					my $value = exists $$extra_columns{$column} ? $$extra_columns{$column}{value} : $$rows{$row}{$column};
					$$rows{$row}{"${column}___raw"} = $value if $pass==1;
					if((my $code = $$viewer_value_transforms{$column})   &&   $qs !~ /(^|&)raw$column=yes(&|$)/i)
					{
						transform_value_according_to_code($dbtable, $value, \%{$$rows{$row}}, $code, $column, $pass, \%already_transformed);
					}
					elsif((my $code = $PREF{"${viewerprefname}_editmode_frontend_value_transforms"}{lc($column)})   &&   $qs !~ /(^|&)raw$column=yes(&|$)/i)
					{
						transform_value_according_to_code($dbtable, $value, \%{$$rows{$row}}, $code, $column, $pass, \%already_transformed);
					}
					else
					{
						$$rows{$row}{$column} = $value;
					}
				}
			}
		}

		my $there_was_some_output = 0;
		my $numcols = 0;
		my $i = 1;
		foreach my $row (sort
		{
			  $$rows{$a}{$sortkey} =~ /^\d*$/ && $$rows{$b}{$sortkey} =~ /^\d*$/ && $reverse	? lc($$rows{$b}{$sortkey}) <=> lc($$rows{$a}{$sortkey})
			: $$rows{$a}{$sortkey} =~ /^\d*$/ && $$rows{$b}{$sortkey} =~ /^\d*$/			? lc($$rows{$a}{$sortkey}) <=> lc($$rows{$b}{$sortkey})
			: $reverse										? lc($$rows{$b}{$sortkey}) cmp lc($$rows{$a}{$sortkey})
			: 											  lc($$rows{$a}{$sortkey}) cmp lc($$rows{$b}{$sortkey})
		}
		keys %$rows)
		{
			my $failed_to_match_url_spec = my $row_is_hidden_via_value_regex = 0;
			foreach my $column (split(/,/, $column_list))
			{
				# 20110823: moved to above the SQL query.
				#
				#if($qs =~ /(?:^|&)$column=([^&]*)(?:&|$)/i)
				#{
				#	my $url_specified_value = $1;
				#	enc_urldecode($url_specified_value);
				#	$failed_to_match_url_spec = 1 if $$rows{$row}{$column} ne $url_specified_value;
				#}

				if(exists $PREF{"${viewerprefname}_viewer_hidden_values_regex"}{lc($column)} && $qs !~ /showhiddenrows=true/)
				{
					my $regex = $PREF{"${viewerprefname}_viewer_hidden_values_regex"}{lc($column)};
					$row_is_hidden_via_value_regex ||= $regex && $$rows{$row}{$column} =~ /($regex)/i;
				}
			}
			next if $failed_to_match_url_spec || $row_is_hidden_via_value_regex;

			next if $editmode && $$rows{$row}{id} != $row_id_to_edit;

			$numcols = 0;
			my $oddeven = oddeven($i);
			$output .= qq`<div id="${dbtable}_table" class="enc_tbl enc_db_tbl $tblclass">\n<table>\n` if $vertical;
			$output .= qq`<tr class="$oddeven">` unless $vertical;
			foreach my $column (split(/,/, $column_list))
			{
				next if $disabled_columns{$column} || $column =~ /^enchddn_/i;
				my $value = '';

				if($editmode)
				{
					$value = $$rows{$row}{"${column}___raw"};
					my $transformed_value = $$rows{$row}{$column};

					# If *any* of the columns in this row are specified in _viewer_undeletable_rows,
					# then the whole row must be undeletable, so disable the $allowed_to_delete bit.
					#
					$allowed_to_delete = 0 if exists $PREF{"${viewerprefname}_viewer_undeletable_rows"}{lc($column)}{$value};
					#
					# Or if the table has an "enchddn_undeletable" column, and it's enabled for this
					# row, then disable the $allowed_to_delete bit.
					#
					$allowed_to_delete = 0 if $$rows{$row}{enchddn_undeletable};

					my $uneditable_value = exists $PREF{"${viewerprefname}_viewer_uneditable_values"}{lc($column)}{$value};
					my $readonly = $$extra_columns{lc($column)} || $uneditable_columns{lc($column)} || $uneditable_value;
					$readonly = 1 if $value ne $transformed_value && exists $PREF{"${viewerprefname}_viewer_readonly_if_transformed"}{lc($column)};
					$readonly = 1 if exists $$rows{$row}{enchddn_uneditable_cols_in_this_row} && $$rows{$row}{enchddn_uneditable_cols_in_this_row} =~ /$column/i;

					if($PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)} && !$readonly)
					{
						$value = qq`<input type="checkbox" name="encdb_$column" ` . ($value ? qq`checked="checked"` : '') . qq` />`;
					}
					elsif(exists $PREF{"${viewerprefname}_viewer_column_is_toggle"}{lc($column)} && !$readonly)
					{
						my ($yes,$no) = $PREF{"${viewerprefname}_viewer_column_toggle_values"}{lc($column)} =~ /(.+)\|(.+)/ ? ($1,$2) : ($TEXT{boolean_true_string}, $TEXT{boolean_false_string});
						if($transformed_value =~ /^[01]?$/)
						{
							$value  = qq`<select name="encdb_$column">`
								. qq`<option value="1"` . ($value  ? ' selected="selected"' : '') . qq`>$yes</option>`
								. qq`<option value="0"` . (!$value ? ' selected="selected"' : '') . qq`>$no</option>`
								. qq`</selected>`;
						}
						else
						{
							# So we can use a transform to set the displayed value to 'N/A' (for example)
							# if necessary, for cases where the column shouldn't apply at all based on
							# other column values for this row.
							#
							$value = $transformed_value;
						}
					}
					elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{lc($column)})
					{
						my $dropdown = qq`<select name="encdb_$column">`;
						my $value_is_in_list = 0;
						foreach my $item (split(/\s*\|\|\|\s*/, $list))
						{
							my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
							my $selected = '';
							if($submitted_value eq $value)
							{
								$selected = 'selected="selected"';
								$value_is_in_list = 1;
							}
							$dropdown .= qq`<option value="$submitted_value" $selected>$displayed_value</option>`;
						}
						$dropdown .= qq`<option selected="selected" value="$value">$value (error: not in list!)</option>` if !$value_is_in_list && $value;
						$dropdown .= qq`</select>`;
						$value = $dropdown;
					}
					elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_multibox"}{lc($column)})
					{
						my %allvalues = map { $_ => 1 } split(/\|\|\|/, $value);
						my @boxes = ();
						my $value_is_in_list = 0;
						foreach my $item (split(/\s*\|\|\|\s*/, $list))
						{
							my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
							my $checked = '';
							if($allvalues{$submitted_value})
							{
								$checked = 'checked="checked"';
								$value_is_in_list = 1;
							}
							my $submitted_value_for_paramname = enc_urlencode_return($submitted_value);
							my $boxid = "encdb_multibox_col_${column}_val_${submitted_value_for_paramname}";
							push @boxes, qq`<input type="checkbox" name="$boxid" id="$boxid" $checked /><label for="$boxid">$displayed_value</label>`;
						}
						push @boxes, qq`$value (error: not in list!)` if !$value_is_in_list && $value;
						my $separator = $PREF{"db_viewer_multibox_separator___$column"} || $PREF{db_viewer_multibox_separator___global} || '<br />';
						$value = join $separator, @boxes;
					}
					elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_radio_buttons"}{lc($column)})
					{
						my $item_i = 1;
						my @buttons = ();
						my $value_is_in_list = 0;
						foreach my $item (split(/\s*\|\|\|\s*/, $list))
						{
							my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
							my $checked = '';
							if($submitted_value eq $value)
							{
								$checked = 'checked="checked"';
								$value_is_in_list = 1;
							}
							push @buttons, qq`<input type="radio" name="encdb_$column" id="encdb_radio_${column}_${item_i}" value="$submitted_value" $checked /><label for="encdb_radio_${column}_${item_i}">$displayed_value</label>`;
							$item_i++;
						}
						my $separator = $PREF{"db_viewer_radiobutton_separator___$column"} || $PREF{db_viewer_radiobutton_separator___global} || '<br />';
						$value = join $separator, @buttons;
					}
					elsif(my $query = $PREF{"${viewerprefname}_editmode_dropdown_from_SQL"}{lc($column)})
					{
						# The value of this query pref must start with: SELECT foo,bar FROM [...].
						# The first column will be the submitted value and the second the displayed value.

						my ($col1,$col2) = ($query =~ /^SELECT (\w+),(\w+) FROM /);
						my $dropdown = qq`<select name="encdb_$column">`;
						my $value_is_in_list = 0;
						my $results = enc_sql_select_multi($query);
						foreach my $k (sort { $a <=> $b } keys %$results)
						{
							my $submitted_value = $$results{$k}{$col1};
							my $displayed_value = $$results{$k}{$col2};
							my $selected = '';
							if($submitted_value eq $value)
							{
								$selected = 'selected="selected"';
								$value_is_in_list = 1;
							}
							$dropdown .= qq`<option value="$submitted_value" $selected>$displayed_value</option>`;
						}
						$dropdown .= qq`<option selected="selected" value="$value">$value (error: not in list!)</option>` if !$value_is_in_list && $value;
						$dropdown .= qq`</select>`;
						$value = $dropdown;
					}
					elsif(my $folder = $PREF{"${viewerprefname}_file_list"}{lc($column)})
					{
						my @files = get_all_files($folder);
						my $dropdown = qq`<select name="encdb_$column">`;
						my $value_is_in_list = 0;
						foreach my $file (@files)
						{
							my $selected = '';
							if($file eq $value)
							{
								$selected = 'selected="selected"';
								$value_is_in_list = 1;
							}
							$dropdown .= qq`<option value="$file" $selected>$file</option>`;
						}
						$dropdown .= qq`<option selected="selected" value="$value">$value (error: file does not exist!)</option>` if !$value_is_in_list && $value;
						$dropdown .= qq`</select>`;
						$value = $dropdown;
					}
					elsif(exists $PREF{"${viewerprefname}_image_picker"}{lc($column)})
					{
						my $image_picker = \%{$PREF{"${viewerprefname}_image_picker"}{lc($column)}};
						my $link_url = $$image_picker{link_url};
						my $thumb_url = $$image_picker{thumb_url};
						my $dbvalue = $value;
						my @chosen_filenames = split(/:::::/, $dbvalue);
						my @filenames = split(/\|\|\|/, $$image_picker{filenames});
						$value  = qq`<div class="encdb_imgpkr_wrapper">\n<div class="encdb_imgpkr_chosen_label">$TEXT{database_image_picker_chosen_images_label}</div>\n<div class="encdb_imgpkr_chosen" id="encdb_imgpkr_chosen_$column">`;
						if(@chosen_filenames)
						{
							foreach my $image (@chosen_filenames)
							{
								my $css_id = $image; $css_id =~ s!\W!_!g;
								$value .= qq`<div class="encdb_imgpkr_image_block" id="encdb_imgpkr_image_chosen_${column}_${css_id}">`
									. qq`<div class="imgpkr_thumb"><a href="$link_url/$image"><img src="$thumb_url/$image" /></a></div>`
									. qq`<div class="imgpkr_text">$image<br /><a href="#" class="encdb_imgpkr_actionlink" onclick="encdb_imgpkr_unchoose('$column','$image','$css_id'); return false" />$TEXT{database_image_picker_remove_button}</a></div>`
									. qq`</div>\n`;
							}
						}
						else
						{
							$value .= qq`<div class="empty_placeholder">$TEXT{database_image_picker_no_images_label}</div>`;
						}
						$value .= qq`</div>\n`;
						$value .= qq`<div class="encdb_imgpkr_all_label">$TEXT{database_image_picker_available_images_label}</div>\n<div class="encdb_imgpkr_all" id="encdb_imgpkr_all_$column">\n`;
						foreach my $image (@filenames)
						{
							my $css_id = $image; $css_id =~ s!\W!_!g;
							$value .= qq`<div class="encdb_imgpkr_image_block" id="encdb_imgpkr_image_${column}_${css_id}">`
								. qq`<div class="imgpkr_thumb"><a href="$link_url/$image"><img src="$thumb_url/$image" /></a></div>`
								. qq`<div class="imgpkr_text">$image<br /><a href="#" class="encdb_imgpkr_actionlink" onclick="encdb_imgpkr_choose('$column','$image','$css_id'); return false" />$TEXT{database_image_picker_choose_button}</a></div>`
								. qq`</div>\n`;
						}
						$value .= qq`<input type="hidden" name="encdb_$column" id="encdb_$column" class="text" value="$dbvalue" />\n`;
						$value .= qq`</div>\n`;
					}
					else
					{
						$value = $transformed_value if $readonly; # display the transformed value, instead of the raw value, if it's not editable.
						$value = $transformed_value if $PREF{"${viewerprefname}_editmode_frontend_value_transforms"}{lc($column)};

						$value =~ s!"!&quot;!g unless $readonly;
						my $textlength = length($value) < 50 ? 'shorttext' : length($value) < 200 ? 'mediumtext' : 'longtext';
						my $force_textarea = $PREF{"${viewerprefname}_viewer_force_textarea"}{lc($column)};

						if(!$value && exists $PREF{"${viewerprefname}_viewer_display_value_if_null"}{lc($column)})
						{
							$value = $PREF{"${viewerprefname}_viewer_display_value_if_null"}{lc($column)};
						}

						$value = $readonly
							? qq`<div class="readonly">$value</div>`
							: (length($value) > 50 || $force_textarea)
							? qq`<textarea name="encdb_$column" class="text $textlength">$value</textarea>`
							: qq`<input type="text" name="encdb_$column" class="text" value="$value" />`;
					}
				}
				else
				{
					$value = $$rows{$row}{$column};

					# Value processing:
					#
					if($PREF{"${viewerprefname}_viewer_column_is_checkbox"}{lc($column)})
					{
						$value = $value ? $TEXT{boolean_true_string} : $TEXT{boolean_false_string};
					}
					elsif($PREF{"${viewerprefname}_viewer_column_is_toggle"}{lc($column)})
					{
						my ($yes,$no) = $PREF{"${viewerprefname}_viewer_column_toggle_values"}{lc($column)} =~ /(.+)\|(.+)/ ? ($1,$2) : ($TEXT{boolean_true_string}, $TEXT{boolean_false_string});
						$value = $value == 1 ? $yes : $value =~ /^0?$/ ? $no : $value;
					}
					elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_predefined_list"}{lc($column)})
					{
						foreach my $item (split(/\s*\|\|\|\s*/, $list))
						{
							my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
							$value = $displayed_value if $submitted_value eq $value;
						}
					}
					elsif(my $list = $PREF{"${viewerprefname}_viewer_column_is_multibox"}{lc($column)})
					{
						my %allvalues = map { $_ => 1 } split(/\|\|\|/, $value);
						my @boxes = ();
						foreach my $item (split(/\s*\|\|\|\s*/, $list))
						{
							my ($submitted_value, $displayed_value) = $item =~ m!(.*)///(.*)! ? ($1,$2) : ($item,$item);
							push(@boxes, $displayed_value) if $allvalues{$submitted_value};
						}
						my $sep = $PREF{"${viewerprefname}_viewer_column_multibox_separator"}{lc($column)} || '<br />';
						$value = join $sep, @boxes;
					}
					elsif(exists $PREF{"${viewerprefname}_image_picker"}{lc($column)})
					{
						my $sep = $PREF{"${viewerprefname}_image_picker_separator"}{lc($column)} || ',<br />';
						$value = join $sep, split(/:::::/, $value);
					}

					# Value correction/cleanup:
					#
					if(length($value) > $display_length && $value !~ m!</?\w+>!) # don't shorten values containing HTML, b/c it'll break the code.
					{
						my $abbreviated_value = $value;
						$abbreviated_value =~ s/^(.{$display_length}).*/$1.../;
						$value =~ s/"/\\"/g;
						$value = qq`<span title="$value">$abbreviated_value</span>`;
					}
					if(!$value && exists $PREF{"${viewerprefname}_viewer_display_value_if_null"}{lc($column)})
					{
						$value = $PREF{"${viewerprefname}_viewer_display_value_if_null"}{lc($column)};
					}
					if($PREF{"${viewerprefname}_viewer_show_HTML_as_code"}{lc($column)})
					{
						$value =~ s/</&lt;/g;
						$value =~ s/>/&gt;/g;
					}
					$value =~ s!\n!<br />\n!g;
				}

				my $style_horiz = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_horiz"}{$column} . qq`"`) if exists $PREF{"${viewerprefname}_viewer_style_horiz"}{$column};
				my $style_vert  = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_vert"}{$column} . qq`"`)  if exists $PREF{"${viewerprefname}_viewer_style_vert"}{$column};
				my $style = $vertical ? $style_vert : $style_horiz;
				my $vertclass = 'vertcell' if $vertical;
				$output .= qq`<tr class="$oddeven vertrow">` if $vertical;
				$output .= $headers_vert{$column} if $vertical;
				$output .= qq`<td class="col_$column $vertclass" $hidden_cells{$column} $style>$value</td>`;
				$output .= qq`</tr>\n` if $vertical;
				$there_was_some_output = 1;
				$numcols++;
			}

			if($vertical)
			{
				if($editmode)
				{
					$output .= qq`<tr class="` . oddeven($i) . qq`">`;
					$output .= qq`<td colspan="$numcols" class="button"><input type="hidden" name="enc_form_dfp" value="$live_data_fingerprint" /><input type="submit" class="button" value="$TEXT{database_save_button}" /></td>`;
					$output .= qq`</tr>\n`;
				}
				elsif($allowed_to_create)
				{
					$output .= qq`<tr class="` . oddeven($i) . qq` enc_sortbottom">`;
					$output .= qq`<td colspan="$numcols" class="addnew"><a href="$PREF{REQ_URI_SANS_QS}?$qs&amp;createmode=true&amp;format=vert">$TEXT{database_create_button}</a></td>`;
					$output .= qq`</tr>\n`;
				}
			}

			$output .= qq`</tr>\n` unless $vertical;
			$output .= qq`</table>\n</div>\n` if $vertical;
		}

		unless($numcols)
		{
			foreach my $column (split(/,/, $column_list))
			{
				next if $disabled_columns{$column} || $column =~ /^enchddn_/i;
				$numcols++;
			}
		}

		if(!$vertical)
		{
			if($editmode)
			{
				$output .= qq`<tr class="` . oddeven($i) . qq`">`;
				$output .= qq`<td colspan="$numcols" class="button"><input type="hidden" name="enc_form_dfp" value="$live_data_fingerprint" /><input type="submit" class="button" value="$TEXT{database_save_button}" /></td>`;
				$output .= qq`</tr>\n`;
				$there_was_some_output = 1;
			}
			elsif($allowed_to_create)
			{
				$output .= qq`<tr class="` . oddeven($i) . qq` enc_sortbottom">`;
				$output .= qq`<td colspan="$numcols" class="addnew"><a href="$PREF{REQ_URI_SANS_QS}?$qs&amp;createmode=true&amp;format=vert">$TEXT{database_create_button}</a></td>`;
				$output .= qq`</tr>\n`;
				$there_was_some_output = 1;
			}
		}

		unless($there_was_some_output)
		{
			$output .= qq`<div id="${dbtable}_table" class="enc_tbl enc_db_tbl">\n<table>\n` if $vertical;
			$output .= qq`<tr class="` . oddeven($i) . qq`">`;
			$output .= qq`<td colspan="$numcols">$TEXT{no_output_from_database}</td>`;
			$output .= qq`</tr>\n`;
			$output .= qq`</table>\n</div>\n` if $vertical;
		}

		$output .= qq`</table>\n</div>\n` unless $vertical;
		$output .= qq`<input type="hidden" name="enc_post_return_url" value="$PREF{REQ_URI_SANS_QS}" />\n` if $editmode;
		$output .= qq`</form>\n` if $editmode;


		if($editmode && $allowed_to_delete)
		{
			$output .= qq`
					<form id="database_deleter" method="post" action="$ENV{SCRIPT_NAME}?$qs&amp;editdelete=true"><div class="enc_tbl enc_db_tbl"><table>
					<tr class="headers"><th>$TEXT{database_deleter_title}</th></tr>
					<tr class="` . oddeven($i) . qq`"><td><input type="checkbox" class="checkbox" name="confirmdeleterecord" id="confirmdeleterecord" /><label for="confirmdeleterecord">` . ($PREF{"${viewerprefname}_record_deletion_warning"} || $TEXT{database_deleter_checkbox}) . qq`</label></td></tr>
					<tr class="` . oddeven($i) . qq`"><td class="button"><input type="hidden" name="enc_form_dfp" value="$live_data_fingerprint" /><input type="submit" class="button" value="$TEXT{database_deleter_button}" /></td></tr>
					</table></div>
					<input type="hidden" name="enc_post_return_url" value="$PREF{REQ_URI_SANS_QS}" />
					</form>
			`;
		}


		$output .= qq`

		<script type="text/javascript">

		function toggle_column(theclass)
		{
			var rows = document.getElementById('${dbtable}_table').getElementsByTagName('tr');

			var cells = new Array;
			for(i = 0; i < rows.length; i++)
			{
				var headers = rows[i].getElementsByTagName('th');
				for(j = 0; j < headers.length; j++)
				{
					//if(headers[j].className == theclass)
					//	cells.push(headers[j]);

					var re = new RegExp('(^| )' + theclass + '( |\$)', "i");
					if(headers[j].className.match(re))
						cells.push(headers[j]);
				}

				var nonheaders = rows[i].getElementsByTagName('td');
				for(j = 0; j < nonheaders.length; j++)
				{
					//if(nonheaders[j].className == theclass)
					//	cells.push(nonheaders[j]);

					var re = new RegExp('(^| )' + theclass + '( |\$)', "i");
					if(nonheaders[j].className.match(re))
						cells.push(nonheaders[j]);
				}
			}
			for(i = 0; i < cells.length; i++)
			{
				if(cells[i].style.display == 'none')
				{
					cells[i].style.display = navigator.userAgent.indexOf("MSIE") ==  -1 ? 'table-cell' : 'block'; // IE doesn't support table-cell...
					document.getElementById("link-" + theclass).style.textDecoration = '';
				}
				else
				{
					cells[i].style.display = 'none';
					document.getElementById("link-" + theclass).style.textDecoration = 'line-through';
				}
			}
		}
		
		</script>

		`;
	}


	my $search_form = '';
	if(!$editmode && !$createmode && $PREF{"${viewerprefname}_allowed_to_search"})
	#if(0) # this is in progress.
	{
		$search_form .= qq`<div id="${dbtable}_search_wrapper" class="db_search">\n<div id="search_title" onclick="showhide_element('db_search_form');">Search:</div>\n`;
		$search_form .= qq`<form method="post" id="db_search_form" action="$ENV{SCRIPT_NAME}?$qs" ` . ($qs !~ /(^|&)srch[123]_(\w+)/ ? qq`style="position: absolute; left: -7000px; height: 0; overflow: hidden;"` : '') . qq`>\n`;
		$search_form .= qq`<div id="${dbtable}_search_table" class="not_enc_tbl">\n<table class="" id="db_viewer_search_table">\n` unless $vertical;
		$search_form .= qq`<tr class="headers">%%headers_horiz_local%%</tr>\n` unless $vertical;

		my $i = 0;
		my $numcols = 0;
		my $oddeven = oddeven($i);
		my $headers_horiz_local = '';
		$search_form .= qq`<div id="${dbtable}_search_table" class="db_search">\n<table>\n` if $vertical;
		$search_form .= qq`<tr class="$oddeven">` unless $vertical;
		foreach my $column (split(/,/, $column_list))
		{
			next if $disabled_columns{$column} || $column =~ /^enchddn_/i;
			next if $$extra_columns{$column}{position} == 1 && $column eq 'edit';
			$numcols++;
			
			$headers_horiz_local .= $headers_horiz{$column};

			my $style_horiz = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_horiz"}{$column} . qq`"`) if exists $PREF{"${viewerprefname}_viewer_style_horiz"}{$column};
			my $style_vert  = (qq`style="` . $PREF{"${viewerprefname}_viewer_style_vert"}{$column} . qq`"`)  if exists $PREF{"${viewerprefname}_viewer_style_vert"}{$column};
			my $style = $vertical ? $style_vert : $style_horiz;
			my $vertclass = 'vertcell' if $vertical;
			$search_form .= qq`<tr class="$oddeven vertrow">` if $vertical;
			$search_form .= $headers_vert{$column} if $vertical;
			
			$search_form .= qq`<td class="col_$column $vertclass" $hidden_cells{$column} $style><input type="text" class="srch_text" name="srch_$column" value="` . (get_qs_var("srch1_$column") || get_qs_var("srch2_$column") || get_qs_var("srch3_$column")) . qq`" />`;
			$search_form .= qq`<br /><input type="radio" name="srchmode_$column" id="srchmode_${column}_1" value="1" ` . ($qs =~ /(^|&)srch1_${column}=/ ? qq`checked="checked"` : '')	. qq`/><label for="srchmode_${column}_1">Must match exactly</label>`;
			$search_form .= qq`<br /><input type="radio" name="srchmode_$column" id="srchmode_${column}_2" value="2" ` . ($qs =~ /(^|&)srch2_${column}=/ ? qq`checked="checked"` : '')	. qq`/><label for="srchmode_${column}_2">Partial match OK</label>`;
			$search_form .= qq`<br /><input type="radio" name="srchmode_$column" id="srchmode_${column}_3" value="3" ` . ($qs =~ /(^|&)srch3_${column}=/ ? qq`checked="checked"` : '')	. qq`/><label for="srchmode_${column}_3">Must not match</label>`;
			$search_form .= qq`<br /><input type="radio" name="srchmode_$column" id="srchmode_${column}_4" value="4" ` . ($qs !~ /(^|&)srch[123]_${column}=/ ? qq`checked="checked"` : '')	. qq`/><label for="srchmode_${column}_4">Unused in this search</label>`;
			$search_form .= qq`</td>`;
			
			$search_form .= qq`</tr>\n` if $vertical;
		}
		$search_form =~ s!%%headers_horiz_local%%!$headers_horiz_local!;

		if(!$vertical)
		{
			$search_form .= qq`</tr>\n`; # unless $vertical;
		}

		#$search_form .= qq`<tr class="` . oddeven($i) . qq` enc_sortbottom">`;
		#$search_form .= qq`<td colspan="$numcols" class="search"><input type="submit" value="$TEXT{database_search_button}" /></td>`;
		#$search_form .= qq`</tr>\n`;
		#
		#$search_form .= qq`</table>\n</div>\n`;

		my $search_reset_url = $qs;
		$search_reset_url =~ s!(^|&)srch[1234]_[^=]+=[^&]+!!g;
		defooify('&', $search_reset_url);
		$search_reset_url = $PREF{REQ_URI_SANS_QS} . '?' . $search_reset_url;

		$search_form .= qq`</table>\n<input type="submit" value="$TEXT{database_search_button}" />\n`;
		$search_form .= qq`<input type="button" name="db_search_form_reset_button" id="db_search_form_reset_button" value="Reset" onclick='if(window.confirm("Really clear the search form?")) { location.href="$search_reset_url"; }' />\n`;
		$search_form .= qq`</div>\n`;

		$search_form .= qq`<input type="hidden" name="searchmode" value="true" />\n`;
		$search_form .= qq`<input type="hidden" name="enc_post_return_url" value="$PREF{REQ_URI_SANS_QS}" />\n`;
		$search_form .= qq`</form>\n</div>\n`;
	}


	$template =~ s!%%output%%!$output!;

	my $uri = $ENV{REQUEST_URI};
	$uri =~ s/(\?|&)format=(horiz|vert)/$1/gi;
	defooify('&', $uri);
	my $horizlink	= $uri . ($uri =~ /\?/ ? '&' : '?') . qq`format=horiz`;
	my $vertlink	= $uri . ($uri =~ /\?/ ? '&' : '?') . qq`format=vert`;
	$uri = $ENV{REQUEST_URI};
	$uri =~ s!editdelete=true!!g;
	$uri =~ s!(edit|create)mode=true!!g;
	$uri =~ s!editid=\d+!!g;
	clean_database_url($uri);
	defooify('&',$uri);
	defooify('\?',$uri);

	my @template_viewcontrols_pruned = ();
	for(@template_viewcontrols)
	{
		if($PREF{"${viewerprefname}_viewer_forced_mode"} =~ /horiz|vert/)
		{
			s!%%(?:horiz|vert)link:text=([^%]+)%%!!g;
		}
		else
		{
			s!%%horizlink:text=([^%]+)%%!$vertical ? qq`<a href="$horizlink">$1</a>` : $1!eg;
			s!%%vertlink:text=([^%]+)%%!$vertical ? $1 : qq`<a href="$vertlink">$1</a>`!eg;
		}

		s!%%viewalllink:text=([^%]+)%%!$editmode || $createmode ? qq`<a href="$uri">$1</a>` : ''!eg;

		push(@template_viewcontrols_pruned, $_) if $_;
	}

	# For example:   %%%if-whence%%% %%whencelink:text=Back To Fields List%% | %%%end-whence%%%
	#
	$template =~ s!%%whencelink:text=([^%]+)%%!$PREF{dbvwrwhence} ? qq`<a href="$PREF{dbvwrwhence}">$1</a>` : ''!eg;
	$template =~ s!%%%if-whence%%%(.*?)%%%end-whence%%%!$PREF{dbvwrwhence} ? $1 : ''!egs;

	$template =~ s!%%%if-db_view_controls%%%(.*?)%%%end-db_view_controls%%%!@template_viewcontrols_pruned ? $1 : ''!egs;
	$template =~ s!%%db_view_controls%%!join $template_viewcontrols_sep, @template_viewcontrols_pruned!egs;

	my $numitems = enc_sql_select("SELECT COUNT(*) FROM `$dbtable` $selection_restrictions");
	my $pagelinks = get_pagination_links_mark2( { range_start => $range_start, range_end => $range_end, num_items => $numitems, items_per_page => $itemsperpage } ) unless $createmode || $editmode;
	$template =~ s!%%%if-pagelinks%%%(.*?)%%%end-pagelinks%%%!$pagelinks ? $1 : ''!egs;
	$template =~ s!%%pagelinks%%!$pagelinks!g;
	$template =~ s!%%search_form%%!$search_form!g;
	$template =~ s!%%itemname_plural%%!$PREF{"${viewerprefname}_viewer_item_name_plural"}!g;
	
	if(get_qs_var('srchvrfymode') eq 'true')
	{
		my $go = $there_were_some_results ? $PREF{"${viewerprefname}_search_verify_mode_redirection_url_for_matches"} : $PREF{"${viewerprefname}_search_verify_mode_redirection_url_for_misses"};;
		my %searchterms = ();
		while($qs =~ /(?:^|&)srch[123]_([^=]+)=([^&]+)/g)
		{
			$searchterms{$1} = $2;
		}
		$go =~ s!%%(\w+)%%!$searchterms{$1}!g;
		if($go)
		{
			enc_redirect($go);
		}
		else
		{
			my $srchmatch = $TEXT{db_search_verify_mode_match_text} || qq`Your search found a match.`;
			my $srchmiss = $TEXT{db_search_verify_mode_miss_text} || qq`Your search found no match.`;
			exit_with_notice($there_were_some_results ? $srchmatch : $srchmiss);
		}
	}

	# This is down here, instead of further up, because we want to allow the allowed_to_search
	# permission to allow access in the case where the search is just returning a matched/failed
	# result (not returning any actual database rows for viewing).  For example, in the situation
	# where a customer needs to be able to look up a license number, registration code, coupon
	# code, etc, and the site owner wants to allow that, but only for verification purposes, not
	# to display the database search result rows to the customer.
	#
	exit_with_needprivs() unless $allowed_to_view;

	return $template;
}


sub send_notification_emails_for_database_update($)
{
	my $details_ref = shift; my %details = %$details_ref;

	my $viewerprefname	= $details{viewerprefname};
	my $recipients		= $PREF{"${viewerprefname}_emailalert_recipients"};
	my $from		= $PREF{"${viewerprefname}_emailalert_sender"};
	my $subject		= $PREF{"${viewerprefname}_emailalert_subject"};
	my $body		= $PREF{"${viewerprefname}_emailalert_body"};
	my $format		= $PREF{"${viewerprefname}_emailalert_type"};
	my $failure_action	= $PREF{"${viewerprefname}_emailalert_failure_action"};

	my $changes_rows = '';
	if($details{changed_record})
	{
		foreach my $col_i (sort { $a <=> $b } keys %{$details{changed_record}})
		{
			my $changes_template = $PREF{"${viewerprefname}_emailalert_changes_template"};
			$changes_template =~ s!%%column%%!$details{changed_record}{$col_i}{column}!g;
			$changes_template =~ s!%%old_value%%!$details{changed_record}{$col_i}{old_value}!g;
			$changes_template =~ s!%%new_value%%!$details{changed_record}{$col_i}{new_value}!g;
			$changes_rows .= $changes_template;
		}
	}

	my $all_rows = '';
	my $sorted_column_list = '';
	my $whole_record = $details{deleted_record} || $details{created_record} || $details{whole_changed_record};
	foreach my $col (sort { lc($a) cmp lc($b) } keys %{$$whole_record{1}})
	{
		$sorted_column_list .= "$col," unless $PREF{"${viewerprefname}_emailalert_fields_to_hide"} =~ /(^|,)\s*$col\s*(,|$)/;
	}
	$sorted_column_list = $PREF{"${viewerprefname}_emailalert_fields_to_show"} if $PREF{"${viewerprefname}_emailalert_fields_to_show"};
	decommaify($sorted_column_list);
	foreach my $col (split(/\s*,\s*/, $sorted_column_list))
	{
		my $allrows_template = $PREF{"${viewerprefname}_emailalert_record_template"};
		$allrows_template =~ s!%%column%%!$col!g;
		$allrows_template =~ s!%%value%%!$$whole_record{1}{$col}!g;
		$all_rows .= $allrows_template;
	}

	$body =~ s!%%username%%!$PREF{logged_in_username} || '(unknown)'!eg;
	$body =~ s!%%action%%!$details{action}!g;
	$body =~ s!%%action_pasttense%%!$details{action_pasttense}!g;
	$body =~ s!%%table%%!$details{table}!g;
	$body =~ s!%%record_id%%!$details{record_id}!g;
	$body =~ s!%%db_url%%!$PREF{"${viewerprefname}_viewer_db_url"}!g;
	$body =~ s!%%db_url_full%%!$PREF{"${viewerprefname}_viewer_db_url_full"}!g;
	$body =~ s!%%changes%%!$PREF{"${viewerprefname}_emailalert_changes_header"}$changes_rows!g;
	$body =~ s!%%record%%!$PREF{"${viewerprefname}_emailalert_record_header"}$all_rows!g;

	$body =~ s!%%%if-edit%%%(.*?)%%%endif-edit%%%!$details{action} eq 'edit' ? $1 : $2!egs;
	$body =~ s!%%%ifelse-deletion%%%(.*?)%%%else%%%(.*?)%%%endelse-deletion%%%!$details{action} eq 'delete' ? $1 : $2!egs;
	
	foreach my $to (split(/\s*,\s*/, $recipients))
	{
		if($to eq 'all_members_of_the_loggedin_users_custom_groups')
		{
			foreach my $to_inner (get_email_addresses_for_all_members_of_this_users_groups($PREF{logged_in_userid}))
			{
				send_email($to_inner, $from, $subject, $body, $format, $failure_action);
			}
		}
		else
		{
			send_email($to, $from, $subject, $body, $format, $failure_action);
		}
	}
}


sub get_return_url_for_dbviewer($)
{
	my $return_url_base = shift;
	my $qsl = $qs;
	$qsl =~ s!format=(horiz|vert)!!g if $qsl =~ /format=horiz/i && $qsl =~ /format=vert/i; # if both are present, remove both.
	$qsl =~ s!format=vert!!; # we always add 1 format=vert on the way to this page, so we should always remove 1 on the way back out.
	$qsl =~ s!editdelete=true!!g;
	$qsl =~ s!editmode=true!!g;
	$qsl =~ s!editid=\d+!!g;
	$qsl =~ s!createmode=true!!g;
	defooify('&',$qsl);
	return $return_url_base . ($qsl ? "?$qsl" : '');
}


sub datatype_is_bool($$)
{
	my ($table,$column) = @_;
	my $datatype = get_field_datatype($table,$column);
	return $datatype =~ /^(bool|tinyint\(1\))/i;
}


sub get_field_datatype($$)
{
	my ($table,$column) = @_;
	sql_untaint($table,$column);
	die_unless_sqlsafe($table,$column);

	# This fails on some older MySQL versions, which apparently don't allow the WHERE clause
	# on the SHOW COLUMNS query.  So we'll have to return all columns and manually search them.
	#my $coltypetest = enc_sql_select_multi("SHOW COLUMNS FROM `$table` WHERE `field` = '$column'");
	#return $$coltypetest{1}{Type} || $$coltypetest{1}{type};

	my $coltypetest = enc_sql_select_multi("SHOW COLUMNS FROM `$table`");
	foreach my $j (keys %$coltypetest)
	{
		return ($$coltypetest{$j}{Type} || $$coltypetest{$j}{type}) if ($$coltypetest{$j}{Field} =~ /^$column$/i || $$coltypetest{$j}{field} =~ /^$column$/i);
	}
}


sub get_field_details_from_db($$)
{
	my ($table,$column) = @_;
	sql_untaint($table,$column);
	die_unless_sqlsafe($table,$column);

	my %details = ();
	my $coltypetest = enc_sql_select_multi("SHOW COLUMNS FROM `$table`");
	foreach my $j (keys %$coltypetest)
	{
		 if($$coltypetest{$j}{Field} =~ /^$column$/i || $$coltypetest{$j}{field} =~ /^$column$/i)
		 {
		 	$details{type}		= exists $$coltypetest{$j}{Type}	? $$coltypetest{$j}{Type}	: $$coltypetest{$j}{type};
		 	$details{null}		= exists $$coltypetest{$j}{Null}	? $$coltypetest{$j}{Null}	: $$coltypetest{$j}{null};
		 	$details{key}		= exists $$coltypetest{$j}{Key}		? $$coltypetest{$j}{Key}	: $$coltypetest{$j}{key};
		 	$details{default}	= exists $$coltypetest{$j}{Default}	? $$coltypetest{$j}{Default}	: $$coltypetest{$j}{default};
		 	$details{extra}		= exists $$coltypetest{$j}{Extra}	? $$coltypetest{$j}{Extra}	: $$coltypetest{$j}{extra};
		 	
		 	# For integer types, the returned value will be something like one of the following:
		 	#
		 	#	bigint(20)
		 	#	int(10) unsigned
		 	#
		 	# But the number in parentheses is added by MySQL automatically (i.e. even when you
		 	# don't specify it when creating the column, which you wouldn't in most cases), and
		 	# it is NOT an indicator of the field size, as the MySQL manual explains:
		 	#
		 	#	http://dev.mysql.com/doc/refman/5.0/en/numeric-types.html
		 	#	
		 	#	Numeric Type Attributes
		 	#	
		 	#	MySQL supports an extension for optionally specifying the display width of
		 	#	integer data types in parentheses following the base keyword for the type.
		 	#	For example, INT(4) specifies an INT with a display width of four digits.
		 	#	This optional display width may be used by applications to display integer
		 	#	values having a width less than the width specified for the column by
		 	#	left-padding them with spaces. (That is, this width is present in the
		 	#	metadata returned with result sets. Whether it is used or not is up to the
		 	#	application.)
			#	
			#	The display width does *not* constrain the range of values that can be stored
			#	in the column. Nor does it prevent values wider than the column display width
			#	from being displayed correctly. For example, a column specified as
			#	SMALLINT(3) has the usual SMALLINT range of -32768 to 32767, and values
			#	outside the range permitted by three digits are displayed in full using more
			#	than three digits. 
		 	#	
		 	# Therefore, for our purposes here, where in 99% of cases we didn't specify this number
		 	# explicitly, and therefore it's meaningless in the context of determining whether the
		 	# column type has changed, we will remove this number.
		 	#
		 	$details{type} =~ s!int\(\d+\)!int!;
		 	
		 	return \%details;
		 }
	}
}


sub get_field_details_from_creation_string($)
{
	my ($creation_string) = @_;

	my %details = ();
 	$details{type}		= ($creation_string =~ m!^(\S+( unsigned)?)!i)[0];
 	$details{null}		= $creation_string =~ m!not null!i ? 'NO' : 'YES';
 	$details{key}		= $creation_string =~ m!primary key!i ? 'PRI' : ''; # TODO: add detection of other key types.
	$details{default}	= $creation_string =~ m!default (\S+)!i ? $1 : ''; # TODO: some types have a default DEFAULT value other than NULL.
	$details{extra}		= $creation_string =~ m!auto_increment!i ? 'auto_increment' : ''; # TODO: potentially lots of other stuff here.
 	
	$details{type} =~ s!int\(\d+\)!int!; # see note in the get_field_details_from_db() sub.

	$details{default} =~ s!^'(.*)'$!$1!; # In case the specified default value is quoted, remove
	$details{default} =~ s!^"(.*)"$!$1!; # the quotes before actually using/comparing the value.
	 	
 	return \%details;
}


sub field_datatype_has_changed($$$)
{
	my ($table,$fieldname,$creation_string) = @_;
	my $new_fieldtype = get_field_details_from_creation_string($creation_string);
	my $old_fieldtype = get_field_details_from_db($table,$fieldname);
	
	my $changed = 0;
	my ($old,$new) = ();
	foreach my $attrib (sort keys %$old_fieldtype)
	{
		$changed = 1 if lc($$old_fieldtype{$attrib}) ne lc($$new_fieldtype{$attrib});
		$old .= "old $attrib: " . lc($$old_fieldtype{$attrib}) . "; ";
		$new .= "new $attrib: " . lc($$new_fieldtype{$attrib}) . "; ";
	}

	if($changed)
	{
		encdebug "datatype has changed for '$fieldname':\nold=$old\nnew=$new\n";
		return 1;
	}
	else
	{
		encdebug "datatype has NOT changed for '$fieldname':\nold=$old\nnew=$new\n";
		return 0;
	}
}


sub clean_database_url
{
	$_[0] =~ s!format=(horiz|vert)!!g if $_[0] =~ /format=horiz/ && $_[0] =~ /format=vert/; # if both are present, remove all.
	for('horiz','vert')
	{
		if($_[0] =~ /format=$_/) { $_[0] =~ s!format=$_!!g; $_[0] .= "&format=$_"; } # condense multiple occurrences of the same one.
	}
	$_[0] =~ s!\?&+!?!g;
}


sub verify_new_database_value($$$$$$)
{
	# Notes:
	#
	#	_viewer_unique_values and _viewer_unique_values_ignorecase require that
	# 	the table has a column called "id" which is unique and not null.
	#

	my ($dbtable,$viewerprefname,$column,$value,$rowid,$all_fields) = @_;
	sql_untaint($value,$column);
	die_unless_sqlsafe($value,$column);

	if(exists $PREF{"${viewerprefname}_viewer_unique_values"}{lc($column)})
	{
		if($rowid =~ /^\d+$/) # edit mode.
		{
			if(enc_sql_select("SELECT COUNT(*) FROM `$dbtable` WHERE `$column` = '$value' AND `id` != $rowid"))
			{
				exit_with_error(qq`Error: '$column' must be unique, but the one you entered ('$value') already exists.`);
			}
		}
		else # add-new-record mode.
		{
			if(enc_sql_select("SELECT COUNT(*) FROM `$dbtable` WHERE `$column` = '$value'"))
			{
				exit_with_error(qq`Error: '$column' must be unique, but the one you entered ('$value') already exists.`);
			}
		}
	}

	if(exists $PREF{"${viewerprefname}_viewer_unique_values_ignorecase"}{lc($column)})
	{
		if($rowid =~ /^\d+$/) # edit mode.
		{
			if(enc_sql_select("SELECT COUNT(*) FROM `$dbtable` WHERE LOWER(`$column`) = LOWER('$value') AND `id` != $rowid"))
			{
				exit_with_error(qq`Error: '$column' must be unique, but the one you entered ('$value') already exists.`);
			}
		}
		else # add-new-record mode.
		{
			if(enc_sql_select("SELECT COUNT(*) FROM `$dbtable` WHERE LOWER(`$column`) = LOWER('$value')"))
			{
				exit_with_error(qq`Error: '$column' must be unique, but the one you entered ('$value') already exists.`);
			}
		}
	}

	# 201001: APICHANGE: $PREF{"${viewerprefname}_viewer_value_verifications"}{lc($column)} was a string; now it's a hash.
	#
	if(exists $PREF{"${viewerprefname}_viewer_value_verifications"}{lc($column)})
	{
		foreach my $testnum (keys %{ $PREF{"${viewerprefname}_viewer_value_verifications"}{lc($column)} })
		{
			my $code = $PREF{"${viewerprefname}_viewer_value_verifications"}{lc($column)}{$testnum};
			if($code =~ /^preset:(.+)/)
			{
				foreach my $preset (split(/\s*,\s*/, $1))
				{
					my ($error,%vars) = ('',());
					   if(($preset eq 'nonnull')		&& (!$value && ($value !~ /^0$/)))	{ $error = $TEXT{Error_input_null}; }
					elsif(($preset eq 'alnum')		&& ($value !~ /^[[:alnum:]]*$/))	{ $error = $TEXT{Error_input_not_alnum}; }
					elsif(($preset eq 'word')		&& ($value !~ /^\w*$/))			{ $error = $TEXT{Error_input_not_word}; }
					elsif(($preset eq 'numeric')		&& ($value !~ /^\d*$/))			{ $error = $TEXT{Error_input_not_numeric}; }
					elsif(($preset =~ /^minvalue=(\d+)$/)	&& ($value < $1))			{ $error = $TEXT{Error_input_too_small}; $vars{min} = $1; }
					elsif(($preset =~ /^maxvalue=(\d+)$/)	&& ($value > $1))			{ $error = $TEXT{Error_input_too_large}; $vars{max} = $1; }
					elsif(($preset =~ /^minlength=(\d+)$/)	&& (length($value) < $1))		{ $error = $TEXT{Error_input_too_short}; $vars{min} = $1; }
					elsif(($preset =~ /^maxlength=(\d+)$/)	&& (length($value) > $1))		{ $error = $TEXT{Error_input_too_long}; $vars{max} = $1; }
					#print STDERR "column=$column, value=$value, preset=$preset, error=$error\n";

					if($error) { $error =~ s/%%encfieldname%%/$column/g; $error =~ s/%%(\w+)%%/$vars{$1}/g; kmsg_redirect($error); }
				}
			}
			else
			{
				$code =~ s/%%variable%%/\$value/g;
				$code =~ s/%%encfieldname%%/$column/g;
				$code =~ s/%%(\w+)%%/$$all_fields{$1}/g;
				eval $code; # modified $value directly.
				die $@ if $@; # in case the custom code had an error in it.
				# die_from_eval: can accept a whole literal message, or "smsg_foo" which maps to $TEXT{smsg_foo} -- where possible, use static messages rather than keyed messages.
				if($value =~ /die_from_eval:(.*)/) { my $msg = $1; $msg =~ m!^smsg_(.+)! ? smsg_redirect($1) : kmsg_redirect($msg); }
			}
		}
	}
}


sub transform_value_according_to_code
{
	my $dbtable		= shift;
	my $value		= shift;
	my $values		= shift; # hashref
	my $code		= shift;
	my $column		= shift;
	my $pass		= shift;
	my $already_transformed = shift; # hashref.

	if($code =~ /^preset:(.+)/)
	{
		foreach my $preset (split(/\s*,\s*/, $1))
		{
			   if($preset eq 'make_lowercase')	{ $value = lc($value); }
			elsif($preset eq 'make_uppercase')	{ $value = uc($value); }
			elsif($preset eq 'remove_nonalnum')	{ $value =~ s![^[:alnum:]]!!g; }
			elsif($preset eq 'date8')		{ $value = strftime("%Y%m%d",localtime(offsettime())); }
			elsif($preset eq 'date17')		{ $value = strftime("%Y%m%d-%H:%M:%S",localtime(offsettime())); }
			elsif($preset eq 'etime')		{ $value = offsettime(); }

			elsif($preset eq 'next_int_if_null_or_zero' && !$value)
			{
				$value = enc_sql_select("SELECT MAX(`$column`) FROM `$dbtable`") =~ /^(\d+)$/ ? $1 : 0; $value++;
			}

			#print STDERR "column=$column, value=$value, preset=$preset\n";
		}
		$$values{$column} = $value;
	}
	else
	{
		$code =~ s/%%variable%%/\$value/g;
		$code =~ s/%%(\w+)%%/exists $$values{$1} || $pass==2 ? $$values{$1} : $&/eg;
		if($code !~ /%%\w+%%/ || $pass==2)
		{
			if(!$$already_transformed{$column})
			{
				$$already_transformed{$column} = 1;
				eval $code; # modifies $value directly.
				$$values{$column} = $value;
			}
		}
	}
}


sub get_pagination_range($)
{
	my $items_per_page = $_[0];
	my $page_num = $qs =~ /(?:^|&)page=(\d+)(?:&|$)/ ? $1 : 1;
	my $range_start = ($items_per_page * ($page_num - 1)) + 1; # $range_start = 1 if $range_start < 1; # negative check not necessary if $page_num is guaranteed to be >= 1.
	my $range_end = $items_per_page * $page_num;
	my $sql_range_start = $range_start - 1; # because SQL's LIMIT is zero-based.

	($range_start,$range_end,$sql_range_start) = (1,999999999,0) if $qs =~ /(?:^|&)pagination=off(?:&|$)/;

	# We need to adjust itemsperpage (in the caller), not just the range start & end, when
	# pagination=off, because SQL's 'LIMIT' uses range_start & itemsperpage (not range_end).
	$_[0] = 999999999 if $qs =~ /(?:^|&)pagination=off(?:&|$)/;

	return ($range_start,$range_end,$sql_range_start);
}


sub get_pagination_links_mark2
{
	## first 4 args are mandatory; rest are optional.
	#my ($range_start, $range_end, $num_items, $items_per_page,
	#	$itemname_singular,
	#	$itemname_plural,
	#	$pagename_singular,
	#	$pagename_plural,
	#	$template,
	#	$num_pagelinks,
	#	$viewall_template
	#) = @_;
	#
	# 20110226: APICHANGE: args for this sub are now hash-based:
	#
	my $optsref = shift; my %opts = %$optsref if $optsref;

	$opts{template} ||= qq`
		<div class="pagelinks">
			%%%if-multiple_pages%%%
			<div class="links">
			%%%ifelse-frstlink%%% <a href="%%frstlink%%" class="first">&lt;&lt;</a>	%%%else%%% <span class="disabled first">&lt;&lt;</span>	%%%endelse-frstlink%%% %%spc%%
			%%%ifelse-prevlink%%% <a href="%%prevlink%%">&lt;</a>			%%%else%%% <span class="disabled">&lt;</span>		%%%endelse-prevlink%%% %%spc%%

			%%%template:linklist%%%
				%%%ifelse-currentpage%%%
					<span class="current">%%pagenum%%</span> %%spc%%
				%%%else%%%
					<a href="%%link%%">%%pagenum%%</a> %%spc%%
				%%%endelse-currentpage%%%
			%%%end-template:linklist%%%

			%%%ifelse-nextlink%%% <a href="%%nextlink%%">&gt;</a>			%%%else%%% <span class="disabled">&gt;</span>		%%%endelse-nextlink%%% %%spc%%
			%%%ifelse-lastlink%%% <a href="%%lastlink%%" class="last">&gt;&gt;</a>	%%%else%%% <span class="disabled last">&gt;&gt;</span>	%%%endelse-lastlink%%%
			</div>
			%%%end-multiple_pages%%%

			<div class="text">
			<span class="bookend">{</span>%%num_items%% %%itemname%% on %%num_pages%% %%pagename%%.
			%%%if-show_opts_links%%%
				&nbsp;Options: &nbsp; %%alllink%% %%%if-show_sort_links%%%&nbsp; %%quicksortlink%% %%%end-show_sort_links%%%
			%%%end-show_opts_links%%%
			<span class="bookend">}</span>
			</div>
		</div>
	`;

	$opts{viewall_template} ||= qq`
		<div class="pagelinks">
		(Viewing all %%num_items%% %%itemname%%.&nbsp; <a href="%%pageslink%%">View individual pages?</a>)
		</div>
	`;

	$opts{itemname_singular}	||= $TEXT{item}		|| 'item';
	$opts{itemname_plural}		||= $TEXT{items}	|| 'items';
	$opts{pagename_singular}	||= $TEXT{page}		|| 'page';
	$opts{pagename_plural}		||= $TEXT{pages}	|| 'pages';
	$opts{num_pagelinks}		||= 8;
	my $spacer			= $PREF{pagination_links_spacer} || '';

	my $num_pages = int($opts{num_items}/$opts{items_per_page});
	$num_pages++ if $num_pages < ($opts{num_items}/$opts{items_per_page});
	return '' if $opts{hide_when_single_page} && $num_pages =~ /^(0|1)$/ && get_qs_var('pagination') ne 'off';

	my $viewall_active	= (get_qs_var('pagination') eq 'off') || ($num_pages == 1);
	my $viewall_unclickable	= (get_qs_var('pagination') ne 'off') && ($num_pages == 1);

	my ($link_template) = ($opts{template} =~ m!%%%template:linklist%%%(.+?)%%%end-template:linklist%%%!gs);
	my $link_template_output = '';
	my %pagelinks = ();

	#if($qs =~ /pagination=off/)
	#if($viewall_active)
	if(0)
	{
		my $uri = $ENV{REQUEST_URI};
		$uri =~ s/pagination=off//g;
		defooify('&', $uri);
		$opts{viewall_template} =~ s!%%pageslink%%!$uri!g;
		$opts{viewall_template} =~ s!%%num_items%%!$opts{num_items}!g;
		$opts{viewall_template} =~ s!%%itemname%%!$opts{num_items} == 1 ? $opts{itemname_singular} : $opts{itemname_plural}!eg if $opts{itemname_singular} && $opts{itemname_plural};
		return $opts{viewall_template};
	}
	#elsif($opts{range_start} != 1   ||   $opts{num_items} > $opts{range_end})
	elsif(1)
	{
		my $uri = $ENV{REQUEST_URI};

		# Remove any existing phase/resultmsg, and page number, from the
		# URI, because we don't want to include those on each new page.
		#
		$uri =~ s/(\?|&)page=(\d+)/$1/g;
		$uri =~ s/(\?|&)phase=(\w+)/$1/g;
		$uri =~ s/(\?|&)rsltmsg=(\w+)/$1/g;

		my $uri_for_quicksort_link = my $uri_for_pagination_link = $uri;
		$uri_for_quicksort_link =~ s/(\?|&)quicksort=(on|off)/$1/g;
		$uri_for_pagination_link =~ s/(\?|&)pagination=(on|off)/$1/g;

		for($uri, $uri_for_quicksort_link, $uri_for_pagination_link)
		{
			$_ .= '?' unless $_ =~ /\?/;
			$_ .= '&' if $_ =~ /\?.+/ && $_ !~ /&$/;
			$_ =~ s/&{2,}/&/g;
			$_ =~ s/\?&/?/g;
		}

		my $current_page = 1;
		for(my $j = 1; $j <= $num_pages; $j++)
		{
			my $is_currentpage = ($ENV{REQUEST_URI} =~ /page=$j/ || ($ENV{REQUEST_URI} !~ /page=\d+/ && $j==1));
			$current_page = $j if $is_currentpage;

			my $link_template_local = $link_template;
			$link_template_local =~ s!%%pagenum%%!$j!g;
			$link_template_local =~ s!%%link%%!${uri}page=$j!g;
			$link_template_local =~ s!%%%ifelse-currentpage%%%(.*?)%%%else%%%(.*?)%%%endelse-currentpage%%%!$is_currentpage ? $1 : $2!egs;
			$pagelinks{$j} = $link_template_local;
		}

		foreach my $page (sort { $a <=> $b } keys %pagelinks)
		{
			$link_template_output .= $pagelinks{$page} if (($page - int($opts{num_pagelinks}/2 + .5)) <= $current_page) && ($current_page <= ($page + int($opts{num_pagelinks}/2 + .5)));
		}

		my $prevlink = $current_page > 1 ? $current_page - 1 : 1;
		my $nextlink = $current_page < $num_pages ? $current_page + 1 : $num_pages;
		$opts{template} =~ s!%%prevlink%%!${uri}page=$prevlink!g;
		$opts{template} =~ s!%%nextlink%%!${uri}page=$nextlink!g;
		$opts{template} =~ s!%%alllink%%!$viewall_unclickable ? qq`<span class="disabled">view all</span>` : $viewall_active ? qq`<a href="${uri_for_pagination_link}">view pages</a>` : qq`<a href="${uri_for_pagination_link}pagination=off">view all</a>`!eg;
		$opts{template} =~ s!%%quicksortlink%%!quicksort_is_active() ? qq`<a href="${uri_for_quicksort_link}quicksort=off">server-sort</a>` : qq`<a href="${uri_for_quicksort_link}quicksort=on">quick-sort</a>`!eg;
		$opts{template} =~ s!%%%if-show_opts_links%%%(.*?)%%%end-show_opts_links%%%!$opts{hide_opts_links} ? '' : $1!egs;
		$opts{template} =~ s!%%%if-show_sort_links%%%(.*?)%%%end-show_sort_links%%%!$opts{hide_sort_links} ? '' : $1!egs;
		$opts{template} =~ s!%%%ifelse-prevlink%%%(.*?)%%%else%%%(.*?)%%%endelse-prevlink%%%!$current_page ne 1 ? $1 : $2!egs;
		$opts{template} =~ s!%%%ifelse-nextlink%%%(.*?)%%%else%%%(.*?)%%%endelse-nextlink%%%!$current_page ne $num_pages ? $1 : $2!egs;
		$opts{template} =~ s!%%%if-multiple_pages%%%(.*?)%%%end-multiple_pages%%%!$num_pages > 1 ? $1 : ''!egs;

		$opts{template} =~ s!%%frstlink%%!${uri}page=1!g;
		$opts{template} =~ s!%%lastlink%%!${uri}page=$num_pages!g;
		$opts{template} =~ s!%%%ifelse-frstlink%%%(.*?)%%%else%%%(.*?)%%%endelse-frstlink%%%!$current_page ne 1 ? $1 : $2!egs;
		$opts{template} =~ s!%%%ifelse-lastlink%%%(.*?)%%%else%%%(.*?)%%%endelse-lastlink%%%!$current_page ne $num_pages ? $1 : $2!egs;

		$opts{template} =~ s!%%%template:linklist%%%(.+?)%%%end-template:linklist%%%!$link_template_output!gs;
		$opts{template} =~ s!%%spc%%!$spacer!g;
		$opts{template} =~ s!%%num_items%%!$opts{num_items}!g;
		$opts{template} =~ s!%%num_pages%%!$num_pages!g;
		$opts{template} =~ s!%%itemname%%!$opts{num_items} == 1 ? $opts{itemname_singular} : $opts{itemname_plural}!eg if $opts{itemname_singular} && $opts{itemname_plural};
		$opts{template} =~ s!%%pagename%%!$num_pages == 1 ? $opts{pagename_singular} : $opts{pagename_plural}!eg if $opts{pagename_singular} && $opts{pagename_plural};

		return $opts{template};
	}
	else
	{
		return '';
	}
}


sub quicksort_is_active
{
	return (get_qs_var('quicksort') eq 'on') || ($PREF{enable_quicksort_by_default} =~ /yes/i && get_qs_var('quicksort') ne 'off');
}


sub field_structure_managed_by_us
{
	my $field = shift;
	foreach my $table (keys %{$PREF{tables_listing_fields_whose_structure_we_manage}})
	{
		sql_untaint($field,$table);
		die_unless_sqlsafe($field,$table);
		my $query = "SELECT `fieldtype`,`fieldlabel`,`listitems`,`defaultvalue` FROM `$table` WHERE `fieldname` = '$field'";
		#enc_warn "query=$query\n";

		if(my ($fieldtype,$label,$listitems,$defaultvalue) = enc_sql_select($query))
		{
			#enc_warn qq`fieldtype,label,listitems,defaultvalue = $fieldtype,$label,$listitems,$defaultvalue\n`;
			if($fieldtype =~ /^(freeformsingle|freeformmulti|dropdown|checkbox|radio)$/)
			{
				return ($fieldtype,$label,$listitems,$defaultvalue);
			}
			else
			{
				return ();
			}
		}
	}
}


sub is_valid_email_address
{
	return $_[0] =~ /^[\w\.\+-]+\@[\w\.-]+\.\w+$/;
}


sub is_ipv4_address
{
	return $_[0] =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
}


sub interpolate_vars_from_URL_and_cookies
{
	my $include_undefined = 0;
	my $sql_sanitize = 0;

	my %url_vars = ();
	for(split(/&/, $qs))
	{
		my ($var,$value) = split(/=/);
		enc_urldecode($value);
		$url_vars{$var} = $value;
	}

	my %cookies = ();
	my %jar = get_cookies();
	foreach my $ck (keys %jar)
	{
		$cookies{$ck} = $jar{$ck}->value;
	}

	for(@_)
	{
		$include_undefined = $_ if $_ eq 'include_undefined';
		$sql_sanitize = $_ if $_ eq 'sql_sanitize';

		next unless m!(%URL{|%COOKIE{)!;

		if($sql_sanitize)
		{
			my %done = ();
			while(m!%URL\{([^\{\}]+)\}!g)
			{
				my $varname = $1;
				if(exists $url_vars{$varname}   &&   !$done{$varname})
				{
					sql_untaint($url_vars{$varname});
					replace_nonsqlsafe_chars_with('_', $url_vars{$varname});
					die_unless_sqlsafe($url_vars{$varname});
					$done{$varname} = 1;
				}
			}

			%done = ();
			while(m!%COOKIE\{([^\{\}]+)\}!g)
			{
				my $varname = $1;
				if(exists $cookies{$varname}   &&   !$done{$varname})
				{
					sql_untaint($cookies{$varname});
					replace_nonsqlsafe_chars_with('_', $cookies{$varname});
					die_unless_sqlsafe($cookies{$varname});
					$done{$varname} = 1;
				}
			}
		}

		s!%URL\{([^\{\}]+)\}!exists $url_vars{$1} || $include_undefined ? $url_vars{$1} : $&!eg;
		s!%COOKIE\{(.+?)\}!exists $cookies{$1} || $include_undefined ? $cookies{$1} : $&!eg;
	}
}


sub interpolate_vars_from_prefs
{
	my $include_undefined = $_[0] eq 'include_undefined' ? shift : 0;	# 1st arg may be 'include_undefined' but does not have to be.
	for(@_)
	{
		s/%PREF{(\w+)}/exists $PREF{$1} || $include_undefined ? $PREF{$1} : $&/eg;
		s/%TEXT{(\w+)}/exists $TEXT{$1} || $include_undefined ? $TEXT{$1} : $&/eg;
	}
}


sub interpolate_vars_from_env
{
	my $include_undefined = $_[0] eq 'include_undefined' ? shift : 0;	# 1st arg may be 'include_undefined' but does not have to be.
	for(@_)
	{
		s/%ENV{(\w+)}/exists $ENV{$1} || $include_undefined ? $ENV{$1} : $&/eg;
	}
}


sub interpolate_vars_from_sql
{
	my $include_undefined = $_[0] eq 'include_undefined' ? shift : 0;	# 1st arg may be 'include_undefined' but does not have to be.
	for(@_)
	{
		while(m!(%SQL\{\{(.+?)\}\})!g)
		{
			my ($wholething,$sql_statement) = ($1,$2);
			get_db_connection() unless $PREF{dbh};
			interpolate_vars_from_URL_and_cookies($include_undefined, 'sql_sanitize', $sql_statement);
			my $output = enc_sql_select($sql_statement);
			s!\Q$wholething\E!$output!g;
		}
	}
}


sub interpolate_vars_from_date
{
	my $include_undefined = $_[0] eq 'include_undefined' ? shift : 0;	# 1st arg may be 'include_undefined' but does not have to be.
	my $etime = $_[0] =~ /^etime=(\d+)$/ ? shift : offsettime();
	$etime =~ s/[^\d]//g;
	s!%DATE{(.+?)}{now([\+-]\d+[smhdb])}!strftime($1,localtime(offset_etime($etime,$2)))!eg for @_;
	s!%DATE{(.+?)}!strftime($1,localtime($etime))!eg for @_;
}


sub do_standard_template_conditionals_processing
{
	for(@_)
	{
		s!%%%if-admin_is_logged_in%%%(.*?)%%%end-admin_is_logged_in%%%!$PREF{admin_is_logged_in} ? $1 : ''!egs;
		s!%%%if-admin_not_logged_in%%%(.*?)%%%end-admin_not_logged_in%%%!$PREF{admin_is_logged_in} ? '' : $1!egs;
		s!%%%ifelse-admin_is_logged_in%%%(.*?)%%%else%%%(.*?)%%%endelse-admin_is_logged_in%%%!$PREF{admin_is_logged_in} ? $1 : $2!egs;

		s!%%%if-member_is_logged_in%%%(.*?)%%%end-member_is_logged_in%%%!$PREF{member_is_logged_in} ? $1 : ''!egs;
		s!%%%if-member_not_logged_in%%%(.*?)%%%end-member_not_logged_in%%%!$PREF{member_is_logged_in} ? '' : $1!egs;
		s!%%%ifelse-member_is_logged_in%%%(.*?)%%%else%%%(.*?)%%%endelse-member_is_logged_in%%%!$PREF{member_is_logged_in} ? $1 : $2!egs;

		s!%%%if-member_of_group_([^%]+)%%%(.*?)%%%end-member_of_group_\1%%%!user_is_member_of_group($PREF{logged_in_userid}, $1) ? $2 : ''!egs;
		s!%%%if-not_member_of_group_([^%]+)%%%(.*?)%%%end-not_member_of_group_\1%%%!user_is_member_of_group($PREF{logged_in_userid}, $1) ? '' : $2!egs;

		s!%%%ifelse-member_of_group_([^%]+)%%%(.*?)%%%else%%%(.*?)%%%endelse-member_of_group_\1%%%!user_is_member_of_group($PREF{logged_in_userid}, $1) ? $2 : $3!egs;
		s!%%%ifelse-not_member_of_group_([^%]+)%%%(.*?)%%%else%%%(.*?)%%%endelse-not_member_of_group_\1%%%!user_is_member_of_group($PREF{logged_in_userid}, $1) ? $3 : $2!egs;

		s!%%%if-allowed_to_(\w+)%%%(.*?)%%%end-allowed_to_\1%%%!user_is_allowed_to($1) ? $2 : ''!egs;
		s!%%%ifelse-allowed_to_(\w+)%%%(.*?)%%%else%%%(.*?)%%%endelse-allowed_to_\1%%%!user_is_allowed_to($1) ? $2 : $3!egs;
	}
}


sub do_standard_template_vars_processing
{
	interpolate_vars_from_sql(@_); # do this one first, so we can SQL-sanitize any nested URL/cookie variables and interpolate them manually, rather than letting the following functions do the regular interpolation with no SQL-sanitization.
	interpolate_vars_from_env(@_);
	interpolate_vars_from_prefs(@_);
	interpolate_vars_from_URL_and_cookies(@_);
	interpolate_vars_from_date(@_);
}


sub do_standard_template_leftover_nulling
{
	# Go in order from most specific to least specific.  For example, %%%set...%%%
	# is near the end, because it can contain spaces, so we need to make the
	# regex a little looser to match it.  And we explicitly match %%\w+%% even
	# though we later have a more generic %%[^%\s]+?%% because removing the
	# simple all-alphanumeric vars first makes it more straightforward to match
	# the more varied possibilities later.

	for(@_)
	{
		s!%%%if-(\S+)%%%.+?%%%end-\1%%%!!gs;
		s!%%%ifelse-(\S+)%%%.*?%%%else%%%.*?%%%endelse-\1%%%!!gs;
		s!%%%calculate:([^%]+)%%%.+?%%%end-calculate%%%!!gs;
		s!%%%customcode(:[^%]+)?%%%.+?%%%end-customcode%%%!!gs;
		s!%%\w+%%!!g;
		#s!%%[^%\s]+?%%!!g;
		s!%%%set[^%]+?%%%!!g;
	}
}


sub do_standard_template_oddeven_processing # make this your last template-processing action, so any %%oddeven%%s present will definitely be present in the output.
{
	for(@_)
	{
		my $i = 0; while(/%%oddeven%%/g) { s!%%oddeven%%!oddeven($i)!e; }
	}
}


# This sub is designed to skip any interpolations that are currently null and/or
# whose values have other raw template variables within them.  This allows the
# template's various operations and variables to be nested in arbitrarily deep
# and complex ways.  Because of this, the sub iterates multiple times, since
# items that were skipped on earlier passes will be able to be processed on
# later passes.
#
sub do_custom_template_processing
{
	my $templatevars = shift; # hashref.
	for(my $i=0; $i<8; $i++)
	{
		for(@_)
		{
			s!%%%if-([^%]+)==([^%]+)%%%(.*?)%%%end-\1==\2%%%!$1 eq $2 ? $3 : ''!egs;

			s!%%%if-is_valid_price_([^%]+)%%%(.*?)%%%end-is_valid_price_\1%%%!item_price_is_valid($1) ? $2 : ''!egs;

			#while(m!\s*%%%set-urlencoded:(\w+)=([^%]*)%%%\s*!g)
			#{
			#	my ($name,$val) = ($1,$2);
			#	enc_urlencode($val);
			#	$$templatevars{$name} = $val;
			#}

			$$templatevars{$1} = $2 while $_ =~ m!\s*%%%set:(\w+)=([^%]*)%%%\s*!g;
			s!%%(\w+?)%%!exists $$templatevars{$1} ? $$templatevars{$1} : $&!eg;
			s!%%(\w+?)_urlencoded%%!exists $$templatevars{$1} ? enc_urlencode_return($$templatevars{$1}) : $&!eg;

			while(m!(%%%calculate:([^%]+)%%%\s*(.+?)\s*%%%end-calculate%%%)!gs)
			{
				#die "code is: '$3', wholething is: '$1'";
				my ($wholething,$options,$code) = ($1,$2,$3);

				next if $code =~ /%%\w+%%/; # skip it if it still has unprocessed variables in it.

				my $output = eval $code;
				exit_with_error($1) if $output =~ /die_from_eval:(.*)/;
				my $outputvarname = '';

				for(split(/\s*,\s*/, $options))
				{
					if(/numdecimals=(\d+)/)
					{
						my $numdec = $1;
						$output =~ s/(\.\d{$numdec})\d+$/$1/;
						$output .= '.' unless $output =~ /\.\d*$/;
						$output .= '0' while length(   ($output =~ /\.(\d*)$/)[0]   ) < $numdec;
					}
					elsif(/varname=(\w+)/)
					{
						$outputvarname = $1;
					}
				}

				s!\Q$wholething\E!%%%set:$outputvarname=$output%%%!s;
			}

			while(m!(%%%customcode(:[^%]+)?%%%\s*(.+?)\s*%%%end-customcode%%%)!gs)
			{
				#die "code is: '$3', wholething is: '$1'";
				my ($wholething,$options,$code) = ($1,$2,$3);

				next if $code =~ /%%\w+%%/; # skip it if it still has unprocessed variables in it.

				my $output = eval $code;

				exit_with_error($1) if $output =~ /die_from_eval:(.*)/;

				s!\Q$wholething\E!!s;
			}

			if(exists $$templatevars{eitemcode} && exists $$templatevars{eitemname} && exists $$templatevars{eitemdesc} && exists $$templatevars{eitemopts} && exists $$templatevars{eitemcost})
			{
				$$templatevars{eitemfingerprint} = get_cart_item_fingerprint(
										$$templatevars{eitemcode},
										$$templatevars{eitemname},
										$$templatevars{eitemdesc},
										$$templatevars{eitemopts},
										$$templatevars{eitemcost}
				);
			}
		}
	}
}


# Create a fingerprint before and after adding the item to the cart, to
# prevent modification of any of the values (particularly the price).
#
sub get_cart_item_fingerprint($$$$$)
{
	return enc_hash(
			$PREF{database_name} . $PREF{database_username} . $PREF{database_password} . 
			$_[0] . $_[1] . $_[2] . $_[3] . $_[4] . 
			$ENV{DOCUMENT_ROOT} . $ENV{PATH} . $ENV{SCRIPT_FILENAME}
	);
}


sub format_xml_nicely
{
	my $input_xml = shift;
	my $output_xml = '';
	my $depth = 0;
	my $prev_line_was_opener = 0;
	while($input_xml =~ /(<[^<>]+>)/g)
	{
		my $line = $1;
		#print STDERR "Line is: '$line'\n";
		my $opener = 0;
		if($line =~ m!^<\?xml!i)
		{
			$output_xml .= "$line\n";
			next;
		}
		elsif($line =~ m!^<[^<]+/>$!)
		{
			$depth++ if $prev_line_was_opener;
		}
		elsif($line =~ m!^</[^<]+>$!)
		{
			$depth--;
			$opener = 0;
			#$line .= '-';
		}
		elsif($line =~ m!^<[^<]+>$!)
		{
			$depth++;
			$opener = 1;
			#$line .= '+';
		}

		$output_xml .= '  ' x ($depth - 1);
		$output_xml .= "$line\n";

		$prev_line_was_opener = $opener;
	}
	return $output_xml;
}


sub is_zero # to differentiate values from null.
{
	return $_[0] =~ /^0$/;
}


sub dumphash
{
	my ($hashref,$separator) = @_;
	$separator ||= ', ';
	my $output = '';
	foreach my $key (sort keys %$hashref) { $output .= "$key=$$hashref{$key}$separator"; }
	$output =~ s!$separator$!!;
	return $output;
}


sub remove_common_leading_substring
{
	# Pass in an array of strings, and this sub will remove any common leading
	# portion from each of the strings in the array.  Note: this currently has
	# a hard-coded relief valve (the "$done = 1 if $i > N") until it gets more
	# widespread testing, because a malfunction could result in an infinite loop.

	my $done = 0;
	my $i = 0;
	my $longest_common_substring = '';
	while(!$done)
	{
		$i++;
		#print STDERR "increasing \$i to $i\n";
		my $substring = '';
		for(@_)
		{
			#print STDERR "\tprocessing $_ : ";
			if(!length($substring))
			{
				# Set our test string from the first string in the array.  And this is
				# in its own separate if() because there's no sense in testing whether
				# this first string matches itself.
				#
				$substring = substr($_, 0, $i);

				# Also note that, because of this if() and the fact that we only set
				# the LCS variable in the following else(), that means we're technically
				# only removing length(LCS)-1 characters -- but that's what we want,
				# because otherwise we'd be leaving a null string in the event that one
				# of the strings *is* the LCS.  Instead we're leaving one character from
				# the end of the LCS as the first character on all the output strings.
			}
			else
			{
				if(/^$substring/)
				{
					#print STDERR "still matches ('$_' matches '$substring')\n";
					$longest_common_substring = $substring;
				}
				else
				{
					# failed the match, so we need to roll it back by 1 char:
					$longest_common_substring = substr($longest_common_substring, 0, -1);
					#print STDERR "failed match; we're done here. \$longest_common_substring='$longest_common_substring'\n";
					$done = 1; last;
				}
			}
			if(length($substring) >= length($_))
			{
				#print STDERR "\n\tsubstring now as long as the shortest string; we're done here\n";
				$done = 1; last;
			}
		}
		$done = 1 if $i > 100; 
	}
	s!^$longest_common_substring!! for @_;
}


sub datestring8_to_etime($$)
{
	my $d8 = shift;
	my $when = shift;
	$when = $when =~ /start/ ? 'start' : 'end';

	my ($year,$month,$day) = ($d8 =~ /^(\d{4})(\d{2})(\d{2})$/);

	my ($sec,$min,$hour);
	if($when eq 'start')
	{
		($sec,$min,$hour) = (0,0,0);
	}
	else
	{
		($sec,$min,$hour) = (59,59,23);
	}

	return timelocal($sec,$min,$hour,$day,($month - 1),$year);
}


sub num_elapsed_days_between_datestring8_dates($$)
{
	my $earlier_date = shift;
	my $later_date = shift;

	if($earlier_date !~ /^\d{8}$/ || $later_date !~ /^\d{8}$/)
	{
		die qq`$0: datestrings must contain exactly 8 digits and nothing else, but you've passed "$earlier_date" and "$later_date"\n`;
	}

	return 0 if $earlier_date == $later_date;

	if($earlier_date > $later_date)
	{
		my $temp = $earlier_date;
		$earlier_date = $later_date;
		$later_date = $temp;
	}

	# now $earlier_date is smaller/earlier than $later_date.

	my $elapsed_days = 0;
	while($earlier_date < $later_date)
	{
		$later_date = decrement_datestring_8($later_date, 1);
		$elapsed_days++;
	}

	return $elapsed_days;
}


sub increment_datestring_8($$)
{
	my $start = shift;
	my $amount = shift;
	my $i = ();

	die_nice("Error: increment_datestring_8('$start', '$amount'): invalid start date '$start'.\n") unless $start =~ /^\d{8}$/;

	for($i=1; $i<=$amount; $i++)
	{
		my ($year,$month,$day) = ($start =~ /(\d{4})(\d{2})(\d{2})/);
		my ($newmonth,$newday) = ($month,$day);

		s/^0// for($newmonth,$newday);

		# try to inc the day
		eval { timelocal(0,0,0,$newday+1,$newmonth-1,$year); }; # note: timelocal's month is 0..11 so $month-1 = $month
		if($@) # means there was an error.
		{
			# try to inc the month
			eval { timelocal(0,0,0,1,$newmonth,$year); };
			if($@)
			{
				# inc the year
				eval { timelocal(0,0,0,1,0,$year+1); };
				if($@)
				{
					die_nice("Error: increment_datestring_8('$start', '$amount'): can't increment the year: $@\n");
				}
				else
				{
					$year++;
					$start = $year . '0101';
				}
			}
			else
			{
				$newmonth++;
				$newmonth = "0$newmonth" if ($newmonth =~ /^\d$/);
				$start = $year . $newmonth . '01';
			}
		}
		else
		{
			$newday++;
			$newday = "0$newday" if ($newday =~ /^\d$/);
			$start = $year . $month . $newday;
		}
	}

	return $start;
}


sub decrement_datestring_8($$)
{
	my $start = shift;
	my $amount = shift;
	my $i = ();

	die_nice("Error: decrement_datestring_8('$start', '$amount'): invalid start date '$start'.\n") unless $start =~ /^\d{8}$/;

	for($i=1; $i<=$amount; $i++)
	{
		my ($year,$month,$day) = ($start =~ /(\d{4})(\d{2})(\d{2})/);
		my ($newmonth,$newday) = ($month,$day);

		s/^0// for($newmonth,$newday);

		# try to dec the day
		eval { timelocal(0,0,0,$newday-1,$newmonth-1,$year); }; # note: timelocal's month is 0..11 so $month-1 = $month
		if($@ || $newday !~ /[1-9]/) # $@ means there was an error.  also need to make sure $newday is nonzero for servers whose timelocal() is broken, incorrectly reporting 0 as a valid day.
		{
			# try to dec the month
			eval { timelocal(0,0,0,1,$newmonth-2,$year); };
			if($@)
			{
				# month is Jan... dec the year
				eval { timelocal(0,0,0,1,0,$year-1); };
				if($@)
				{
					die_nice("Error: decrement_datestring_8('$start', '$amount'): can't decrement the year: $@\n");
				}
				else
				{
					$year--;
					$start = $year . '1231';
				}
			}
			else
			{
				# we know the month is valid, so find the highest valid day:
				$newday = 32;
				do { $newday--; eval { timelocal(0,0,0,$newday,$newmonth-2,$year); }; } while ($@);

				$newmonth--;
				$newmonth = "0$newmonth" if ($newmonth =~ /^\d$/);
				$start = $year . $newmonth . $newday;
			}
		}
		else
		{
			$newday--;
			$newday = "0$newday" if ($newday =~ /^\d$/);
			$start = $year . $month . $newday;
		}
	}

	return $start;
}


sub increment_datestring_6
{
	my $date = shift;
	die_nice qq`Invalid datestring6 value: '$date'.` unless $date =~ /^\d{6}$/;
	my ($year,$month) = ($date =~ /(\d{4})(\d{2})/);
	$month =~ s!^0!!;
	$month++;
	if($month > 12)
	{
		$month = 1;
		$year++;
	}
	$month = "0$month" if $month =~ /^\d$/;
	return "$year$month";
}


sub decrement_datestring_6
{
	my $date = shift;
	die_nice qq`Invalid datestring6 value: '$date'.` unless $date =~ /^\d{6}$/;
	my ($year,$month) = ($date =~ /(\d{4})(\d{2})/);
	$month =~ s!^0!!;
	$month--;
	if($month < 1)
	{
		$month = 12;
		$year--;
	}
	$month = "0$month" if $month =~ /^\d$/;
	return "$year$month";
}


sub split_path_and_filename
{
	return ($_[0] =~ m!^(.*?)([^/\\]+)$!);
}


sub serialize_filename_if_file_exists
{
	my $fullfile = shift;
	my $separator = shift;		# optional
	my $paddinglength = shift || 2;	# optional

	my ($path,$file) = split_path_and_filename($fullfile);
	$separator ||= $file =~ / / ? ' ' : '_';

	my $i = my $j = 1;
	while(-e $fullfile)
	{
		$j = $i;
		$j = "0$j" while(length($j) < $paddinglength);
		my $tempname = $file;
		$tempname =~ s/(\.[^\.]+)$/$separator$j$1/;
		$fullfile = $path . $tempname;
		$i++;
	}

	return wantarray ? ($fullfile, $separator, $j) : $fullfile;
}


sub get_all_subdirs
{
	#print STDERR "get_all_subdirs('$_[0]')\n";

	my $dir = shift;
	my $mode = shift;
	unless(-d $dir)
	{
		print_http_headers();
		print qq`<p>Error: get_all_subdirs(): we need a directory, but we received "$dir".</p>\n`;
		return;
	}
	opendir(DIRHFORSUBS, $dir) or die_nice "couldn't open directory '$dir': $!\n";
	# TODO: the -w test here should be removed, since this sub is named "get_all_subdirs".  It was probably originally
	# included for the sake of FC which generally isn't interested in dirs it can't write to, but that should be handled
	# explicitly in other code, rather than silently in this general-use sub.
	my @dirs = sort { lc($a) cmp lc($b) } grep {  -d "$dir/$_"  &&  -w "$dir/$_"  &&  !/^\.$/  &&  !/^\.{2}$/  } readdir(DIRHFORSUBS);
	closedir DIRHFORSUBS or die_nice "couldn't close directory '$dir': $!\n";

	my @subdirs = ();
	# now recurse through everything below this point.
	foreach my $level1dir (@dirs)
	{
		foreach my $level2dir (get_all_subdirs("$dir/$level1dir"))
		{
			push @subdirs, "$level1dir/$level2dir";
		}
	}
	push @dirs, @subdirs;

	return sort { lc($a) cmp lc($b) } @dirs;
}


sub get_all_files
{
	my $dir = shift;
	opendir(DIRHFORFILES, $dir) or die_nice "couldn't open directory '$dir': $!\n";
	my @files = sort { lc($a) cmp lc($b) } grep {  -f "$dir/$_"  &&  -r "$dir/$_"  &&  !/^\.$/  &&  !/\.{2}/  } readdir(DIRHFORFILES);
	closedir DIRHFORFILES or die_nice "couldn't close directory '$dir': $!\n";
	return @files;
}


sub get_enc_visitor_id_iframe()
{
	return $PREF{enc_visitor_id_was_missing} ? qq`<iframe src="$ENV{SCRIPT_NAME}?action=set_enc_visitor_id&amp;newid=$PREF{enc_visitor_id}" name="enc_vis_id_setter" id="enc_vis_id_setter" width="1" height="1"></iframe>\n` : '';
}


sub set_enc_visitor_id()
{
	set_cookie($PREF{enc_visitor_id_cookie}, get_qs_var('newid'), "+365d");
	print_http_headers();
	exit;
}


sub generate_random_hash()
{
	# We're using md5_hex() here instead of enc_hash() because the latter is prefs-dependent,
	# but we need this sub to be callable before prefs are loaded; and because, for a random
	# hash, as opposed to a hash of sensitive data like a password, the issues that make MD5
	# weaker than SHA1 are irrelevant.  Also note that, because the input data will be
	# different every single time this sub is called, and thus the output hash will never be
	# the same for any two calls (which is the whole point), that means that at any point in
	# the future, we can change to a different hash function, without it breaking anything
	# (for example, if/when sha1_hex() ever becomes available on virtually every installation,
	# as md5_hex() is now).

	return md5_hex($ENV{REMOTE_ADDR} . $$ . $ENV{HTTP_USER_AGENT} . $ENV{REMOTE_PORT} . time() . rand());
}


sub get_css_std()
{
	return	  $PREF{css} . "\n\n"
		. $PREF{css_shared} . "\n\n"
		. ($PREF{default_app_style} eq 'dark' ? "$PREF{css_dark}\n$PREF{css_shared_dark}" : "$PREF{css_light}\n$PREF{css_shared_light}") . "\n\n"
		. $PREF{css_extra};
}


sub start_html_output_std
{
	return if $PREF{start_html_output_called};
	$PREF{start_html_output_called} = 1;

	my $subtitle = shift;

	print_http_headers();
	if($PREF{internal_appname} eq 'userbase') { return if $qs =~ /format=mini/; }

	my $css = get_css();
	my $js = get_js();

	$PREF{title} = $PREF{"title_$PREF{on_page}"} if exists $PREF{"title_$PREF{on_page}"};
	my $show_app_pagetitle = $PREF{"hide_app_pagetitle_on_$PREF{on_page}_page"} !~ /yes/i;
	my $show_app_subtitle  = $PREF{"hide_app_subtitle_on_$PREF{on_page}_page"} !~ /yes/i;
	my $title_for_titlebar = exists $PREF{"titlebar_title___$PREF{on_page}"} ? $PREF{"titlebar_title___$PREF{on_page}"} : exists $PREF{titlebar_title} ? $PREF{titlebar_title} : $PREF{title};
	$title_for_titlebar =~ s!%%subtitle%%!$subtitle!g;
	$title_for_titlebar =~ s!<[^>]*>!!g;

	my $body_details = qq`id="$PREF{twochar_app_id}body" class="$PREF{on_page}body $PREF{current_app_style}_style"`;

	if($PREF{we_are_embedded})
	{
		print	  $PREF{extra_header_output};
		print	  $PREF{body_container_start} || qq`<div $body_details>\n`;
	}
	elsif($PREF{encodable_app_template_file} && -e $PREF{encodable_app_template_file})
	{
		my $title = $PREF{title_for_template_file} || $title_for_titlebar || $subtitle;
		open(HEADERFH, "<$PREF{encodable_app_template_file}") or die "$0: couldn't open \$PREF{encodable_app_template_file} ('$PREF{encodable_app_template_file}') for reading:: $!\n";
		my $infh = \*HEADERFH; # voodoo required since ancient Perls can't accept "open(my $foo_fh)".
		flock $infh, 1;
		seek $infh, 0, 0;
		while(<$infh>)
		{
			s!%%title%%!$title!g;
			s#(<!--\s*)?%%js%%(\s*-->)?#<script type="text/javascript" src="$ENV{SCRIPT_NAME}?js"></script>#g;
			s#(<!--\s*)?%%css%%(\s*-->)?#<link rel="stylesheet" type="text/css" media="all" href="$ENV{SCRIPT_NAME}?css">#g;

			if(/^(.*?)(?:<!--\s*)?%%encodable_app_output%%/i)
			{
				print $1; last;
			}
			else
			{
				print $_;
			}
		}
		close $infh or die "$0: couldn't close \$PREF{encodable_app_template_file} ('$PREF{encodable_app_template_file}') after reading:: $!\n";

		print	  $PREF{extra_header_output};
		print	  $PREF{body_container_start} || qq`<div $body_details>\n`;
	}
	#if($ENV{REQUEST_METHOD} =~ /post/i   ||   $PREF{"print_full_html_tags_for_$PREF{on_page}"} =~ /yes/i   ||   ($PREF{print_full_html_tags} =~ /yes/i   &&   $PREF{"print_full_html_tags_for_$PREF{on_page}"} !~ /no/i)   ||   (get_qs_var('forcefullhtml') eq 'yes')   ||   (get_qs_var('forcefullpage') eq 'yes'))
	else
	{
		print	  qq`<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">`
			. qq`\n<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">`
			. qq`\n<head>`
			. qq`\n<meta http-equiv="Content-type" content="text/html; charset=ISO-8859-1" />`
			. qq`\n<title>$title_for_titlebar</title>`
			. qq`\n<script type="text/javascript">\n/* <![CDATA[ */  /* so (X)HTML validators ignore the javascript. */\n\n$js\n\n/* ]]> */  /* so (X)HTML validators ignore the javascript. */\n</script>`
			. qq`\n<style type="text/css">$css</style>`
			. $PREF{extra_header_output}
			. qq`\n</head>`
			. qq`\n<body $body_details>`
			. qq`\n`;
	}

	$PREF{app_output_template} =~ s!%%title%%!$PREF{title}!g;
	$PREF{app_output_template} =~ s!%%subtitle%%!$subtitle ? qq`<div id="encsubtitle">$subtitle</div>` : ''!eg;
	$PREF{app_output_template} =~ s!%%%if-pagetitle%%%(.*?)%%%end-pagetitle%%%!$PREF{title} && $show_app_pagetitle ? $1 : ''!egs;
	$PREF{app_output_template} =~ s!%%%if-pagesubtitle%%%(.*?)%%%end-pagesubtitle%%%!$subtitle && $show_app_subtitle ? $1 : ''!egs;
	$PREF{app_output_template} =~ s!%%on_page%%!$PREF{on_page}!g;
	$PREF{app_output_template} =~ s!%%wide_page_css_wrapper_id%%!$PREF{on_a_wide_page} ? "$PREF{twochar_app_id}wrapper_widepage" : ''!egs;
	$PREF{app_output_template} =~ s!%%%if-onpage_(\w+)%%%(.*?)%%%endif-onpage_\1%%%!$PREF{on_page} eq $1 ? $2 : ''!egs;
	$PREF{app_output_template} =~ s!%%%ifelse-onpage_(\w+)%%%(.*?)%%%else%%%(.*?)%%%endelse-onpage_\1%%%!$PREF{on_page} eq $1 ? $2 : $3!egs;
	do_standard_template_vars_processing('include_undefined', $PREF{app_output_template});

	my $output_tophalf = ($PREF{app_output_template} =~ /(.*)%%app_output_body%%/s)[0];
	my $linkbar = get_linkbar(@_);
	$output_tophalf =~ s!%%linkbar_top%%!$linkbar!g;
	print $output_tophalf;

	if($PREF{internal_appname} eq 'userbase' && -e $PREF{default_account_temp_file}) { print qq`<div style="margin: 20px auto; max-width: 400px;">To determine your default admin account, login to your server via your normal method (FTP, etc) and then read the file $PREF{default_account_temp_file} (within your cgi-bin folder or login folder by default).&nbsp; This message will be displayed until you delete that file.</div>\n`; }
}


sub finish_html_output_std
{
	return if $PREF{finish_html_output_called};
	$PREF{finish_html_output_called} = 1;

	if($PREF{internal_appname} eq 'userbase') { return if $qs =~ /format=mini/; }

	my $linkbar = get_linkbar(@_);
	my $output_bottomhalf = ($PREF{app_output_template} =~ /%%app_output_body%%(.*)/s)[0];
	$output_bottomhalf =~ s!%%linkbar_bottom%%!$linkbar!g;
	$output_bottomhalf =~ s!%%powered_by%%!$PREF{hide_poweredby} eq 'yes' ? '' : get_powered_by()!eg;
	print $output_bottomhalf;

	print qq`<div style="margin: 20px auto; max-width: 600px; padding: 10px; border: 1px solid #999; background: #f3f3f3; color: #444;">This is the trial version of CornerStore.&nbsp; Some features are disabled, including checkout, password protection, and email notification, and the item catalog is limited to 7 items.&nbsp; Get <a href="http://encodable.com/cornerstore/#buy" style="text-decoration:underline;">the full version</a> to remove these limitations.</div>`;

	if($PREF{enable_debug} =~ /yes/i)
	{
		print qq`<div style="margin: 20px auto; min-width: 400px; max-width: 600px; padding: 5px; background: #fff; color: #444; border: 1px solid #999;">`
			. qq`Warning: you've set \$PREF{enable_debug} to 'yes'.&nbsp; If you're not having problems, you should disable this.&nbsp; And if you are having problems, you should still disable this, because in some cases it can cause features not to work.&nbsp; Only enable this temporarily.`
			. qq`\n</div>\n`;
	}

	if(($CGI::VERSION ne '')   &&   ($CGI::VERSION < 3.03)   &&   ($PREF{ignore_ancient_CGI_module} !~ /yes/i))
	{
		print qq`<div style="margin: 20px auto; min-width: 400px; max-width: 600px; padding: 5px; background: #fff; color: #444; border: 1px solid #999;">`
			. qq`Warning: your server's version of the CGI.pm Perl module is $CGI::VERSION, which is extremely outdated.&nbsp; `
			. qq`Some features like uploading may not work at all, or may be unreliable.&nbsp; To fix this, `
			. qq`<a href="http://encodable.com/sharedfaq/#oldcgi" target="_blank">update your CGI module</a>.&nbsp; `
			. qq`To ignore this problem (not recommended), add this line to the end of your prefs file: `
			. qq`\$PREF{ignore_ancient_CGI_module}='yes';</div>\n`;
	}

	print get_enc_visitor_id_iframe();
	send_event_calendar_reminders() if $PREF{internal_appname} eq 'userbase';
	print get_extra_debug_output();

	if($PREF{we_are_embedded})
	{
		print	  $PREF{body_container_end} || qq`</div><!-- end #$PREF{twochar_app_id}body -->\n`;
		print	  $PREF{extra_footer_output};
	}
	elsif($PREF{encodable_app_template_file} && -e $PREF{encodable_app_template_file})
	{
		print	  $PREF{body_container_end} || qq`</div><!-- end #$PREF{twochar_app_id}body -->\n`;
		print	  $PREF{extra_footer_output};

		open(FOOTERFH, "<$PREF{encodable_app_template_file}") or die "$0: couldn't open \$PREF{encodable_app_template_file} ('$PREF{encodable_app_template_file}') for reading:: $!\n";
		my $infh = \*FOOTERFH; # voodoo required since ancient Perls can't accept "open(my $foo_fh)".
		flock $infh, 1;
		seek $infh, 0, 0;
		my $found_token = 0;
		while(<$infh>)
		{
			if($found_token)					{ print $_; }
			elsif(/%%encodable_app_output%%(?:\s*-->)?(.*?)$/i)	{ print $1; $found_token = 1; }
		}
		close $infh or die "$0: couldn't close \$PREF{encodable_app_template_file} ('$PREF{encodable_app_template_file}') after reading:: $!\n";
	}
	#if($ENV{REQUEST_METHOD} =~ /post/i   ||   $PREF{"print_full_html_tags_for_$PREF{on_page}"} =~ /yes/i   ||   ($PREF{print_full_html_tags} =~ /yes/i   &&   $PREF{"print_full_html_tags_for_$PREF{on_page}"} !~ /no/i)   ||   (get_qs_var('forcefullhtml') eq 'yes')   ||   (get_qs_var('forcefullpage') eq 'yes'))
	else
	{
		print	  $PREF{extra_footer_output};
		print	  qq`</body>\n</html>\n`;
	}
}


sub check_image_modules
{
	my $separator = qq`<br /><br /><hr><br />\n`;

	start_html_output("Check Image Modules");
	print qq`\n<div style="text-align: left; margin: 30px auto;">$PREF{internal_appname_nice} uses image modules in order to enable image-based features like rotation, resizing/thumbnails, etc.&nbsp; It supports 3 different methods for this: the GD Perl module, the ImageMagick Perl module, and the ImageMagick convert/identify commands; and usually only one of these is necessary.&nbsp; This page will show whether your server supports these modules.&nbsp; See <a href="http://encodable.com/filechucker/faq/#image">this FAQ</a> for more details.$separator`;

	unless($PREF{already_tested_for_im})
	{
		eval { require Image::Magick; }; $PREF{imagemagick_error} = $@;
	}
	unless($PREF{already_tested_for_gd})
	{
		eval { require GD; require GD::Simple; }; $PREF{gd_error} = $@;
	}
	foreach my $module ('ImageMagick', 'GD')
	{
		my $error = $PREF{lc($module) . "_error"};
		print qq`Attempting to load the $module Perl module... `;
		print !$error	? qq`success.`
			: qq`failed.&nbsp; The error was: <div style="margin: 20px 40px;">$error</div>`
			. qq`This means that <strong>the $module Perl module is not installed, or not installed <em>properly</em>, on your server</strong>.&nbsp; `
			. qq`This is a server error, not a $PREF{internal_appname_nice} error.&nbsp; <a href="http://encodable.com/filechucker/faq/#image">This FAQ</a> may help, `
			. qq`but you'll need to contact your hosting company if you want to get the $module Perl module installed properly.&nbsp; Or, if you have `
			. qq`root/Administrator access to your server, then we may be able to install it for you; the cost is typically 1 hour of labor.&nbsp; `
			. qq`<a href="http://encodable.com/contact/">Contact us</a> if you'd like us to look into this.`;
		print $separator;
	}

	print "Attempting to locate a 'convert' command:<br />\n";
	print "\nExecuting 'which convert': ";
	my $which_output = `which convert`;
	print $which_output && $which_output !~ /no convert in/ ? "found one or more convert commands: $which_output" : "command produced no output; no 'convert' in PATH.";
	print "<br />\n";
	print "Manually checking /usr/bin/convert: " . (-e '/usr/bin/convert' ? 'exists.' : 'does not exist.') . "<br />\n";
	print "Manually checking /usr/local/bin/convert: " . (-e '/usr/local/bin/convert' ? 'exists.' : 'does not exist.') . "<br />\n";
	print "<br />\nIf a convert command was found here, you can set \$PREF{convert_command} to it, and then enable the \$PREF{try_to_use_convert_*} settings (and probably also the \$PREF{try_to_use_identify_*} settings because an identify command probably exists in the same location).\n";
	#print "\nExecuting 'find / -name convert':<br />\n";
	#print `find / -name convert -type f`;
	print $separator;

	if($PREF{im_and_gd_disabled_internally})
	{
		print qq`Because neither the ImageMagick nor GD Perl modules are properly installed on your server, $PREF{internal_appname_nice} has internally disabled the \$PREF{try_to_use_*} prefs for them.&nbsp; You may be able to use the \$PREF{try_to_use_convert_*} settings instead.&nbsp; See <a href="http://encodable.com/filechucker/faq/#image">this FAQ</a> for more details.$separator`;
	}

	print qq`Note that this only affects the image-based features like rotation, thumbnails, etc.&nbsp; It does not affect $PREF{internal_appname_nice}'s core functionality.&nbsp; So $PREF{internal_appname_nice} itself will work just fine even if your server does not support these image modules.`;
	print qq`</div>\n`;

	finish_html_output();
}


sub try_to_load_image_modules()
{
	# TODO: find a reliable way to test whether the jpegtran and convert binaries are available.
	# For now, just hardcode the $PREF{(jpegtran|convert)_available} = 'yes'; and use the try_to_*
	# PREF to switch it off.
	#
	#if(!jpegtran_is_available()   &&   ($PREF{try_to_use_jpegtran_for_rotation} =~ /yes/i))
	#{
	#	die_nice qq`$PREF{internal_appname}: jpegtran is not available on your server, so you must either install it, or else disable the following setting in PREFs Section 15: <br /><br />\n\$PREF{try_to_use_jpegtran_for_rotation}`;
	#}
	$PREF{jpegtran_available} = 'yes';
	$PREF{convert_available} = 'yes';
	$PREF{identify_available} = 'yes';

	# Note: the call to *_is_available() MUST come last in these if()s, so that on
	# servers where the module is corrupt, we can prevent even trying to load it,
	# by setting the PREFs to 'no'.
	#
	my $tried_im_and_failed = 1 if(($PREF{try_to_use_imagemagick_for_rotation} =~ /yes/i || $PREF{try_to_use_imagemagick_for_resizing} =~ /yes/i || $PREF{try_to_use_imagemagick_for_humantest} =~ /yes/i)   &&   !imagemagick_is_available());
	my $tried_gd_and_failed = 1 if(($PREF{try_to_use_gd_for_rotation} =~ /yes/i || $PREF{try_to_use_gd_for_resizing} =~ /yes/i || $PREF{try_to_use_gd_for_humantest} =~ /yes/i)   &&   !gd_is_available());
	if($tried_im_and_failed   &&   $tried_gd_and_failed)
	{
		$PREF{im_and_gd_disabled_internally} = 1;
		foreach my $pref (keys %PREF) { $PREF{$pref} = 'no' if $pref =~ /^try_to_use_(imagemagick|gd)/i; }
	}
}

sub jpegtran_is_available()
{
	$PREF{jpegtran_test_command} = 'jpegtran </dev/null >/dev/null 2>&1';
	my ($success,$msg) = enc_sys_call($PREF{jpegtran_test_command});
	if($success)	{ $PREF{jpegtran_available} = 'yes';	$PREF{jpegtran_error} = ''; }
	else		{ $PREF{jpegtran_available} = 'no';	$PREF{jpegtran_error} = "Failed to execute jpegtran: $msg"; }
	return !$PREF{jpegtran_error};
}


sub imagemagick_is_available()
{
	unless($PREF{already_tested_for_im})
	{
		$PREF{already_tested_for_im} = 1;
		eval { require Image::Magick; }; $PREF{imagemagick_error} = $@;
		$PREF{imagemagick_available} = !$PREF{imagemagick_error};
	}
	return $PREF{imagemagick_available};
}


sub gd_is_available()
{
	unless($PREF{already_tested_for_gd})
	{
		$PREF{already_tested_for_gd} = 1;
		eval { require GD; require GD::Simple; }; $PREF{gd_error} = $@;
		$PREF{gd_available} = !$PREF{gd_error};
	}
	return $PREF{gd_available};
}


sub do_automatic_resizing($)
{
	my $files = shift;
	# hashref, formatted like this:
	# $$files{01}{name} = 'foo.jpg',
	# $$files{01}{realpath} = '/full/path/to/imagedir',
	# $$files{01}{force_overwrite} = 1 (optional).

	my @results = ();
	my $filecount = scalar keys %$files;

	if($PREF{resize_uploaded_images} =~ /yes/i   ||   $PREF{create_resized_copies_of_uploaded_images} =~ /yes/i)
	{
		foreach my $pref (sort keys %PREF)
		{
			if($pref =~ /^create_resized_copies_(\d+)__imagemagick_size$/)
			{
				my $num = $1;
				foreach my $file (sort keys %$files)
				{
					if(is_image($$files{$file}{name}))
					{
						my $file_id_for_status = $filecount == 1 ? $$files{$file}{name} : "#$file ($$files{$file}{name})";

						my $input_file_full = $$files{$file}{realpath} . '/' . $$files{$file}{name};
						condense_slashes('leave_leading_UNC', $input_file_full);

						if($PREF{create_resized_copies_of_uploaded_images} =~ /yes/i)
						{
							my $smallsize = ($PREF{imagemagick_available} && $PREF{try_to_use_imagemagick_for_resizing} =~ /yes/i) || $PREF{try_to_use_convert_for_resizing} =~ /yes/i ? $PREF{"create_resized_copies_${num}__imagemagick_size"} : gd_is_available() ? $PREF{"create_resized_copies_${num}__gd_size"} : '';

							if(-s $input_file_full > $PREF{"create_resized_copies_${num}__skip_if_bigger_than"})
							{
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: skipping because input file is bigger than the limit ($PREF{"create_resized_copies_${num}__skip_if_bigger_than"} bytes).`;
								next;
							}

							my $output_dir = $PREF{"create_resized_copies_${num}__location_type"} eq 'absolute' ? $PREF{"create_resized_copies_${num}__folder_name"} : $$files{$file}{realpath};
							$output_dir .= '/' . $PREF{"create_resized_copies_${num}__folder_name"} if $PREF{"create_resized_copies_${num}__folder_name"} && $PREF{"create_resized_copies_${num}__location_type"} eq 'relative';
							condense_slashes('leave_leading_UNC', $output_dir);
							create_dir_if_DNE($output_dir,$PREF{writable_dir_perms});

							my $output_file = $PREF{"create_resized_copies_${num}__new_filename"};
							my ($origname,$ext) = ($$files{$file}{name} =~ /(.+)\.(.+)/);
							$output_file =~ s!%%orig%%!$origname!g;
							$output_file =~ s!%%ext%%!$ext!g;

							my $output_file_full = $output_dir . '/' . $output_file;
							#unless($PREF{overwrite_existing_files} =~ /yes/i)
							if($PREF{"create_resized_copies_${num}__serialize_or_overwrite"} eq 'serialize')
							{
								$output_file_full = serialize_filename_if_file_exists($output_file_full);
							}

							# Make sure to do the skip-if-exists check before the image-dims check, because
							# the latter is expensive.
							#
							if(-e $output_file_full && !$$files{$file}{force_overwrite})
							{
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: skipping because output file already exists.`;
								next;
							}

							my ($origw,$origh) = get_image_dims($input_file_full);
							my ($thumbw,$thumbh) = ($smallsize =~ /^(\d*)x?(\d*)$/i);
							if($origw > $thumbw || $origh > $thumbh || !$origw || !$thumbw)
							{
								#resize_image($input_file_full, $output_file_full, $smallsize);
								my ($success,$msg) = resize_image___withtimeout($PREF{image_resizing_timeout}, $input_file_full, $output_file_full, $smallsize);
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: error: $msg` unless $success;
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: OK.` if -e $output_file_full;
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: failed (output file does not exist afterwards).` unless -e $output_file_full;
							}
							else
							{
								copy($input_file_full, $output_file_full) or die_nice "couldn't copy image file '$input_file_full' to thumbnail file '$output_file_full': $!\n";
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: OK (copied from original because original was already small enough).` if -e $output_file_full;
								push @results, qq`Creating ${smallsize}px resized copy of $file_id_for_status: failed (tried to copy from original because original was already small enough).` unless -e $output_file_full;
							}
							chmod $PREF{writable_file_perms}, $output_file_full;
						}

						if($PREF{resize_uploaded_images} =~ /yes/i)
						{
							next if -s $input_file_full > $PREF{resize_uploaded_images__skip_if_bigger_than};

							my $smallsize = ($PREF{imagemagick_available} && $PREF{try_to_use_imagemagick_for_resizing} =~ /yes/i) || $PREF{try_to_use_convert_for_resizing} =~ /yes/i ? $PREF{resize_uploaded_images__imagemagick_size} : gd_is_available() ? $PREF{resize_uploaded_images__gd_size} : '';
							my ($origw,$origh) = get_image_dims($input_file_full);
							my ($thumbw,$thumbh) = ($smallsize =~ /^(\d*)x?(\d*)$/i);
							if($origw > $thumbw || $origh > $thumbh || !$origw || !$thumbw)
							{
								#resize_image($input_file_full, $input_file_full, $smallsize);
								my ($success,$msg) = resize_image___withtimeout($PREF{image_resizing_timeout}, $input_file_full, $input_file_full, $smallsize);
								push @results, qq`Resizing $file_id_for_status to ${smallsize}px: error: $msg` unless $success;
								push @results, qq`Resizing $file_id_for_status to ${smallsize}px: OK.` if -e $input_file_full;
								chmod $PREF{writable_file_perms}, $input_file_full;
							}
						}
					}
				}
			}
		}
	}

	return @results;
}


sub get_image_dims
{
	my $filename = shift;
	my ($width, $height, $xres, $yres) = ();
	my $decpoints = $PREF{num_decimal_points_for_image_details} =~ /^(\d+)$/ ? $1 : 2;
	if($PREF{identify_available} =~ /yes/i && $PREF{try_to_use_identify_for_dimensions} =~ /yes/i)
	{
		my $info = `$PREF{identify_command} -verbose "$filename"`;
		($width,$height) = ($1,$2) if $info =~ /^\s*Geometry:\s*(\d+)x(\d+)/m;
		($xres,$yres) = ($1,$2) if $info =~ /^\s*Resolution:\s*(\d+)x(\d+)/m;

		# This works, and doesn't require reading the whole image into memory so it's
		# quicker, but it can only get a few image attributes, not all of them.
		#
		#my $info = `$PREF{identify_command} "$filename"`;
		#($width,$height) = ($1,$2) if $info =~ /^$filename [A-Z]+ (\d+)x(\d+) /   ||   $info =~ /^$filename [A-Z]+ (\d+)x(\d+)\+\d+\+\d+ /;
	}
	elsif($PREF{imagemagick_available} && $PREF{try_to_use_imagemagick_for_dimensions} =~ /yes/i)
	{
		my $image = new Image::Magick;
		my $x = $image->Read($filename);
		#die_nice "ImageMagick Read() error: $x" if "$x"; # seems to die too easily, i.e. for unknown meta tags in an otherwise OK image.
		($width, $height, $xres, $yres) = $image->Get('width', 'height', 'x-resolution', 'y-resolution');

		# This works, and doesn't require reading the whole image into memory so it's
		# quicker, but it can only get a few image attributes, not all of them.
		#
		#my $image = new Image::Magick;
		#my ($width, $height, $size, $format) = $image->Ping($filename);
		#return ($width, $height);

		# This works, but the output goes directly to STDOUT/STDERR instead of into @details.
		#
		#my $image = new Image::Magick;
		#my $x = $image->Read($filename);
		#die_nice "ImageMagick Read() error: $x" if "$x";
		#my @details = $image->Identify();
		##die_nice (qq`Details: \n<br />` . join("\n<br /><br />", @details));
	}
	elsif(gd_is_available() && $PREF{try_to_use_gd_for_dimensions} =~ /yes/i)
	{
		my $image = GD::Image->new($filename);
		($width,$height) = ($image->width, $image->height) if $image;
	}

	my $width_inches  = $width  && $xres ? $width/$xres  : '';
	my $height_inches = $height && $yres ? $height/$yres : '';

	for($xres, $yres, $width_inches, $height_inches)
	{
		s!(\.\d{$decpoints}).+!$1!; $_ = int($_) unless $decpoints;
	}

	return ($width, $height, $xres, $yres, $width_inches, $height_inches);
}


sub resize_image___withtimeout
{
	my $timeout = shift;
	my $ignore_other_errors	= $_[0] eq 'ignore_other_errors' ? shift : '';
	my $timeouts_are_errors	= $_[0] eq 'timeouts_are_errors' ? shift : '';
	my ($success, $msg) = ();

	#use Time::HiRes 'gettimeofday';
	#my $starttime = gettimeofday();

	if($timeout)
	{
		my $ipc_msg_id = enc_hash('resize_image___withtimeout' . $$ . $ENV{HTTP_HOST} . rand() . $ENV{REMOTE_ADDR} . time() . $ENV{REMOTE_PORT} . $ENV{HTTP_USER_AGENT});

		if(0) # eval method: (doesn't always work; for exaple with timeout set to 8, a certain image still takes 100+ seconds??)
		{
			eval {
				local $SIG{ALRM} = sub { die "alarm\n" }; # NB: \n required
				alarm $timeout;
				my ($success, $msg) = resize_image(@_);
				alarm 0;
				die $msg unless $success;
			};
			if($@)
			{
				if($@ eq "alarm\n")	{ $timeouts_are_errors	&& die_nice("Timed out while trying to resize image.\n");	} # timed out.
				else			{ $ignore_other_errors	|| die_nice("Error while trying to resize image: $@\n");	} # propagate unexpected errors.
			}
			# else it didn't time out.
		}
		else # fork method:
		{
			my $pid = fork;
			defined $pid or die_nice "Could not fork: $!\n";
			unless ($pid) {
				# child:
				local $SIG{ALRM} = 'DEFAULT';
				alarm $timeout;
				my ($success, $msg) = resize_image(@_);
				alarm 0;
				#die $msg unless $success; # must be die, not die_nice, in the child.
				pass_child_error_to_parent($ipc_msg_id, $msg) unless $success;
				exit; # exit the child.
			}
			waitpid $pid, 0;
			
			# The $? and ${^CHILD_ERROR_NATIVE} seem to require the child to die() in order
			# to be set, but they don't actually contain the string passed to die(), and the
			# client still sees the ugly die() output, so this isn't really a great solution.
			#
			#die_nice $? if $?;
			#die_nice ${^CHILD_ERROR_NATIVE} if ${^CHILD_ERROR_NATIVE};

			($success, $msg) = read_child_error($ipc_msg_id);
		}
	}
	else { ($success, $msg) = resize_image(@_); }

	#print STDERR "resize_image___withtimeout: timeout set to $timeout; actual time was " . int(gettimeofday() - $starttime) . "\n";
	
	return ($success, $msg);
}


# 20110911: APICHANGE: previously this sub returned nothing; now it returns
# ($success, $message).  This change means that any existing code calling
# this sub must now check for success itself, and die if success=0.
#
sub resize_image
{
	my $infile = shift;
	my $outfile = shift;
	my $newW = shift;
	my $newH = shift;

	return unless -s $infile;

	my $geom = ();
	if($newW =~ /(\d*)x(\d*)!?/i)
	{
		$geom = $newW;
		($newW,$newH) = ($1,$2);
	}
	else
	{
		$geom = $newW . 'x' . $newH;
	}

	unless($newW =~ /[1-9]/ || $newH =~ /[1-9]/)
	{
		my $errormsg = "can't resize image because at least one of the dimensions must be specified (\$newW='$newW', \$newH='$newH')\n";
		encdebug $errormsg;
		return(0, $errormsg);
	}

	if($PREF{convert_available} =~ /yes/i   &&   $PREF{try_to_use_convert_for_resizing} =~ /yes/i)
	{
		#printd qq`resize_image(): using convert\n`;

		my $cmd = $PREF{convert_resize_template};
		$cmd =~ s!%%size%%!${newW}x${newH}!g;
		$cmd =~ s!%%infile%%!$infile!g;
		$cmd =~ s!%%outfile%%!$outfile!g;
		my ($success,$msg) = enc_sys_call($cmd);
		unless($success) { return(0, "failed: $msg"); }
	}
	elsif($PREF{imagemagick_available}   &&   $PREF{try_to_use_imagemagick_for_resizing} =~ /yes/i)
	{
		#printd qq`resize_image(): using IM\n`;

		my $image = new Image::Magick;
		my $retval = ();

		$retval = $image->Read($infile);
		if($retval)	{ printd "error: \$image->Read()   returned $retval.\n"; return;	}

		$retval = $image->Resize(geometry=>$geom, filter=>'Lanczos');
		if($retval)	{ printd "error: \$image->Resize() returned $retval.\n"; return;	}

		$image->Set(quality=>95);
		$image->Write($outfile);
	}
	elsif(gd_is_available()   &&   $PREF{try_to_use_gd_for_resizing} =~ /yes/i)
	{
		#printd qq`resize_image(): using GD\n`;

		my $inputimage = GD::Image->new($infile);
		if(!$inputimage)	{ printd "error: GD::Image->new($infile) returned null...\n"; return;	}

		my $oldW = $inputimage->width;
		my $oldH = $inputimage->height;

		return(0, "can't resize image because a dimension is missing (\$oldW='$oldW', \$oldH='$oldH')\n") unless $oldW =~ /[1-9]/ && $oldH =~ /[1-9]/;

		if(!$newW)
		{
			$newW = ($newH * $oldW) / $oldH;
			$newW =~ s/\..*//;
		}
		if(!$newH)
		{
			$newH = ($newW * $oldH) / $oldW;
			$newH =~ s/\..*//;
		}

		my $outputimage = GD::Image->newTrueColor($newW,$newH);
		$outputimage->copyResampled($inputimage,0,0,0,0,$newW,$newH,$oldW,$oldH);
		open(RESIMG, ">$outfile") or return(0, "couldn't create file '$outfile': $!\n");
		my $fh = \*RESIMG; # voodoo required since ancient Perls can't accept "open(my $foo_fh)".
		binmode $fh;
		   if($outfile =~ /\.jpe?g$/i)	{ print $fh $outputimage->jpeg(95);	}
		elsif($outfile =~ /\.png$/i)	{ print $fh $outputimage->png(3);	}
		elsif($outfile =~ /\.gif$/i)	{ print $fh $outputimage->gif();	}
		else				{ return(0, "image format not supported by GD.\n"); }
		close $fh or return(0, "couldn't close file '$outfile' after creating it: $!\n");
	}
	else
	{
		return(0, "no image-resizing library available.");
	}

	my $errormsg = qq`Output file does not exist after resizing; try adjusting or disabling \$PREF{image_resizing_timeout} and other image/video timeouts.`;
	encdebug $errormsg;
	return(0, $errormsg) unless -f $outfile;
}


sub image_orientation_is_resettable($)
{
	my $filename = shift;
	return 0 unless $filename =~ /\.(jpg|jpe|jpeg)$/i;
	return command_is_available("exiftool") || command_is_available("exifautotran");
}


sub reset_image_orientation($)
{
	my $filename_with_path = shift;
	exit_with_error qq`file doesn't exist: '$filename_with_path'.` unless -e $filename_with_path;
	if(command_is_available("exiftool"))
	{
		system("exiftool -q -n -P -Orientation=1 \"$filename_with_path\"");
	}
	elsif(command_is_available("exifautotran"))
	{
		system("exifautotran \"$filename_with_path\"");
	}
	else
	{
		exit_with_error qq`no image-orientation-resetting program available.`;
	}
	chmod $PREF{writable_file_perms}, $filename_with_path;
}


# Prereqs: the passed command must be *just* a command; it must
# not contain any arguments.  (But because of systems with dumb
# setups (i.e. Windows), the command may still contain spaces.)
# The reason is that we'll actually execute whatever command is
# passed in, so including arguments on it will make the command
# actually do stuff, as opposed to just executing and quitting,
# as most commands will do when no arg is passed.
#
sub command_is_available($)
{
	my $cmd = shift;
	my $retval = $^O =~ /MSWin/ ? system("$cmd >NUL 2>NUL") : system("$cmd >/dev/null 2>&1");
	my $failed = 0;
	$failed = 1 if $? == -1;
	#$failed = 1 if $? & 127;
	$failed = 1 if $retval != 0;
	return $failed ? 0 : 1;
}


sub it_is_time_for_periodic_task($)
{
	# Usage: create a task in your prefs like this:
	#
	#	$PREF{periodic_tasks}{01}{name}		= 'some_task';
	#	$PREF{periodic_tasks}{01}{enabled}	= 'yes';
	#	$PREF{periodic_tasks}{01}{period}	= 60*10; # in seconds.
	#
	# Then in the code, do this:
	#
	#	do_the_some_task_function() if it_is_time_for_periodic_task('some_task');

	my $taskname = shift;
	my $period = '';
	my $enabled = 0;
	foreach my $i (sort { $a <=> $b } keys %{$PREF{periodic_tasks}})
	{
		if($PREF{periodic_tasks}{$i}{name} eq $taskname)
		{
			$period = $PREF{periodic_tasks}{$i}{period};
			$enabled = $PREF{periodic_tasks}{$i}{enabled} =~ /yes/i;
		}
	}
	return unless $taskname && $enabled;
	exit_with_error qq`Error: missing or invalid period setting for periodic task "$taskname".  You must create a \$PREF{periodic_tasks}{NN}{period} setting, and set it to a number, indicating the number of seconds to wait between executions of this particular task.` unless $period =~ /^\d+$/;

	my $taskslist = $PREF{datadir} . "/periodic_tasks_log.cgi";
	create_file_if_DNE($taskslist, $PREF{writable_file_perms});
	open(my $iofh, "+<$taskslist") or die_nice qq`couldn't open taskslist file '$taskslist' for I/O: $!`;
	flock $iofh, 2;
	seek $iofh, 0, 0;
	my @contents = ();
	my $time_of_last_execution = '';
	while(<$iofh>)
	{
		chomp;
		if(/^(\d+):$taskname$/)
		{
			$time_of_last_execution = $1;
		}
		else
		{
			push @contents, "$_\n";
		}
	}

	my $it_is_time = 0;
	if(!$time_of_last_execution)
	{
		$it_is_time = 1;
		push (@contents, offsettime() . ":" . $taskname . "\n");
		seek $iofh, 0, 0; print $iofh @contents; truncate $iofh, tell $iofh;
		encdebug qq`This task has never been executed before, so it IS time for task $taskname.`;
	}
	elsif((offsettime() - $time_of_last_execution) > $period)
	{
		$it_is_time = 1;
		push (@contents, offsettime() . ":" . $taskname . "\n");
		seek $iofh, 0, 0; print $iofh @contents; truncate $iofh, tell $iofh;
		encdebug qq`offsettime() - $time_of_last_execution = ` . (offsettime() - $time_of_last_execution) . qq`, which exceeds the period of $period, so it IS time for task $taskname.`;
	}
	else
	{
		encdebug qq`offsettime() - $time_of_last_execution = ` . (offsettime() - $time_of_last_execution) . qq`, which is less than $period, so it is not time for task $taskname.`;
	}

	close $iofh or die_nice qq`couldn't close taskslist file '$taskslist' after I/O: $!`;

	return $it_is_time;
}


$PREF{regerr} = sub
{
	exit_with_error qq`Registration error: $PREF{internal_appname_nice} must be installed on the registered domain, as stated in your license email.&nbsp; If you'd like to change your registered domain, please <a href="http://encodable.com/contact/" target="_blank">contact us</a> and include your old and new domains along with your license number.`;
};


sub cat($)
{
	my $file = shift;
	open(my $infh, $file) or die_nice "couldn't open file '$file' for reading: $!\n";
	flock $infh, 1;
	seek $infh, 0, 0;
	my $contents = '';
	while(<$infh>) { $contents .= $_; }
	close $infh or die_nice "couldn't close file '$file' after reading: $!\n";
	return $contents;
}


##############################################################################
### Login-CS: ################################################################
##############################################################################


sub do_login
{
	if($PREF{internal_appname} eq 'userbase')
	{
		$PREF{admin_is_logged_in} = 0;
		$PREF{member_is_logged_in} = 0;

		# Get the user's inputted username and password:
		my $input_username	= param($PREF{userbase_user_fieldname}) || ($PREF{on_failed_login_redirect_to} ? enc_redirect($PREF{on_failed_login_redirect_to}) : exit_with_error($TEXT{empty_username_error}));
		my $input_password	= param($PREF{userbase_pass_fieldname}) || ($PREF{on_failed_login_redirect_to} ? enc_redirect($PREF{on_failed_login_redirect_to}) : exit_with_error($TEXT{empty_password_error}));
		my $ref = param("ref");
		my ($expiry) = ();

		$input_username = lc($input_username) if $PREF{make_usernames_case_insensitive} =~ /yes/i && $PREF{make_case_insensitive_usernames_uppercase} !~ /yes/i;
		$input_username = uc($input_username) if $PREF{make_usernames_case_insensitive} =~ /yes/i && $PREF{make_case_insensitive_usernames_uppercase} =~ /yes/i;

		if(param("remember_me") eq "on")
		{
			if($PREF{num_days_rememberme_cookie_lasts} !~ /^\d+$/)
			{
				$PREF{num_days_rememberme_cookie_lasts} = 7;
			}
			$expiry = "+$PREF{num_days_rememberme_cookie_lasts}d";
		}

		my $restrict_ip = (   ($PREF{enable_ip_address_restriction} =~ /yes/i && param("restrict_ip") =~ /on/i)   ||   ($PREF{force_ip_address_restriction} =~ /yes/i)   ) ? 1 : 0;
		$restrict_ip = 0 if $ENV{HTTP_USER_AGENT} =~ /AOL/ && $PREF{disable_ip_restriction_for_AOL_users} =~ /yes/i;

		# Get the crypted version of the input password:
		check_username_for_sql_safeness($input_username);
		my $salt = enc_sql_select("SELECT `salt` FROM `$PREF{user_table}` WHERE `username` = '$input_username';");


		# TODO: remove this if/else, and assume that !$salt is an error condition; but
		# not until around mid-2007 to give clients time to get switched over.
		#
		my ($crypted_input_password, $update_this_account_to_new_pw_system) = ();
		if(!$salt) # old version of UB that's pre-salt, so re-create the password hash and update it in the DB.
		{
			$crypted_input_password = md5_hex($input_password);
			$update_this_account_to_new_pw_system = 1;
		}
		else
		{
			$crypted_input_password = salt_and_crypt_password($input_password, $salt);
		}


		my $account_locked = enc_sql_select("SELECT `acct_locked` FROM `$PREF{user_table}` WHERE `username` = '$input_username';");
		if($account_locked)
		{
			my $lock_expired = ! account_exceeds_failed_login_limit($input_username);
			if($PREF{lock_expires_automatically} =~ /yes/i   &&   $lock_expired)
			{
				my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `acct_locked` = FALSE WHERE `username` = '$input_username';");
				die_nice("Error: do_login(input_username='$input_username'): SQL returned '$success' instead of '1' while updating acct_locked.") unless $success == 1;
			}
			else
			{
				sleep $PREF{num_seconds_to_sleep_on_failed_login};
				enc_redirect("$PREF{login_url}?phase=eacctlck");
			}
		}


		my $go = '';
		if(account_exists($input_username, $crypted_input_password, 'new_login'))
		{
			if(enc_sql_select("SELECT `acct_disabled` FROM `$PREF{user_table}` WHERE `username` = '$input_username';"))
			{
				enc_redirect("$PREF{login_url}?phase=eacctdis");
			}

			$PREF{member_is_logged_in} = 1; # technically true, but can still be revoked by later tests.
			$PREF{logged_in_userid} = my $userid = get_user_id($input_username);

			enc_redirect("$PREF{login_url}?phase=eacctpndvrf&uid=$userid&user=$input_username") if account_is_pending_email_verification($PREF{logged_in_userid});
			enc_redirect("$PREF{login_url}?phase=eacctpndpmt&uid=$userid") if account_is_pending_payment($PREF{logged_in_userid});
			enc_redirect("$PREF{login_url}?phase=eacctpndadm") if account_is_pending_admin_approval($PREF{logged_in_userid});

			my $session_id = create_new_session_id($input_username, $crypted_input_password);
			if(my $shared_session_id = check_for_multiple_logins($userid, $input_username))
			{
				$session_id = $shared_session_id;
			}
			update_loggedin_count_for_this_user($userid);

			set_cookie($PREF{site_session_cookie}, $session_id, $expiry);

			if($update_this_account_to_new_pw_system)
			{
				my $salt = create_random_salt($PREF{salt_length});
				my $new_crypted_password = salt_and_crypt_password($input_password, $salt);
				my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `password` = '$new_crypted_password', `salt` = '$salt' WHERE `id` = $userid;");
				die_nice("Error: do_login(): SQL returned '$success' instead of '1' while updating pw and creating salt.") unless $success == 1;
				$crypted_input_password = $new_crypted_password;
			}

			unless(enc_sql_select("SELECT `failed_logins` FROM `$PREF{user_table}` WHERE `id` = $userid;") eq '')
			{
				my $statement = "UPDATE `$PREF{user_table}` SET `failed_logins` = NULL WHERE `id` = $userid;";
				my $success = enc_sql_update($statement);
				die_nice("Error: do_login(id='$userid'): SQL returned '$success' instead of '1' while updating failed_logins.  SQL was: [[$statement]]") unless $success == 1;
			}

			log_user_into_db($userid, $session_id, offsettime(), $restrict_ip);
			update_logins_table($userid, $session_id);
			$PREF{admin_is_logged_in} = is_admin($PREF{logged_in_userid});

			send_login_notification_email($userid, $input_username);

			my %REDIRS = ();
			if(force_pw_change($userid))
			{
				$REDIRS{force_pw_change} = $PREF{login_url_qsready} . "action=edituser&id=$userid";
			}
			if(   (my $return = param('loginreturn'))   &&   $PREF{loginreturn}{ param('loginreturn') }   )
			{
				$REDIRS{loginreturn} = $PREF{loginreturn}{$return};
			}
			foreach my $pref (sort keys %PREF)
			{
				if($pref =~ /^on_(.+?)_login_redirect_to$/i)
				{
					my $group = $1;
					if(   user_is_member_of_group($PREF{logged_in_userid}, $group)   &&   $PREF{$pref}   &&   !($PREF{admin_is_logged_in} && ($group eq $PREF{member_group_name}))   )
					{
						$REDIRS{redirect} = $PREF{$pref};
						$REDIRS{redirect} =~ s/%%username%%/$input_username/g;
						#last; # Actually, don't skip out after the first one; process them all so only the last one applies.
					}
				}
			}
			$REDIRS{referer} = determine_default_login_destination($ref);

			foreach my $redir_type (split(/\s*,\s*/, "force_pw_change, $PREF{login_destination_precedence_list}"))
			{
				if($REDIRS{$redir_type})
				{
					$go = $REDIRS{$redir_type};
					last;
				}
			}

			enc_redirect($go);
		}

		# Else they tried to log in but failed.
		else
		{
			# Be sure that we do the sleep before the email, so that any
			# potential email errors don't cause us to abort early thereby
			# skipping the sleep and possibly giving away the fact that the
			# login failed.
			#
			sleep $PREF{num_seconds_to_sleep_on_failed_login};

			my $account_locked = account_exceeds_failed_login_limit($input_username, 'increment');
			if($account_locked)
			{
				unless(enc_sql_select("SELECT `acct_locked` FROM `$PREF{user_table}` WHERE `username` = '$input_username'"))
				{
					my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `acct_locked` = TRUE WHERE `username` = '$input_username';");
					die_nice("Error: do_login(input_username='$input_username'): SQL returned '$success' instead of '1' while updating acct_locked.") unless $success == 1;
				}
			}

			update_failed_logins_table($input_username, $input_password);
			email_failed_logins_to_webmaster($input_username, $input_password);

			if($PREF{on_failed_login_redirect_to})
			{
				$go = $PREF{on_failed_login_redirect_to};

				if($account_locked)
				{
					$go .= $go =~ /\?/ ? '&account_locked=1' : '?account_locked=1';
				}
			}
			else
			{
				if($account_locked)	{ $go = "$PREF{login_url}?phase=eacctlck"; }
				else			{ $go = "$PREF{login_url}?phase=ebadauth"; }
			}

			enc_redirect($go);
		}
	}
	else
	{
		my $whence = ($qs =~ /(?:^|&)whence=(.+)/)[0]; $whence = '' if $whence =~ /(log(ged)?out|smsg=|kmsg=)/i;
		if($ENV{REQUEST_METHOD} =~ /post/i)
		{
			smsg_redirect('failedlogin') if param('password') !~ /\S/;
			my $hashed_password = md5_hex(param('password'));
			my $expiry = param('persist') eq 'on' ? "+$PREF{num_days_login_lasts}d" : '';

			smsg_redirect('failedlogin') unless ($PREF{all_admin_password_hashes}{$hashed_password}   ||   $PREF{all_member_password_hashes}{$hashed_password});

			set_cookie($PREF{non_userbase_login_cookie}, $hashed_password, $expiry);
			my $ref = param('ref'); $ref = '' if $ref =~ /(log(ged)?out|smsg=|kmsg=|\?newpw|\?login|action=login)/i;
			$whence =~ s!_THEQS_!?!g; $whence =~ s!_ANAMP_!&!g;
			enc_redirect($ref || $whence || $PREF{here});
		}
		else
		{
			if($PREF{all_admin_password_hashes})
			{
				my $action = $PREF{internal_appname} eq 'visitorlog' ? 'action=vllogin' : 'action=login';
				$action .= $PREF{default_url_vars};
				$action .= "&amp;whence=$whence" if $whence;
				start_html_output($PREF{subtitle___login});
				print	  qq`<form method="post" id="nonub_login" action="$ENV{SCRIPT_NAME}?$action">`
					. qq`\n<p>$TEXT{Enter_the_password}</p>\n<input type="password" name="password" maxlength="200" class="default text" /><input type="hidden" name="ref" value="$ENV{HTTP_REFERER}" />`
					. ($PREF{show_keep_me_logged_in_checkbox_on_login_page} !~ /yes/i ? '' : qq`\n<br /><br /><input type="checkbox" name="persist" id="persist" /><label for="persist"> $TEXT{Keep_me_logged_in_for} $PREF{num_days_login_lasts} $TEXT{days}</label>`)
					. qq`\n<br /><br /><input type="submit" value="$TEXT{Login}" class="default button submit" />\n</form>\n`;
				print $TEXT{Forgot_password_};
				finish_html_output();
			}
			else
			{
				$TEXT{password_not_set} =~ s!%%newpw_link%%!$PREF{here_login_qsready}newpw!g;
				exit_with_output($TEXT{password_not_set});
			}
		}
	}
}


sub check_if_logged_in()
{
	my %cookies = get_cookies();
	($PREF{admin_is_logged_in}, $PREF{member_is_logged_in}, $PREF{logged_in_username}, $PREF{logged_in_realname}, $PREF{logged_in_email}, $PREF{logged_in_userid}) = (0,0,'','','','');

	if($PREF{integrate_with_existing_login_system} =~ /yes/i   &&   $PREF{integrate_with_userbase} !~ /yes/i)
	{
		if($PREF{enable_username_from_apache_auth} =~ /yes/i)
		{
			if(my $username = $ENV{REMOTE_USER})
			{
				$PREF{logged_in_username}	= $username;
				$PREF{member_is_logged_in}	= 1;
				$PREF{admin_is_logged_in}	= $PREF{admin_usernames_list} =~ /(?:^|,)\s*$username\s*(?:,|$)/;
				$PREF{logged_in_userid}		= $PREF{admin_is_logged_in} ? -3 : -2;
			}
		}
		elsif($PREF{enable_username_from_cookie} =~ /yes/i)
		{
			my $username = '';
			if(exists($cookies{$PREF{username_cookie_name}})   &&   ($username = $cookies{$PREF{username_cookie_name}}->value))
			{
				$PREF{logged_in_username}	= $username;
				$PREF{member_is_logged_in}	= 1;
				$PREF{admin_is_logged_in}	= $PREF{admin_usernames_list} =~ /(?:^|,)\s*$username\s*(?:,|$)/;
				$PREF{logged_in_userid}		= $PREF{admin_is_logged_in} ? -3 : -2;
			}
		}
		elsif($PREF{enable_username_from_environment_variable} =~ /yes/i)
		{
			my $username = '';
			if(exists($ENV{$PREF{username_envvar_name}})   &&   ($username = $ENV{$PREF{username_envvar_name}}))
			{
				$PREF{logged_in_username}	= $username;
				$PREF{member_is_logged_in}	= 1;
				$PREF{admin_is_logged_in}	= $PREF{admin_usernames_list} =~ /(?:^|,)\s*$username\s*(?:,|$)/;
				$PREF{logged_in_userid}		= $PREF{admin_is_logged_in} ? -3 : -2;
			}
		}
		elsif($PREF{enable_username_from_php_session} =~ /yes/i)
		{
			my $username = '';
			if(exists $ENV{PHP_ENC_USERNAME}) # must use if(exists $foo) rather than just if($foo) so that we properly unset the variable when a user has logged out; otherwise we'd just pull it from our php-var-cache even though the user had already logged out.
			{
				$username = $ENV{PHP_ENC_USERNAME}; save_php_var_to_cache('username',$username);
			}
			else # we were POSTed to?
			{
				$username = get_php_var_from_cache('username');
			}

			if($username)
			{
				$PREF{logged_in_username}	= $username;
				$PREF{member_is_logged_in}	= 1;
				$PREF{admin_is_logged_in}	= $PREF{admin_usernames_list} =~ /(?:^|,)\s*$username\s*(?:,|$)/;
				$PREF{logged_in_userid}		= $PREF{admin_is_logged_in} ? -3 : -2;
			}
		}
		else
		{
			exit_with_error qq`To use \$PREF{integrate_with_existing_login_system}, you must also enable either \$PREF{enable_username_from_cookie}, \$PREF{enable_username_from_environment_variable}, \$PREF{enable_username_from_php_session}, or \$PREF{enable_username_from_apache_auth}.`;
		}
	}
	elsif($PREF{integrate_with_userbase_method_b} =~ /yes/i   &&   $PREF{path_to_userbase})
	{
		# Won't work on many IIS configurations where executing external commands
		# from within IIS is prevented by user account policy.  But the eval method
		# in the following block works on IIS.
		#
		my $userbase_output = `export QUERY_STRING="action=chklogin" && export SCRIPT_NAME="$PREF{userbase_local_scriptname}" && "$PREF{path_to_userbase}" 2>&1`;

		if($userbase_output !~ /\w+/)
		{
			# Use "package" to create a separate namespace for this block.  This is because we're going to use
			# "eval" as a way to execute another Perl script, but we only want that script's output; we don't
			# want its globals and subroutines being imported into our namespace.  In particular we don't want
			# functions such as start_html_output() "overwriting" our own copy of that function in the main
			# namespace.
			# 
			package CALLTOUBFORLOGINCHECK;

			# Don't die/die_nice anywhere in here; we want to let the next if() check whether $userbase_output
			# is valid and then print a more useful error if not.
			#
			my $file = $PREF{path_to_userbase};
			my $file_contents = ();
			open(IN,"<$file");
			flock IN, 1;
			seek IN, 0, 0;
			while(<IN>) { $file_contents .= $_; }
			close IN;

			$file_contents =~ /(.*)/s;
			$file_contents = $1; # cheap untaint since this is our own file.

			my ($real_qs, $real_sn) = ($ENV{QUERY_STRING}, $ENV{SCRIPT_NAME});
			($ENV{QUERY_STRING}, $ENV{SCRIPT_NAME}) = ("action=chklogin&print=false", $PREF{userbase_local_scriptname});
			$userbase_output = eval $file_contents;
			($ENV{QUERY_STRING}, $ENV{SCRIPT_NAME}) = ($real_qs, $real_sn);
		}

		if($userbase_output =~ /admin=(\d):::::member=(\d):::::username=(.*?):::::userid=(\d*?):::::group_memberships=(.*?):::::realname=(.*?):::::email=(.*?):::::(.*)/s)
		{
			($PREF{admin_is_logged_in},$PREF{member_is_logged_in},$PREF{logged_in_username},$PREF{logged_in_userid},$PREF{logged_in_group_memberships},$PREF{logged_in_realname},$PREF{logged_in_email})
			= ($1,$2,$3,$4,$5,$6,$7);

			$PREF{ub_var_username}	= $PREF{logged_in_username};
			$PREF{ub_var_userid}	= $PREF{logged_in_userid};
			$PREF{ub_var_realname}	= $PREF{logged_in_realname};
			$PREF{ub_var_email}	= $PREF{logged_in_email};

			if(my $other_ub_vars = $8)
			{
				while($other_ub_vars =~ /(.+?)=(.+?):::::/g)
				{
					$PREF{"ub_var_$1"} = $2;
					$PREF{"logged_in_$1"} = $2 unless $PREF{"logged_in_$1"};
				}
			}
		}
		else
		{
			exit_with_error("$PREF{internal_appname}: check_if_logged_in(): integrate_with_userbase_method_b failed: UserBase output was: "
				. ($userbase_output ? 'null' : "[[ $userbase_output ]] ")
				. qq`<br /><br />\n\nMake sure you've got UserBase itself running properly before trying this.`
			);
		}
	}
	elsif(userbase_available())
	{
		if(my $session_id = get_cookie($PREF{site_session_cookie}))
		{
			check_sessionid_for_sql_safeness($session_id);

			my ($username,$realname,$email,$id,$ip) = enc_sql_select("SELECT username,name,email,id,ip FROM `$PREF{user_table}` WHERE `mrsession` = '$session_id';");

			if($username   &&   $id   &&   !account_is_pending($id))
			{
				if(enc_sql_select("SELECT `acct_disabled` FROM `$PREF{user_table}` WHERE `id` = '$id';"))
				{
					enc_redirect("$PREF{login_url}?phase=eacctdis");
				}

				my $numusers = enc_sql_select("SELECT `numusers` FROM `$PREF{user_table}` WHERE `id` = '$id';");
				if(($numusers > 1) && $PREF{prevent_multiple_simultaneous_logons_per_username} =~ /yes/i)
				{
					# If there's already >1 user logged in under this username (for example, because we
					# didn't enable prevent_multiple_simultaneous_logons_per_username until after some
					# usage had already occurred), then we can't really do a one-by-one check to try and
					# decide which logins to kill, so kill them all.

					log_user_out_of_db($username, 'force');
					enc_redirect("$PREF{login_url}?phase=emultkicked");
				}

				# The IP check MUST come *after* the multiple_simultaneous_logons check, because if the
				# multiple_simultaneous_logons check fails, we need to take an action in response (namely
				# logging all the users out of the db) -- but if the IP check also fails (which is likely
				# to happen when the multiple_simultaneous_logons check fails) then we simply return, so
				# the multiple_simultaneous_logons check would never get a chance to do its db-logouts
				# if the IP check came first (and failed).
				#
				if(($PREF{enable_ip_address_restriction} =~ /yes/i && $ip) || ($PREF{force_ip_address_restriction} =~ /yes/i))
				{
					enc_redirect("$PREF{login_url}?phase=eipmismatch") unless $ip eq $PREF{ip};
				}

				$PREF{logged_in_username} = $username;
				$PREF{logged_in_realname} = $realname;
				$PREF{logged_in_email} = $email; $PREF{logged_in_email} = $PREF{logged_in_username} if ($PREF{logged_in_email} !~ /.+\@.+\..+/ && $PREF{logged_in_username} =~ /.+\@.+\..+/);
				$PREF{logged_in_userid} = $id;
				$PREF{member_is_logged_in} = 1;

				if(is_admin($PREF{logged_in_userid}))
				{
					$PREF{admin_is_logged_in} = 1;
				}

				$PREF{ub_var_username}	= $PREF{logged_in_username};
				$PREF{ub_var_userid}	= $PREF{logged_in_userid};
				$PREF{ub_var_realname}	= $PREF{logged_in_realname};
				$PREF{ub_var_email}	= $PREF{logged_in_email};

				foreach my $customfield (get_custom_userbase_field_names($PREF{user_table}))
				{
					my $value = enc_sql_select("SELECT `$customfield` FROM `$PREF{user_table}` WHERE `id` = '$PREF{logged_in_userid}'");
					$PREF{"ub_var_$customfield"} = $value;
					$PREF{"logged_in_$customfield"} = $value unless $PREF{"logged_in_$customfield"};
				}

				# This depends on $PREF{logged_in_userid}, so must come after that is set; but since
				# this is an acct-disabled check, it should still come *before* we officially mark the
				# user as logged in (i.e. before we update the database).
				#
				if(user_is_part_of_a_subgroup($id) && $PREF{subgroup_owned_users_get_disabled_when_their_manager_does} =~ /yes/i)
				{
					die_unless_numeric($PREF{subgroup_manager_userid}, 'subgroup manager user ID');
					if(enc_sql_select("SELECT `acct_disabled` FROM `$PREF{user_table}` WHERE `id` = '$PREF{subgroup_manager_userid}';"))
					{
						enc_redirect("$PREF{login_url}?phase=eacctdis");
					}
				}

				check_and_update_login_session($PREF{logged_in_userid});

				if(force_pw_change($PREF{logged_in_userid}))
				{
					if($PREF{internal_appname} eq 'userbase')
					{
						if($qs !~ /^(logout|logoutall|action=commitedituser)$/)
						{
							print_user_form('edit', $PREF{logged_in_userid});
							exit;
						}
					}
					else
					{
						enc_redirect("$PREF{login_url_qsready}action=edituser&id=$PREF{logged_in_userid}");
					}
				}
			}
		}
	}
	elsif($PREF{all_admin_password_hashes} || $PREF{all_member_password_hashes})
	{
		my $hashed_password_in_cookie = get_cookie($PREF{non_userbase_login_cookie});

		if($hashed_password_in_cookie   &&   $PREF{all_admin_password_hashes}{$hashed_password_in_cookie})
		{
			($PREF{admin_is_logged_in}, $PREF{member_is_logged_in}, $PREF{logged_in_username}, $PREF{logged_in_userid}) = (1, 1, '', -3);
		}
		elsif($hashed_password_in_cookie   &&   $PREF{all_member_password_hashes}{$hashed_password_in_cookie})
		{
			($PREF{admin_is_logged_in}, $PREF{member_is_logged_in}, $PREF{logged_in_username}, $PREF{logged_in_userid}) = (0, 1, '', -2);
		}
		# TODO: explicitly set 0/0/''/-1 for public?
	}
}


sub check_and_update_login_session($)
{
	my $userid = shift;
	my $my_session_id = get_cookie($PREF{site_session_cookie});
	my $session_id_in_db = enc_sql_select("SELECT `mrsession` FROM `$PREF{user_table}` WHERE `id` = $userid;");
	my $login_time = enc_sql_select("SELECT `loggedin` FROM `$PREF{user_table}` WHERE `id` = $userid;");

	#if(   ($my_session_id == $session_id_in_db)   &&   ($login_time =~ /[1-9]/   &&   !login_session_expired($login_time))   )
	 if(   ($my_session_id == $session_id_in_db)   &&   (!login_session_expired($login_time))   )
	{
		 update_loggedin_time($userid, $my_session_id, offsettime());
	}
	else
	{
		do_logout() if $PREF{idle_timeout} > 0;
	}
}


sub update_loggedin_time
{
	my ($userid, $my_session_id, $newtime) = @_;

	die_unless_numeric($userid,'userid');
	die_unless_numeric($newtime,'newtime');
	check_sessionid_for_sql_safeness($my_session_id);

	my $value_is_unchanged = $newtime == enc_sql_select("SELECT `loggedin` FROM `$PREF{user_table}` WHERE `id` = $userid AND `mrsession` = '$my_session_id'");
	unless($value_is_unchanged) # prevent the 0E0 error, which isn't actually an error in the case that the value was unchanged.
	{
		my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `loggedin` = $newtime WHERE `id` = $userid AND `mrsession` = '$my_session_id'");
		die_nice("Error: update_loggedin_time('$userid', '$my_session_id', '$newtime'): SQL returned '$success' instead of '1' while updating loggedin.") unless $success == 1;
	}

	if(db_column_exists('lastactive', $PREF{user_table})) # for backwards compatibility with older versions of apps.
	{
		my $value_is_unchanged = $newtime == enc_sql_select("SELECT `lastactive` FROM `$PREF{user_table}` WHERE `id` = $userid AND `mrsession` = '$my_session_id'");
		unless($value_is_unchanged) # prevent the 0E0 error, which isn't actually an error in the case that the value was unchanged.
		{
			my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `lastactive` = $newtime WHERE `id` = $userid AND `mrsession` = '$my_session_id'");
			die_nice("Error: update_loggedin_time('$userid', '$my_session_id', '$newtime'): SQL returned '$success' instead of '1' while updating lastactive.") unless $success == 1;
		}
	}
}


sub login_session_expired($)
{
	my $loggedin_time = shift;
	return (

		(   ($PREF{idle_timeout} > 0)   &&   (offsettime() - $loggedin_time > $PREF{idle_timeout})   )

		||

		(
			($PREF{num_days_rememberme_cookie_lasts} > 0)
			&&
			(   offsettime()   >   ($loggedin_time + ($PREF{num_days_rememberme_cookie_lasts} * 86400))   )
		)
	);
}


sub log_user_out_of_db
{
	my ($username, $my_session_id) = @_;

	check_username_for_sql_safeness($username);
	check_sessionid_for_sql_safeness($my_session_id) unless $my_session_id eq 'force';

	# It's possible (and probably not particularly uncommon) that a user logs in at one location, then leaves
	# that location and his session goes idle, and then he logs in at another location with the same account.  In
	# that case, a call to log_user_out_of_db() from the first location should not actually do the db logout, 
	# because the session does not belong to him anymore.  But note that this is not an error condition, so we
	# should just silently return.
	#
	my $session_id_in_db = enc_sql_select("SELECT `mrsession` FROM `$PREF{user_table}` WHERE LOWER(`username`) = LOWER('$username');");

	if(($my_session_id == $session_id_in_db)   ||   ($my_session_id eq 'force'))
	{
		my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `loggedin` = 0 WHERE LOWER(`username`) = LOWER('$username');");
		die_nice("Error: log_user_out_of_db('$username', '$my_session_id'): SQL returned '$success' instead of '1' while setting loggedin to zero.") unless $success == 1;

		$success = enc_sql_update("UPDATE `$PREF{user_table}` SET `mrsession` = '' WHERE LOWER(`username`) = LOWER('$username');");
		die_nice("Error: log_user_out_of_db('$username', '$my_session_id'): SQL returned '$success' instead of '1' while setting mrsession to null.") unless $success == 1;

		my $numusers = enc_sql_select("SELECT `numusers` FROM `$PREF{user_table}` WHERE LOWER(`username`) = LOWER('$username');");
		if($numusers) # this check only required because of crappy old MySQL versions that fail to ever set numusers properly in the DB (??).
		{
			$success = enc_sql_update("UPDATE `$PREF{user_table}` SET `numusers` = 0 WHERE LOWER(`username`) = LOWER('$username');");
			die_nice("Error: log_user_out_of_db('$username', '$my_session_id'): SQL returned '$success' instead of '1' while setting numusers to zero.") unless $success == 1;
		}
	}
}


sub do_logout
{
	if($PREF{internal_appname} eq 'userbase')
	{
		my $force_logout_all = shift; $force_logout_all = $force_logout_all eq 'all' ? 1 : 0;

		if($PREF{we_are_virtual})
		{
			print_http_headers();
			$PREF{forced_logout_link} =~ s/%%logout_url%%/$PREF{logout_url}/g;
			print $PREF{forced_logout_link};
			exit;
		}
		else
		{
			my $ref = $ENV{HTTP_REFERER};
			if($ref)
			{
				# Remove the "logout" from the referrer, otherwise we'll get stuck
				# in an infinite logout loop with this Location: call.
				$ref =~ s/\?.*log(ged)?out.*//;

				$ref = '' if $ref =~ /(smsg=|kmsg=)/i; # don't redirect to any static/keyed messages that probably no longer apply now that the login state has changed.
			}

			# Delete the login cookie regardless of $PREF{member_is_logged_in}, because
			# it may be that the user has the cookie but it's invalid (expired, wrong IP,
			# etc) in which case we didn't set $PREF{member_is_logged_in}.  In that case,
			# we still want to allow the user to force a logout (i.e. delete his cookie).
			#
			delete_login_cookie();

			my $whence = '';
			if($PREF{member_is_logged_in})
			{
				if($PREF{prevent_multiple_simultaneous_logons_per_username} =~ /yes/i   ||   $force_logout_all)
				{
					log_user_out_of_db($PREF{logged_in_username}, get_cookie($PREF{site_session_cookie}));
				}
				else
				{
					die_unless_numeric($PREF{logged_in_userid}, 'logged_in_userid');
					my $numusers = enc_sql_select("SELECT `numusers` FROM `$PREF{user_table}` WHERE `id` = '$PREF{logged_in_userid}';");
					if($numusers > 1)
					{
						my $success = enc_sql_update("UPDATE `$PREF{user_table}` SET `numusers`=GREATEST((`numusers`-1),0) WHERE `id` = '$PREF{logged_in_userid}';");
						die_nice("Error: do_logout(): SQL returned '$success' instead of '1' while decrementing numusers column.") unless $success == 1;
					}
					else
					{
						log_user_out_of_db($PREF{logged_in_username}, get_cookie($PREF{site_session_cookie}));
					}
				}

				if($PREF{admin_is_logged_in}   &&   $PREF{on_admin_logout_redirect_to})
				{
					$PREF{on_admin_logout_redirect_to} =~ s/%%username%%/$PREF{logged_in_username}/g;
					enc_redirect($PREF{on_admin_logout_redirect_to});
				}
				elsif($PREF{member_is_logged_in}   &&   !$PREF{admin_is_logged_in}   &&   $PREF{on_member_logout_redirect_to}) # need the !admin because admins are members too.
				{
					$PREF{on_member_logout_redirect_to} =~ s/%%username%%/$PREF{logged_in_username}/g;
					enc_redirect($PREF{on_member_logout_redirect_to});
				}
				else
				{
					# After logging out, return to the page we were on.
					$whence = $ref;
				}
			}
			else
			{
				if($PREF{on_fake_logout_redirect_to})
				{
					enc_redirect($PREF{on_fake_logout_redirect_to});
				}
				else
				{
					$whence = $ref;
				}
			}

			$whence =~ s!^https?://$ENV{HTTP_HOST}!!; # some servers don't like extra "http://"s in URLs.
			enc_urlencode($whence);
			$whence = '' if $PREF{server_bug_prohibits_use_of_whence} =~ /yes/i;
			enc_redirect("$PREF{login_url_qsready}action=loggedout&whence=$whence");
		}
	}
	else
	{
		my $go = '';
		if($PREF{integrate_with_userbase} =~ /yes/i   ||   $PREF{integrate_with_userbase_method_b} =~ /yes/i   ||   $PREF{integrate_with_existing_login_system} =~ /yes/i)
		{
			$go = $PREF{logout_url};
		}
		else
		{
			set_cookie($PREF{non_userbase_login_cookie}, 'blank', '-1d');
			my $whence = $ENV{HTTP_REFERER};
			$whence =~ s!^https?://$ENV{HTTP_HOST}!!; # some servers don't like extra "http://"s in URLs.
			$whence =~ s/\?logout$//; # Remove "logout" from the ref so we don't get stuck in an infinite loop.
			$go = "$PREF{here_login_qsready}action=loggedout&whence=$whence";
		}

		if($PREF{we_are_virtual})
		{
			print_http_headers();
			if($PREF{use_javascript_redirect_when_necessary} !~ /no/i)
			{
				print qq`\n<script type="text/javascript">location.href="$go";</script>\n`;
			}
			else
			{
				$PREF{forced_logout_link} =~ s/%%logout_url%%/$go/g;
				print $PREF{forced_logout_link};
			}
			exit;
		}
		else
		{
			enc_redirect($go);
		}
	}
}


sub delete_login_cookie
{
	set_cookie($PREF{site_session_cookie}, 0, '-1M');
}


sub show_loggedout_page
{
	my $ref = shift;
	enc_urldecode($ref);
	$ref = '' if $ref =~ /(log(ged)?out|smsg=|kmsg=|phase=)/i;
	my $message = $PREF{loggedout_page_template__no_referer};
	if($ref)
	{
		$message = $PREF{loggedout_page_template__with_referer};
		$message =~ s/%%ref%%/$ref/g;
	}
	exit_with_success($message);
}


sub get_logout_url
{
	return $PREF{integrate_with_userbase} =~ /yes/i || $PREF{integrate_with_userbase_method_b} =~ /yes/i || $PREF{integrate_with_existing_login_system} =~ /yes/i ? $PREF{logout_url} : ($ENV{SCRIPT_NAME} . ($ENV{SCRIPT_NAME} =~ /\?/ ? '&' : '?') . "logout");
}


sub get_login_url
{
	return $PREF{integrate_with_userbase} =~ /yes/i || $PREF{integrate_with_userbase_method_b} =~ /yes/i || $PREF{integrate_with_existing_login_system} =~ /yes/i ? $PREF{login_url} : "$PREF{here_login_qsready}action=login";
}


# This function must do a case-sensitive lookup (i.e., do NOT use LOWER()) because
# FC's userdirs are case-sensitive.  So whatever case is used when a username is
# created is the case that must always be used when logging in with it.
# UPDATE: MySQL's equal operator (=) is case-insensitive, absurdly.  To force it
# to act case-sensitively, you must use the BINARY function, as in:
#	... WHERE BINARY `username` = '$username'
#
sub account_exists($$$)
{
	#printd "account_exists('$_[0]', '$_[1]', '$_[2]')\n";

	my $user = shift;
	my $pass = shift;
	my $third_arg = shift;

	check_username_for_sql_safeness($user);
	check_hashedpw_for_sql_safeness($pass);

	my $BINARY = $PREF{make_usernames_case_insensitive} =~ /yes/i ? '' : 'BINARY';

	my $count = ();
	if($third_arg eq 'new_login')
	{
		$count = enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE $BINARY `username` = '$user' AND `password` = '$pass'");
	}
	else
	{
		die_unless_numeric($third_arg,'userid');
		$count = enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE $BINARY `username` = '$user' AND `password` = '$pass' AND `id` = $third_arg");
	}

	if($count == 1)		{ return 1; }
	elsif($count > 1)	{ die_nice("$0: account_exists('$user', '$pass', '$third_arg'): error: duplicate records ($count total) for this user!\n"); }
	else			{ return 0; }
}


sub account_is_pending
{
	return 0 if !userbase_available();
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_is_pending()");
	return (account_is_pending_email_verification($userid) || account_is_pending_admin_approval($userid) || account_is_pending_payment($userid));
}


sub account_is_pending_email_verification
{
	my $userid = shift;
	return ($PREF{require_email_verification_for_new_signups} =~ /yes/i) && account_is_pending_email_verification_in_db($userid);
}


sub account_is_pending_email_verification_in_db
{
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_is_pending_email_verification_in_db()");
	return enc_sql_select("SELECT `pending_email_verification` FROM `$PREF{user_table}` WHERE `id` = $userid");
}


sub account_has_completed_email_verification
{
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_has_completed_email_verification()");
	return enc_sql_select("SELECT `completed_email_verification` FROM `$PREF{user_table}` WHERE `id` = $userid");
}


sub account_is_pending_admin_approval
{
	my $userid = shift;
	return ($PREF{require_admin_approval_for_new_signups} =~ /yes/i) && account_is_pending_admin_approval_in_db($userid);
}


sub account_is_pending_admin_approval_in_db
{
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_is_pending_admin_approval_in_db()");
	return enc_sql_select("SELECT `pending_admin_approval` FROM `$PREF{user_table}` WHERE `id` = $userid");
}


sub account_is_pending_payment
{
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_is_pending_payment()");
	return enc_sql_select("SELECT `pending_payment` FROM `$PREF{user_table}` WHERE `id` = $userid");
}


sub account_has_completed_payment
{
	my $userid = shift;
	die_unless_numeric($userid, "user ID in account_has_completed_payment()");
	return enc_sql_select("SELECT COUNT(*) FROM `$PREF{payments_table}` WHERE `userid` = $userid");
}


sub get_custom_userbase_field_names
{
	my $which_user_table = shift;
	my $include_disabled_fields = shift;

	my (@custom_fields, %custom_fields) = ();
	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{custom_field_list_table}`"))
	{
		my ($fieldname,$fieldlabel,$enabled) = ();
		my $sth = $PREF{dbh}->prepare("SELECT fieldname,fieldlabel,enabled FROM `$PREF{custom_field_list_table}` ORDER BY `fieldposition`");
		$sth->execute() or die_nice("$PREF{internal_appname}: Error: get_custom_userbase_field_names(): $DBI::errstr\n");
		$sth->bind_columns(\$fieldname,\$fieldlabel,\$enabled);
		while($sth->fetchrow_arrayref)
		{
			next unless db_column_exists($fieldname, $which_user_table);
			next if (!$enabled   &&   !$include_disabled_fields);
			$custom_fields{$fieldname} = 1;
			push @custom_fields, $fieldname;
		}
	}

	return wantarray ? @custom_fields : \%custom_fields;
}


sub is_admin($)
{
	#printd "is_admin('$_[0]')\n";

	my $userid = shift;
	return 0 unless $userid;

	return 1 if (!userbase_available()   &&   $userid == -3);

	# don't bother checking the validity of $userid here,
	# because user_is_member_of_group() will do it.
	return user_is_member_of_group($userid,$PREF{admin_group_name});
}


sub force_pw_change($)
{
	my $userid = shift;
	my $force_pw_change = 0;

	if(		$PREF{enable_forced_password_change} =~ /yes/i
			&&
			enc_sql_select("SELECT `forcepwchng` FROM `$PREF{user_table}` WHERE `id` = '$userid';")
			&&
			(
				!is_admin($userid)
				||
				(is_admin($userid) && $PREF{admins_can_be_forced_to_change_their_own_pws} =~ /yes/i)
			)
	)
	{
		$force_pw_change = 1;
	}

	if(password_has_expired())
	{
		$force_pw_change = 1;
	}

	return $force_pw_change;
}


sub password_has_expired
{
	my $expired = 0;
	if($PREF{force_pw_chng_after_this_many_hours} =~ /^\d+$/ && $PREF{force_pw_chng_after_this_many_hours} > 0)
	{
		unless($PREF{admin_is_logged_in} && $PREF{admins_can_be_forced_to_change_their_own_pws} =~ /no/i)
		{
			my $time_now = offsettime();
			die_unless_numeric($PREF{logged_in_userid}, '$PREF{logged_in_userid}');
			my $time_of_last_pw_change = enc_sql_select("SELECT MAX(`timestamp`) FROM `$PREF{password_activity_table}` WHERE `user_id` = $PREF{logged_in_userid}");
			$expired = 1 if ($time_now - $time_of_last_pw_change) > ($PREF{force_pw_chng_after_this_many_hours} * 3600);
		}
	}
	return $expired;
}


sub get_group_id($)
{
	printd "get_group_id($_[0])\n";
	my $group = shift;

	if(userbase_available())
	{
		check_groupname_for_uniqueness($group); # checks for sql safeness too.
		return enc_sql_select("SELECT `id` FROM `$PREF{group_table}` WHERE `group` = '$group'");
	}
	else
	{
		   if($group =~ /^$PREF{public_group_name}$/i)	{ return -1; }
		elsif($group =~ /^$PREF{member_group_name}$/i)	{ return -2; }
		elsif($group =~ /^$PREF{admin_group_name}$/i)	{ return -3; }
		else { die_nice("invalid group name '$group'.\n"); }
	}
}


sub check_uid_for_uniqueness($)
{
	#die_unless_numeric($_[0], 'user ID'); # UIDs can be negative, so this test doesn't work here; and check_id_for_sql_safeness takes care of it anyway.
	check_id_for_sql_safeness($_[0]);
	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE `id` = $_[0]")   >   1)
	{
		die_nice("more than one user record with id=$_[0]!\n");
	}
}


sub check_gid_for_uniqueness($)
{
	return unless userbase_available();
	printd "check_gid_for_uniqueness: '$_[0]'\n";

	check_id_for_sql_safeness($_[0]);
	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{group_table}` WHERE `id` = $_[0]")   >   1)
	{
		die_nice("more than one group record with id=$_[0]!\n");
	}
}


sub check_username_for_uniqueness($)
{
	#printd "check_username_for_uniqueness: '$_[0]'\n";

	check_username_for_sql_safeness($_[0]);
	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE LOWER(`username`) = LOWER('$_[0]')")   >   1)
	{
		die_nice("more than one user record with username='$_[0]'!\n");
	}
}


sub check_groupname_for_uniqueness
{
	return unless userbase_available();
	printd "check_groupname_for_uniqueness($_[0])\n";

	check_groupname_for_sql_safeness($_[0]);
	if(enc_sql_select("SELECT COUNT(*) FROM `$PREF{group_table}` WHERE LOWER(`group`) = LOWER('$_[0]')")   >   1)
	{
		die_nice("more than one user record with groupname='$_[0]'!\n");
	}
}


sub user_is_member_of_group
{
	my $userid = shift;
	my $group = shift;
	my $not_checking_loggedin_user = shift;

	if($PREF{integrate_with_userbase_method_b} =~ /yes/i   &&   $PREF{logged_in_group_memberships}   &&   !$not_checking_loggedin_user)
	{
		return $PREF{logged_in_group_memberships} =~ /(^|,)$group(,|$)/;
	}
	if(userbase_available()   &&   ($PREF{member_is_logged_in} || $not_checking_loggedin_user))
	{
		check_groupname_for_sql_safeness($group);
		die_unless_numeric($userid,'userid');

		return 1 if $group =~ /^$PREF{public_group_name}$/i;
		return 1 if $group =~ /^$PREF{member_group_name}$/i && enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE `id` = $userid;");

		# special internal groups:
		return 1 if $group eq 'encwhitelisted' && $PREF{user_is_encwhitelisted};
		return 1 if $group eq 'encblacklisted' && $PREF{user_is_encblacklisted};

		return enc_sql_select("SELECT COUNT(*) FROM `$PREF{group_table}` WHERE LOWER(`group`) = LOWER('$group') AND `members` REGEXP '(^|,)$userid(,|\$)'");
	}
	else
	{
		# special internal groups:
		return 1 if $group eq 'encwhitelisted' && $PREF{user_is_encwhitelisted};
		return 1 if $group eq 'encblacklisted' && $PREF{user_is_encblacklisted};

		return 1 if $group =~ /^$PREF{public_group_name}$/i;
		return 1 if $group =~ /^$PREF{member_group_name}$/i && $userid =~ /^-(2|3)$/;
		return 1 if $group =~ /^$PREF{admin_group_name}$/i && $userid == -3;
	}
}


sub user_belongs_to_one_of_these_group_ids($$)
{
	my $uid = shift;
	my $idlist = shift; # list of numeric group IDs separated either by commas or "|||".
	$idlist =~ s!\|\|\|!,!g;
	my $belongs = 0;
	foreach my $gid (split(/\s*,\s*/, $idlist))
	{
		#$belongs = 1 if user_is_member_of_group($uid, get_group_name($gid));
		if(user_is_member_of_group($uid, get_group_name($gid)))
		{
			#encdebug qq`user $uid IS member of group ` . get_group_name($gid) . qq` (list=$idlist)`;
			$belongs = 1;
		}
	}
	return $belongs;
}


sub logged_in_user_belongs_to_one_of_these_group_ids($)
{
	return user_belongs_to_one_of_these_group_ids($PREF{logged_in_userid}, $_[0]);
}


sub userbase_available
{
	return ($PREF{internal_appname} eq 'userbase'   ||   $PREF{integrate_with_userbase} =~ /yes/i   ||   $PREF{integrate_with_userbase_method_b} =~ /yes/i);
}


sub get_user_id($)
{
	#printd "get_user_id('$_[0]')\n";

	my $username = shift;

	if(userbase_available()   &&   $username)
	{
		die_nice("Error: invalid username '$username'.\n") unless username_is_valid($username);
		check_username_for_uniqueness($username); # checks for sql safeness too.
		return enc_sql_select("SELECT `id` FROM `$PREF{user_table}` WHERE LOWER(`username`) = LOWER('$username')");
	}
	else
	{
		   if($PREF{admin_is_logged_in})	{ return -3; }
		elsif($PREF{member_is_logged_in})	{ return -2; }
		else					{ return -1; } # public.
	}
}


sub get_member_ids_for_group
{
	printd "get_member_ids_for_group($_[0])\n";

	my $group = shift;
	check_groupname_for_sql_safeness($group);

	 # every account is automatically a member of these groups.
	if($group =~ /^($PREF{public_group_name}|$PREF{member_group_name})$/i)
	{
		my $statement = "SELECT `id` FROM `$PREF{user_table}`";
		return $PREF{dbh}->selectall_hashref($statement, 'id');
	}
	else
	{
		my $member_ids = enc_sql_select("SELECT `members` FROM `$PREF{group_table}` WHERE LOWER(`group`) = LOWER('$group')");
		my %member_ids = map { $_ => 1 } split(/,/, $member_ids);
		return \%member_ids;
	}
}


# 20110404: APICHANGE: previously this sub accepted just a single argument,
# which was the group name.  Now it accepts an anonymous hash.
#
sub get_users_belonging_to_group
{
	# Example usage:
	#my $users = get_users_belonging_to_group({ group=>'member' });
	#foreach my $uid (keys %$users)
	#{
	#	print qq`Name: $$users{$uid}{name}, Email: $$users{$uid}{email} <br /><br />`;
	#}

	my $optsref = shift; my %opts = %$optsref if $optsref;

	my $group = $opts{group};
	check_groupname_for_sql_safeness($group);
	my $userids = '';

	if($group =~ /^($PREF{public_group_name}|$PREF{member_group_name})$/i)
	{
		my $userids_hashref = enc_sql_select_multi("SELECT `id` FROM `$PREF{user_table}`");
		foreach my $j (sort { $a <=> $b } keys %$userids_hashref) { $userids .= $$userids_hashref{$j}{id} . ","; }
		decommaify($userids);
	}
	else
	{
		$userids = enc_sql_select("SELECT `members` FROM `$PREF{group_table}` WHERE LOWER(`group`) = LOWER('$group')");
	}

	my %users = ();
	foreach my $uid (split(/,/, $userids))
	{
		die_unless_numeric($uid, 'user ID');
		next if $opts{exclude_pending} && account_is_pending($uid);
		next if $opts{exclude_admins} && is_admin($uid);
		my $userdata = enc_sql_select_multi("SELECT * FROM `$PREF{user_table}` WHERE `id` = $uid");
		foreach my $field (keys %{$$userdata{1}})
		{
			$users{$uid}{$field} = $$userdata{1}{$field};
		}
	}

	return \%users;
}


sub get_user_name($)
{
	return unless userbase_available();
	check_uid_for_uniqueness($_[0]); # checks for sql safeness too.
	return enc_sql_select("SELECT `username` FROM `$PREF{user_table}` WHERE `id` = $_[0]");
}


sub get_group_name($)
{
	my $gid = shift;
	if(userbase_available())
	{
		check_gid_for_uniqueness($gid); # checks for sql safeness too.
		return enc_sql_select("SELECT `group` FROM `$PREF{group_table}` WHERE `id` = $gid");
	}
	else
	{
		   if($gid == -1)	{ return $PREF{public_group_name}; }
		elsif($gid == -2)	{ return $PREF{member_group_name}; }
		elsif($gid == -3)	{ return $PREF{admin_group_name}; }
		else { die_nice("$PREF{internal_appname}: get_group_name(): invalid group ID '$gid'.\n"); }
	}
}


sub get_email_address($)
{
	return unless userbase_available();
	check_uid_for_uniqueness($_[0]); # checks for sql safeness too.
	my ($username,$email) = enc_sql_select("SELECT `username`,`email` FROM `$PREF{user_table}` WHERE `id` = $_[0]");
	$email = $username if is_valid_email_address($username) && !is_valid_email_address($email);
	return $email;
}


sub hashedpw_is_valid				{ return  $_[0] =~ /^[0-9A-Za-z]+$/					&&	length($_[0]) <= $PREF{max_hashedpw_length};	}
sub sessionid_is_valid				{ return  $_[0] =~ /^[0-9A-Za-z]+$/					&&	length($_[0]) <= $PREF{max_hashedpw_length};	}


sub username_is_valid
{
	my $space = $PREF{allow_spaces_in_usernames} =~ /yes/i ? ' ' : '';
	my $atsign = $PREF{allow_atsigns_in_usernames} =~ /yes/i ? '@' : '';
	my $dot = $PREF{allow_dots_in_usernames} =~ /yes/i ? '.' : '';
	my $dash = $PREF{allow_dashes_in_usernames} =~ /yes/i ? '-' : '';

	return ($_[0] =~ /^[0-9A-Za-z_$space$atsign$dot$dash]+$/   &&   $_[0] =~ /\w/	&&	length($_[0]) <= $PREF{max_username_length});
}

sub groupname_is_valid
{
	my $space	= ($PREF{allow_spaces_in_usernames} =~ /yes/i	|| $PREF{allow_spaces_in_groupnames} =~ /yes/i)		? ' ' : '';
	my $atsign	= ($PREF{allow_atsigns_in_usernames} =~ /yes/i	|| $PREF{allow_atsigns_in_groupnames} =~ /yes/i)	? '@' : '';
	my $dot		= ($PREF{allow_dots_in_usernames} =~ /yes/i	|| $PREF{allow_dots_in_groupnames} =~ /yes/i)		? '.' : '';
	my $dash	= ($PREF{allow_dashes_in_usernames} =~ /yes/i	|| $PREF{allow_dashes_in_groupnames} =~ /yes/i)		? '-' : '';

	return ($_[0] =~ /^[0-9A-Za-z_$space$atsign$dot$dash]+$/   &&   $_[0] =~ /\w/	&&	length($_[0]) <= $PREF{max_groupname_length});
}

sub check_hashedpw_for_sql_safeness		{ die_nice(qq`Invalid hashed password:	'$_[0]' [called from: ` . (caller 1)[3]  . qq`]`) unless hashedpw_is_valid($_[0]);	}
sub check_username_for_sql_safeness		{ die_nice(qq`Invalid username:		'$_[0]' [called from: ` . (caller 1)[3]  . qq`]`) unless username_is_valid($_[0]);	}
sub check_groupname_for_sql_safeness		{ die_nice(qq`Invalid groupname:	'$_[0]' [called from: ` . (caller 1)[3]  . qq`]`) unless groupname_is_valid($_[0]);	}
sub check_sessionid_for_sql_safeness		{ die_nice(qq`Invalid session ID:	'$_[0]' [called from: ` . (caller 1)[3]  . qq`]`) unless sessionid_is_valid($_[0]);	}
sub check_id_for_sql_safeness			{ die_nice(qq`Invalid ID:		'$_[0]' [called from: ` . (caller 1)[3]  . qq`]`) unless $_[0] =~ /^(\d+|-[123])$/;	}


sub get_groups_hash
{
	printd "get_groups_hash('$_[0]')\n";

	# If you pass in a uid, then the resulting hash will
	# also indicate which groups that user is a member of.
	#

	my $user_id = shift;

	my ($id, $group, $members, %groups) = ();
	if(userbase_available())
	{
		my $sth = $PREF{dbh}->prepare("SELECT `id`, `group`, `members` FROM `$PREF{group_table}`");
		$sth->execute();
		$sth->bind_columns(\$id, \$group, \$members);
		while($sth->fetchrow_arrayref)
		{
			$groups{$group}{name} = $group;
			$groups{$group}{id} = $id;
			$groups{$group}{members} = $members;

			my $is_member = ();
			   if($group =~ /^($PREF{public_group_name}|$PREF{member_group_name})$/i)	{ $is_member = 1; }
			elsif($user_id =~ /^\d+$/)							{ $is_member = $members =~ /(^|,)$user_id(,|$)/; }

			$groups{$group}{is_member} = $is_member;
		}
	}
	else
	{
		$groups{$PREF{public_group_name}}{name}		= $PREF{public_group_name};
		$groups{$PREF{public_group_name}}{id}		= -1;
		$groups{$PREF{public_group_name}}{is_member}	= 1; # everyone's a member of the public.

		$groups{$PREF{member_group_name}}{name}		= $PREF{member_group_name};
		$groups{$PREF{member_group_name}}{id}		= -2;
		$groups{$PREF{member_group_name}}{is_member}	= 1 if $user_id =~ /^-(2|3)$/;

		$groups{$PREF{admin_group_name}}{name}		= $PREF{admin_group_name};
		$groups{$PREF{admin_group_name}}{id}		= -3;
		$groups{$PREF{admin_group_name}}{is_member}	= 1 if $user_id =~ /^-3$/;
	}

	return \%groups;
}


sub get_email_addresses_for_all_members_of_this_users_groups
{
	my $uid = shift; die_unless_numeric($uid, "user ID");
	my $include_users_own_email_address = shift; $include_users_own_email_address = 0 unless $include_users_own_email_address eq 'include_users_own_email_address';
	my $include_builtin_public_group = shift;    $include_builtin_public_group    = 0 unless $include_builtin_public_group    eq 'include_builtin_public_group';
	my $include_builtin_member_group = shift;    $include_builtin_member_group    = 0 unless $include_builtin_member_group    eq 'include_builtin_member_group';
	my $include_builtin_admin_group = shift;     $include_builtin_admin_group     = 0 unless $include_builtin_admin_group     eq 'include_builtin_admin_group';

	my %email_addresses = ();
	my $allgroups = get_groups_hash($uid);
	foreach my $group (sort keys %$allgroups)
	{
		next if $group =~ /^$PREF{public_group_name}$/i && !$include_builtin_public_group;
		next if $group =~ /^$PREF{member_group_name}$/i && !$include_builtin_member_group;
		next if $group =~ /^$PREF{admin_group_name}$/i  && !$include_builtin_admin_group;

		if(my $this_user_belongs_to_this_group = $$allgroups{$group}{is_member})
		{
			foreach my $member_id (split(/\s*,\s*/, $$allgroups{$group}{members}))
			{
				my $email = get_email_address($member_id);
				$email_addresses{ $email } = 1 unless !$include_users_own_email_address && $email eq $PREF{logged_in_email};
			}
		}
	}
	return keys %email_addresses;   # returns an array when this sub is called in list context.
}


# This function must do a case-insensitive lookup (i.e. use LOWER() on both sides)
# so that we never create a username multiple times with different cases.
#
sub username_is_taken
{
	return 0 unless userbase_available();
	my $user = shift;
	check_username_for_sql_safeness($user);
	return enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE LOWER(`username`) = LOWER('$user')");
}


sub email_address_is_taken
{
	my $address = shift;
	check_emailaddr_for_sql_safeness($address);
	return enc_sql_select("SELECT COUNT(*) FROM `$PREF{user_table}` WHERE LOWER(`email`) = LOWER('$address')");
}


sub salt_and_crypt_password($$)
{
	my $plaintext_password = shift;
	my $salt = shift;
	$plaintext_password = lc($plaintext_password) if $PREF{make_passwords_case_insensitive} =~ /yes/i;
	die "$0: salt_and_crypt_password(): no salt?\n" unless $salt;
	my ($salt1,$salt2) = ($salt =~ /^(.{15})(.{25})$/);
	my $crypted_password = enc_hash($salt1 . $plaintext_password . $salt2);
	return $crypted_password;
}


sub make_password_hash
{
	if($ENV{REQUEST_METHOD} =~ /post/i)
	{
		my $hashed_password = md5_hex(param('password'));
		start_html_output('Here is your hashed password...');
		print	  qq`<p>The hashed version of the password you just entered is:</p><p>$hashed_password</p>`
			. qq`<p>Now open your prefs file and paste this hash into one of the `
			. qq`\n\$PREF{admin_password_hash*} or \$PREF{member_password_hash*} settings.</p>`;
		finish_html_output();
		
	}
	else
	{
		start_html_output('Enter your new password');
		print	  qq`<form method="post" action="$ENV{SCRIPT_NAME}?newpw" id="newpass">`
			. qq`\n<br /><br /><input type="password" name="password" maxlength="200" class="default text" />`
			. qq`\n<br /><br /><input type="submit" value="create hash" class="default button submit" />`
			. qq`\n</form>`;
		finish_html_output();
	}
}


sub user_is_allowed_to
{
	# TODO: these separate per-app branches can probably be partially or totally reconciled.

	if($PREF{internal_appname} eq 'userbase')
	{
		my $userid_performing_action = scalar(@_) == 1 ? $PREF{logged_in_userid} : shift; # if only 1 arg was passed, it's the action, implying we should automatically use the logged_in_userid.
		my $action = shift;
		my $user_affected_by_action = shift;
		my $userid_affected_by_action = get_user_id($user_affected_by_action);

		if($action eq 'edit_user_info')
		{
			return 1 if (logged_in_user_is_subgroup_manager()   &&   $userid_affected_by_action   &&   logged_in_subgroup_manager_owns_this_user($userid_affected_by_action));
		}

		foreach my $group (split(/\s*,\s*/, $PREF{"groups_not_allowed_to_$action"}))
		{
			return 0 if user_is_member_of_group($userid_performing_action, $group);
		}

		foreach my $group (split(/\s*,\s*/, $PREF{"groups_not_allowed_to_$action"}))
		{
			if($group =~ /^self$/i)
			{
				return 0 if ($PREF{member_is_logged_in}   &&   $userid_performing_action == $userid_affected_by_action);
			}
			else
			{
				return 0 if user_is_member_of_group($userid_performing_action, $group);
			}
		}

		foreach my $group (split(/\s*,\s*/, $PREF{"groups_allowed_to_$action"}))
		{
			if($group =~ /^self$/i)
			{
				return 1 if ($PREF{member_is_logged_in}   &&   $userid_performing_action == $userid_affected_by_action);
			}
			else
			{
				return 1 if user_is_member_of_group($userid_performing_action, $group);
			}
		}

		return 0;
	}
	else
	{
		my $action = shift;
		foreach my $group (split(/\s*,\s*/, $PREF{"groups_not_allowed_to_$action"}))
		{
			return 0 if user_is_member_of_group($PREF{logged_in_userid}, $group);
		}
		foreach my $group (split(/\s*,\s*/, $PREF{"groups_allowed_to_$action"}))
		{
			return 1 if user_is_member_of_group($PREF{logged_in_userid}, $group);
		}
		return 0;
	}
}


sub logged_in_user_is_part_of_a_subgroup()
{
	return 0 unless $PREF{member_is_logged_in};
	return user_is_part_of_a_subgroup($PREF{logged_in_userid});
}


sub user_is_part_of_a_subgroup($)
{
	#foreach my $group (enc_sql_select("SELECT "))
	#{
	#	if($group =~ /.+$PREF{subgroup_groupname_suffix}$/i)
	#	{
	#		return enc_sql_select("SELECT COUNT(*) FROM `$PREF{group_table}` WHERE LOWER(`group`) = LOWER('$group') AND `members` REGEXP '(^|,)$PREF{logged_in_userid}(,|\$)'");
	#	}
	#}

	my $uid = shift;
	return '' unless userbase_available();
	return $PREF{subgroup_manager_username} if exists $PREF{subgroup_manager_username}; # if this sub has already been called once, no need to re-do it.

	my $subgroup_groupname_suffix = $PREF{subgroup_groupname_suffix};
	sql_untaint($subgroup_groupname_suffix);
	exit_with_error("not SQL safe: \$subgroup_groupname_suffix ('$subgroup_groupname_suffix').") if not_sqlsafe($subgroup_groupname_suffix);

	die_unless_numeric($uid, '$uid');

	#return enc_sql_select("SELECT COUNT(*) FROM `$PREF{group_table}` WHERE `group` REGEXP '.+$subgroup_groupname_suffix\$' AND `members` REGEXP '(^|,)$uid(,|\$)'");
	#
	# 20111112: changing this to return the username of the SGM, rather than just
	# a zero or a number greater than zero, which doesn't change the true/false
	# value of the result, but makes it more useful:
	#
	my $subgroup = enc_sql_select("SELECT `group` FROM `$PREF{group_table}` WHERE `group` REGEXP '.+$subgroup_groupname_suffix\$' AND `members` REGEXP '(^|,)$uid(,|\$)'");
	$PREF{subgroup_manager_username} = ($subgroup =~ m!(.+)$subgroup_groupname_suffix$!)[0];
	$PREF{subgroup_manager_userid} = get_user_id($PREF{subgroup_manager_username}) if $PREF{subgroup_manager_username};
	return $PREF{subgroup_manager_username};
}


sub logged_in_user_is_subgroup_manager
{
	foreach my $group (split(/\s*,\s*/, $PREF{groups_that_can_manage_subgroup_users}))
	{
		return 1 if user_is_member_of_group($PREF{logged_in_userid}, $group);
	}
	return 0;
}


sub logged_in_subgroup_manager_owns_this_user($)
{
	my $userid_to_check = shift;
	return user_is_member_of_group($userid_to_check, "$PREF{logged_in_username}$PREF{subgroup_groupname_suffix}");
}


sub user_is_subgroup_manager
{
	my $username = shift;
	my $userid = get_user_id($username);
	foreach my $group (split(/\s*,\s*/, $PREF{groups_that_can_manage_subgroup_users}))
	{
		return 1 if user_is_member_of_group($userid, $group, 1);
	}
	return 0;
}


sub this_subgroup_manager_owns_this_user($$)
{
	my $subgroup_manager_userid = shift;
	my $userid_to_check = shift;
	my $subgroup_manager_username = get_user_name($subgroup_manager_userid);
	return user_is_subgroup_manager($subgroup_manager_username) && user_is_member_of_group($userid_to_check, "${subgroup_manager_username}$PREF{subgroup_groupname_suffix}");
}


sub exit_with_access_denied
{
	exit_with_needprivs();
}


##############################################################################
### Dispatch-CS: #############################################################
##############################################################################


load_prefs();

   if($qs =~ /(?:^|&)action=addtocart(?:&|$)/)				{ add_to_cart();			}
elsif($qs =~ /(?:^|&)action=addtocartdyn(?:&|$)/)			{ add_to_cart();			}
elsif($qs =~ /(?:^|&)add=\w+(?:&|$)/)					{ add_to_cart();			}
elsif($qs =~ /(?:^|&)addmulti=[\w\.-]+(?:&|$)/)				{ add_to_cart();			}
elsif($qs =~ /(?:^|&)action=remfromcart(?:&|$)/)			{ remove_from_cart();			}
elsif($qs =~ /(?:^|&)action=updatecart(?:&|$)/)				{ update_cart_page();			}
elsif($qs =~ /(?:^|&)kmsg=(\w+)(?:&|$)/)				{ exit_with_kmsg($1);			}
elsif($qs =~ /(?:^|&)smsg=(\w+)(?:&|$)/)
{
	exit_with_error($TEXT{The_password_you_entered_is_incorrect___}) if $1 eq 'failedlogin';
	exit_with_error($TEXT{"smsg_$1"}) if $TEXT{"smsg_$1"}; # for text strings that are entirely static, name them $TEXT{smsg_foo}.
}

elsif($qs =~ /(?:^|&)action=storemenu(?:&|$)/)				{ show_store_menu();			}
elsif($qs =~ /(?:^|&)showitem=(\d+)/)					{ show_shopping_page( { id => $1 } );	}
elsif($qs =~ /(?:^|&)showitemcode=(\w+)/)				{ show_shopping_page( { code => $1 } );	}
elsif($qs =~ /(?:^|&)action=showsaleslog(?:&|$)/)			{ show_saleslog();			}
elsif($qs =~ /(?:^|&)action=showsaleslogfull(?:&|$)/)			{ show_saleslog('full');		}
elsif($qs =~ /(?:^|&)action=cart(?:&|$)/)				{ show_my_cart();			}
elsif($qs =~ /(?:^|&)action=orders(?:&|$)/)				{ show_my_orders();			}
elsif($qs =~ /(?:^|&)action=download&token=(\w+)(?:&|$)/)		{ show_download_links($1);		}
elsif($qs =~ /(?:^|&)action=download&item=(\w+)&token=(\w+)(?:&|$)/)	{ download_item($1,$2);			}
elsif($qs =~ /(?:^|&)action=showrawpaypal(?:&|$)/)			{ show_raw_paypal_data();		}
elsif($qs =~ /(?:^|&)action=showallcarts(?:&|$)/)			{ show_all_shopping_carts();		}
elsif($qs =~ /(?:^|&)action=resendpmtnote&sid=(\d+)(?:&|$)/)		{ resend_payment_notification_emails($1);}
elsif($qs =~ /(?:^|&)action=relogsale&sid=(\d+)(?:&|$)/)		{ relog_sale($1);			}

elsif($qs =~ /(?:^|&)action=cartcount(?:&|$)/)				{ show_cart_count();			}
elsif($qs =~ /(?:^|&)action=promocodes(?:&|$)/)				{ show_promocodes();			}
elsif($qs =~ /(?:^|&)action=managecats(?:&|$)/)				{ manage_categories();			}
elsif($qs =~ /(?:^|&)action=manageitems(?:&|$)/)			{ manage_items();			}
elsif($qs =~ /(?:^|&)action=manageimages(?:&|$)/)			{ manage_item_images();			}
elsif($qs =~ /(?:^|&)action=delete_item_image(?:&|$)/)			{ delete_item_image();			}
elsif($qs =~ /(?:^|&)action=delete_resized_item_image_copies(?:&|$)/)	{ delete_resized_item_image_copies();	}
elsif($qs =~ /(?:^|&)action=upload_item_images(?:&|$)/)			{ upload_item_images();			}
elsif($qs =~ /(?:^|&)action=importitems(?:&|$)/)			{ import_items();			}

elsif(get_qs_var('action') eq 'showprefs')				{ show_prefs();				}
elsif(get_qs_var('action') eq 'serverinfo')				{ show_server_info();			}
elsif(get_qs_var('action') eq 'imagemodules')				{ check_image_modules();		}

elsif($qs =~ /(?:^|&)$PREF{product_pages_url_keyword}=(\w+)/ && exists $PREF{product_pages}{$1})	{ show_product_page($1); }

elsif($qs =~ /do_email_test/ && ($PREF{enable_email_test} =~ /yes/i || $PREF{admin_is_logged_in})) { do_email_test();	}

elsif(!$qs && $ENV{REQUEST_METHOD} =~ /post/i)				{ log_paypal_ipn_data();		}

else									{ show_shopping_page();			}

